import { NgTemplateOutlet } from "@angular/common";
import { ChangeDetectionStrategy, Component, contentChild, inject, input, TemplateRef, ViewEncapsulation, } from "@angular/core";
import { SdBusyContainerControl } from "../controls/sd-busy-container.control";
import { SdDockContainerControl } from "../controls/sd-dock-container.control";
import { SdDockControl } from "../controls/sd-dock.control";
import { SdIconControl } from "../controls/sd-icon.control";
import { SdPaneControl } from "../controls/sd-pane.control";
import { SdTopbarContainerControl } from "../controls/sd-topbar-container.control";
import { SdTopbarControl } from "../controls/sd-topbar.control";
import { SdShowEffectDirective } from "../directives/sd-show-effect.directive";
import { SdAngularConfigProvider } from "../providers/sd-angular-config.provider";
import { SdAppStructureProvider } from "../providers/sd-app-structure.provider";
import { SdActivatedModalProvider } from "../providers/sd-modal.provider";
import { $computed } from "../utils/bindings/$computed";
import { useCurrentPageCodeSignal } from "../utils/signals/use-current-page-code.signal";
import { useFullPageCodeSignal } from "../utils/signals/use-full-page-code.signal";
import { useViewTypeSignal } from "../utils/signals/use-view-type.signal";
import { transformBoolean } from "../utils/type-tramsforms";
import * as i0 from "@angular/core";
const _c0 = ["pageTopbar"];
const _c1 = ["content"];
const _c2 = ["modalBottom"];
function SdBaseContainerControl_Conditional_1_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "sd-pane", 1);
    i0.ɵɵelement(1, "br")(2, "sd-icon", 3)(3, "br")(4, "br");
    i0.ɵɵtext(5);
    i0.ɵɵelementEnd();
} if (rf & 2) {
    const ctx_r0 = i0.ɵɵnextContext();
    i0.ɵɵproperty("sd-show-effect", ctx_r0.currViewType() !== "modal");
    i0.ɵɵadvance(2);
    i0.ɵɵproperty("icon", ctx_r0.icons.triangleExclamation);
    i0.ɵɵadvance(3);
    i0.ɵɵtextInterpolate1(" '", ctx_r0.title(), "'\uC5D0 \uB300\uD55C \uC0AC\uC6A9\uAD8C\uD55C\uC774 \uC5C6\uC2B5\uB2C8\uB2E4. \uC2DC\uC2A4\uD15C \uAD00\uB9AC\uC790\uC5D0\uAC8C \uBB38\uC758\uD558\uC138\uC694. ");
} }
function SdBaseContainerControl_Conditional_2_ng_template_4_Template(rf, ctx) { }
function SdBaseContainerControl_Conditional_2_ng_template_5_Template(rf, ctx) { }
function SdBaseContainerControl_Conditional_2_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "sd-topbar-container")(1, "sd-topbar")(2, "h4");
    i0.ɵɵtext(3);
    i0.ɵɵelementEnd();
    i0.ɵɵtemplate(4, SdBaseContainerControl_Conditional_2_ng_template_4_Template, 0, 0, "ng-template", 2);
    i0.ɵɵelementEnd();
    i0.ɵɵtemplate(5, SdBaseContainerControl_Conditional_2_ng_template_5_Template, 0, 0, "ng-template", 2);
    i0.ɵɵelementEnd();
} if (rf & 2) {
    let tmp_2_0;
    let tmp_3_0;
    const ctx_r0 = i0.ɵɵnextContext();
    i0.ɵɵadvance(3);
    i0.ɵɵtextInterpolate(ctx_r0.title());
    i0.ɵɵadvance();
    i0.ɵɵproperty("ngTemplateOutlet", (tmp_2_0 = ctx_r0.pageTopbarTemplateRef()) !== null && tmp_2_0 !== undefined ? tmp_2_0 : null);
    i0.ɵɵadvance();
    i0.ɵɵproperty("ngTemplateOutlet", (tmp_3_0 = ctx_r0.contentTemplateRef()) !== null && tmp_3_0 !== undefined ? tmp_3_0 : null);
} }
function SdBaseContainerControl_Conditional_3_ng_template_1_Template(rf, ctx) { }
function SdBaseContainerControl_Conditional_3_ng_template_3_Template(rf, ctx) { }
function SdBaseContainerControl_Conditional_3_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "sd-dock-container");
    i0.ɵɵtemplate(1, SdBaseContainerControl_Conditional_3_ng_template_1_Template, 0, 0, "ng-template", 2);
    i0.ɵɵelementStart(2, "sd-dock", 4);
    i0.ɵɵtemplate(3, SdBaseContainerControl_Conditional_3_ng_template_3_Template, 0, 0, "ng-template", 2);
    i0.ɵɵelementEnd()();
} if (rf & 2) {
    let tmp_1_0;
    let tmp_2_0;
    const ctx_r0 = i0.ɵɵnextContext();
    i0.ɵɵadvance();
    i0.ɵɵproperty("ngTemplateOutlet", (tmp_1_0 = ctx_r0.contentTemplateRef()) !== null && tmp_1_0 !== undefined ? tmp_1_0 : null);
    i0.ɵɵadvance(2);
    i0.ɵɵproperty("ngTemplateOutlet", (tmp_2_0 = ctx_r0.modalBottomTemplateRef()) !== null && tmp_2_0 !== undefined ? tmp_2_0 : null);
} }
function SdBaseContainerControl_Conditional_4_ng_template_0_Template(rf, ctx) { }
function SdBaseContainerControl_Conditional_4_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵtemplate(0, SdBaseContainerControl_Conditional_4_ng_template_0_Template, 0, 0, "ng-template", 2);
} if (rf & 2) {
    let tmp_1_0;
    const ctx_r0 = i0.ɵɵnextContext();
    i0.ɵɵproperty("ngTemplateOutlet", (tmp_1_0 = ctx_r0.contentTemplateRef()) !== null && tmp_1_0 !== undefined ? tmp_1_0 : null);
} }
export class SdBaseContainerControl {
    constructor() {
        this.icons = inject(SdAngularConfigProvider).icons;
        this._sdActivatedModal = inject(SdActivatedModalProvider, { optional: true });
        this._sdAppStructure = inject(SdAppStructureProvider);
        this._fullPageCode = useFullPageCodeSignal();
        this._currPageCode = useCurrentPageCodeSignal();
        this.pageTopbarTemplateRef = contentChild("pageTopbar", { read: TemplateRef });
        this.contentTemplateRef = contentChild("content", { read: TemplateRef });
        this.modalBottomTemplateRef = contentChild("modalBottom", { read: TemplateRef });
        this.perms = $computed(() => this._sdAppStructure.getViewPerms([this._fullPageCode()], ["use"]));
        this._viewType = useViewTypeSignal();
        this.viewType = input();
        this.currViewType = $computed(() => this.viewType() ?? this._viewType());
        this.title = $computed(() => this._sdActivatedModal?.modalComponent()?.title() ??
            this._sdAppStructure.getTitleByCode(this._currPageCode?.() ?? this._fullPageCode()));
        this.busy = input(false, { transform: transformBoolean });
        this.busyMessage = input();
    }
    static { this.ɵfac = function SdBaseContainerControl_Factory(__ngFactoryType__) { return new (__ngFactoryType__ || SdBaseContainerControl)(); }; }
    static { this.ɵcmp = /*@__PURE__*/ i0.ɵɵdefineComponent({ type: SdBaseContainerControl, selectors: [["sd-base-container"]], contentQueries: function SdBaseContainerControl_ContentQueries(rf, ctx, dirIndex) { if (rf & 1) {
            i0.ɵɵcontentQuerySignal(dirIndex, ctx.pageTopbarTemplateRef, _c0, 5, TemplateRef);
            i0.ɵɵcontentQuerySignal(dirIndex, ctx.contentTemplateRef, _c1, 5, TemplateRef);
            i0.ɵɵcontentQuerySignal(dirIndex, ctx.modalBottomTemplateRef, _c2, 5, TemplateRef);
        } if (rf & 2) {
            i0.ɵɵqueryAdvance(3);
        } }, inputs: { viewType: [1, "viewType"], busy: [1, "busy"], busyMessage: [1, "busyMessage"] }, decls: 5, vars: 3, consts: [[3, "busy", "message"], [1, "tx-theme-grey-light", "p-xxl", "tx-center", 3, "sd-show-effect"], [3, "ngTemplateOutlet"], ["fixedWidth", "", "size", "5x", 3, "icon"], ["position", "bottom"]], template: function SdBaseContainerControl_Template(rf, ctx) { if (rf & 1) {
            i0.ɵɵelementStart(0, "sd-busy-container", 0);
            i0.ɵɵtemplate(1, SdBaseContainerControl_Conditional_1_Template, 6, 3, "sd-pane", 1)(2, SdBaseContainerControl_Conditional_2_Template, 6, 3, "sd-topbar-container")(3, SdBaseContainerControl_Conditional_3_Template, 4, 2, "sd-dock-container")(4, SdBaseContainerControl_Conditional_4_Template, 1, 1, null, 2);
            i0.ɵɵelementEnd();
        } if (rf & 2) {
            i0.ɵɵproperty("busy", ctx.busy())("message", ctx.busyMessage());
            i0.ɵɵadvance();
            i0.ɵɵconditional(!ctx.perms().includes("use") ? 1 : ctx.currViewType() === "page" ? 2 : ctx.currViewType() === "modal" && ctx.modalBottomTemplateRef() ? 3 : 4);
        } }, dependencies: [SdPaneControl,
            SdIconControl,
            SdTopbarContainerControl,
            SdTopbarControl,
            SdBusyContainerControl,
            NgTemplateOutlet,
            SdDockContainerControl,
            SdDockControl,
            SdShowEffectDirective], encapsulation: 2, changeDetection: 0 }); }
}
(() => { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(SdBaseContainerControl, [{
        type: Component,
        args: [{
                selector: "sd-base-container",
                changeDetection: ChangeDetectionStrategy.OnPush,
                encapsulation: ViewEncapsulation.None,
                standalone: true,
                imports: [
                    SdPaneControl,
                    SdIconControl,
                    SdTopbarContainerControl,
                    SdTopbarControl,
                    SdBusyContainerControl,
                    NgTemplateOutlet,
                    SdDockContainerControl,
                    SdDockControl,
                    SdShowEffectDirective,
                ],
                template: `
    <sd-busy-container [busy]="busy()" [message]="busyMessage()">
      @if (!perms().includes("use")) {
        <sd-pane
          class="tx-theme-grey-light p-xxl tx-center"
          [sd-show-effect]="currViewType() !== 'modal'"
        >
          <br />
          <sd-icon [icon]="icons.triangleExclamation" fixedWidth size="5x" />
          <br />
          <br />
          '{{ title() }}'에 대한 사용권한이 없습니다. 시스템 관리자에게 문의하세요.
        </sd-pane>
      } @else if (currViewType() === "page") {
        <sd-topbar-container>
          <sd-topbar>
            <h4>{{ title() }}</h4>

            <ng-template [ngTemplateOutlet]="pageTopbarTemplateRef() ?? null" />
          </sd-topbar>

          <ng-template [ngTemplateOutlet]="contentTemplateRef() ?? null" />
        </sd-topbar-container>
      } @else if (currViewType() === "modal" && modalBottomTemplateRef()) {
        <sd-dock-container>
          <ng-template [ngTemplateOutlet]="contentTemplateRef() ?? null" />

          <sd-dock position="bottom">
            <ng-template [ngTemplateOutlet]="modalBottomTemplateRef() ?? null" />
          </sd-dock>
        </sd-dock-container>
      } @else {
        <ng-template [ngTemplateOutlet]="contentTemplateRef() ?? null" />
      }
    </sd-busy-container>
  `,
            }]
    }], null, null); })();
(() => { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassDebugInfo(SdBaseContainerControl, { className: "SdBaseContainerControl", filePath: "packages/sd-angular/src/advanced/sd-base-container.control.ts", lineNumber: 81 }); })();
//# sourceMappingURL=sd-base-container.control.js.map