import { Signal, TemplateRef, WritableSignal } from "@angular/core";
import { SdFormControl } from "../../controls/sd-form.control";
import { TSdViewType } from "../../utils/signals/use-view-type.signal";
import * as i0 from "@angular/core";
export declare class SdDataDetailControl<T extends object> {
    protected readonly icons: import("../../providers/sd-angular-config.provider").ISdAngularIcon;
    private _sdToast;
    private _sdSharedData;
    viewModel: import("@angular/core").InputSignal<ISdDataDetailViewModel<T>>;
    private _viewType;
    viewType: import("@angular/core").InputSignal<TSdViewType | undefined>;
    currViewType: Signal<TSdViewType>;
    close: import("@angular/core").OutputEmitterRef<boolean>;
    hasPerm(code: string): boolean;
    initialized: import("../../utils/bindings/$signal").SdWritableSignal<boolean>;
    busyCount: import("../../utils/bindings/$signal").SdWritableSignal<number>;
    formCtrl: Signal<SdFormControl | undefined>;
    contentTemplateRef: Signal<TemplateRef<any>>;
    constructor();
    checkIgnoreChanges(): boolean;
    onRefreshButtonClick(): Promise<void>;
    private _refresh;
    onToggleDeleteButtonClick(del: boolean): Promise<void>;
    onSubmitButtonClick(): void;
    onSubmit(): Promise<void>;
    static ɵfac: i0.ɵɵFactoryDeclaration<SdDataDetailControl<any>, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<SdDataDetailControl<any>, "sd-data-detail", never, { "viewModel": { "alias": "viewModel"; "required": true; "isSignal": true; }; "viewType": { "alias": "viewType"; "required": false; "isSignal": true; }; }, { "close": "close"; }, ["contentTemplateRef"], never, true, never>;
}
export interface ISdDataDetailViewModel<T extends object> {
    perms?: Signal<string[]>;
    data: WritableSignal<T>;
    getIsNew?(): boolean;
    getIsDeleted?(): boolean;
    getDefaultData?(): T;
    getDataAsync(): Promise<T>;
    toggleDeleteAsync?(del: boolean): Promise<boolean>;
    submitAsync(): Promise<boolean>;
}
