import { NgIf, NgTemplateOutlet } from "@angular/common";
import { ChangeDetectionStrategy, Component, contentChild, HostListener, inject, input, output, TemplateRef, viewChild, ViewEncapsulation, } from "@angular/core";
import { TXT_CHANGE_IGNORE_CONFIRM } from "../../commons";
import { SdButtonControl } from "../../controls/sd-button.control";
import { SdFormControl } from "../../controls/sd-form.control";
import { SdIconControl } from "../../controls/sd-icon.control";
import { SdTopbarMenuItemControl } from "../../controls/sd-topbar-menu-item.control";
import { SdTopbarMenuControl } from "../../controls/sd-topbar-menu.control";
import { SdShowEffectDirective } from "../../directives/sd-show-effect.directive";
import { SdAngularConfigProvider } from "../../providers/sd-angular-config.provider";
import { SdToastProvider } from "../../providers/sd-toast.provider";
import { $computed } from "../../utils/bindings/$computed";
import { $effect } from "../../utils/bindings/$effect";
import { $signal } from "../../utils/bindings/$signal";
import { $obj } from "../../utils/bindings/wrappers/$obj";
import { setupCanDeactivate } from "../../utils/setups/setup-can-deactivate";
import { useViewTypeSignal } from "../../utils/signals/use-view-type.signal";
import { SdBaseContainerControl } from "../sd-base-container.control";
import { SdSharedDataProvider } from "../shared-data/sd-shared-data.provider";
import * as i0 from "@angular/core";
const _c0 = ["formCtrl"];
function SdDataDetailControl_ng_template_1_Template(rf, ctx) { if (rf & 1) {
    const _r1 = i0.ɵɵgetCurrentView();
    i0.ɵɵelementStart(0, "sd-topbar-menu")(1, "sd-topbar-menu-item", 5);
    i0.ɵɵlistener("click", function SdDataDetailControl_ng_template_1_Template_sd_topbar_menu_item_click_1_listener() { i0.ɵɵrestoreView(_r1); const ctx_r1 = i0.ɵɵnextContext(); return i0.ɵɵresetView(ctx_r1.onSubmitButtonClick()); });
    i0.ɵɵelement(2, "sd-icon", 6);
    i0.ɵɵtext(3, " \uC800\uC7A5 ");
    i0.ɵɵelementStart(4, "small");
    i0.ɵɵtext(5, "(CTRL+S)");
    i0.ɵɵelementEnd()();
    i0.ɵɵelementStart(6, "sd-topbar-menu-item", 7);
    i0.ɵɵlistener("click", function SdDataDetailControl_ng_template_1_Template_sd_topbar_menu_item_click_6_listener() { i0.ɵɵrestoreView(_r1); const ctx_r1 = i0.ɵɵnextContext(); return i0.ɵɵresetView(ctx_r1.onRefreshButtonClick()); });
    i0.ɵɵelement(7, "sd-icon", 6);
    i0.ɵɵtext(8, " \uC0C8\uB85C\uACE0\uCE68 ");
    i0.ɵɵelementStart(9, "small");
    i0.ɵɵtext(10, "(CTRL+ALT+L)");
    i0.ɵɵelementEnd()()();
} if (rf & 2) {
    const ctx_r1 = i0.ɵɵnextContext();
    i0.ɵɵadvance(2);
    i0.ɵɵproperty("icon", ctx_r1.icons.save);
    i0.ɵɵadvance(5);
    i0.ɵɵproperty("icon", ctx_r1.icons.refresh);
} }
function SdDataDetailControl_ng_template_3_ng_container_0_ng_template_3_Template(rf, ctx) { }
function SdDataDetailControl_ng_template_3_ng_container_0_Template(rf, ctx) { if (rf & 1) {
    const _r3 = i0.ɵɵgetCurrentView();
    i0.ɵɵelementContainerStart(0);
    i0.ɵɵelementStart(1, "sd-form", 9, 3);
    i0.ɵɵlistener("submit", function SdDataDetailControl_ng_template_3_ng_container_0_Template_sd_form_submit_1_listener() { i0.ɵɵrestoreView(_r3); const ctx_r1 = i0.ɵɵnextContext(2); return i0.ɵɵresetView(ctx_r1.onSubmit()); });
    i0.ɵɵtemplate(3, SdDataDetailControl_ng_template_3_ng_container_0_ng_template_3_Template, 0, 0, "ng-template", 10);
    i0.ɵɵelementEnd();
    i0.ɵɵelementContainerEnd();
} if (rf & 2) {
    const ctx_r1 = i0.ɵɵnextContext(2);
    i0.ɵɵadvance(3);
    i0.ɵɵproperty("ngTemplateOutlet", ctx_r1.contentTemplateRef());
} }
function SdDataDetailControl_ng_template_3_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵtemplate(0, SdDataDetailControl_ng_template_3_ng_container_0_Template, 4, 1, "ng-container", 8);
} if (rf & 2) {
    const ctx_r1 = i0.ɵɵnextContext();
    i0.ɵɵproperty("ngIf", ctx_r1.initialized());
} }
function SdDataDetailControl_ng_template_5_Conditional_0_Conditional_1_Conditional_1_Template(rf, ctx) { if (rf & 1) {
    const _r5 = i0.ɵɵgetCurrentView();
    i0.ɵɵelementStart(0, "sd-button", 16);
    i0.ɵɵlistener("click", function SdDataDetailControl_ng_template_5_Conditional_0_Conditional_1_Conditional_1_Template_sd_button_click_0_listener() { i0.ɵɵrestoreView(_r5); const ctx_r1 = i0.ɵɵnextContext(4); return i0.ɵɵresetView(ctx_r1.onToggleDeleteButtonClick(true)); });
    i0.ɵɵtext(1, " \uC0AD\uC81C ");
    i0.ɵɵelementEnd();
} }
function SdDataDetailControl_ng_template_5_Conditional_0_Conditional_1_Conditional_2_Template(rf, ctx) { if (rf & 1) {
    const _r6 = i0.ɵɵgetCurrentView();
    i0.ɵɵelementStart(0, "sd-button", 17);
    i0.ɵɵlistener("click", function SdDataDetailControl_ng_template_5_Conditional_0_Conditional_1_Conditional_2_Template_sd_button_click_0_listener() { i0.ɵɵrestoreView(_r6); const ctx_r1 = i0.ɵɵnextContext(4); return i0.ɵɵresetView(ctx_r1.onToggleDeleteButtonClick(false)); });
    i0.ɵɵtext(1, " \uBCF5\uAD6C ");
    i0.ɵɵelementEnd();
} }
function SdDataDetailControl_ng_template_5_Conditional_0_Conditional_1_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "div");
    i0.ɵɵtemplate(1, SdDataDetailControl_ng_template_5_Conditional_0_Conditional_1_Conditional_1_Template, 2, 0, "sd-button", 14)(2, SdDataDetailControl_ng_template_5_Conditional_0_Conditional_1_Conditional_2_Template, 2, 0, "sd-button", 15);
    i0.ɵɵelementEnd();
} if (rf & 2) {
    const ctx_r1 = i0.ɵɵnextContext(3);
    i0.ɵɵadvance();
    i0.ɵɵconditional(!ctx_r1.viewModel().getIsDeleted || !ctx_r1.viewModel().getIsDeleted() ? 1 : 2);
} }
function SdDataDetailControl_ng_template_5_Conditional_0_Template(rf, ctx) { if (rf & 1) {
    const _r4 = i0.ɵɵgetCurrentView();
    i0.ɵɵelementStart(0, "div", 11);
    i0.ɵɵtemplate(1, SdDataDetailControl_ng_template_5_Conditional_0_Conditional_1_Template, 3, 1, "div");
    i0.ɵɵelementStart(2, "div", 12)(3, "sd-button", 13);
    i0.ɵɵlistener("click", function SdDataDetailControl_ng_template_5_Conditional_0_Template_sd_button_click_3_listener() { i0.ɵɵrestoreView(_r4); const ctx_r1 = i0.ɵɵnextContext(2); return i0.ɵɵresetView(ctx_r1.onSubmitButtonClick()); });
    i0.ɵɵtext(4, "\uD655\uC778");
    i0.ɵɵelementEnd()()();
} if (rf & 2) {
    const ctx_r1 = i0.ɵɵnextContext(2);
    i0.ɵɵadvance();
    i0.ɵɵconditional(ctx_r1.viewModel().getIsNew && !ctx_r1.viewModel().getIsNew() ? 1 : -1);
} }
function SdDataDetailControl_ng_template_5_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵtemplate(0, SdDataDetailControl_ng_template_5_Conditional_0_Template, 5, 1, "div", 11);
} if (rf & 2) {
    const ctx_r1 = i0.ɵɵnextContext();
    i0.ɵɵconditional(ctx_r1.hasPerm("edit") ? 0 : -1);
} }
export class SdDataDetailControl {
    hasPerm(code) {
        return !this.viewModel().perms || this.viewModel().perms().includes(code);
    }
    constructor() {
        this.icons = inject(SdAngularConfigProvider).icons;
        this._sdToast = inject(SdToastProvider);
        this._sdSharedData = inject(SdSharedDataProvider);
        //-- base
        this.viewModel = input.required();
        this._viewType = useViewTypeSignal();
        this.viewType = input();
        this.currViewType = $computed(() => this.viewType() ?? this._viewType());
        this.close = output();
        //-- view
        this.initialized = $signal(false);
        this.busyCount = $signal(0);
        this.formCtrl = viewChild("formCtrl");
        this.contentTemplateRef = contentChild.required(TemplateRef);
        $effect([], async () => {
            if (!this.hasPerm("use")) {
                this.initialized.set(true);
                return;
            }
            this.busyCount.update((v) => v + 1);
            await this._sdToast.try(async () => {
                await this._sdSharedData.wait();
                await this._refresh();
            });
            this.busyCount.update((v) => v - 1);
            this.initialized.set(true);
        });
        setupCanDeactivate(() => this.currViewType() === "modal" || this.checkIgnoreChanges());
    }
    checkIgnoreChanges() {
        return !$obj(this.viewModel().data).changed() || confirm(TXT_CHANGE_IGNORE_CONFIRM);
    }
    async onRefreshButtonClick() {
        if (this.busyCount() > 0)
            return;
        if (!this.checkIgnoreChanges())
            return;
        this.busyCount.update((v) => v + 1);
        await this._sdToast.try(async () => {
            await this._refresh();
        });
        this.busyCount.update((v) => v - 1);
    }
    async _refresh() {
        if (this.viewModel().getIsNew &&
            this.viewModel().getDefaultData &&
            this.viewModel().getIsNew()) {
            this.viewModel().data.set(this.viewModel().getDefaultData());
        }
        else {
            this.viewModel().data.set(await this.viewModel().getDataAsync());
        }
        $obj(this.viewModel().data).snapshot();
    }
    async onToggleDeleteButtonClick(del) {
        if (this.busyCount() > 0)
            return;
        if (!this.hasPerm("edit"))
            return;
        this.busyCount.update((v) => v + 1);
        await this._sdToast.try(async () => {
            const result = await this.viewModel().toggleDeleteAsync?.(del);
            if (!result)
                return;
            this._sdToast.success(`${del ? "삭제" : "복구"}되었습니다.`);
        });
        this.busyCount.update((v) => v - 1);
        this.close.emit(true);
    }
    onSubmitButtonClick() {
        if (this.busyCount() > 0)
            return;
        this.formCtrl()?.requestSubmit();
    }
    async onSubmit() {
        if (this.busyCount() > 0)
            return;
        if (!this.hasPerm("edit"))
            return;
        if (!$obj(this.viewModel().data).changed()) {
            this._sdToast.info("변경사항이 없습니다.");
            return;
        }
        this.busyCount.update((v) => v + 1);
        await this._sdToast.try(async () => {
            const result = await this.viewModel().submitAsync();
            if (!result)
                return;
            this._sdToast.success("저장되었습니다.");
        });
        this.busyCount.update((v) => v - 1);
        this.close.emit(true);
    }
    static { this.ɵfac = function SdDataDetailControl_Factory(__ngFactoryType__) { return new (__ngFactoryType__ || SdDataDetailControl)(); }; }
    static { this.ɵcmp = /*@__PURE__*/ i0.ɵɵdefineComponent({ type: SdDataDetailControl, selectors: [["sd-data-detail"]], contentQueries: function SdDataDetailControl_ContentQueries(rf, ctx, dirIndex) { if (rf & 1) {
            i0.ɵɵcontentQuerySignal(dirIndex, ctx.contentTemplateRef, TemplateRef, 5);
        } if (rf & 2) {
            i0.ɵɵqueryAdvance();
        } }, viewQuery: function SdDataDetailControl_Query(rf, ctx) { if (rf & 1) {
            i0.ɵɵviewQuerySignal(ctx.formCtrl, _c0, 5);
        } if (rf & 2) {
            i0.ɵɵqueryAdvance();
        } }, hostBindings: function SdDataDetailControl_HostBindings(rf, ctx) { if (rf & 1) {
            i0.ɵɵlistener("sdRefreshCommand", function SdDataDetailControl_sdRefreshCommand_HostBindingHandler() { return ctx.onRefreshButtonClick(); })("sdSaveCommand", function SdDataDetailControl_sdSaveCommand_HostBindingHandler() { return ctx.onSubmitButtonClick(); });
        } }, inputs: { viewModel: [1, "viewModel"], viewType: [1, "viewType"] }, outputs: { close: "close" }, decls: 7, vars: 2, consts: [["pageTopbar", ""], ["content", ""], ["modalBottom", ""], ["formCtrl", ""], [3, "busy", "viewType"], [3, "click"], ["fixedWidth", "", 3, "icon"], ["theme", "info", 3, "click"], [4, "ngIf"], ["sd-show-effect", "", 3, "submit"], [3, "ngTemplateOutlet"], [1, "p-sm-default", "flex-row"], [1, "flex-grow", "tx-right"], ["theme", "primary", "inline", "", 3, "click"], ["theme", "danger", "inline", ""], ["theme", "warning", "inline", ""], ["theme", "danger", "inline", "", 3, "click"], ["theme", "warning", "inline", "", 3, "click"]], template: function SdDataDetailControl_Template(rf, ctx) { if (rf & 1) {
            i0.ɵɵelementStart(0, "sd-base-container", 4);
            i0.ɵɵtemplate(1, SdDataDetailControl_ng_template_1_Template, 11, 2, "ng-template", null, 0, i0.ɵɵtemplateRefExtractor)(3, SdDataDetailControl_ng_template_3_Template, 1, 1, "ng-template", null, 1, i0.ɵɵtemplateRefExtractor)(5, SdDataDetailControl_ng_template_5_Template, 1, 1, "ng-template", null, 2, i0.ɵɵtemplateRefExtractor);
            i0.ɵɵelementEnd();
        } if (rf & 2) {
            i0.ɵɵproperty("busy", ctx.busyCount() > 0)("viewType", ctx.currViewType());
        } }, dependencies: [SdBaseContainerControl,
            SdFormControl,
            SdButtonControl,
            SdShowEffectDirective,
            SdTopbarMenuControl,
            SdTopbarMenuItemControl,
            SdIconControl,
            NgIf,
            NgTemplateOutlet], encapsulation: 2, changeDetection: 0 }); }
}
(() => { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(SdDataDetailControl, [{
        type: Component,
        args: [{
                selector: "sd-data-detail",
                changeDetection: ChangeDetectionStrategy.OnPush,
                encapsulation: ViewEncapsulation.None,
                standalone: true,
                imports: [
                    SdBaseContainerControl,
                    SdFormControl,
                    SdButtonControl,
                    SdShowEffectDirective,
                    SdTopbarMenuControl,
                    SdTopbarMenuItemControl,
                    SdIconControl,
                    NgIf,
                    NgTemplateOutlet,
                ],
                template: `
    <sd-base-container [busy]="busyCount() > 0" [viewType]="currViewType()">
      <ng-template #pageTopbar>
        <sd-topbar-menu>
          <sd-topbar-menu-item (click)="onSubmitButtonClick()">
            <sd-icon [icon]="icons.save" fixedWidth />
            저장
            <small>(CTRL+S)</small>
          </sd-topbar-menu-item>
          <sd-topbar-menu-item theme="info" (click)="onRefreshButtonClick()">
            <sd-icon [icon]="icons.refresh" fixedWidth />
            새로고침
            <small>(CTRL+ALT+L)</small>
          </sd-topbar-menu-item>
        </sd-topbar-menu>
      </ng-template>

      <ng-template #content>
        <ng-container *ngIf="initialized()">
          <sd-form #formCtrl (submit)="onSubmit()" sd-show-effect>
            <ng-template [ngTemplateOutlet]="contentTemplateRef()" />
          </sd-form>
        </ng-container>
      </ng-template>

      <ng-template #modalBottom>
        @if (hasPerm("edit")) {
          <div class="p-sm-default flex-row">
            @if (viewModel().getIsNew && !viewModel().getIsNew!()) {
              <div>
                @if (!viewModel().getIsDeleted || !viewModel().getIsDeleted!()) {
                  <sd-button theme="danger" inline (click)="onToggleDeleteButtonClick(true)">
                    삭제
                  </sd-button>
                } @else {
                  <sd-button theme="warning" inline (click)="onToggleDeleteButtonClick(false)">
                    복구
                  </sd-button>
                }
              </div>
            }

            <div class="flex-grow tx-right">
              <sd-button theme="primary" inline (click)="onSubmitButtonClick()">확인</sd-button>
            </div>
          </div>
        }
      </ng-template>
    </sd-base-container>
  `,
            }]
    }], () => [], { onRefreshButtonClick: [{
            type: HostListener,
            args: ["sdRefreshCommand"]
        }], onSubmitButtonClick: [{
            type: HostListener,
            args: ["sdSaveCommand"]
        }] }); })();
(() => { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassDebugInfo(SdDataDetailControl, { className: "SdDataDetailControl", filePath: "packages/sd-angular/src/advanced/sd-data-sheet/sd-data-detail.control.ts", lineNumber: 101 }); })();
//# sourceMappingURL=sd-data-detail.control.js.map