import { Signal } from "@angular/core";
import { ISdSortingDef } from "../../utils/managers/sd-sorting-manager";
import { TSdViewType } from "../../utils/signals/use-view-type.signal";
import { ISelectModalOutputResult } from "../sd-select-modal-button.control";
import { SdDataSheetColumnDirective } from "./sd-data-sheet-column.directive";
import { SdDataSheetFilterDirective } from "./sd-data-sheet-filter.directive";
import { SdDataSheetToolDirective } from "./sd-data-sheet-tool.directive";
import * as i0 from "@angular/core";
export declare class SdDataSheetControl<VM extends ISdDataSheetViewModel<any, any, any>> {
    protected readonly icons: import("../../providers/sd-angular-config.provider").ISdAngularIcon;
    private _sdToast;
    private _sdSharedData;
    private _sdFileDialog;
    viewModel: import("@angular/core").InputSignal<VM>;
    private _viewType;
    viewType: import("@angular/core").InputSignal<TSdViewType | undefined>;
    currViewType: Signal<TSdViewType>;
    initialized: import("../../utils/bindings/$signal").SdWritableSignal<boolean>;
    busyCount: import("../../utils/bindings/$signal").SdWritableSignal<number>;
    filterControls: Signal<readonly SdDataSheetFilterDirective[]>;
    toolControls: Signal<readonly SdDataSheetToolDirective[]>;
    columnControls: Signal<readonly SdDataSheetColumnDirective<any>[]>;
    items: import("../../utils/bindings/$signal").SdWritableSignal<TVMItem<VM>[]>;
    selectedItems: import("@angular/core").ModelSignal<TVMItem<VM>[]>;
    trackByFn: (item: TVMItem<VM>) => TVMItemKey<VM>;
    page: import("../../utils/bindings/$signal").SdWritableSignal<number>;
    pageLength: import("../../utils/bindings/$signal").SdWritableSignal<number>;
    ordering: import("../../utils/bindings/$signal").SdWritableSignal<ISdSortingDef[]>;
    selectMode: import("@angular/core").InputSignal<"single" | "multi" | undefined>;
    selectedItemKeys: import("@angular/core").ModelSignal<ReturnType<VM["getKey"]>[]>;
    lastFilter: import("../../utils/bindings/$signal").SdWritableSignal<ReturnType<VM["filter"]> | undefined>;
    constructor();
    onFilterSubmit(): void;
    private _updateLastFilter;
    onRefreshCommand(): void;
    refreshAsync(): Promise<void>;
    searchAllAsync(): Promise<any[]>;
    onCreateItemButtonClick(): Promise<void>;
    onItemClick(item: TVMItem<VM>, index: number, event: MouseEvent): Promise<void>;
    private _editItemAsync;
    isSelectedItemsHasDeleted: Signal<boolean>;
    isSelectedItemsHasNotDeleted: Signal<boolean>;
    getItemCellStyleFn: (item: TVMItem<VM>) => "text-decoration: line-through;" | undefined;
    onToggleDeletesButtonClick(del: boolean): Promise<void>;
    onDownloadExcelButtonClick(): Promise<void>;
    onUploadExcelButtonClick(): Promise<void>;
    close: import("@angular/core").OutputEmitterRef<ISelectModalOutputResult>;
    onConfirmButtonClick(): void;
    onCancelButtonClick(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<SdDataSheetControl<any>, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<SdDataSheetControl<any>, "sd-data-sheet", never, { "viewModel": { "alias": "viewModel"; "required": true; "isSignal": true; }; "viewType": { "alias": "viewType"; "required": false; "isSignal": true; }; "selectedItems": { "alias": "selectedItems"; "required": false; "isSignal": true; }; "selectMode": { "alias": "selectMode"; "required": false; "isSignal": true; }; "selectedItemKeys": { "alias": "selectedItemKeys"; "required": false; "isSignal": true; }; }, { "selectedItems": "selectedItemsChange"; "selectedItemKeys": "selectedItemKeysChange"; "close": "close"; }, ["filterControls", "toolControls", "columnControls"], never, true, never>;
}
export interface ISdDataSheetViewModel<F extends Record<string, any>, I, K> {
    key: string;
    name: string;
    perms: Signal<string[]>;
    filter: Signal<F>;
    getKey(item: I): K;
    getIsDeleted?(item: I): boolean;
    searchAsync(type: "excel" | "sheet", lastFilter: F, sortingDefs: ISdSortingDef[], page?: number): Promise<{
        items: I[];
        pageLength?: number;
    }>;
    editItemAsync?(item?: I): Promise<boolean>;
    toggleDeletesAsync?(selectedItems: I[], del: boolean): Promise<boolean>;
    downloadExcelAsync?(items: I[]): Promise<void>;
    uploadExcelAsync?(file: File): Promise<void>;
}
type TVMItem<T extends ISdDataSheetViewModel<any, any, any>> = Parameters<T["getKey"]>[0];
type TVMItemKey<T extends ISdDataSheetViewModel<any, any, any>> = ReturnType<T["getKey"]>;
export {};
