import { NgTemplateOutlet } from "@angular/common";
import { ChangeDetectionStrategy, Component, contentChildren, HostListener, inject, input, model, output, ViewEncapsulation, } from "@angular/core";
import { ObjectUtils } from "@simplysm/sd-core-common";
import { SdAnchorControl } from "../../controls/sd-anchor.control";
import { SdButtonControl } from "../../controls/sd-button.control";
import { SdDockContainerControl } from "../../controls/sd-dock-container.control";
import { SdDockControl } from "../../controls/sd-dock.control";
import { SdFormBoxItemControl } from "../../controls/sd-form-box-item.control";
import { SdFormBoxControl } from "../../controls/sd-form-box.control";
import { SdFormControl } from "../../controls/sd-form.control";
import { SdIconControl } from "../../controls/sd-icon.control";
import { SdPaneControl } from "../../controls/sd-pane.control";
import { SdSheetColumnCellTemplateDirective } from "../../controls/sd-sheet/directives/sd-sheet-column-cell.template-directive";
import { SdSheetColumnDirective } from "../../controls/sd-sheet/directives/sd-sheet-column.directive";
import { SdSheetControl } from "../../controls/sd-sheet/sd-sheet.control";
import { SdTopbarMenuItemControl } from "../../controls/sd-topbar-menu-item.control";
import { SdTopbarMenuControl } from "../../controls/sd-topbar-menu.control";
import { SdShowEffectDirective } from "../../directives/sd-show-effect.directive";
import { SdAngularConfigProvider } from "../../providers/sd-angular-config.provider";
import { SdFileDialogProvider } from "../../providers/sd-file-dialog.provider";
import { SdToastProvider } from "../../providers/sd-toast.provider";
import { $computed } from "../../utils/bindings/$computed";
import { $effect } from "../../utils/bindings/$effect";
import { $signal } from "../../utils/bindings/$signal";
import { setupCumulateSelectedKeys } from "../../utils/setups/setup-cumulate-selected-keys";
import { useViewTypeSignal } from "../../utils/signals/use-view-type.signal";
import { SdBaseContainerControl } from "../sd-base-container.control";
import { SdSharedDataProvider } from "../shared-data/sd-shared-data.provider";
import { SdDataSheetColumnDirective } from "./sd-data-sheet-column.directive";
import { SdDataSheetFilterDirective } from "./sd-data-sheet-filter.directive";
import { SdDataSheetToolDirective } from "./sd-data-sheet-tool.directive";
import { setupCloserWhenSingleSelectionChange } from "../../utils/setups/setup-closer-when-single-selection-change";
import * as i0 from "@angular/core";
const _c0 = (a0, a1, a2, a3, a4) => ({ $implicit: a0, item: a1, index: a2, depth: a3, edit: a4 });
const _forTrack0 = ($index, $item) => $item.key;
function SdDataSheetControl_ng_template_1_Template(rf, ctx) { if (rf & 1) {
    const _r1 = i0.ɵɵgetCurrentView();
    i0.ɵɵelementStart(0, "sd-topbar-menu")(1, "sd-topbar-menu-item", 7);
    i0.ɵɵlistener("click", function SdDataSheetControl_ng_template_1_Template_sd_topbar_menu_item_click_1_listener() { i0.ɵɵrestoreView(_r1); const ctx_r1 = i0.ɵɵnextContext(); return i0.ɵɵresetView(ctx_r1.onRefreshCommand()); });
    i0.ɵɵelement(2, "sd-icon", 8);
    i0.ɵɵtext(3, " \uC0C8\uB85C\uACE0\uCE68 ");
    i0.ɵɵelementStart(4, "small");
    i0.ɵɵtext(5, "(CTRL+ALT+L)");
    i0.ɵɵelementEnd()()();
} if (rf & 2) {
    const ctx_r1 = i0.ɵɵnextContext();
    i0.ɵɵadvance(2);
    i0.ɵɵproperty("icon", ctx_r1.icons.refresh);
} }
function SdDataSheetControl_ng_template_3_Conditional_0_For_9_Conditional_1_ng_template_0_ng_template_0_Template(rf, ctx) { }
function SdDataSheetControl_ng_template_3_Conditional_0_For_9_Conditional_1_ng_template_0_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵtemplate(0, SdDataSheetControl_ng_template_3_Conditional_0_For_9_Conditional_1_ng_template_0_ng_template_0_Template, 0, 0, "ng-template", 18);
} if (rf & 2) {
    const filterControl_r4 = i0.ɵɵnextContext(2).$implicit;
    i0.ɵɵproperty("ngTemplateOutlet", filterControl_r4.labelTemplateRef());
} }
function SdDataSheetControl_ng_template_3_Conditional_0_For_9_Conditional_1_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵtemplate(0, SdDataSheetControl_ng_template_3_Conditional_0_For_9_Conditional_1_ng_template_0_Template, 1, 1, "ng-template", null, 2, i0.ɵɵtemplateRefExtractor);
} }
function SdDataSheetControl_ng_template_3_Conditional_0_For_9_ng_template_2_Template(rf, ctx) { }
function SdDataSheetControl_ng_template_3_Conditional_0_For_9_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "sd-form-box-item", 14);
    i0.ɵɵtemplate(1, SdDataSheetControl_ng_template_3_Conditional_0_For_9_Conditional_1_Template, 2, 0)(2, SdDataSheetControl_ng_template_3_Conditional_0_For_9_ng_template_2_Template, 0, 0, "ng-template", 18);
    i0.ɵɵelementEnd();
} if (rf & 2) {
    const filterControl_r4 = ctx.$implicit;
    i0.ɵɵproperty("label", filterControl_r4.label())("labelTooltip", filterControl_r4.labelTooltip());
    i0.ɵɵadvance();
    i0.ɵɵconditional(filterControl_r4.labelTemplateRef() ? 1 : -1);
    i0.ɵɵadvance();
    i0.ɵɵproperty("ngTemplateOutlet", filterControl_r4.contentTemplateRef());
} }
function SdDataSheetControl_ng_template_3_Conditional_0_Conditional_12_Conditional_0_Template(rf, ctx) { if (rf & 1) {
    const _r5 = i0.ɵɵgetCurrentView();
    i0.ɵɵelementStart(0, "sd-button", 22);
    i0.ɵɵlistener("click", function SdDataSheetControl_ng_template_3_Conditional_0_Conditional_12_Conditional_0_Template_sd_button_click_0_listener() { i0.ɵɵrestoreView(_r5); const ctx_r1 = i0.ɵɵnextContext(4); return i0.ɵɵresetView(ctx_r1.onCreateItemButtonClick()); });
    i0.ɵɵelement(1, "sd-icon", 8);
    i0.ɵɵtext(2, " \uB4F1\uB85D ");
    i0.ɵɵelementStart(3, "small");
    i0.ɵɵtext(4, "(CTRL+INSERT)");
    i0.ɵɵelementEnd()();
} if (rf & 2) {
    const ctx_r1 = i0.ɵɵnextContext(4);
    i0.ɵɵadvance();
    i0.ɵɵproperty("icon", ctx_r1.icons.add);
} }
function SdDataSheetControl_ng_template_3_Conditional_0_Conditional_12_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵtemplate(0, SdDataSheetControl_ng_template_3_Conditional_0_Conditional_12_Conditional_0_Template, 5, 1, "sd-button", 21);
} if (rf & 2) {
    const ctx_r1 = i0.ɵɵnextContext(3);
    i0.ɵɵconditional(ctx_r1.viewModel().perms().includes("edit") ? 0 : -1);
} }
function SdDataSheetControl_ng_template_3_Conditional_0_Conditional_13_Conditional_0_Conditional_3_Template(rf, ctx) { if (rf & 1) {
    const _r7 = i0.ɵɵgetCurrentView();
    i0.ɵɵelementStart(0, "sd-button", 26);
    i0.ɵɵlistener("click", function SdDataSheetControl_ng_template_3_Conditional_0_Conditional_13_Conditional_0_Conditional_3_Template_sd_button_click_0_listener() { i0.ɵɵrestoreView(_r7); const ctx_r1 = i0.ɵɵnextContext(5); return i0.ɵɵresetView(ctx_r1.onToggleDeletesButtonClick(false)); });
    i0.ɵɵelement(1, "sd-icon", 24);
    i0.ɵɵtext(2, " \uC120\uD0DD \uBCF5\uAD6C ");
    i0.ɵɵelementEnd();
} if (rf & 2) {
    const ctx_r1 = i0.ɵɵnextContext(5);
    i0.ɵɵadvance();
    i0.ɵɵproperty("icon", ctx_r1.icons.redo)("fixedWidth", true);
} }
function SdDataSheetControl_ng_template_3_Conditional_0_Conditional_13_Conditional_0_Template(rf, ctx) { if (rf & 1) {
    const _r6 = i0.ɵɵgetCurrentView();
    i0.ɵɵelementStart(0, "sd-button", 23);
    i0.ɵɵlistener("click", function SdDataSheetControl_ng_template_3_Conditional_0_Conditional_13_Conditional_0_Template_sd_button_click_0_listener() { i0.ɵɵrestoreView(_r6); const ctx_r1 = i0.ɵɵnextContext(4); return i0.ɵɵresetView(ctx_r1.onToggleDeletesButtonClick(true)); });
    i0.ɵɵelement(1, "sd-icon", 24);
    i0.ɵɵtext(2, " \uC120\uD0DD \uC0AD\uC81C ");
    i0.ɵɵelementEnd();
    i0.ɵɵtemplate(3, SdDataSheetControl_ng_template_3_Conditional_0_Conditional_13_Conditional_0_Conditional_3_Template, 3, 2, "sd-button", 25);
} if (rf & 2) {
    const ctx_r1 = i0.ɵɵnextContext(4);
    i0.ɵɵproperty("disabled", !ctx_r1.isSelectedItemsHasNotDeleted());
    i0.ɵɵadvance();
    i0.ɵɵproperty("icon", ctx_r1.icons.delete)("fixedWidth", true);
    i0.ɵɵadvance(2);
    i0.ɵɵconditional(ctx_r1.isSelectedItemsHasDeleted() ? 3 : -1);
} }
function SdDataSheetControl_ng_template_3_Conditional_0_Conditional_13_Conditional_1_Template(rf, ctx) { if (rf & 1) {
    const _r8 = i0.ɵɵgetCurrentView();
    i0.ɵɵelementStart(0, "sd-button", 27);
    i0.ɵɵlistener("click", function SdDataSheetControl_ng_template_3_Conditional_0_Conditional_13_Conditional_1_Template_sd_button_click_0_listener() { i0.ɵɵrestoreView(_r8); const ctx_r1 = i0.ɵɵnextContext(4); return i0.ɵɵresetView(ctx_r1.onUploadExcelButtonClick()); });
    i0.ɵɵelement(1, "sd-icon", 8);
    i0.ɵɵtext(2, " \uC5D1\uC140 \uC5C5\uB85C\uB4DC ");
    i0.ɵɵelementEnd();
} if (rf & 2) {
    const ctx_r1 = i0.ɵɵnextContext(4);
    i0.ɵɵadvance();
    i0.ɵɵproperty("icon", ctx_r1.icons.upload);
} }
function SdDataSheetControl_ng_template_3_Conditional_0_Conditional_13_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵtemplate(0, SdDataSheetControl_ng_template_3_Conditional_0_Conditional_13_Conditional_0_Template, 4, 4)(1, SdDataSheetControl_ng_template_3_Conditional_0_Conditional_13_Conditional_1_Template, 3, 1, "sd-button", 17);
} if (rf & 2) {
    const ctx_r1 = i0.ɵɵnextContext(3);
    i0.ɵɵconditional(ctx_r1.viewModel().toggleDeletesAsync ? 0 : -1);
    i0.ɵɵadvance();
    i0.ɵɵconditional(ctx_r1.viewModel().uploadExcelAsync ? 1 : -1);
} }
function SdDataSheetControl_ng_template_3_Conditional_0_Conditional_14_Template(rf, ctx) { if (rf & 1) {
    const _r9 = i0.ɵɵgetCurrentView();
    i0.ɵɵelementStart(0, "sd-button", 27);
    i0.ɵɵlistener("click", function SdDataSheetControl_ng_template_3_Conditional_0_Conditional_14_Template_sd_button_click_0_listener() { i0.ɵɵrestoreView(_r9); const ctx_r1 = i0.ɵɵnextContext(3); return i0.ɵɵresetView(ctx_r1.onDownloadExcelButtonClick()); });
    i0.ɵɵelement(1, "sd-icon", 8);
    i0.ɵɵtext(2, " \uC5D1\uC140 \uB2E4\uC6B4\uB85C\uB4DC ");
    i0.ɵɵelementEnd();
} if (rf & 2) {
    const ctx_r1 = i0.ɵɵnextContext(3);
    i0.ɵɵadvance();
    i0.ɵɵproperty("icon", ctx_r1.icons.fileExcel);
} }
function SdDataSheetControl_ng_template_3_Conditional_0_For_16_ng_template_0_Template(rf, ctx) { }
function SdDataSheetControl_ng_template_3_Conditional_0_For_16_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵtemplate(0, SdDataSheetControl_ng_template_3_Conditional_0_For_16_ng_template_0_Template, 0, 0, "ng-template", 18);
} if (rf & 2) {
    const toolControl_r10 = ctx.$implicit;
    i0.ɵɵproperty("ngTemplateOutlet", toolControl_r10.contentTemplateRef());
} }
function SdDataSheetControl_ng_template_3_Conditional_0_For_20_Conditional_1_ng_template_0_ng_template_0_Template(rf, ctx) { }
function SdDataSheetControl_ng_template_3_Conditional_0_For_20_Conditional_1_ng_template_0_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵtemplate(0, SdDataSheetControl_ng_template_3_Conditional_0_For_20_Conditional_1_ng_template_0_ng_template_0_Template, 0, 0, "ng-template", 18);
} if (rf & 2) {
    const columnControl_r11 = i0.ɵɵnextContext(2).$implicit;
    i0.ɵɵproperty("ngTemplateOutlet", columnControl_r11.headerTemplateRef());
} }
function SdDataSheetControl_ng_template_3_Conditional_0_For_20_Conditional_1_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵtemplate(0, SdDataSheetControl_ng_template_3_Conditional_0_For_20_Conditional_1_ng_template_0_Template, 1, 1, "ng-template", null, 3, i0.ɵɵtemplateRefExtractor);
} }
function SdDataSheetControl_ng_template_3_Conditional_0_For_20_Conditional_2_ng_template_0_ng_template_0_Template(rf, ctx) { }
function SdDataSheetControl_ng_template_3_Conditional_0_For_20_Conditional_2_ng_template_0_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵtemplate(0, SdDataSheetControl_ng_template_3_Conditional_0_For_20_Conditional_2_ng_template_0_ng_template_0_Template, 0, 0, "ng-template", 18);
} if (rf & 2) {
    const columnControl_r11 = i0.ɵɵnextContext(2).$implicit;
    i0.ɵɵproperty("ngTemplateOutlet", columnControl_r11.summaryTemplateRef());
} }
function SdDataSheetControl_ng_template_3_Conditional_0_For_20_Conditional_2_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵtemplate(0, SdDataSheetControl_ng_template_3_Conditional_0_For_20_Conditional_2_ng_template_0_Template, 1, 1, "ng-template", null, 4, i0.ɵɵtemplateRefExtractor);
} }
function SdDataSheetControl_ng_template_3_Conditional_0_For_20_ng_template_3_Conditional_0_ng_template_4_Template(rf, ctx) { }
function SdDataSheetControl_ng_template_3_Conditional_0_For_20_ng_template_3_Conditional_0_Template(rf, ctx) { if (rf & 1) {
    const _r12 = i0.ɵɵgetCurrentView();
    i0.ɵɵelementStart(0, "sd-anchor", 31);
    i0.ɵɵlistener("click", function SdDataSheetControl_ng_template_3_Conditional_0_For_20_ng_template_3_Conditional_0_Template_sd_anchor_click_0_listener($event) { i0.ɵɵrestoreView(_r12); const ctx_r12 = i0.ɵɵnextContext(); const item_r14 = ctx_r12.$implicit; const index_r15 = ctx_r12.index; const ctx_r1 = i0.ɵɵnextContext(4); return i0.ɵɵresetView(ctx_r1.onItemClick(item_r14, index_r15, $event)); });
    i0.ɵɵelementStart(1, "div", 32);
    i0.ɵɵelement(2, "sd-icon", 33);
    i0.ɵɵelementEnd();
    i0.ɵɵelementStart(3, "div", 34);
    i0.ɵɵtemplate(4, SdDataSheetControl_ng_template_3_Conditional_0_For_20_ng_template_3_Conditional_0_ng_template_4_Template, 0, 0, "ng-template", 30);
    i0.ɵɵelementEnd()();
} if (rf & 2) {
    const ctx_r12 = i0.ɵɵnextContext();
    const item_r14 = ctx_r12.$implicit;
    const index_r15 = ctx_r12.index;
    const depth_r16 = ctx_r12.depth;
    const edit_r17 = ctx_r12.edit;
    const columnControl_r11 = i0.ɵɵnextContext().$implicit;
    const ctx_r1 = i0.ɵɵnextContext(3);
    i0.ɵɵadvance(2);
    i0.ɵɵproperty("icon", ctx_r1.icons.edit);
    i0.ɵɵadvance(2);
    i0.ɵɵproperty("ngTemplateOutlet", columnControl_r11.cellTemplateRef())("ngTemplateOutletContext", i0.ɵɵpureFunction5(3, _c0, item_r14, item_r14, index_r15, depth_r16, edit_r17));
} }
function SdDataSheetControl_ng_template_3_Conditional_0_For_20_ng_template_3_Conditional_1_ng_template_0_Template(rf, ctx) { }
function SdDataSheetControl_ng_template_3_Conditional_0_For_20_ng_template_3_Conditional_1_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵtemplate(0, SdDataSheetControl_ng_template_3_Conditional_0_For_20_ng_template_3_Conditional_1_ng_template_0_Template, 0, 0, "ng-template", 30);
} if (rf & 2) {
    const ctx_r12 = i0.ɵɵnextContext();
    const item_r14 = ctx_r12.$implicit;
    const index_r15 = ctx_r12.index;
    const depth_r16 = ctx_r12.depth;
    const edit_r17 = ctx_r12.edit;
    const columnControl_r11 = i0.ɵɵnextContext().$implicit;
    i0.ɵɵproperty("ngTemplateOutlet", columnControl_r11.cellTemplateRef())("ngTemplateOutletContext", i0.ɵɵpureFunction5(2, _c0, item_r14, item_r14, index_r15, depth_r16, edit_r17));
} }
function SdDataSheetControl_ng_template_3_Conditional_0_For_20_ng_template_3_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵtemplate(0, SdDataSheetControl_ng_template_3_Conditional_0_For_20_ng_template_3_Conditional_0_Template, 5, 9, "sd-anchor", 29)(1, SdDataSheetControl_ng_template_3_Conditional_0_For_20_ng_template_3_Conditional_1_Template, 1, 8, null, 30);
} if (rf & 2) {
    const columnControl_r11 = i0.ɵɵnextContext().$implicit;
    const ctx_r1 = i0.ɵɵnextContext(3);
    i0.ɵɵconditional(ctx_r1.viewModel().editItemAsync && columnControl_r11.edit() && ctx_r1.viewModel().perms().includes("edit") ? 0 : 1);
} }
function SdDataSheetControl_ng_template_3_Conditional_0_For_20_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "sd-sheet-column", 20);
    i0.ɵɵtemplate(1, SdDataSheetControl_ng_template_3_Conditional_0_For_20_Conditional_1_Template, 2, 0)(2, SdDataSheetControl_ng_template_3_Conditional_0_For_20_Conditional_2_Template, 2, 0)(3, SdDataSheetControl_ng_template_3_Conditional_0_For_20_ng_template_3_Template, 2, 1, "ng-template", 28);
    i0.ɵɵelementEnd();
} if (rf & 2) {
    const columnControl_r11 = ctx.$implicit;
    const ctx_r1 = i0.ɵɵnextContext(3);
    i0.ɵɵproperty("key", columnControl_r11.key())("fixed", columnControl_r11.fixed())("header", columnControl_r11.header())("headerStyle", columnControl_r11.headerStyle())("tooltip", columnControl_r11.tooltip())("width", columnControl_r11.width())("disableSorting", columnControl_r11.disableSorting())("disableResizing", columnControl_r11.disableResizing())("hidden", columnControl_r11.hidden())("collapse", columnControl_r11.collapse());
    i0.ɵɵadvance();
    i0.ɵɵconditional(columnControl_r11.headerTemplateRef() ? 1 : -1);
    i0.ɵɵadvance();
    i0.ɵɵconditional(columnControl_r11.summaryTemplateRef() ? 2 : -1);
    i0.ɵɵadvance();
    i0.ɵɵproperty("cell", ctx_r1.items());
} }
function SdDataSheetControl_ng_template_3_Conditional_0_Template(rf, ctx) { if (rf & 1) {
    const _r3 = i0.ɵɵgetCurrentView();
    i0.ɵɵelementStart(0, "sd-dock-container", 9)(1, "sd-dock", 10)(2, "sd-form", 11);
    i0.ɵɵlistener("submit", function SdDataSheetControl_ng_template_3_Conditional_0_Template_sd_form_submit_2_listener() { i0.ɵɵrestoreView(_r3); const ctx_r1 = i0.ɵɵnextContext(2); return i0.ɵɵresetView(ctx_r1.onFilterSubmit()); });
    i0.ɵɵelementStart(3, "sd-form-box", 12)(4, "sd-form-box-item")(5, "sd-button", 13);
    i0.ɵɵelement(6, "sd-icon", 8);
    i0.ɵɵtext(7, " \uC870\uD68C ");
    i0.ɵɵelementEnd()();
    i0.ɵɵrepeaterCreate(8, SdDataSheetControl_ng_template_3_Conditional_0_For_9_Template, 3, 4, "sd-form-box-item", 14, i0.ɵɵrepeaterTrackByIdentity);
    i0.ɵɵelementEnd()()();
    i0.ɵɵelementStart(10, "sd-dock", 15)(11, "div", 16);
    i0.ɵɵtemplate(12, SdDataSheetControl_ng_template_3_Conditional_0_Conditional_12_Template, 1, 1)(13, SdDataSheetControl_ng_template_3_Conditional_0_Conditional_13_Template, 2, 2)(14, SdDataSheetControl_ng_template_3_Conditional_0_Conditional_14_Template, 3, 1, "sd-button", 17);
    i0.ɵɵrepeaterCreate(15, SdDataSheetControl_ng_template_3_Conditional_0_For_16_Template, 1, 1, null, 18, i0.ɵɵrepeaterTrackByIdentity);
    i0.ɵɵelementEnd()();
    i0.ɵɵelementStart(17, "sd-pane")(18, "sd-sheet", 19);
    i0.ɵɵtwoWayListener("currentPageChange", function SdDataSheetControl_ng_template_3_Conditional_0_Template_sd_sheet_currentPageChange_18_listener($event) { i0.ɵɵrestoreView(_r3); const ctx_r1 = i0.ɵɵnextContext(2); i0.ɵɵtwoWayBindingSet(ctx_r1.page, $event) || (ctx_r1.page = $event); return i0.ɵɵresetView($event); })("sortsChange", function SdDataSheetControl_ng_template_3_Conditional_0_Template_sd_sheet_sortsChange_18_listener($event) { i0.ɵɵrestoreView(_r3); const ctx_r1 = i0.ɵɵnextContext(2); i0.ɵɵtwoWayBindingSet(ctx_r1.ordering, $event) || (ctx_r1.ordering = $event); return i0.ɵɵresetView($event); })("selectedItemsChange", function SdDataSheetControl_ng_template_3_Conditional_0_Template_sd_sheet_selectedItemsChange_18_listener($event) { i0.ɵɵrestoreView(_r3); const ctx_r1 = i0.ɵɵnextContext(2); i0.ɵɵtwoWayBindingSet(ctx_r1.selectedItems, $event) || (ctx_r1.selectedItems = $event); return i0.ɵɵresetView($event); });
    i0.ɵɵrepeaterCreate(19, SdDataSheetControl_ng_template_3_Conditional_0_For_20_Template, 4, 13, "sd-sheet-column", 20, _forTrack0);
    i0.ɵɵelementEnd()()();
} if (rf & 2) {
    let tmp_15_0;
    const ctx_r1 = i0.ɵɵnextContext(2);
    i0.ɵɵadvance(6);
    i0.ɵɵproperty("icon", ctx_r1.icons.search);
    i0.ɵɵadvance(2);
    i0.ɵɵrepeater(ctx_r1.filterControls());
    i0.ɵɵadvance(4);
    i0.ɵɵconditional(ctx_r1.viewModel().editItemAsync ? 12 : -1);
    i0.ɵɵadvance();
    i0.ɵɵconditional(!ctx_r1.selectMode() ? 13 : -1);
    i0.ɵɵadvance();
    i0.ɵɵconditional(ctx_r1.viewModel().downloadExcelAsync ? 14 : -1);
    i0.ɵɵadvance();
    i0.ɵɵrepeater(ctx_r1.toolControls());
    i0.ɵɵadvance(3);
    i0.ɵɵproperty("key", ctx_r1.viewModel().key + "-sheet")("items", ctx_r1.items());
    i0.ɵɵtwoWayProperty("currentPage", ctx_r1.page);
    i0.ɵɵproperty("totalPageCount", ctx_r1.pageLength());
    i0.ɵɵtwoWayProperty("sorts", ctx_r1.ordering);
    i0.ɵɵproperty("selectMode", (tmp_15_0 = ctx_r1.selectMode()) !== null && tmp_15_0 !== undefined ? tmp_15_0 : "multi")("autoSelect", ctx_r1.selectMode() === "single" ? "click" : undefined);
    i0.ɵɵtwoWayProperty("selectedItems", ctx_r1.selectedItems);
    i0.ɵɵproperty("trackByFn", ctx_r1.trackByFn)("getItemCellStyleFn", ctx_r1.getItemCellStyleFn);
    i0.ɵɵadvance();
    i0.ɵɵrepeater(ctx_r1.columnControls());
} }
function SdDataSheetControl_ng_template_3_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵtemplate(0, SdDataSheetControl_ng_template_3_Conditional_0_Template, 21, 14, "sd-dock-container", 9);
} if (rf & 2) {
    const ctx_r1 = i0.ɵɵnextContext();
    i0.ɵɵconditional(ctx_r1.initialized() ? 0 : -1);
} }
function SdDataSheetControl_Conditional_5_ng_template_0_Conditional_3_Template(rf, ctx) { if (rf & 1) {
    const _r19 = i0.ɵɵgetCurrentView();
    i0.ɵɵelementStart(0, "sd-button", 38);
    i0.ɵɵlistener("click", function SdDataSheetControl_Conditional_5_ng_template_0_Conditional_3_Template_sd_button_click_0_listener() { i0.ɵɵrestoreView(_r19); const ctx_r1 = i0.ɵɵnextContext(3); return i0.ɵɵresetView(ctx_r1.onConfirmButtonClick()); });
    i0.ɵɵtext(1);
    i0.ɵɵelementEnd();
} if (rf & 2) {
    const ctx_r1 = i0.ɵɵnextContext(3);
    i0.ɵɵadvance();
    i0.ɵɵtextInterpolate1(" \uD655\uC778(", ctx_r1.selectedItemKeys().length, ") ");
} }
function SdDataSheetControl_Conditional_5_ng_template_0_Template(rf, ctx) { if (rf & 1) {
    const _r18 = i0.ɵɵgetCurrentView();
    i0.ɵɵelementStart(0, "sd-dock", 35)(1, "sd-button", 36);
    i0.ɵɵlistener("click", function SdDataSheetControl_Conditional_5_ng_template_0_Template_sd_button_click_1_listener() { i0.ɵɵrestoreView(_r18); const ctx_r1 = i0.ɵɵnextContext(2); return i0.ɵɵresetView(ctx_r1.onCancelButtonClick()); });
    i0.ɵɵtext(2);
    i0.ɵɵelementEnd();
    i0.ɵɵtemplate(3, SdDataSheetControl_Conditional_5_ng_template_0_Conditional_3_Template, 2, 1, "sd-button", 37);
    i0.ɵɵelementEnd();
} if (rf & 2) {
    const ctx_r1 = i0.ɵɵnextContext(2);
    i0.ɵɵadvance(2);
    i0.ɵɵtextInterpolate1(" ", ctx_r1.selectMode() === "multi" ? "\uBAA8\uB450" : "\uC120\uD0DD", " \uD574\uC81C ");
    i0.ɵɵadvance();
    i0.ɵɵconditional(ctx_r1.selectMode() === "multi" ? 3 : -1);
} }
function SdDataSheetControl_Conditional_5_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵtemplate(0, SdDataSheetControl_Conditional_5_ng_template_0_Template, 4, 2, "ng-template", null, 5, i0.ɵɵtemplateRefExtractor);
} }
export class SdDataSheetControl {
    constructor() {
        this.icons = inject(SdAngularConfigProvider).icons;
        this._sdToast = inject(SdToastProvider);
        this._sdSharedData = inject(SdSharedDataProvider);
        this._sdFileDialog = inject(SdFileDialogProvider);
        //-- base
        this.viewModel = input.required();
        this._viewType = useViewTypeSignal();
        this.viewType = input();
        this.currViewType = $computed(() => this.viewType() ?? this._viewType());
        //-- view
        this.initialized = $signal(false);
        this.busyCount = $signal(0);
        this.filterControls = contentChildren(SdDataSheetFilterDirective);
        this.toolControls = contentChildren(SdDataSheetToolDirective);
        this.columnControls = contentChildren((SdDataSheetColumnDirective));
        //-- items
        this.items = $signal([]);
        this.selectedItems = model([]);
        this.trackByFn = (item) => this.viewModel().getKey(item);
        this.page = $signal(0);
        this.pageLength = $signal(0);
        this.ordering = $signal([]);
        this.selectMode = input();
        this.selectedItemKeys = model([]);
        //-- search
        this.lastFilter = $signal();
        //-- delete
        this.isSelectedItemsHasDeleted = $computed(() => this.selectedItems().some((item) => this.viewModel().getIsDeleted?.(item) ?? false));
        this.isSelectedItemsHasNotDeleted = $computed(() => this.selectedItems().some((item) => !(this.viewModel().getIsDeleted?.(item) ?? false)));
        this.getItemCellStyleFn = (item) => this.viewModel().getIsDeleted?.(item) ? "text-decoration: line-through;" : undefined;
        //-- modal
        this.close = output();
        setupCumulateSelectedKeys({
            items: this.items,
            selectMode: this.selectMode,
            selectedItems: this.selectedItems,
            selectedItemKeys: this.selectedItemKeys,
            keySelectorFn: (item) => this.trackByFn(item),
        });
        setupCloserWhenSingleSelectionChange({
            selectMode: this.selectMode,
            selectedItemKeys: this.selectedItemKeys,
            close: this.close,
        });
        $effect([this.page, this.lastFilter, this.ordering], async () => {
            if (!this.viewModel().perms().includes("use")) {
                this.initialized.set(true);
                return;
            }
            if (this.lastFilter() == null) {
                this._updateLastFilter();
            }
            this.busyCount.update((v) => v + 1);
            await this._sdToast.try(async () => {
                await this._sdSharedData.wait();
                await this.refreshAsync();
            });
            this.busyCount.update((v) => v - 1);
            this.initialized.set(true);
        });
    }
    onFilterSubmit() {
        this.page.set(0);
        this._updateLastFilter();
    }
    _updateLastFilter() {
        this.lastFilter.set(ObjectUtils.clone(this.viewModel().filter()));
    }
    onRefreshCommand() {
        if (this.busyCount() > 0)
            return;
        this.lastFilter.$mark();
    }
    async refreshAsync() {
        if (this.lastFilter() == null)
            return;
        const result = await this.viewModel().searchAsync("sheet", this.lastFilter(), this.ordering(), this.page());
        this.items.set(result.items);
        this.pageLength.set(result.pageLength ?? 0);
        this.selectedItems.set(this.items().filter((item) => this.selectedItems().some((sel) => this.viewModel().getKey(sel) === this.viewModel().getKey(item))));
    }
    async searchAllAsync() {
        return (await this.viewModel().searchAsync("excel", this.lastFilter(), this.ordering())).items;
    }
    //-- edit
    async onCreateItemButtonClick() {
        if (!this.viewModel().perms().includes("edit"))
            return;
        await this._editItemAsync();
    }
    async onItemClick(item, index, event) {
        if (!this.viewModel().perms().includes("edit"))
            return;
        event.preventDefault();
        event.stopPropagation();
        await this._editItemAsync(item);
    }
    async _editItemAsync(item) {
        if (!this.viewModel().editItemAsync)
            return;
        const result = await this.viewModel().editItemAsync(item);
        if (!result)
            return;
        this.busyCount.update((v) => v + 1);
        await this._sdToast.try(async () => {
            await this.refreshAsync();
        });
        this.busyCount.update((v) => v - 1);
    }
    async onToggleDeletesButtonClick(del) {
        if (!this.viewModel().toggleDeletesAsync)
            return;
        if (!this.viewModel().perms().includes("edit"))
            return;
        this.busyCount.update((v) => v + 1);
        await this._sdToast.try(async () => {
            const result = await this.viewModel().toggleDeletesAsync(this.selectedItems(), del);
            if (!result)
                return;
            await this.refreshAsync();
            this._sdToast.success(`${del ? "삭제" : "복구"} 되었습니다.`);
        });
        this.busyCount.update((v) => v - 1);
    }
    //-- excel
    async onDownloadExcelButtonClick() {
        if (!this.viewModel().downloadExcelAsync)
            return;
        this.busyCount.update((v) => v + 1);
        await this._sdToast.try(async () => {
            if (this.lastFilter() == null)
                return;
            const data = await this.viewModel().searchAsync("excel", this.lastFilter(), this.ordering());
            await this.viewModel().downloadExcelAsync(data.items);
        });
        this.busyCount.update((v) => v - 1);
    }
    async onUploadExcelButtonClick() {
        if (!this.viewModel().uploadExcelAsync)
            return;
        if (!this.viewModel().perms().includes("edit"))
            return;
        const file = await this._sdFileDialog.showAsync(false, "application/vnd.openxmlformats-officedocument.spreadsheetml.sheet");
        if (!file)
            return;
        this.busyCount.update((v) => v + 1);
        await this._sdToast.try(async () => {
            await this.viewModel().uploadExcelAsync(file);
            await this.refreshAsync();
            this._sdToast.success("엑셀 업로드가 완료 되었습니다.");
        });
        this.busyCount.update((v) => v - 1);
    }
    onConfirmButtonClick() {
        this.close.emit({ selectedItemKeys: this.selectedItemKeys() });
    }
    onCancelButtonClick() {
        this.close.emit({ selectedItemKeys: [] });
    }
    static { this.ɵfac = function SdDataSheetControl_Factory(__ngFactoryType__) { return new (__ngFactoryType__ || SdDataSheetControl)(); }; }
    static { this.ɵcmp = /*@__PURE__*/ i0.ɵɵdefineComponent({ type: SdDataSheetControl, selectors: [["sd-data-sheet"]], contentQueries: function SdDataSheetControl_ContentQueries(rf, ctx, dirIndex) { if (rf & 1) {
            i0.ɵɵcontentQuerySignal(dirIndex, ctx.filterControls, SdDataSheetFilterDirective, 4);
            i0.ɵɵcontentQuerySignal(dirIndex, ctx.toolControls, SdDataSheetToolDirective, 4);
            i0.ɵɵcontentQuerySignal(dirIndex, ctx.columnControls, (SdDataSheetColumnDirective), 4);
        } if (rf & 2) {
            i0.ɵɵqueryAdvance(3);
        } }, hostBindings: function SdDataSheetControl_HostBindings(rf, ctx) { if (rf & 1) {
            i0.ɵɵlistener("sdRefreshCommand", function SdDataSheetControl_sdRefreshCommand_HostBindingHandler() { return ctx.onRefreshCommand(); });
        } }, inputs: { viewModel: [1, "viewModel"], viewType: [1, "viewType"], selectedItems: [1, "selectedItems"], selectMode: [1, "selectMode"], selectedItemKeys: [1, "selectedItemKeys"] }, outputs: { selectedItems: "selectedItemsChange", selectedItemKeys: "selectedItemKeysChange", close: "close" }, decls: 6, vars: 3, consts: [["pageTopbar", ""], ["content", ""], ["label", ""], ["header", ""], ["summary", ""], ["modalBottom", ""], [3, "busy", "viewType"], ["theme", "info", 3, "click"], ["fixedWidth", "", 3, "icon"], ["sd-show-effect", "", 1, "p-lg"], [1, "pb-lg"], [3, "submit"], ["layout", "inline"], ["type", "submit", "theme", "info"], [3, "label", "labelTooltip"], [1, "pb-xs"], [1, "flex-row", "flex-gap-sm"], ["size", "sm", "theme", "link-success"], [3, "ngTemplateOutlet"], [3, "currentPageChange", "sortsChange", "selectedItemsChange", "key", "items", "currentPage", "totalPageCount", "sorts", "selectMode", "autoSelect", "selectedItems", "trackByFn", "getItemCellStyleFn"], [3, "key", "fixed", "header", "headerStyle", "tooltip", "width", "disableSorting", "disableResizing", "hidden", "collapse"], ["size", "sm", "theme", "link-primary"], ["size", "sm", "theme", "link-primary", 3, "click"], ["size", "sm", "theme", "link-danger", 3, "click", "disabled"], [3, "icon", "fixedWidth"], ["size", "sm", "theme", "link-warning"], ["size", "sm", "theme", "link-warning", 3, "click"], ["size", "sm", "theme", "link-success", 3, "click"], [3, "cell"], [1, "flex-row"], [3, "ngTemplateOutlet", "ngTemplateOutletContext"], [1, "flex-row", 3, "click"], [1, "p-xs-sm", "pr-0"], [3, "icon"], [1, "flex-grow"], ["position", "bottom", 1, "p-sm-default", "bdt", "bdt-trans-light", "flex-row", "flex-gap-sm", 2, "justify-content", "right"], ["theme", "danger", "inline", "", 3, "click"], ["theme", "primary", "inline", ""], ["theme", "primary", "inline", "", 3, "click"]], template: function SdDataSheetControl_Template(rf, ctx) { if (rf & 1) {
            i0.ɵɵelementStart(0, "sd-base-container", 6);
            i0.ɵɵtemplate(1, SdDataSheetControl_ng_template_1_Template, 6, 1, "ng-template", null, 0, i0.ɵɵtemplateRefExtractor)(3, SdDataSheetControl_ng_template_3_Template, 1, 1, "ng-template", null, 1, i0.ɵɵtemplateRefExtractor)(5, SdDataSheetControl_Conditional_5_Template, 2, 0);
            i0.ɵɵelementEnd();
        } if (rf & 2) {
            i0.ɵɵproperty("busy", ctx.busyCount() > 0)("viewType", ctx.currViewType());
            i0.ɵɵadvance(5);
            i0.ɵɵconditional(ctx.selectMode() ? 5 : -1);
        } }, dependencies: [SdTopbarMenuControl,
            SdTopbarMenuItemControl,
            SdIconControl,
            SdDockContainerControl,
            SdDockControl,
            SdShowEffectDirective,
            SdFormControl,
            SdFormBoxControl,
            SdFormBoxItemControl,
            SdButtonControl,
            SdPaneControl,
            SdSheetControl,
            SdSheetColumnDirective,
            SdSheetColumnCellTemplateDirective,
            SdAnchorControl,
            NgTemplateOutlet,
            SdBaseContainerControl], encapsulation: 2, changeDetection: 0 }); }
}
(() => { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(SdDataSheetControl, [{
        type: Component,
        args: [{
                selector: "sd-data-sheet",
                changeDetection: ChangeDetectionStrategy.OnPush,
                encapsulation: ViewEncapsulation.None,
                standalone: true,
                imports: [
                    SdTopbarMenuControl,
                    SdTopbarMenuItemControl,
                    SdIconControl,
                    SdDockContainerControl,
                    SdDockControl,
                    SdShowEffectDirective,
                    SdFormControl,
                    SdFormBoxControl,
                    SdFormBoxItemControl,
                    SdButtonControl,
                    SdPaneControl,
                    SdSheetControl,
                    SdSheetColumnDirective,
                    SdSheetColumnCellTemplateDirective,
                    SdAnchorControl,
                    NgTemplateOutlet,
                    SdBaseContainerControl,
                ],
                template: `
    <sd-base-container [busy]="busyCount() > 0" [viewType]="currViewType()">
      <ng-template #pageTopbar>
        <sd-topbar-menu>
          <sd-topbar-menu-item theme="info" (click)="onRefreshCommand()">
            <sd-icon [icon]="icons.refresh" fixedWidth />
            새로고침
            <small>(CTRL+ALT+L)</small>
          </sd-topbar-menu-item>
        </sd-topbar-menu>
      </ng-template>

      <ng-template #content>
        @if (initialized()) {
          <sd-dock-container class="p-lg" sd-show-effect>
            <sd-dock class="pb-lg">
              <sd-form (submit)="onFilterSubmit()">
                <sd-form-box layout="inline">
                  <sd-form-box-item>
                    <sd-button type="submit" theme="info">
                      <sd-icon [icon]="icons.search" fixedWidth />
                      조회
                    </sd-button>
                  </sd-form-box-item>
                  @for (filterControl of filterControls(); track filterControl) {
                    <sd-form-box-item
                      [label]="filterControl.label()"
                      [labelTooltip]="filterControl.labelTooltip()"
                    >
                      @if (filterControl.labelTemplateRef()) {
                        <ng-template #label>
                          <ng-template [ngTemplateOutlet]="filterControl.labelTemplateRef()!" />
                        </ng-template>
                      }
                      <ng-template [ngTemplateOutlet]="filterControl.contentTemplateRef()" />
                    </sd-form-box-item>
                  }
                </sd-form-box>
              </sd-form>
            </sd-dock>

            <sd-dock class="pb-xs">
              <div class="flex-row flex-gap-sm">
                @if (viewModel().editItemAsync) {
                  @if (viewModel().perms().includes("edit")) {
                    <sd-button size="sm" theme="link-primary" (click)="onCreateItemButtonClick()">
                      <sd-icon [icon]="icons.add" fixedWidth />
                      등록
                      <small>(CTRL+INSERT)</small>
                    </sd-button>
                  }
                }

                @if (!selectMode()) {
                  @if (viewModel().toggleDeletesAsync) {
                    <sd-button
                      size="sm"
                      theme="link-danger"
                      (click)="onToggleDeletesButtonClick(true)"
                      [disabled]="!isSelectedItemsHasNotDeleted()"
                    >
                      <sd-icon [icon]="icons.delete" [fixedWidth]="true" />
                      선택 삭제
                    </sd-button>
                    @if (isSelectedItemsHasDeleted()) {
                      <sd-button
                        size="sm"
                        theme="link-warning"
                        (click)="onToggleDeletesButtonClick(false)"
                      >
                        <sd-icon [icon]="icons.redo" [fixedWidth]="true" />
                        선택 복구
                      </sd-button>
                    }
                  }

                  @if (viewModel().uploadExcelAsync) {
                    <sd-button size="sm" theme="link-success" (click)="onUploadExcelButtonClick()">
                      <sd-icon [icon]="icons.upload" fixedWidth />
                      엑셀 업로드
                    </sd-button>
                  }
                }

                @if (viewModel().downloadExcelAsync) {
                  <sd-button size="sm" theme="link-success" (click)="onDownloadExcelButtonClick()">
                    <sd-icon [icon]="icons.fileExcel" fixedWidth />
                    엑셀 다운로드
                  </sd-button>
                }

                @for (toolControl of toolControls(); track toolControl) {
                  <ng-template [ngTemplateOutlet]="toolControl.contentTemplateRef()" />
                }
              </div>
            </sd-dock>

            <sd-pane>
              <sd-sheet
                [key]="viewModel().key + '-sheet'"
                [items]="items()"
                [(currentPage)]="page"
                [totalPageCount]="pageLength()"
                [(sorts)]="ordering"
                [selectMode]="selectMode() ?? 'multi'"
                [autoSelect]="selectMode() === 'single' ? 'click' : undefined"
                [(selectedItems)]="selectedItems"
                [trackByFn]="trackByFn"
                [getItemCellStyleFn]="getItemCellStyleFn"
              >
                @for (columnControl of columnControls(); track columnControl.key) {
                  <sd-sheet-column
                    [key]="columnControl.key()"
                    [fixed]="columnControl.fixed()"
                    [header]="columnControl.header()"
                    [headerStyle]="columnControl.headerStyle()"
                    [tooltip]="columnControl.tooltip()"
                    [width]="columnControl.width()"
                    [disableSorting]="columnControl.disableSorting()"
                    [disableResizing]="columnControl.disableResizing()"
                    [hidden]="columnControl.hidden()"
                    [collapse]="columnControl.collapse()"
                  >
                    @if (columnControl.headerTemplateRef()) {
                      <ng-template #header>
                        <ng-template [ngTemplateOutlet]="columnControl.headerTemplateRef()!" />
                      </ng-template>
                    }
                    @if (columnControl.summaryTemplateRef()) {
                      <ng-template #summary>
                        <ng-template [ngTemplateOutlet]="columnControl.summaryTemplateRef()!" />
                      </ng-template>
                    }

                    <ng-template
                      [cell]="items()"
                      let-item
                      let-index="index"
                      let-depth="depth"
                      let-edit="edit"
                    >
                      @if (
                        viewModel().editItemAsync &&
                        columnControl.edit() &&
                        viewModel().perms().includes("edit")
                      ) {
                        <sd-anchor class="flex-row" (click)="onItemClick(item, index, $event)">
                          <div class="p-xs-sm pr-0">
                            <sd-icon [icon]="icons.edit" />
                          </div>
                          <div class="flex-grow">
                            <ng-template
                              [ngTemplateOutlet]="columnControl.cellTemplateRef()"
                              [ngTemplateOutletContext]="{
                                $implicit: item,
                                item: item,
                                index: index,
                                depth: depth,
                                edit: edit,
                              }"
                            />
                          </div>
                        </sd-anchor>
                      } @else {
                        <ng-template
                          [ngTemplateOutlet]="columnControl.cellTemplateRef()"
                          [ngTemplateOutletContext]="{
                            $implicit: item,
                            item: item,
                            index: index,
                            depth: depth,
                            edit: edit,
                          }"
                        />
                      }
                    </ng-template>
                  </sd-sheet-column>
                }
              </sd-sheet>
            </sd-pane>
          </sd-dock-container>
        }
      </ng-template>
      @if (selectMode()) {
        <ng-template #modalBottom>
          <sd-dock
            position="bottom"
            class="p-sm-default bdt bdt-trans-light flex-row flex-gap-sm"
            style="justify-content: right"
          >
            <sd-button theme="danger" inline (click)="onCancelButtonClick()">
              {{ selectMode() === "multi" ? "모두" : "선택" }}
              해제
            </sd-button>
            @if (selectMode() === "multi") {
              <sd-button theme="primary" inline (click)="onConfirmButtonClick()">
                확인({{ selectedItemKeys().length }})
              </sd-button>
            }
          </sd-dock>
        </ng-template>
      }
    </sd-base-container>
  `,
            }]
    }], () => [], { onRefreshCommand: [{
            type: HostListener,
            args: ["sdRefreshCommand"]
        }] }); })();
(() => { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassDebugInfo(SdDataSheetControl, { className: "SdDataSheetControl", filePath: "packages/sd-angular/src/advanced/sd-data-sheet/sd-data-sheet.control.ts", lineNumber: 276 }); })();
//# sourceMappingURL=sd-data-sheet.control.js.map