import { ChangeDetectionStrategy, Component, inject, input, model, ViewEncapsulation, } from "@angular/core";
import { SdAdditionalButtonControl } from "../controls/sd-additional-button.control";
import { SdAnchorControl } from "../controls/sd-anchor.control";
import { SdButtonControl } from "../controls/sd-button.control";
import { SdIconControl } from "../controls/sd-icon.control";
import { SdAngularConfigProvider } from "../providers/sd-angular-config.provider";
import { SdModalProvider } from "../providers/sd-modal.provider";
import { $computed } from "../utils/bindings/$computed";
import { setupInvalid } from "../utils/setups/setup-invalid";
import { transformBoolean } from "../utils/type-tramsforms";
import * as i0 from "@angular/core";
const _c0 = ["*"];
function SdSelectModalButtonControl_Conditional_2_Template(rf, ctx) { if (rf & 1) {
    const _r1 = i0.ɵɵgetCurrentView();
    i0.ɵɵelementStart(0, "sd-anchor", 3);
    i0.ɵɵlistener("click", function SdSelectModalButtonControl_Conditional_2_Template_sd_anchor_click_0_listener() { i0.ɵɵrestoreView(_r1); const ctx_r1 = i0.ɵɵnextContext(); return i0.ɵɵresetView(ctx_r1.onCancelButtonClick()); });
    i0.ɵɵelement(1, "sd-icon", 4);
    i0.ɵɵelementEnd();
} if (rf & 2) {
    const ctx_r1 = i0.ɵɵnextContext();
    i0.ɵɵadvance();
    i0.ɵɵproperty("icon", ctx_r1.icons.xmark);
} }
function SdSelectModalButtonControl_Conditional_3_Template(rf, ctx) { if (rf & 1) {
    const _r3 = i0.ɵɵgetCurrentView();
    i0.ɵɵelementStart(0, "sd-button", 5);
    i0.ɵɵlistener("click", function SdSelectModalButtonControl_Conditional_3_Template_sd_button_click_0_listener($event) { i0.ɵɵrestoreView(_r3); const ctx_r1 = i0.ɵɵnextContext(); return i0.ɵɵresetView(ctx_r1.onModalButtonClick($event)); });
    i0.ɵɵelement(1, "sd-icon", 4);
    i0.ɵɵelementEnd();
} if (rf & 2) {
    const ctx_r1 = i0.ɵɵnextContext();
    i0.ɵɵadvance();
    i0.ɵɵproperty("icon", ctx_r1.icons.search);
} }
export class SdSelectModalButtonControl {
    constructor() {
        this.icons = inject(SdAngularConfigProvider).icons;
        this._sdModal = inject(SdModalProvider);
        this.value = model();
        this.disabled = input(false, { transform: transformBoolean });
        this.required = input(false, { transform: transformBoolean });
        this.inset = input(false, { transform: transformBoolean });
        this.size = input();
        this.selectMode = input("single");
        this.modal = input.required();
        this.isNoValue = $computed(() => {
            return (this.value() == null ||
                (this.selectMode() === "multi" && this.value().length === 0));
        });
        setupInvalid(() => (this.required() && this.value() == null ? "값을 입력하세요." : ""));
    }
    async onModalButtonClick(event) {
        event.preventDefault();
        event.stopPropagation();
        const modal = this.modal();
        const result = await this._sdModal.showAsync({
            ...modal,
            inputs: {
                selectMode: this.selectMode(),
                selectedItemKeys: (this.selectMode() === "multi"
                    ? this.value()
                    : [this.value()]).filterExists(),
                ...modal.inputs,
            },
        });
        if (result) {
            const newValue = this.selectMode() === "multi" ? result.selectedItemKeys : result.selectedItemKeys[0];
            this.value.set(newValue);
        }
    }
    onCancelButtonClick() {
        this.value.set((this.selectMode() === "multi" ? [] : undefined));
    }
    static { this.ɵfac = function SdSelectModalButtonControl_Factory(__ngFactoryType__) { return new (__ngFactoryType__ || SdSelectModalButtonControl)(); }; }
    static { this.ɵcmp = /*@__PURE__*/ i0.ɵɵdefineComponent({ type: SdSelectModalButtonControl, selectors: [["sd-select-modal-button"]], inputs: { value: [1, "value"], disabled: [1, "disabled"], required: [1, "required"], inset: [1, "inset"], size: [1, "size"], selectMode: [1, "selectMode"], modal: [1, "modal"] }, outputs: { value: "valueChange" }, ngContentSelectors: _c0, decls: 4, vars: 4, consts: [[3, "inset", "size"], ["theme", "danger"], ["inset", ""], ["theme", "danger", 3, "click"], [3, "icon"], ["inset", "", 3, "click"]], template: function SdSelectModalButtonControl_Template(rf, ctx) { if (rf & 1) {
            i0.ɵɵprojectionDef();
            i0.ɵɵelementStart(0, "sd-additional-button", 0);
            i0.ɵɵprojection(1);
            i0.ɵɵtemplate(2, SdSelectModalButtonControl_Conditional_2_Template, 2, 1, "sd-anchor", 1)(3, SdSelectModalButtonControl_Conditional_3_Template, 2, 1, "sd-button", 2);
            i0.ɵɵelementEnd();
        } if (rf & 2) {
            i0.ɵɵproperty("inset", ctx.inset())("size", ctx.size());
            i0.ɵɵadvance(2);
            i0.ɵɵconditional(!ctx.disabled() && !ctx.isNoValue() ? 2 : -1);
            i0.ɵɵadvance();
            i0.ɵɵconditional(!ctx.disabled() ? 3 : -1);
        } }, dependencies: [SdAdditionalButtonControl, SdIconControl, SdButtonControl, SdAnchorControl], styles: ["sd-select-modal-button{display:block;width:100%;min-width:10em}\n"], encapsulation: 2, changeDetection: 0 }); }
}
(() => { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(SdSelectModalButtonControl, [{
        type: Component,
        args: [{ selector: "sd-select-modal-button", changeDetection: ChangeDetectionStrategy.OnPush, encapsulation: ViewEncapsulation.None, standalone: true, imports: [SdAdditionalButtonControl, SdIconControl, SdButtonControl, SdAnchorControl], template: `
    <sd-additional-button [inset]="inset()" [size]="size()">
      <ng-content />

      @if (!disabled() && !isNoValue()) {
        <sd-anchor (click)="onCancelButtonClick()" theme="danger">
          <sd-icon [icon]="icons.xmark" />
        </sd-anchor>
      }

      @if (!disabled()) {
        <sd-button (click)="onModalButtonClick($event)" inset>
          <sd-icon [icon]="icons.search" />
        </sd-button>
      }
    </sd-additional-button>
  `, styles: ["sd-select-modal-button{display:block;width:100%;min-width:10em}\n"] }]
    }], () => [], null); })();
(() => { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassDebugInfo(SdSelectModalButtonControl, { className: "SdSelectModalButtonControl", filePath: "packages/sd-angular/src/advanced/sd-select-modal-button.control.ts", lineNumber: 54 }); })();
//# sourceMappingURL=sd-select-modal-button.control.js.map