import { NgTemplateOutlet } from "@angular/common";
import { ChangeDetectionStrategy, Component, contentChild, input, model, TemplateRef, ViewEncapsulation, } from "@angular/core";
import { SdItemOfTemplateDirective, } from "../../directives/sd-item-of.template-directive";
import { $effect } from "../../utils/bindings/$effect";
import { $signal } from "../../utils/bindings/$signal";
import { transformBoolean } from "../../utils/type-tramsforms";
import { SdSelectModalButtonControl } from "../sd-select-modal-button.control";
import * as i0 from "@angular/core";
const _c0 = (a0, a1, a2) => ({ $implicit: a0, item: a1, index: a2, depth: 0 });
const _forTrack0 = ($index, $item) => $item.__valueKey;
function SdSharedDataSelectModalButtonControl_For_2_Conditional_0_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "div", 1);
    i0.ɵɵtext(1, ",\u00A0");
    i0.ɵɵelementEnd();
} }
function SdSharedDataSelectModalButtonControl_For_2_ng_template_2_Template(rf, ctx) { }
function SdSharedDataSelectModalButtonControl_For_2_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵtemplate(0, SdSharedDataSelectModalButtonControl_For_2_Conditional_0_Template, 2, 0, "div", 1);
    i0.ɵɵelementStart(1, "div", 1);
    i0.ɵɵtemplate(2, SdSharedDataSelectModalButtonControl_For_2_ng_template_2_Template, 0, 0, "ng-template", 2);
    i0.ɵɵelementEnd();
} if (rf & 2) {
    const item_r1 = ctx.$implicit;
    const ɵ$index_3_r2 = ctx.$index;
    const ctx_r2 = i0.ɵɵnextContext();
    i0.ɵɵconditional(ɵ$index_3_r2 !== 0 ? 0 : -1);
    i0.ɵɵadvance(2);
    i0.ɵɵproperty("ngTemplateOutlet", ctx_r2.itemTemplateRef())("ngTemplateOutletContext", i0.ɵɵpureFunction3(3, _c0, item_r1, item_r1, ɵ$index_3_r2));
} }
export class SdSharedDataSelectModalButtonControl {
    constructor() {
        this.required = input(false, { transform: transformBoolean });
        this.disabled = input(false, { transform: transformBoolean });
        this.inset = input(false, { transform: transformBoolean });
        this.size = input();
        this.selectMode = input("single");
        this.value = model();
        this.items = input([]);
        this.selectedItems = $signal([]);
        this.modal = input.required();
        this.itemTemplateRef = contentChild.required(SdItemOfTemplateDirective, {
            read: TemplateRef,
        });
        $effect([this.value, this.selectMode, this.items], () => {
            const value = this.value();
            if (this.selectMode() === "multi" && value instanceof Array && value.length > 0) {
                this.selectedItems.set(this.items().filter((item) => value.includes(item.__valueKey)));
            }
            else if (this.selectMode() === "single" && !(value instanceof Array) && value != null) {
                this.selectedItems.set(this.items().filter((item) => item.__valueKey === value));
            }
            else {
                this.selectedItems.set([]);
            }
        });
    }
    static { this.ɵfac = function SdSharedDataSelectModalButtonControl_Factory(__ngFactoryType__) { return new (__ngFactoryType__ || SdSharedDataSelectModalButtonControl)(); }; }
    static { this.ɵcmp = /*@__PURE__*/ i0.ɵɵdefineComponent({ type: SdSharedDataSelectModalButtonControl, selectors: [["sd-shared-data-select-modal-button"]], contentQueries: function SdSharedDataSelectModalButtonControl_ContentQueries(rf, ctx, dirIndex) { if (rf & 1) {
            i0.ɵɵcontentQuerySignal(dirIndex, ctx.itemTemplateRef, SdItemOfTemplateDirective, 5, TemplateRef);
        } if (rf & 2) {
            i0.ɵɵqueryAdvance();
        } }, inputs: { required: [1, "required"], disabled: [1, "disabled"], inset: [1, "inset"], size: [1, "size"], selectMode: [1, "selectMode"], value: [1, "value"], items: [1, "items"], modal: [1, "modal"] }, outputs: { value: "valueChange" }, decls: 3, vars: 7, consts: [[3, "valueChange", "required", "disabled", "inset", "size", "value", "selectMode", "modal"], [2, "display", "inline-block"], [3, "ngTemplateOutlet", "ngTemplateOutletContext"]], template: function SdSharedDataSelectModalButtonControl_Template(rf, ctx) { if (rf & 1) {
            i0.ɵɵelementStart(0, "sd-select-modal-button", 0);
            i0.ɵɵtwoWayListener("valueChange", function SdSharedDataSelectModalButtonControl_Template_sd_select_modal_button_valueChange_0_listener($event) { i0.ɵɵtwoWayBindingSet(ctx.value, $event) || (ctx.value = $event); return $event; });
            i0.ɵɵrepeaterCreate(1, SdSharedDataSelectModalButtonControl_For_2_Template, 3, 7, null, null, _forTrack0);
            i0.ɵɵelementEnd();
        } if (rf & 2) {
            i0.ɵɵproperty("required", ctx.required())("disabled", ctx.disabled())("inset", ctx.inset())("size", ctx.size());
            i0.ɵɵtwoWayProperty("value", ctx.value);
            i0.ɵɵproperty("selectMode", ctx.selectMode())("modal", ctx.modal());
            i0.ɵɵadvance();
            i0.ɵɵrepeater(ctx.selectedItems());
        } }, dependencies: [SdSelectModalButtonControl, NgTemplateOutlet], encapsulation: 2, changeDetection: 0 }); }
}
(() => { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(SdSharedDataSelectModalButtonControl, [{
        type: Component,
        args: [{
                selector: "sd-shared-data-select-modal-button",
                changeDetection: ChangeDetectionStrategy.OnPush,
                encapsulation: ViewEncapsulation.None,
                standalone: true,
                imports: [SdSelectModalButtonControl, NgTemplateOutlet],
                template: `
    <sd-select-modal-button
      [required]="required()"
      [disabled]="disabled()"
      [inset]="inset()"
      [size]="size()"
      [(value)]="value"
      [selectMode]="selectMode()"
      [modal]="modal()"
    >
      @for (item of selectedItems(); track item.__valueKey; let index = $index) {
        @if (index !== 0) {
          <div style="display: inline-block">,&nbsp;</div>
        }
        <div style="display: inline-block">
          <ng-template
            [ngTemplateOutlet]="itemTemplateRef()"
            [ngTemplateOutletContext]="{
              $implicit: item,
              item: item,
              index: index,
              depth: 0,
            }"
          ></ng-template>
        </div>
      }
    </sd-select-modal-button>
  `,
            }]
    }], () => [], null); })();
(() => { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassDebugInfo(SdSharedDataSelectModalButtonControl, { className: "SdSharedDataSelectModalButtonControl", filePath: "packages/sd-angular/src/advanced/shared-data/sd-shared-data-select-modal-button.control.ts", lineNumber: 57 }); })();
//# sourceMappingURL=sd-shared-data-select-modal-button.control.js.map