import { NgTemplateOutlet } from "@angular/common";
import { ChangeDetectionStrategy, Component, contentChild, inject, input, model, TemplateRef, ViewEncapsulation, } from "@angular/core";
import { StringUtils } from "@simplysm/sd-core-common";
import { SdAnchorControl } from "../../controls/sd-anchor.control";
import { SdBusyContainerControl } from "../../controls/sd-busy-container.control";
import { SdDockContainerControl } from "../../controls/sd-dock-container.control";
import { SdDockControl } from "../../controls/sd-dock.control";
import { SdIconControl } from "../../controls/sd-icon.control";
import { SdListItemControl } from "../../controls/sd-list-item.control";
import { SdListControl } from "../../controls/sd-list.control";
import { SdPaginationControl } from "../../controls/sd-pagination.control";
import { SdPaneControl } from "../../controls/sd-pane.control";
import { SdTextfieldControl } from "../../controls/sd-textfield.control";
import { SdItemOfTemplateDirective, } from "../../directives/sd-item-of.template-directive";
import { SdAngularConfigProvider } from "../../providers/sd-angular-config.provider";
import { SdModalProvider } from "../../providers/sd-modal.provider";
import { $computed } from "../../utils/bindings/$computed";
import { $effect } from "../../utils/bindings/$effect";
import { $signal } from "../../utils/bindings/$signal";
import { transformBoolean } from "../../utils/type-tramsforms";
import { setupModelHook } from "../../utils/setups/setup-model-hook";
import * as i0 from "@angular/core";
const _c0 = ["headerTemplate"];
const _c1 = ["filterTemplate"];
const _c2 = ["undefinedTemplate"];
const _c3 = (a0, a1, a2) => ({ $implicit: a0, item: a1, index: a2, depth: 0 });
const _forTrack0 = ($index, $item) => $item.__valueKey;
function SdSharedDataSelectViewControl_Conditional_2_Conditional_3_ng_template_0_Template(rf, ctx) { }
function SdSharedDataSelectViewControl_Conditional_2_Conditional_3_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵtemplate(0, SdSharedDataSelectViewControl_Conditional_2_Conditional_3_ng_template_0_Template, 0, 0, "ng-template", 3);
} if (rf & 2) {
    const ctx_r0 = i0.ɵɵnextContext(2);
    i0.ɵɵproperty("ngTemplateOutlet", ctx_r0.headerTemplateRef());
} }
function SdSharedDataSelectViewControl_Conditional_2_Conditional_4_Template(rf, ctx) { if (rf & 1) {
    const _r2 = i0.ɵɵgetCurrentView();
    i0.ɵɵelementStart(0, "div")(1, "sd-anchor", 8);
    i0.ɵɵlistener("click", function SdSharedDataSelectViewControl_Conditional_2_Conditional_4_Template_sd_anchor_click_1_listener() { i0.ɵɵrestoreView(_r2); const ctx_r0 = i0.ɵɵnextContext(2); return i0.ɵɵresetView(ctx_r0.onModalButtonClick()); });
    i0.ɵɵelement(2, "sd-icon", 9);
    i0.ɵɵelementEnd()();
} if (rf & 2) {
    const ctx_r0 = i0.ɵɵnextContext(2);
    i0.ɵɵadvance(2);
    i0.ɵɵproperty("icon", ctx_r0.icons.externalLink);
} }
function SdSharedDataSelectViewControl_Conditional_2_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "sd-dock", 1)(1, "div", 6)(2, "div", 7);
    i0.ɵɵtemplate(3, SdSharedDataSelectViewControl_Conditional_2_Conditional_3_Template, 1, 1, null, 3);
    i0.ɵɵelementEnd();
    i0.ɵɵtemplate(4, SdSharedDataSelectViewControl_Conditional_2_Conditional_4_Template, 3, 1, "div");
    i0.ɵɵelementEnd()();
} if (rf & 2) {
    const ctx_r0 = i0.ɵɵnextContext();
    i0.ɵɵadvance(3);
    i0.ɵɵconditional(ctx_r0.headerTemplateRef() ? 3 : -1);
    i0.ɵɵadvance();
    i0.ɵɵconditional(ctx_r0.modal() ? 4 : -1);
} }
function SdSharedDataSelectViewControl_Conditional_4_Template(rf, ctx) { if (rf & 1) {
    const _r3 = i0.ɵɵgetCurrentView();
    i0.ɵɵelementStart(0, "sd-textfield", 10);
    i0.ɵɵtwoWayListener("valueChange", function SdSharedDataSelectViewControl_Conditional_4_Template_sd_textfield_valueChange_0_listener($event) { i0.ɵɵrestoreView(_r3); const ctx_r0 = i0.ɵɵnextContext(); i0.ɵɵtwoWayBindingSet(ctx_r0.searchText, $event) || (ctx_r0.searchText = $event); return i0.ɵɵresetView($event); });
    i0.ɵɵelementEnd();
} if (rf & 2) {
    const ctx_r0 = i0.ɵɵnextContext();
    i0.ɵɵtwoWayProperty("value", ctx_r0.searchText);
} }
function SdSharedDataSelectViewControl_Conditional_5_ng_template_0_Template(rf, ctx) { }
function SdSharedDataSelectViewControl_Conditional_5_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵtemplate(0, SdSharedDataSelectViewControl_Conditional_5_ng_template_0_Template, 0, 0, "ng-template", 3);
} if (rf & 2) {
    const ctx_r0 = i0.ɵɵnextContext();
    i0.ɵɵproperty("ngTemplateOutlet", ctx_r0.filterTemplateRef());
} }
function SdSharedDataSelectViewControl_Conditional_6_Template(rf, ctx) { if (rf & 1) {
    const _r4 = i0.ɵɵgetCurrentView();
    i0.ɵɵelementStart(0, "sd-dock", 1)(1, "sd-pagination", 11);
    i0.ɵɵtwoWayListener("currentPageChange", function SdSharedDataSelectViewControl_Conditional_6_Template_sd_pagination_currentPageChange_1_listener($event) { i0.ɵɵrestoreView(_r4); const ctx_r0 = i0.ɵɵnextContext(); i0.ɵɵtwoWayBindingSet(ctx_r0.page, $event) || (ctx_r0.page = $event); return i0.ɵɵresetView($event); });
    i0.ɵɵelementEnd()();
} if (rf & 2) {
    const ctx_r0 = i0.ɵɵnextContext();
    i0.ɵɵadvance();
    i0.ɵɵtwoWayProperty("currentPage", ctx_r0.page);
    i0.ɵɵproperty("totalPageCount", ctx_r0.pageLength());
} }
function SdSharedDataSelectViewControl_Conditional_9_Conditional_1_ng_template_0_Template(rf, ctx) { }
function SdSharedDataSelectViewControl_Conditional_9_Conditional_1_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵtemplate(0, SdSharedDataSelectViewControl_Conditional_9_Conditional_1_ng_template_0_Template, 0, 0, "ng-template", 3);
} if (rf & 2) {
    const ctx_r0 = i0.ɵɵnextContext(2);
    i0.ɵɵproperty("ngTemplateOutlet", ctx_r0.undefinedTemplateRef());
} }
function SdSharedDataSelectViewControl_Conditional_9_Conditional_2_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "span", 13);
    i0.ɵɵtext(1, "\uBBF8\uC9C0\uC815");
    i0.ɵɵelementEnd();
} }
function SdSharedDataSelectViewControl_Conditional_9_Template(rf, ctx) { if (rf & 1) {
    const _r5 = i0.ɵɵgetCurrentView();
    i0.ɵɵelementStart(0, "sd-list-item", 12);
    i0.ɵɵlistener("click", function SdSharedDataSelectViewControl_Conditional_9_Template_sd_list_item_click_0_listener() { i0.ɵɵrestoreView(_r5); const ctx_r0 = i0.ɵɵnextContext(); return i0.ɵɵresetView(ctx_r0.select(undefined)); });
    i0.ɵɵtemplate(1, SdSharedDataSelectViewControl_Conditional_9_Conditional_1_Template, 1, 1, null, 3)(2, SdSharedDataSelectViewControl_Conditional_9_Conditional_2_Template, 2, 0, "span", 13);
    i0.ɵɵelementEnd();
} if (rf & 2) {
    const ctx_r0 = i0.ɵɵnextContext();
    i0.ɵɵproperty("selected", ctx_r0.selectedItem() === undefined)("selectedIcon", ctx_r0.selectedIcon());
    i0.ɵɵadvance();
    i0.ɵɵconditional(ctx_r0.undefinedTemplateRef() ? 1 : 2);
} }
function SdSharedDataSelectViewControl_For_11_ng_template_1_Template(rf, ctx) { }
function SdSharedDataSelectViewControl_For_11_Template(rf, ctx) { if (rf & 1) {
    const _r6 = i0.ɵɵgetCurrentView();
    i0.ɵɵelementStart(0, "sd-list-item", 12);
    i0.ɵɵlistener("click", function SdSharedDataSelectViewControl_For_11_Template_sd_list_item_click_0_listener() { const item_r7 = i0.ɵɵrestoreView(_r6).$implicit; const ctx_r0 = i0.ɵɵnextContext(); return i0.ɵɵresetView(ctx_r0.toggle(item_r7)); });
    i0.ɵɵtemplate(1, SdSharedDataSelectViewControl_For_11_ng_template_1_Template, 0, 0, "ng-template", 14);
    i0.ɵɵelementEnd();
} if (rf & 2) {
    let tmp_13_0;
    const item_r7 = ctx.$implicit;
    const ɵ$index_49_r8 = ctx.$index;
    const ctx_r0 = i0.ɵɵnextContext();
    i0.ɵɵproperty("selected", ctx_r0.selectedItem() === item_r7)("selectedIcon", ctx_r0.selectedIcon());
    i0.ɵɵadvance();
    i0.ɵɵproperty("ngTemplateOutlet", (tmp_13_0 = ctx_r0.itemTemplateRef()) !== null && tmp_13_0 !== undefined ? tmp_13_0 : null)("ngTemplateOutletContext", i0.ɵɵpureFunction3(4, _c3, item_r7, item_r7, ɵ$index_49_r8));
} }
export class SdSharedDataSelectViewControl {
    constructor() {
        this.icons = inject(SdAngularConfigProvider).icons;
        this._sdModal = inject(SdModalProvider);
        this.selectedItem = model();
        this.beforeSelectFn = input(() => true);
        this.items = input.required();
        this.selectedIcon = input();
        this.useUndefined = input(false, { transform: transformBoolean });
        this.filterFn = input();
        this.modal = input();
        this.headerTemplateRef = contentChild("headerTemplate", { read: TemplateRef });
        this.filterTemplateRef = contentChild("filterTemplate", { read: TemplateRef });
        this.itemTemplateRef = contentChild(SdItemOfTemplateDirective, {
            read: TemplateRef,
        });
        this.undefinedTemplateRef = contentChild("undefinedTemplate", {
            read: TemplateRef,
        });
        this.busyCount = $signal(0);
        this.searchText = $signal();
        this.pageItemCount = input();
        this.page = $signal(0);
        this.pageLength = $computed(() => {
            if (Boolean(this.pageItemCount())) {
                return Math.ceil(this.items().length / this.pageItemCount());
            }
            return 0;
        });
        this.displayItems = $computed(() => {
            let result = this.items().filter((item) => !item.__isHidden);
            if (!StringUtils.isNullOrEmpty(this.searchText())) {
                result = result.filter((item) => item.__searchText.includes(this.searchText()));
            }
            if (this.filterFn()) {
                result = result.filter((item, i) => this.filterFn()(item, i));
            }
            if (Boolean(this.pageItemCount())) {
                result = result.slice(this.pageItemCount() * this.page(), this.pageItemCount() * (this.page() + 1));
            }
            return result;
        });
        setupModelHook(this.selectedItem, this.beforeSelectFn);
        $effect([this.items], () => {
            const newSelectedItem = this.items().single((item) => item.__valueKey === this.selectedItem()?.__valueKey);
            this.selectedItem.set(newSelectedItem);
        });
    }
    select(item) {
        this.selectedItem.set(item);
    }
    toggle(item) {
        this.selectedItem.update((v) => (v === item ? undefined : item));
    }
    async onModalButtonClick() {
        const modal = this.modal();
        if (!modal)
            return;
        const result = await this._sdModal.showAsync({
            ...modal,
            inputs: {
                selectMode: "single",
                selectedItemKeys: [this.selectedItem()].filterExists().map((item) => item.__valueKey),
                ...modal.inputs,
            },
        });
        if (result) {
            const newSelectedItem = this.items().single((item) => item.__valueKey === result.selectedItemKeys[0]);
            this.selectedItem.set(newSelectedItem);
        }
    }
    static { this.ɵfac = function SdSharedDataSelectViewControl_Factory(__ngFactoryType__) { return new (__ngFactoryType__ || SdSharedDataSelectViewControl)(); }; }
    static { this.ɵcmp = /*@__PURE__*/ i0.ɵɵdefineComponent({ type: SdSharedDataSelectViewControl, selectors: [["sd-shared-data-select-view"]], contentQueries: function SdSharedDataSelectViewControl_ContentQueries(rf, ctx, dirIndex) { if (rf & 1) {
            i0.ɵɵcontentQuerySignal(dirIndex, ctx.headerTemplateRef, _c0, 5, TemplateRef);
            i0.ɵɵcontentQuerySignal(dirIndex, ctx.filterTemplateRef, _c1, 5, TemplateRef);
            i0.ɵɵcontentQuerySignal(dirIndex, ctx.itemTemplateRef, SdItemOfTemplateDirective, 5, TemplateRef);
            i0.ɵɵcontentQuerySignal(dirIndex, ctx.undefinedTemplateRef, _c2, 5, TemplateRef);
        } if (rf & 2) {
            i0.ɵɵqueryAdvance(4);
        } }, inputs: { selectedItem: [1, "selectedItem"], beforeSelectFn: [1, "beforeSelectFn"], items: [1, "items"], selectedIcon: [1, "selectedIcon"], useUndefined: [1, "useUndefined"], filterFn: [1, "filterFn"], modal: [1, "modal"], pageItemCount: [1, "pageItemCount"] }, outputs: { selectedItem: "selectedItemChange" }, decls: 12, vars: 5, consts: [[3, "busy"], [1, "pb-default"], ["type", "text", "placeholder", "\uAC80\uC0C9\uC5B4", 3, "value"], [3, "ngTemplateOutlet"], ["inset", ""], [3, "selected", "selectedIcon"], [1, "flex-row"], [1, "flex-grow"], [3, "click"], ["fixedWidth", "", 3, "icon"], ["type", "text", "placeholder", "\uAC80\uC0C9\uC5B4", 3, "valueChange", "value"], [3, "currentPageChange", "currentPage", "totalPageCount"], [3, "click", "selected", "selectedIcon"], [1, "tx-theme-grey-default"], [3, "ngTemplateOutlet", "ngTemplateOutletContext"]], template: function SdSharedDataSelectViewControl_Template(rf, ctx) { if (rf & 1) {
            i0.ɵɵelementStart(0, "sd-busy-container", 0)(1, "sd-dock-container");
            i0.ɵɵtemplate(2, SdSharedDataSelectViewControl_Conditional_2_Template, 5, 2, "sd-dock", 1);
            i0.ɵɵelementStart(3, "sd-dock", 1);
            i0.ɵɵtemplate(4, SdSharedDataSelectViewControl_Conditional_4_Template, 1, 1, "sd-textfield", 2)(5, SdSharedDataSelectViewControl_Conditional_5_Template, 1, 1, null, 3);
            i0.ɵɵelementEnd();
            i0.ɵɵtemplate(6, SdSharedDataSelectViewControl_Conditional_6_Template, 2, 2, "sd-dock", 1);
            i0.ɵɵelementStart(7, "sd-pane")(8, "sd-list", 4);
            i0.ɵɵtemplate(9, SdSharedDataSelectViewControl_Conditional_9_Template, 3, 3, "sd-list-item", 5);
            i0.ɵɵrepeaterCreate(10, SdSharedDataSelectViewControl_For_11_Template, 2, 8, "sd-list-item", 5, _forTrack0);
            i0.ɵɵelementEnd()()()();
        } if (rf & 2) {
            i0.ɵɵproperty("busy", ctx.busyCount() > 0);
            i0.ɵɵadvance(2);
            i0.ɵɵconditional(ctx.headerTemplateRef() || ctx.modal() ? 2 : -1);
            i0.ɵɵadvance(2);
            i0.ɵɵconditional(!ctx.filterTemplateRef() ? 4 : 5);
            i0.ɵɵadvance(2);
            i0.ɵɵconditional(ctx.pageItemCount() ? 6 : -1);
            i0.ɵɵadvance(3);
            i0.ɵɵconditional(ctx.useUndefined() ? 9 : -1);
            i0.ɵɵadvance();
            i0.ɵɵrepeater(ctx.displayItems());
        } }, dependencies: [SdBusyContainerControl,
            SdDockContainerControl,
            SdDockControl,
            NgTemplateOutlet,
            SdTextfieldControl,
            SdListControl,
            SdPaneControl,
            SdListItemControl,
            SdAnchorControl,
            SdIconControl,
            SdPaginationControl], encapsulation: 2, changeDetection: 0 }); }
}
(() => { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(SdSharedDataSelectViewControl, [{
        type: Component,
        args: [{
                selector: "sd-shared-data-select-view",
                changeDetection: ChangeDetectionStrategy.OnPush,
                encapsulation: ViewEncapsulation.None,
                standalone: true,
                imports: [
                    SdBusyContainerControl,
                    SdDockContainerControl,
                    SdDockControl,
                    NgTemplateOutlet,
                    SdTextfieldControl,
                    SdListControl,
                    SdPaneControl,
                    SdListItemControl,
                    SdAnchorControl,
                    SdIconControl,
                    SdPaginationControl,
                ],
                template: `
    <sd-busy-container [busy]="busyCount() > 0">
      <sd-dock-container>
        @if (headerTemplateRef() || modal()) {
          <sd-dock class="pb-default">
            <div class="flex-row">
              <div class="flex-grow">
                @if (headerTemplateRef()) {
                  <ng-template [ngTemplateOutlet]="headerTemplateRef()!"></ng-template>
                }
              </div>
              @if (modal()) {
                <div>
                  <sd-anchor (click)="onModalButtonClick()">
                    <sd-icon [icon]="icons.externalLink" fixedWidth />
                  </sd-anchor>
                </div>
              }
            </div>
          </sd-dock>
        }

        <sd-dock class="pb-default">
          @if (!filterTemplateRef()) {
            <sd-textfield type="text" placeholder="검색어" [(value)]="searchText" />
          } @else {
            <ng-template [ngTemplateOutlet]="filterTemplateRef()!" />
          }
        </sd-dock>

        @if (pageItemCount()) {
          <sd-dock class="pb-default">
            <sd-pagination [(currentPage)]="page" [totalPageCount]="pageLength()" />
          </sd-dock>
        }

        <sd-pane>
          <sd-list inset>
            @if (useUndefined()) {
              <sd-list-item
                [selected]="selectedItem() === undefined"
                (click)="select(undefined)"
                [selectedIcon]="selectedIcon()"
              >
                @if (undefinedTemplateRef()) {
                  <ng-template [ngTemplateOutlet]="undefinedTemplateRef()!" />
                } @else {
                  <span class="tx-theme-grey-default">미지정</span>
                }
              </sd-list-item>
            }
            @for (item of displayItems(); let index = $index; track item.__valueKey) {
              <sd-list-item
                [selected]="selectedItem() === item"
                (click)="toggle(item)"
                [selectedIcon]="selectedIcon()"
              >
                <ng-template
                  [ngTemplateOutlet]="itemTemplateRef() ?? null"
                  [ngTemplateOutletContext]="{
                    $implicit: item,
                    item: item,
                    index: index,
                    depth: 0,
                  }"
                ></ng-template>
              </sd-list-item>
            }
          </sd-list>
        </sd-pane>
      </sd-dock-container>
    </sd-busy-container>
  `,
            }]
    }], () => [], null); })();
(() => { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassDebugInfo(SdSharedDataSelectViewControl, { className: "SdSharedDataSelectViewControl", filePath: "packages/sd-angular/src/advanced/shared-data/sd-shared-data-select-view.control.ts", lineNumber: 130 }); })();
//# sourceMappingURL=sd-shared-data-select-view.control.js.map