import { TemplateRef } from "@angular/core";
import { TSelectValue } from "../../controls/sd-select-control";
import { SdItemOfTemplateContext } from "../../directives/sd-item-of.template-directive";
import { ISdModal, ISdModalInput } from "../../providers/sd-modal.provider";
import { TSdSelectModalInput } from "../sd-select-modal-button.control";
import { ISharedDataBase } from "./sd-shared-data.provider";
import * as i0 from "@angular/core";
export declare class SdSharedDataSelectControl<T extends ISharedDataBase<string | number>, M extends keyof TSelectValue<T>> {
    protected readonly icons: import("../../providers/sd-angular-config.provider").ISdAngularIcon;
    private _sdModal;
    value: import("@angular/core").ModelSignal<TSelectValue<T["__valueKey"] | undefined>[M] | undefined>;
    items: import("@angular/core").InputSignal<T[]>;
    disabled: import("@angular/core").InputSignalWithTransform<boolean, boolean | "" | undefined>;
    required: import("@angular/core").InputSignalWithTransform<boolean, boolean | "" | undefined>;
    useUndefined: import("@angular/core").InputSignalWithTransform<boolean, boolean | "" | undefined>;
    inset: import("@angular/core").InputSignalWithTransform<boolean, boolean | "" | undefined>;
    inline: import("@angular/core").InputSignalWithTransform<boolean, boolean | "" | undefined>;
    size: import("@angular/core").InputSignal<"sm" | "lg" | undefined>;
    selectMode: import("@angular/core").InputSignal<M>;
    filterFn: import("@angular/core").InputSignal<((item: T, index: number, ...params: any[]) => boolean) | undefined>;
    filterFnParams: import("@angular/core").InputSignal<any[] | undefined>;
    modal: import("@angular/core").InputSignal<TSdSelectModalInput | undefined>;
    editModal: import("@angular/core").InputSignal<ISdModalInput<ISdModal<boolean>, ""> | undefined>;
    selectClass: import("@angular/core").InputSignal<string | undefined>;
    multiSelectionDisplayDirection: import("@angular/core").InputSignal<"vertical" | "horizontal" | undefined>;
    getIsHiddenFn: import("@angular/core").InputSignal<(item: T, index: number) => boolean>;
    getSearchTextFn: import("@angular/core").InputSignal<(item: T, index: number) => string>;
    parentKeyProp: import("@angular/core").InputSignal<string | undefined>;
    displayOrderKeyProp: import("@angular/core").InputSignal<string | undefined>;
    itemTemplateRef: import("@angular/core").Signal<TemplateRef<SdItemOfTemplateContext<T>> | undefined>;
    undefinedTemplateRef: import("@angular/core").Signal<TemplateRef<void> | undefined>;
    trackByFn: (item: T, index: number) => string | number;
    open: import("../../utils/bindings/$signal").SdWritableSignal<boolean>;
    searchText: import("../../utils/bindings/$signal").SdWritableSignal<string | undefined>;
    itemByParentKeyMap: import("@angular/core").Signal<Map<T["__valueKey"] | undefined, any> | undefined>;
    rootDisplayItems: import("@angular/core").Signal<T[]>;
    getItemSelectable(item: any, index: number, depth: number): boolean;
    getItemVisible(item: any, index: number, depth: number): boolean;
    isIncludeSearchText(item: any, index: number, depth: number): boolean;
    getChildren: (item: ISharedDataBase<string | number>, index: number, depth: number) => any[];
    onOpenChange(): void;
    onModalButtonClick(event: MouseEvent): Promise<void>;
    onEditModalButtonClick(event: MouseEvent): Promise<void>;
    static ɵfac: i0.ɵɵFactoryDeclaration<SdSharedDataSelectControl<any, any>, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<SdSharedDataSelectControl<any, any>, "sd-shared-data-select", never, { "value": { "alias": "value"; "required": false; "isSignal": true; }; "items": { "alias": "items"; "required": true; "isSignal": true; }; "disabled": { "alias": "disabled"; "required": false; "isSignal": true; }; "required": { "alias": "required"; "required": false; "isSignal": true; }; "useUndefined": { "alias": "useUndefined"; "required": false; "isSignal": true; }; "inset": { "alias": "inset"; "required": false; "isSignal": true; }; "inline": { "alias": "inline"; "required": false; "isSignal": true; }; "size": { "alias": "size"; "required": false; "isSignal": true; }; "selectMode": { "alias": "selectMode"; "required": false; "isSignal": true; }; "filterFn": { "alias": "filterFn"; "required": false; "isSignal": true; }; "filterFnParams": { "alias": "filterFnParams"; "required": false; "isSignal": true; }; "modal": { "alias": "modal"; "required": false; "isSignal": true; }; "editModal": { "alias": "editModal"; "required": false; "isSignal": true; }; "selectClass": { "alias": "selectClass"; "required": false; "isSignal": true; }; "multiSelectionDisplayDirection": { "alias": "multiSelectionDisplayDirection"; "required": false; "isSignal": true; }; "getIsHiddenFn": { "alias": "getIsHiddenFn"; "required": false; "isSignal": true; }; "getSearchTextFn": { "alias": "getSearchTextFn"; "required": false; "isSignal": true; }; "parentKeyProp": { "alias": "parentKeyProp"; "required": false; "isSignal": true; }; "displayOrderKeyProp": { "alias": "displayOrderKeyProp"; "required": false; "isSignal": true; }; }, { "value": "valueChange"; }, ["itemTemplateRef", "undefinedTemplateRef"], never, true, never>;
}
