import { Signal } from "@angular/core";
import { SdServiceEventListenerBase } from "@simplysm/sd-service-common";
import * as i0 from "@angular/core";
export interface ISharedSignal<T extends ISharedDataBase<string | number>> extends Signal<T[]> {
    $get(key: T["__valueKey"] | undefined): T | undefined;
}
export declare class SdSharedDataProvider<T extends Record<string, ISharedDataBase<string | number>>> {
    private _sdServiceFactory;
    private _infoMap;
    loadingCount: number;
    register<K extends keyof T & string>(name: K, getter: ISharedDataInfo<T[K]>): void;
    emitAsync<K extends keyof T & string>(name: K, changeKeys?: T[K]["__valueKey"][]): Promise<void>;
    wait(): Promise<void>;
    getSignal<K extends keyof T & string>(name: K): ISharedSignal<T[K]>;
    private _loadDataAsync;
    private _ordering;
    static ɵfac: i0.ɵɵFactoryDeclaration<SdSharedDataProvider<any>, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<SdSharedDataProvider<any>>;
}
export interface ISharedDataInfo<T extends ISharedDataBase<string | number>> {
    serviceKey: string;
    getDataAsync: (changeKeys?: T["__valueKey"][]) => Promise<T[]>;
    orderBy: [(data: T) => any, "asc" | "desc"][];
    filter: any;
}
export interface ISharedDataBase<VK extends string | number> {
    __valueKey: VK;
    __searchText: string;
    __isHidden: boolean;
    __parentKey?: VK;
}
export declare class SdSharedDataChangeEvent extends SdServiceEventListenerBase<{
    name: string;
    filter: any;
}, (string | number)[] | undefined> {
}
