import { ChangeDetectionStrategy, Component, input, ViewEncapsulation } from "@angular/core";
import { transformBoolean } from "../utils/type-tramsforms";
import * as i0 from "@angular/core";
const _c0 = ["*"];
/**
 * 앵커 컨트롤 컴포넌트
 * 클릭 가능한 앵커 링크를 표시하는 컴포넌트
 */
export class SdAnchorControl {
    constructor() {
        /** 비활성화 여부 */
        this.disabled = input(false, { transform: transformBoolean });
        /** 테마 - 컴포넌트의 색상 테마를 설정 */
        this.theme = input("primary");
    }
    static { this.ɵfac = function SdAnchorControl_Factory(__ngFactoryType__) { return new (__ngFactoryType__ || SdAnchorControl)(); }; }
    static { this.ɵcmp = /*@__PURE__*/ i0.ɵɵdefineComponent({ type: SdAnchorControl, selectors: [["sd-anchor"]], hostVars: 3, hostBindings: function SdAnchorControl_HostBindings(rf, ctx) { if (rf & 2) {
            i0.ɵɵattribute("sd-theme", ctx.theme())("sd-disabled", ctx.disabled())("tabindex", ctx.disabled() ? undefined : 0);
        } }, inputs: { disabled: [1, "disabled"], theme: [1, "theme"] }, ngContentSelectors: _c0, decls: 1, vars: 0, template: function SdAnchorControl_Template(rf, ctx) { if (rf & 1) {
            i0.ɵɵprojectionDef();
            i0.ɵɵprojection(0);
        } }, styles: ["sd-anchor{display:inline-block;cursor:pointer}sd-anchor[sd-theme=grey]{color:var(--theme-grey-default)}sd-anchor[sd-theme=grey]:hover{color:var(--theme-grey-darker);text-decoration:underline}sd-anchor[sd-theme=grey]:active{color:var(--theme-grey-default)}@media all and (pointer: coarse){sd-anchor[sd-theme=grey]:hover{color:var(--theme-grey-default);text-decoration:none}}sd-anchor[sd-theme=blue-grey]{color:var(--theme-blue-grey-default)}sd-anchor[sd-theme=blue-grey]:hover{color:var(--theme-blue-grey-darker);text-decoration:underline}sd-anchor[sd-theme=blue-grey]:active{color:var(--theme-blue-grey-default)}@media all and (pointer: coarse){sd-anchor[sd-theme=blue-grey]:hover{color:var(--theme-blue-grey-default);text-decoration:none}}sd-anchor[sd-theme=primary]{color:var(--theme-primary-default)}sd-anchor[sd-theme=primary]:hover{color:var(--theme-primary-darker);text-decoration:underline}sd-anchor[sd-theme=primary]:active{color:var(--theme-primary-default)}@media all and (pointer: coarse){sd-anchor[sd-theme=primary]:hover{color:var(--theme-primary-default);text-decoration:none}}sd-anchor[sd-theme=secondary]{color:var(--theme-secondary-default)}sd-anchor[sd-theme=secondary]:hover{color:var(--theme-secondary-darker);text-decoration:underline}sd-anchor[sd-theme=secondary]:active{color:var(--theme-secondary-default)}@media all and (pointer: coarse){sd-anchor[sd-theme=secondary]:hover{color:var(--theme-secondary-default);text-decoration:none}}sd-anchor[sd-theme=info]{color:var(--theme-info-default)}sd-anchor[sd-theme=info]:hover{color:var(--theme-info-darker);text-decoration:underline}sd-anchor[sd-theme=info]:active{color:var(--theme-info-default)}@media all and (pointer: coarse){sd-anchor[sd-theme=info]:hover{color:var(--theme-info-default);text-decoration:none}}sd-anchor[sd-theme=success]{color:var(--theme-success-default)}sd-anchor[sd-theme=success]:hover{color:var(--theme-success-darker);text-decoration:underline}sd-anchor[sd-theme=success]:active{color:var(--theme-success-default)}@media all and (pointer: coarse){sd-anchor[sd-theme=success]:hover{color:var(--theme-success-default);text-decoration:none}}sd-anchor[sd-theme=warning]{color:var(--theme-warning-default)}sd-anchor[sd-theme=warning]:hover{color:var(--theme-warning-darker);text-decoration:underline}sd-anchor[sd-theme=warning]:active{color:var(--theme-warning-default)}@media all and (pointer: coarse){sd-anchor[sd-theme=warning]:hover{color:var(--theme-warning-default);text-decoration:none}}sd-anchor[sd-theme=danger]{color:var(--theme-danger-default)}sd-anchor[sd-theme=danger]:hover{color:var(--theme-danger-darker);text-decoration:underline}sd-anchor[sd-theme=danger]:active{color:var(--theme-danger-default)}@media all and (pointer: coarse){sd-anchor[sd-theme=danger]:hover{color:var(--theme-danger-default);text-decoration:none}}sd-anchor[sd-disabled=true]{color:var(--theme-grey-light);cursor:default;pointer-events:none}\n"], encapsulation: 2, changeDetection: 0 }); }
}
(() => { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(SdAnchorControl, [{
        type: Component,
        args: [{ selector: "sd-anchor", changeDetection: ChangeDetectionStrategy.OnPush, encapsulation: ViewEncapsulation.None, standalone: true, imports: [], template: `
    <ng-content></ng-content>
  `, host: {
                    "[attr.sd-theme]": "theme()",
                    "[attr.sd-disabled]": "disabled()",
                    "[attr.tabindex]": "disabled() ? undefined : 0",
                }, styles: ["sd-anchor{display:inline-block;cursor:pointer}sd-anchor[sd-theme=grey]{color:var(--theme-grey-default)}sd-anchor[sd-theme=grey]:hover{color:var(--theme-grey-darker);text-decoration:underline}sd-anchor[sd-theme=grey]:active{color:var(--theme-grey-default)}@media all and (pointer: coarse){sd-anchor[sd-theme=grey]:hover{color:var(--theme-grey-default);text-decoration:none}}sd-anchor[sd-theme=blue-grey]{color:var(--theme-blue-grey-default)}sd-anchor[sd-theme=blue-grey]:hover{color:var(--theme-blue-grey-darker);text-decoration:underline}sd-anchor[sd-theme=blue-grey]:active{color:var(--theme-blue-grey-default)}@media all and (pointer: coarse){sd-anchor[sd-theme=blue-grey]:hover{color:var(--theme-blue-grey-default);text-decoration:none}}sd-anchor[sd-theme=primary]{color:var(--theme-primary-default)}sd-anchor[sd-theme=primary]:hover{color:var(--theme-primary-darker);text-decoration:underline}sd-anchor[sd-theme=primary]:active{color:var(--theme-primary-default)}@media all and (pointer: coarse){sd-anchor[sd-theme=primary]:hover{color:var(--theme-primary-default);text-decoration:none}}sd-anchor[sd-theme=secondary]{color:var(--theme-secondary-default)}sd-anchor[sd-theme=secondary]:hover{color:var(--theme-secondary-darker);text-decoration:underline}sd-anchor[sd-theme=secondary]:active{color:var(--theme-secondary-default)}@media all and (pointer: coarse){sd-anchor[sd-theme=secondary]:hover{color:var(--theme-secondary-default);text-decoration:none}}sd-anchor[sd-theme=info]{color:var(--theme-info-default)}sd-anchor[sd-theme=info]:hover{color:var(--theme-info-darker);text-decoration:underline}sd-anchor[sd-theme=info]:active{color:var(--theme-info-default)}@media all and (pointer: coarse){sd-anchor[sd-theme=info]:hover{color:var(--theme-info-default);text-decoration:none}}sd-anchor[sd-theme=success]{color:var(--theme-success-default)}sd-anchor[sd-theme=success]:hover{color:var(--theme-success-darker);text-decoration:underline}sd-anchor[sd-theme=success]:active{color:var(--theme-success-default)}@media all and (pointer: coarse){sd-anchor[sd-theme=success]:hover{color:var(--theme-success-default);text-decoration:none}}sd-anchor[sd-theme=warning]{color:var(--theme-warning-default)}sd-anchor[sd-theme=warning]:hover{color:var(--theme-warning-darker);text-decoration:underline}sd-anchor[sd-theme=warning]:active{color:var(--theme-warning-default)}@media all and (pointer: coarse){sd-anchor[sd-theme=warning]:hover{color:var(--theme-warning-default);text-decoration:none}}sd-anchor[sd-theme=danger]{color:var(--theme-danger-default)}sd-anchor[sd-theme=danger]:hover{color:var(--theme-danger-darker);text-decoration:underline}sd-anchor[sd-theme=danger]:active{color:var(--theme-danger-default)}@media all and (pointer: coarse){sd-anchor[sd-theme=danger]:hover{color:var(--theme-danger-default);text-decoration:none}}sd-anchor[sd-disabled=true]{color:var(--theme-grey-light);cursor:default;pointer-events:none}\n"] }]
    }], null, null); })();
(() => { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassDebugInfo(SdAnchorControl, { className: "SdAnchorControl", filePath: "packages/sd-angular/src/controls/sd-anchor.control.ts", lineNumber: 64 }); })();
//# sourceMappingURL=sd-anchor.control.js.map