import { ElementRef } from "@angular/core";
import * as i0 from "@angular/core";
/**
 * jsbarcode 라이브러리를 사용하여 바코드를 렌더링하는 Angular 컴포넌트입니다.
 * 이 컴포넌트는 구성 가능한 속성을 가진 SVG 바코드를 생성합니다.
 */
export declare class SdBarcodeControl {
    /**
     * 바코드로 인코딩될 값입니다.
     * 이것은 바코드로 표현될 데이터입니다.
     */
    value: import("@angular/core").InputSignal<string | undefined>;
    /**
     * 바코드의 유형/형식입니다.
     * 기본값은 "code128"이지만, jsbarcode에서 지원하는 다른 형식으로 변경할 수 있습니다.
     */
    type: import("@angular/core").InputSignal<string>;
    /**
     * 바코드의 각 라인 너비입니다.
     * 기본값은 1입니다.
     */
    lineWidth: import("@angular/core").InputSignal<number>;
    /**
     * 바코드의 높이(픽셀 단위)입니다.
     * 기본값은 58입니다.
     */
    height: import("@angular/core").InputSignal<number>;
    /**
     * 바코드가 렌더링될 템플릿의 SVG 요소에 대한 참조입니다.
     */
    svgElRef: import("@angular/core").Signal<ElementRef<SVGElement>>;
    /**
     * 컴포넌트를 초기화하고 입력 속성이 변경될 때마다
     * 바코드를 렌더링하는 효과를 설정합니다.
     */
    constructor();
    static ɵfac: i0.ɵɵFactoryDeclaration<SdBarcodeControl, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<SdBarcodeControl, "sd-barcode", never, { "value": { "alias": "value"; "required": false; "isSignal": true; }; "type": { "alias": "type"; "required": false; "isSignal": true; }; "lineWidth": { "alias": "lineWidth"; "required": false; "isSignal": true; }; "height": { "alias": "height"; "required": false; "isSignal": true; }; }, {}, never, never, true, never>;
}
