import { ChangeDetectionStrategy, Component, contentChild, inject, input, TemplateRef, ViewEncapsulation, } from "@angular/core";
import { DateOnly } from "@simplysm/sd-core-common";
import { SdAngularConfigProvider } from "../providers/sd-angular-config.provider";
import { FormatPipe } from "../pipes/format.pipe";
import { SdItemOfTemplateDirective, } from "../directives/sd-item-of.template-directive";
import { NgTemplateOutlet } from "@angular/common";
import { $computed } from "../utils/bindings/$computed";
import * as i0 from "@angular/core";
const _c0 = (a0, a1, a2) => ({ $implicit: a0, item: a1, index: a2, depth: 0 });
function SdCalendarControl_For_19_For_2_For_6_ng_template_0_Template(rf, ctx) { }
function SdCalendarControl_For_19_For_2_For_6_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵtemplate(0, SdCalendarControl_For_19_For_2_For_6_ng_template_0_Template, 0, 0, "ng-template", 3);
} if (rf & 2) {
    const item_r1 = ctx.$implicit;
    const ɵ$index_33_r2 = i0.ɵɵnextContext().$index;
    const ɵ$index_30_r3 = i0.ɵɵnextContext().$index;
    const ctx_r3 = i0.ɵɵnextContext();
    i0.ɵɵproperty("ngTemplateOutlet", ctx_r3.itemTemplateRef())("ngTemplateOutletContext", i0.ɵɵpureFunction3(2, _c0, item_r1, item_r1, ɵ$index_30_r3 * 7 + ɵ$index_33_r2));
} }
function SdCalendarControl_For_19_For_2_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "td")(1, "div", 1);
    i0.ɵɵtext(2);
    i0.ɵɵpipe(3, "format");
    i0.ɵɵelementEnd();
    i0.ɵɵelementStart(4, "div", 2);
    i0.ɵɵrepeaterCreate(5, SdCalendarControl_For_19_For_2_For_6_Template, 1, 6, null, 3, i0.ɵɵrepeaterTrackByIndex);
    i0.ɵɵelementEnd()();
} if (rf & 2) {
    const data_r5 = ctx.$implicit;
    const ctx_r3 = i0.ɵɵnextContext(2);
    i0.ɵɵclassProp("not-current", data_r5.date.month !== ctx_r3.yearMonth().month);
    i0.ɵɵadvance(2);
    i0.ɵɵtextInterpolate1(" ", i0.ɵɵpipeBind2(3, 3, data_r5.date, "d"), " ");
    i0.ɵɵadvance(3);
    i0.ɵɵrepeater(data_r5.items);
} }
function SdCalendarControl_For_19_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "tr");
    i0.ɵɵrepeaterCreate(1, SdCalendarControl_For_19_For_2_Template, 7, 6, "td", 0, i0.ɵɵrepeaterTrackByIndex);
    i0.ɵɵelementEnd();
} if (rf & 2) {
    const row_r6 = ctx.$implicit;
    i0.ɵɵadvance();
    i0.ɵɵrepeater(row_r6);
} }
export class SdCalendarControl {
    constructor() {
        this.icons = inject(SdAngularConfigProvider).icons;
        this.items = input.required();
        this.getItemDateFn = input.required();
        this.yearMonth = input(new DateOnly().setDay(1));
        this.itemTemplateRef = contentChild.required(SdItemOfTemplateDirective, { read: TemplateRef });
        this.weekStartDay = input(0);
        this.minDaysInFirstWeek = input(1);
        this.weeks = ["일", "월", "화", "수", "목", "금", "토"];
        this.dataTable = $computed(() => {
            const result = [];
            const firstDate = this.yearMonth()
                .getWeekSeqStartDate(this.weekStartDay(), this.minDaysInFirstWeek());
            for (let r = 0; r < 6; r++) {
                const row = [];
                for (let c = 0; c < 7; c++) {
                    const date = firstDate.addDays(r * 7 + c);
                    row.push({
                        date,
                        items: this.items()
                            .filter((item, index1) => this.getItemDateFn()(item, index1).tick === date.tick),
                    });
                }
                result.push(row);
            }
            return result;
        });
    }
    static { this.ɵfac = function SdCalendarControl_Factory(__ngFactoryType__) { return new (__ngFactoryType__ || SdCalendarControl)(); }; }
    static { this.ɵcmp = /*@__PURE__*/ i0.ɵɵdefineComponent({ type: SdCalendarControl, selectors: [["sd-calendar"]], contentQueries: function SdCalendarControl_ContentQueries(rf, ctx, dirIndex) { if (rf & 1) {
            i0.ɵɵcontentQuerySignal(dirIndex, ctx.itemTemplateRef, SdItemOfTemplateDirective, 5, TemplateRef);
        } if (rf & 2) {
            i0.ɵɵqueryAdvance();
        } }, inputs: { items: [1, "items"], getItemDateFn: [1, "getItemDateFn"], yearMonth: [1, "yearMonth"], weekStartDay: [1, "weekStartDay"], minDaysInFirstWeek: [1, "minDaysInFirstWeek"] }, decls: 20, vars: 7, consts: [[3, "not-current"], [1, "day"], [1, "content"], [3, "ngTemplateOutlet", "ngTemplateOutletContext"]], template: function SdCalendarControl_Template(rf, ctx) { if (rf & 1) {
            i0.ɵɵelementStart(0, "table")(1, "thead")(2, "tr")(3, "th");
            i0.ɵɵtext(4);
            i0.ɵɵelementEnd();
            i0.ɵɵelementStart(5, "th");
            i0.ɵɵtext(6);
            i0.ɵɵelementEnd();
            i0.ɵɵelementStart(7, "th");
            i0.ɵɵtext(8);
            i0.ɵɵelementEnd();
            i0.ɵɵelementStart(9, "th");
            i0.ɵɵtext(10);
            i0.ɵɵelementEnd();
            i0.ɵɵelementStart(11, "th");
            i0.ɵɵtext(12);
            i0.ɵɵelementEnd();
            i0.ɵɵelementStart(13, "th");
            i0.ɵɵtext(14);
            i0.ɵɵelementEnd();
            i0.ɵɵelementStart(15, "th");
            i0.ɵɵtext(16);
            i0.ɵɵelementEnd()()();
            i0.ɵɵelementStart(17, "tbody");
            i0.ɵɵrepeaterCreate(18, SdCalendarControl_For_19_Template, 3, 0, "tr", null, i0.ɵɵrepeaterTrackByIndex);
            i0.ɵɵelementEnd()();
        } if (rf & 2) {
            i0.ɵɵadvance(4);
            i0.ɵɵtextInterpolate1(" ", ctx.weeks[ctx.weekStartDay() % 7], " ");
            i0.ɵɵadvance(2);
            i0.ɵɵtextInterpolate1(" ", ctx.weeks[(ctx.weekStartDay() + 1) % 7], " ");
            i0.ɵɵadvance(2);
            i0.ɵɵtextInterpolate1(" ", ctx.weeks[(ctx.weekStartDay() + 2) % 7], " ");
            i0.ɵɵadvance(2);
            i0.ɵɵtextInterpolate1(" ", ctx.weeks[(ctx.weekStartDay() + 3) % 7], " ");
            i0.ɵɵadvance(2);
            i0.ɵɵtextInterpolate1(" ", ctx.weeks[(ctx.weekStartDay() + 4) % 7], " ");
            i0.ɵɵadvance(2);
            i0.ɵɵtextInterpolate1(" ", ctx.weeks[(ctx.weekStartDay() + 5) % 7], " ");
            i0.ɵɵadvance(2);
            i0.ɵɵtextInterpolate1(" ", ctx.weeks[(ctx.weekStartDay() + 6) % 7], " ");
            i0.ɵɵadvance(2);
            i0.ɵɵrepeater(ctx.dataTable());
        } }, dependencies: [FormatPipe,
            NgTemplateOutlet], styles: ["sd-calendar>table{border-collapse:collapse;width:100%;height:100%}sd-calendar>table>*>tr>*{padding:var(--gap-sm) var(--gap-default);border:1px solid var(--theme-grey-light);width:14.2857142857%}sd-calendar>table>thead>tr>th{background:var(--theme-grey-lighter);height:10%}sd-calendar>table>tbody>tr>td{vertical-align:top;height:15%}sd-calendar>table>tbody>tr>td>.day{margin-bottom:var(--gap-sm)}sd-calendar>table>tbody>tr>td.not-current{background:var(--theme-grey-lightest)}sd-calendar>table>tbody>tr>td.not-current>.day{color:var(--theme-grey-default)}sd-calendar>table>tbody>tr>td>.content{display:flex;flex-wrap:nowrap;flex-direction:column;gap:var(--gap-sm)}\n"], encapsulation: 2, changeDetection: 0 }); }
}
(() => { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(SdCalendarControl, [{
        type: Component,
        args: [{ selector: "sd-calendar", changeDetection: ChangeDetectionStrategy.OnPush, encapsulation: ViewEncapsulation.None, standalone: true, imports: [
                    FormatPipe,
                    NgTemplateOutlet,
                ], template: `
    <table>
      <thead>
        <tr>
          <th>
            {{ weeks[weekStartDay() % 7] }}
          </th>
          <th>
            {{ weeks[(weekStartDay() + 1) % 7] }}
          </th>
          <th>
            {{ weeks[(weekStartDay() + 2) % 7] }}
          </th>
          <th>
            {{ weeks[(weekStartDay() + 3) % 7] }}
          </th>
          <th>
            {{ weeks[(weekStartDay() + 4) % 7] }}
          </th>
          <th>
            {{ weeks[(weekStartDay() + 5) % 7] }}
          </th>
          <th>
            {{ weeks[(weekStartDay() + 6) % 7] }}
          </th>
        </tr>
      </thead>
      <tbody>
        @for (row of dataTable(); let r = $index; track r) {
          <tr>
            @for (data of row; let c = $index; track c) {
              <td [class.not-current]="data.date.month !== yearMonth().month">
                <div class="day">
                  {{ data.date | format: "d" }}
                </div>
                <div class="content">
                  @for (item of data.items; track $index) {
                    <ng-template
                      [ngTemplateOutlet]="itemTemplateRef()"
                      [ngTemplateOutletContext]="{
                      $implicit: item,
                      item: item,
                      index: r * 7 + c,
                      depth: 0,
                    }"
                    ></ng-template>
                  }
                </div>
              </td>
            }
          </tr>
        }
      </tbody>
    </table>
  `, styles: ["sd-calendar>table{border-collapse:collapse;width:100%;height:100%}sd-calendar>table>*>tr>*{padding:var(--gap-sm) var(--gap-default);border:1px solid var(--theme-grey-light);width:14.2857142857%}sd-calendar>table>thead>tr>th{background:var(--theme-grey-lighter);height:10%}sd-calendar>table>tbody>tr>td{vertical-align:top;height:15%}sd-calendar>table>tbody>tr>td>.day{margin-bottom:var(--gap-sm)}sd-calendar>table>tbody>tr>td.not-current{background:var(--theme-grey-lightest)}sd-calendar>table>tbody>tr>td.not-current>.day{color:var(--theme-grey-default)}sd-calendar>table>tbody>tr>td>.content{display:flex;flex-wrap:nowrap;flex-direction:column;gap:var(--gap-sm)}\n"] }]
    }], null, null); })();
(() => { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassDebugInfo(SdCalendarControl, { className: "SdCalendarControl", filePath: "packages/sd-angular/src/controls/sd-calendar.control.ts", lineNumber: 132 }); })();
//# sourceMappingURL=sd-calendar.control.js.map