import { ChangeDetectionStrategy, Component, forwardRef, inject, input, ViewEncapsulation } from "@angular/core";
import { SdCheckboxGroupControl } from "./sd-checkbox-group.control";
import { SdCheckboxControl } from "./sd-checkbox.control";
import { transformBoolean } from "../utils/type-tramsforms";
import { $computed } from "../utils/bindings/$computed";
import * as i0 from "@angular/core";
const _c0 = ["*"];
export class SdCheckboxGroupItemControl {
    constructor() {
        this._parentControl = inject(forwardRef(() => SdCheckboxGroupControl));
        this.value = input.required();
        this.inline = input(false, { transform: transformBoolean });
        this.isSelected = $computed(() => this._parentControl.value().includes(this.value()));
        this.disabled = $computed(() => this._parentControl.disabled());
    }
    onSelectedChange(selected) {
        this._parentControl.value.update((v) => {
            if (selected) {
                return [...v, this.value()];
            }
            else {
                return v.filter((item) => item !== this.value());
            }
        });
    }
    static { this.ɵfac = function SdCheckboxGroupItemControl_Factory(__ngFactoryType__) { return new (__ngFactoryType__ || SdCheckboxGroupItemControl)(); }; }
    static { this.ɵcmp = /*@__PURE__*/ i0.ɵɵdefineComponent({ type: SdCheckboxGroupItemControl, selectors: [["sd-checkbox-group-item"]], inputs: { value: [1, "value"], inline: [1, "inline"] }, ngContentSelectors: _c0, decls: 2, vars: 3, consts: [[3, "valueChange", "value", "inline", "disabled"]], template: function SdCheckboxGroupItemControl_Template(rf, ctx) { if (rf & 1) {
            i0.ɵɵprojectionDef();
            i0.ɵɵelementStart(0, "sd-checkbox", 0);
            i0.ɵɵlistener("valueChange", function SdCheckboxGroupItemControl_Template_sd_checkbox_valueChange_0_listener($event) { return ctx.onSelectedChange($event); });
            i0.ɵɵprojection(1);
            i0.ɵɵelementEnd();
        } if (rf & 2) {
            i0.ɵɵproperty("value", ctx.isSelected())("inline", ctx.inline())("disabled", ctx.disabled());
        } }, dependencies: [SdCheckboxControl], encapsulation: 2, changeDetection: 0 }); }
}
(() => { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(SdCheckboxGroupItemControl, [{
        type: Component,
        args: [{
                selector: "sd-checkbox-group-item",
                changeDetection: ChangeDetectionStrategy.OnPush,
                encapsulation: ViewEncapsulation.None,
                standalone: true,
                imports: [SdCheckboxControl],
                template: `
    <sd-checkbox
      [value]="isSelected()"
      (valueChange)="onSelectedChange($event)"
      [inline]="inline()"
      [disabled]="disabled()"
    >
      <ng-content></ng-content>
    </sd-checkbox>
  `,
            }]
    }], null, null); })();
(() => { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassDebugInfo(SdCheckboxGroupItemControl, { className: "SdCheckboxGroupItemControl", filePath: "packages/sd-angular/src/controls/sd-checkbox-group-item.control.ts", lineNumber: 24 }); })();
//# sourceMappingURL=sd-checkbox-group-item.control.js.map