import { ChangeDetectionStrategy, Component, HostListener, inject, input, model, ViewEncapsulation, } from "@angular/core";
import { SdAngularConfigProvider } from "../providers/sd-angular-config.provider";
import { setupRipple } from "../utils/setups/setup-ripple";
import { transformBoolean } from "../utils/type-tramsforms";
import { SdIconControl } from "./sd-icon.control";
import { setupModelHook } from "../utils/setups/setup-model-hook";
import * as i0 from "@angular/core";
const _c0 = ["*"];
function SdCheckboxControl_Conditional_2_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelement(0, "sd-icon", 2);
} if (rf & 2) {
    const ctx_r0 = i0.ɵɵnextContext();
    i0.ɵɵproperty("icon", ctx_r0.icon());
} }
function SdCheckboxControl_Conditional_3_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelement(0, "div");
} }
export class SdCheckboxControl {
    constructor() {
        this.icons = inject(SdAngularConfigProvider).icons;
        this.value = model(false);
        this.beforeChangeFn = input(() => true);
        this.icon = input(this.icons.check);
        this.radio = input(false, { transform: transformBoolean });
        this.disabled = input(false, { transform: transformBoolean });
        this.size = input();
        this.inline = input(false, { transform: transformBoolean });
        this.inset = input(false, { transform: transformBoolean });
        this.theme = input();
        this.contentStyle = input();
        setupModelHook(this.value, this.beforeChangeFn);
        setupRipple(() => !this.disabled());
    }
    onClick() {
        if (this.disabled())
            return;
        if (this.radio()) {
            this.value.set(true);
        }
        else {
            this.value.update((v) => !v);
        }
    }
    onKeydown(event) {
        if (event.key === " ") {
            if (this.disabled())
                return;
            if (this.radio()) {
                this.value.set(true);
            }
            else {
                this.value.update((v) => !v);
            }
        }
    }
    static { this.ɵfac = function SdCheckboxControl_Factory(__ngFactoryType__) { return new (__ngFactoryType__ || SdCheckboxControl)(); }; }
    static { this.ɵcmp = /*@__PURE__*/ i0.ɵɵdefineComponent({ type: SdCheckboxControl, selectors: [["sd-checkbox"]], hostVars: 8, hostBindings: function SdCheckboxControl_HostBindings(rf, ctx) { if (rf & 1) {
            i0.ɵɵlistener("click", function SdCheckboxControl_click_HostBindingHandler() { return ctx.onClick(); })("keydown", function SdCheckboxControl_keydown_HostBindingHandler($event) { return ctx.onKeydown($event); });
        } if (rf & 2) {
            i0.ɵɵattribute("sd-checked", ctx.value())("sd-disabled", ctx.disabled())("sd-inline", ctx.inline())("sd-inset", ctx.inset())("sd-radio", ctx.radio())("sd-size", ctx.size())("sd-theme", ctx.theme())("tabindex", 0);
        } }, inputs: { value: [1, "value"], beforeChangeFn: [1, "beforeChangeFn"], icon: [1, "icon"], radio: [1, "radio"], disabled: [1, "disabled"], size: [1, "size"], inline: [1, "inline"], inset: [1, "inset"], theme: [1, "theme"], contentStyle: [1, "contentStyle"] }, outputs: { value: "valueChange" }, ngContentSelectors: _c0, decls: 6, vars: 3, consts: [[1, "_indicator_rect"], [1, "_indicator"], [3, "icon"], [1, "_contents"]], template: function SdCheckboxControl_Template(rf, ctx) { if (rf & 1) {
            i0.ɵɵprojectionDef();
            i0.ɵɵelementStart(0, "div", 0)(1, "div", 1);
            i0.ɵɵtemplate(2, SdCheckboxControl_Conditional_2_Template, 1, 1, "sd-icon", 2)(3, SdCheckboxControl_Conditional_3_Template, 1, 0, "div");
            i0.ɵɵelementEnd()();
            i0.ɵɵelementStart(4, "div", 3);
            i0.ɵɵprojection(5);
            i0.ɵɵelementEnd();
        } if (rf & 2) {
            i0.ɵɵadvance(2);
            i0.ɵɵconditional(!ctx.radio() ? 2 : 3);
            i0.ɵɵadvance(2);
            i0.ɵɵstyleMap(ctx.contentStyle());
        } }, dependencies: [SdIconControl], styles: ["sd-checkbox{display:block;width:100%;padding:var(--gap-sm) var(--gap-default);border:1px solid transparent;font-size:var(--font-size-default);font-family:var(--font-family);font-variant-numeric:tabular-nums;line-height:var(--line-height);color:var(--text-trans-default);color:inherit;cursor:pointer;border-radius:var(--border-radius-xs);height:calc(var(--font-size-default) * var(--line-height-strip-unit) + var(--gap-sm) * 2 + 2px);gap:var(--gap-sm)}sd-checkbox>._indicator_rect{display:inline-block;vertical-align:middle;user-select:none;width:calc(var(--font-size-default) + 2px);height:calc(var(--font-size-default) + 2px);border:1px solid var(--trans-light);background:var(--theme-secondary-lightest);border-radius:var(--border-radius-xs)}sd-checkbox>._indicator_rect>._indicator{text-align:center;opacity:0;color:#fff}sd-checkbox>._indicator_rect>._indicator>sd-icon>svg{vertical-align:top}sd-checkbox ._contents{display:inline-block;vertical-align:top;padding-left:var(--gap-sm)}sd-checkbox>._indicator_rect+._contents:empty{display:none}sd-checkbox:focus>._indicator_rect{border-color:var(--theme-primary-dark)}sd-checkbox[sd-checked=true]>._indicator_rect{background:var(--theme-primary-default)}sd-checkbox[sd-checked=true]>._indicator_rect>._indicator{opacity:1}sd-checkbox[sd-theme=grey]>._indicator_rect{background:var(--theme-grey-lightest)}sd-checkbox[sd-theme=grey]>._indicator_rect>._indicator{color:var(--theme-grey-default)}sd-checkbox[sd-theme=grey]:focus>._indicator_rect{border-color:var(--theme-grey-default)}sd-checkbox[sd-theme=grey][sd-checked=true]>._indicator_rect{background:var(--theme-grey-default)}sd-checkbox[sd-theme=grey][sd-checked=true]>._indicator_rect>._indicator{color:#fff}sd-checkbox[sd-theme=blue-grey]>._indicator_rect{background:var(--theme-blue-grey-lightest)}sd-checkbox[sd-theme=blue-grey]>._indicator_rect>._indicator{color:var(--theme-blue-grey-default)}sd-checkbox[sd-theme=blue-grey]:focus>._indicator_rect{border-color:var(--theme-blue-grey-default)}sd-checkbox[sd-theme=blue-grey][sd-checked=true]>._indicator_rect{background:var(--theme-blue-grey-default)}sd-checkbox[sd-theme=blue-grey][sd-checked=true]>._indicator_rect>._indicator{color:#fff}sd-checkbox[sd-theme=primary]>._indicator_rect{background:var(--theme-primary-lightest)}sd-checkbox[sd-theme=primary]>._indicator_rect>._indicator{color:var(--theme-primary-default)}sd-checkbox[sd-theme=primary]:focus>._indicator_rect{border-color:var(--theme-primary-default)}sd-checkbox[sd-theme=primary][sd-checked=true]>._indicator_rect{background:var(--theme-primary-default)}sd-checkbox[sd-theme=primary][sd-checked=true]>._indicator_rect>._indicator{color:#fff}sd-checkbox[sd-theme=secondary]>._indicator_rect{background:var(--theme-secondary-lightest)}sd-checkbox[sd-theme=secondary]>._indicator_rect>._indicator{color:var(--theme-secondary-default)}sd-checkbox[sd-theme=secondary]:focus>._indicator_rect{border-color:var(--theme-secondary-default)}sd-checkbox[sd-theme=secondary][sd-checked=true]>._indicator_rect{background:var(--theme-secondary-default)}sd-checkbox[sd-theme=secondary][sd-checked=true]>._indicator_rect>._indicator{color:#fff}sd-checkbox[sd-theme=info]>._indicator_rect{background:var(--theme-info-lightest)}sd-checkbox[sd-theme=info]>._indicator_rect>._indicator{color:var(--theme-info-default)}sd-checkbox[sd-theme=info]:focus>._indicator_rect{border-color:var(--theme-info-default)}sd-checkbox[sd-theme=info][sd-checked=true]>._indicator_rect{background:var(--theme-info-default)}sd-checkbox[sd-theme=info][sd-checked=true]>._indicator_rect>._indicator{color:#fff}sd-checkbox[sd-theme=success]>._indicator_rect{background:var(--theme-success-lightest)}sd-checkbox[sd-theme=success]>._indicator_rect>._indicator{color:var(--theme-success-default)}sd-checkbox[sd-theme=success]:focus>._indicator_rect{border-color:var(--theme-success-default)}sd-checkbox[sd-theme=success][sd-checked=true]>._indicator_rect{background:var(--theme-success-default)}sd-checkbox[sd-theme=success][sd-checked=true]>._indicator_rect>._indicator{color:#fff}sd-checkbox[sd-theme=warning]>._indicator_rect{background:var(--theme-warning-lightest)}sd-checkbox[sd-theme=warning]>._indicator_rect>._indicator{color:var(--theme-warning-default)}sd-checkbox[sd-theme=warning]:focus>._indicator_rect{border-color:var(--theme-warning-default)}sd-checkbox[sd-theme=warning][sd-checked=true]>._indicator_rect{background:var(--theme-warning-default)}sd-checkbox[sd-theme=warning][sd-checked=true]>._indicator_rect>._indicator{color:#fff}sd-checkbox[sd-theme=danger]>._indicator_rect{background:var(--theme-danger-lightest)}sd-checkbox[sd-theme=danger]>._indicator_rect>._indicator{color:var(--theme-danger-default)}sd-checkbox[sd-theme=danger]:focus>._indicator_rect{border-color:var(--theme-danger-default)}sd-checkbox[sd-theme=danger][sd-checked=true]>._indicator_rect{background:var(--theme-danger-default)}sd-checkbox[sd-theme=danger][sd-checked=true]>._indicator_rect>._indicator{color:#fff}sd-checkbox[sd-theme=white]>._indicator_rect{background:var(--control-color);border-color:var(--text-trans-lightest)}sd-checkbox[sd-theme=white]:focus>._indicator_rect{border-color:var(--text-trans-default)}sd-checkbox[sd-theme=white][sd-checked=true]>._indicator_rect{background:var(--theme-primary-default)}sd-checkbox[sd-radio=true]>._indicator_rect{border-radius:100%;padding:var(--gap-xs)}sd-checkbox[sd-radio=true]>._indicator_rect>._indicator{border-radius:100%;width:100%;height:100%;background:var(--theme-primary-default)}sd-checkbox[sd-radio=true][sd-checked=true]>._indicator_rect{background:var(--theme-secondary-lightest);border-color:var(--theme-primary-dark)}sd-checkbox[sd-size=sm]{height:calc(var(--font-size-default) * var(--line-height-strip-unit) + var(--gap-xs) * 2 + 2px);padding:var(--gap-xs) var(--gap-sm);gap:var(--gap-xs)}sd-checkbox[sd-size=lg]{height:calc(var(--font-size-default) * var(--line-height-strip-unit) + var(--gap-default) * 2 + 2px);padding:var(--gap-default) var(--gap-lg);gap:var(--gap-default)}sd-checkbox[sd-inset=true]{height:calc(var(--font-size-default) * var(--line-height-strip-unit) + var(--gap-sm) * 2);border:none;justify-content:center}sd-checkbox[sd-inset=true][sd-size=sm]{height:calc(var(--font-size-default) * var(--line-height-strip-unit) + var(--gap-xs) * 2)}sd-checkbox[sd-inset=true][sd-size=lg]{height:calc(var(--font-size-default) * var(--line-height-strip-unit) + var(--gap-default) * 2)}sd-checkbox[sd-inline=true]{display:inline-block;vertical-align:top;padding:0;border:none;height:calc(var(--font-size-default) * var(--line-height-strip-unit));width:auto}sd-checkbox[sd-disabled=true]>._indicator_rect{background:var(--theme-grey-lighter);border:1px solid var(--trans-light)}sd-checkbox[sd-disabled=true]>._indicator_rect>._indicator{color:var(--theme-grey-default)}sd-checkbox[sd-disabled=true]:focus>._indicator_rect{border-color:var(--theme-grey-default)}\n"], encapsulation: 2, changeDetection: 0 }); }
}
(() => { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(SdCheckboxControl, [{
        type: Component,
        args: [{ selector: "sd-checkbox", changeDetection: ChangeDetectionStrategy.OnPush, encapsulation: ViewEncapsulation.None, standalone: true, imports: [SdIconControl], template: `
    <div class="_indicator_rect">
      <div class="_indicator">
        @if (!radio()) {
          <sd-icon [icon]="icon()" />
        } @else {
          <div></div>
        }
      </div>
    </div>
    <div class="_contents" [style]="contentStyle()">
      <ng-content />
    </div>
  `, host: {
                    "[attr.sd-checked]": "value()",
                    "[attr.sd-disabled]": "disabled()",
                    "[attr.sd-inline]": "inline()",
                    "[attr.sd-inset]": "inset()",
                    "[attr.sd-radio]": "radio()",
                    "[attr.sd-size]": "size()",
                    "[attr.sd-theme]": "theme()",
                    "[attr.tabindex]": "0",
                }, styles: ["sd-checkbox{display:block;width:100%;padding:var(--gap-sm) var(--gap-default);border:1px solid transparent;font-size:var(--font-size-default);font-family:var(--font-family);font-variant-numeric:tabular-nums;line-height:var(--line-height);color:var(--text-trans-default);color:inherit;cursor:pointer;border-radius:var(--border-radius-xs);height:calc(var(--font-size-default) * var(--line-height-strip-unit) + var(--gap-sm) * 2 + 2px);gap:var(--gap-sm)}sd-checkbox>._indicator_rect{display:inline-block;vertical-align:middle;user-select:none;width:calc(var(--font-size-default) + 2px);height:calc(var(--font-size-default) + 2px);border:1px solid var(--trans-light);background:var(--theme-secondary-lightest);border-radius:var(--border-radius-xs)}sd-checkbox>._indicator_rect>._indicator{text-align:center;opacity:0;color:#fff}sd-checkbox>._indicator_rect>._indicator>sd-icon>svg{vertical-align:top}sd-checkbox ._contents{display:inline-block;vertical-align:top;padding-left:var(--gap-sm)}sd-checkbox>._indicator_rect+._contents:empty{display:none}sd-checkbox:focus>._indicator_rect{border-color:var(--theme-primary-dark)}sd-checkbox[sd-checked=true]>._indicator_rect{background:var(--theme-primary-default)}sd-checkbox[sd-checked=true]>._indicator_rect>._indicator{opacity:1}sd-checkbox[sd-theme=grey]>._indicator_rect{background:var(--theme-grey-lightest)}sd-checkbox[sd-theme=grey]>._indicator_rect>._indicator{color:var(--theme-grey-default)}sd-checkbox[sd-theme=grey]:focus>._indicator_rect{border-color:var(--theme-grey-default)}sd-checkbox[sd-theme=grey][sd-checked=true]>._indicator_rect{background:var(--theme-grey-default)}sd-checkbox[sd-theme=grey][sd-checked=true]>._indicator_rect>._indicator{color:#fff}sd-checkbox[sd-theme=blue-grey]>._indicator_rect{background:var(--theme-blue-grey-lightest)}sd-checkbox[sd-theme=blue-grey]>._indicator_rect>._indicator{color:var(--theme-blue-grey-default)}sd-checkbox[sd-theme=blue-grey]:focus>._indicator_rect{border-color:var(--theme-blue-grey-default)}sd-checkbox[sd-theme=blue-grey][sd-checked=true]>._indicator_rect{background:var(--theme-blue-grey-default)}sd-checkbox[sd-theme=blue-grey][sd-checked=true]>._indicator_rect>._indicator{color:#fff}sd-checkbox[sd-theme=primary]>._indicator_rect{background:var(--theme-primary-lightest)}sd-checkbox[sd-theme=primary]>._indicator_rect>._indicator{color:var(--theme-primary-default)}sd-checkbox[sd-theme=primary]:focus>._indicator_rect{border-color:var(--theme-primary-default)}sd-checkbox[sd-theme=primary][sd-checked=true]>._indicator_rect{background:var(--theme-primary-default)}sd-checkbox[sd-theme=primary][sd-checked=true]>._indicator_rect>._indicator{color:#fff}sd-checkbox[sd-theme=secondary]>._indicator_rect{background:var(--theme-secondary-lightest)}sd-checkbox[sd-theme=secondary]>._indicator_rect>._indicator{color:var(--theme-secondary-default)}sd-checkbox[sd-theme=secondary]:focus>._indicator_rect{border-color:var(--theme-secondary-default)}sd-checkbox[sd-theme=secondary][sd-checked=true]>._indicator_rect{background:var(--theme-secondary-default)}sd-checkbox[sd-theme=secondary][sd-checked=true]>._indicator_rect>._indicator{color:#fff}sd-checkbox[sd-theme=info]>._indicator_rect{background:var(--theme-info-lightest)}sd-checkbox[sd-theme=info]>._indicator_rect>._indicator{color:var(--theme-info-default)}sd-checkbox[sd-theme=info]:focus>._indicator_rect{border-color:var(--theme-info-default)}sd-checkbox[sd-theme=info][sd-checked=true]>._indicator_rect{background:var(--theme-info-default)}sd-checkbox[sd-theme=info][sd-checked=true]>._indicator_rect>._indicator{color:#fff}sd-checkbox[sd-theme=success]>._indicator_rect{background:var(--theme-success-lightest)}sd-checkbox[sd-theme=success]>._indicator_rect>._indicator{color:var(--theme-success-default)}sd-checkbox[sd-theme=success]:focus>._indicator_rect{border-color:var(--theme-success-default)}sd-checkbox[sd-theme=success][sd-checked=true]>._indicator_rect{background:var(--theme-success-default)}sd-checkbox[sd-theme=success][sd-checked=true]>._indicator_rect>._indicator{color:#fff}sd-checkbox[sd-theme=warning]>._indicator_rect{background:var(--theme-warning-lightest)}sd-checkbox[sd-theme=warning]>._indicator_rect>._indicator{color:var(--theme-warning-default)}sd-checkbox[sd-theme=warning]:focus>._indicator_rect{border-color:var(--theme-warning-default)}sd-checkbox[sd-theme=warning][sd-checked=true]>._indicator_rect{background:var(--theme-warning-default)}sd-checkbox[sd-theme=warning][sd-checked=true]>._indicator_rect>._indicator{color:#fff}sd-checkbox[sd-theme=danger]>._indicator_rect{background:var(--theme-danger-lightest)}sd-checkbox[sd-theme=danger]>._indicator_rect>._indicator{color:var(--theme-danger-default)}sd-checkbox[sd-theme=danger]:focus>._indicator_rect{border-color:var(--theme-danger-default)}sd-checkbox[sd-theme=danger][sd-checked=true]>._indicator_rect{background:var(--theme-danger-default)}sd-checkbox[sd-theme=danger][sd-checked=true]>._indicator_rect>._indicator{color:#fff}sd-checkbox[sd-theme=white]>._indicator_rect{background:var(--control-color);border-color:var(--text-trans-lightest)}sd-checkbox[sd-theme=white]:focus>._indicator_rect{border-color:var(--text-trans-default)}sd-checkbox[sd-theme=white][sd-checked=true]>._indicator_rect{background:var(--theme-primary-default)}sd-checkbox[sd-radio=true]>._indicator_rect{border-radius:100%;padding:var(--gap-xs)}sd-checkbox[sd-radio=true]>._indicator_rect>._indicator{border-radius:100%;width:100%;height:100%;background:var(--theme-primary-default)}sd-checkbox[sd-radio=true][sd-checked=true]>._indicator_rect{background:var(--theme-secondary-lightest);border-color:var(--theme-primary-dark)}sd-checkbox[sd-size=sm]{height:calc(var(--font-size-default) * var(--line-height-strip-unit) + var(--gap-xs) * 2 + 2px);padding:var(--gap-xs) var(--gap-sm);gap:var(--gap-xs)}sd-checkbox[sd-size=lg]{height:calc(var(--font-size-default) * var(--line-height-strip-unit) + var(--gap-default) * 2 + 2px);padding:var(--gap-default) var(--gap-lg);gap:var(--gap-default)}sd-checkbox[sd-inset=true]{height:calc(var(--font-size-default) * var(--line-height-strip-unit) + var(--gap-sm) * 2);border:none;justify-content:center}sd-checkbox[sd-inset=true][sd-size=sm]{height:calc(var(--font-size-default) * var(--line-height-strip-unit) + var(--gap-xs) * 2)}sd-checkbox[sd-inset=true][sd-size=lg]{height:calc(var(--font-size-default) * var(--line-height-strip-unit) + var(--gap-default) * 2)}sd-checkbox[sd-inline=true]{display:inline-block;vertical-align:top;padding:0;border:none;height:calc(var(--font-size-default) * var(--line-height-strip-unit));width:auto}sd-checkbox[sd-disabled=true]>._indicator_rect{background:var(--theme-grey-lighter);border:1px solid var(--trans-light)}sd-checkbox[sd-disabled=true]>._indicator_rect>._indicator{color:var(--theme-grey-default)}sd-checkbox[sd-disabled=true]:focus>._indicator_rect{border-color:var(--theme-grey-default)}\n"] }]
    }], () => [], { onClick: [{
            type: HostListener,
            args: ["click"]
        }], onKeydown: [{
            type: HostListener,
            args: ["keydown", ["$event"]]
        }] }); })();
(() => { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassDebugInfo(SdCheckboxControl, { className: "SdCheckboxControl", filePath: "packages/sd-angular/src/controls/sd-checkbox.control.ts", lineNumber: 246 }); })();
//# sourceMappingURL=sd-checkbox.control.js.map