import { ChangeDetectionStrategy, Component, inject, input, ViewEncapsulation, } from "@angular/core";
import { SdAngularConfigProvider } from "../providers/sd-angular-config.provider";
import { $computed } from "../utils/bindings/$computed";
import { transformBoolean } from "../utils/type-tramsforms";
import { SdIconControl } from "./sd-icon.control";
import * as i0 from "@angular/core";
export class SdCollapseIconControl {
    constructor() {
        this.icons = inject(SdAngularConfigProvider).icons;
        this.icon = input(this.icons.angleDown);
        this.open = input(false, { transform: transformBoolean });
        this.openRotate = input(90);
        this.transform = $computed(() => (this.open() ? "rotate(" + this.openRotate() + "deg)" : ""));
    }
    static { this.ɵfac = function SdCollapseIconControl_Factory(__ngFactoryType__) { return new (__ngFactoryType__ || SdCollapseIconControl)(); }; }
    static { this.ɵcmp = /*@__PURE__*/ i0.ɵɵdefineComponent({ type: SdCollapseIconControl, selectors: [["sd-collapse-icon"]], hostVars: 3, hostBindings: function SdCollapseIconControl_HostBindings(rf, ctx) { if (rf & 2) {
            i0.ɵɵattribute("sd-open", ctx.open());
            i0.ɵɵstyleProp("transform", ctx.transform());
        } }, inputs: { icon: [1, "icon"], open: [1, "open"], openRotate: [1, "openRotate"] }, decls: 1, vars: 1, consts: [["fixedWidth", "", 3, "icon"]], template: function SdCollapseIconControl_Template(rf, ctx) { if (rf & 1) {
            i0.ɵɵelement(0, "sd-icon", 0);
        } if (rf & 2) {
            i0.ɵɵproperty("icon", ctx.icon());
        } }, dependencies: [SdIconControl], styles: ["sd-collapse-icon{display:inline-block;transition:transform .1s ease-in}sd-collapse-icon[sd-open=true]{transition:transform .1s ease-out}\n"], encapsulation: 2, changeDetection: 0 }); }
}
(() => { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(SdCollapseIconControl, [{
        type: Component,
        args: [{ selector: "sd-collapse-icon", changeDetection: ChangeDetectionStrategy.OnPush, encapsulation: ViewEncapsulation.None, standalone: true, imports: [
                    SdIconControl,
                ], template: `
    <sd-icon [icon]="icon()" fixedWidth />
  `, host: {
                    "[attr.sd-open]": "open()",
                    "[style.transform]": "transform()",
                }, styles: ["sd-collapse-icon{display:inline-block;transition:transform .1s ease-in}sd-collapse-icon[sd-open=true]{transition:transform .1s ease-out}\n"] }]
    }], null, null); })();
(() => { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassDebugInfo(SdCollapseIconControl, { className: "SdCollapseIconControl", filePath: "packages/sd-angular/src/controls/sd-collapse-icon.control.ts", lineNumber: 41 }); })();
//# sourceMappingURL=sd-collapse-icon.control.js.map