import { ChangeDetectionStrategy, Component, ElementRef, input, viewChild, ViewEncapsulation } from "@angular/core";
import { SdEventsDirective } from "../directives/sd-events.directive";
import { transformBoolean } from "../utils/type-tramsforms";
import { $signal } from "../utils/bindings/$signal";
import { $computed } from "../utils/bindings/$computed";
import { $effect } from "../utils/bindings/$effect";
import * as i0 from "@angular/core";
const _c0 = ["contentEl"];
const _c1 = ["*"];
export class SdCollapseControl {
    constructor() {
        this.open = input(false, { transform: transformBoolean });
        this.contentElRef = viewChild.required("contentEl", { read: ElementRef });
        this.contentHeight = $signal(0);
        this.marginTop = $computed(() => (this.open() ? "" : -this.contentHeight() + "px"));
        $effect(() => {
            this.contentHeight.set(this.contentElRef().nativeElement.offsetHeight);
        });
    }
    onContentResize() {
        this.contentHeight.set(this.contentElRef().nativeElement.offsetHeight);
    }
    static { this.ɵfac = function SdCollapseControl_Factory(__ngFactoryType__) { return new (__ngFactoryType__ || SdCollapseControl)(); }; }
    static { this.ɵcmp = /*@__PURE__*/ i0.ɵɵdefineComponent({ type: SdCollapseControl, selectors: [["sd-collapse"]], viewQuery: function SdCollapseControl_Query(rf, ctx) { if (rf & 1) {
            i0.ɵɵviewQuerySignal(ctx.contentElRef, _c0, 5, ElementRef);
        } if (rf & 2) {
            i0.ɵɵqueryAdvance();
        } }, hostVars: 1, hostBindings: function SdCollapseControl_HostBindings(rf, ctx) { if (rf & 2) {
            i0.ɵɵattribute("sd-open", ctx.open());
        } }, inputs: { open: [1, "open"] }, ngContentSelectors: _c1, decls: 3, vars: 2, consts: [["contentEl", ""], [1, "_content", 3, "sdResize"]], template: function SdCollapseControl_Template(rf, ctx) { if (rf & 1) {
            const _r1 = i0.ɵɵgetCurrentView();
            i0.ɵɵprojectionDef();
            i0.ɵɵelementStart(0, "div", 1, 0);
            i0.ɵɵlistener("sdResize", function SdCollapseControl_Template_div_sdResize_0_listener() { i0.ɵɵrestoreView(_r1); return i0.ɵɵresetView(ctx.onContentResize()); });
            i0.ɵɵprojection(2);
            i0.ɵɵelementEnd();
        } if (rf & 2) {
            i0.ɵɵstyleProp("margin-top", ctx.marginTop());
        } }, dependencies: [SdEventsDirective], styles: ["sd-collapse{display:block;overflow:hidden}sd-collapse[sd-open=false]>._content{transition:margin-top .1s ease-in}sd-collapse[sd-open=true]>._content{transition:margin-top .1s ease-out}\n"], encapsulation: 2, changeDetection: 0 }); }
}
(() => { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(SdCollapseControl, [{
        type: Component,
        args: [{ selector: "sd-collapse", changeDetection: ChangeDetectionStrategy.OnPush, encapsulation: ViewEncapsulation.None, standalone: true, imports: [SdEventsDirective], template: `
    <div #contentEl class="_content" (sdResize)="onContentResize()" [style.margin-top]="marginTop()">
      <ng-content></ng-content>
    </div>
  `, host: {
                    "[attr.sd-open]": "open()",
                }, styles: ["sd-collapse{display:block;overflow:hidden}sd-collapse[sd-open=false]>._content{transition:margin-top .1s ease-in}sd-collapse[sd-open=true]>._content{transition:margin-top .1s ease-out}\n"] }]
    }], () => [], null); })();
(() => { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassDebugInfo(SdCollapseControl, { className: "SdCollapseControl", filePath: "packages/sd-angular/src/controls/sd-collapse.control.ts", lineNumber: 39 }); })();
//# sourceMappingURL=sd-collapse.control.js.map