import { ChangeDetectionStrategy, Component, contentChildren, ElementRef, viewChild, ViewEncapsulation, } from "@angular/core";
import { $effect } from "../utils/bindings/$effect";
import { SdDockControl } from "./sd-dock.control";
import * as i0 from "@angular/core";
const _c0 = ["content"];
const _c1 = ["*"];
export class SdDockContainerControl {
    constructor() {
        this.dockControls = contentChildren(SdDockControl);
        this.contentElRef = viewChild.required("content", { read: ElementRef });
        $effect(() => {
            let top = 0;
            let left = 0;
            let bottom = 0;
            let right = 0;
            for (const dockControl of this.dockControls()) {
                const position = dockControl.position();
                if (position === "top") {
                    dockControl.assignStyle({
                        top: top + "px",
                        bottom: "",
                        left: left + "px",
                        right: right + "px",
                    });
                    top += dockControl.size();
                }
                else if (position === "bottom") {
                    dockControl.assignStyle({
                        top: "",
                        bottom: bottom + "px",
                        left: left + "px",
                        right: right + "px",
                    });
                    bottom += dockControl.size();
                }
                else if (position === "left") {
                    dockControl.assignStyle({
                        top: top + "px",
                        bottom: bottom + "px",
                        left: left + "px",
                        right: "",
                    });
                    left += dockControl.size();
                }
                else {
                    dockControl.assignStyle({
                        top: top + "px",
                        bottom: bottom + "px",
                        left: "",
                        right: right + "px",
                    });
                    right += dockControl.size();
                }
            }
            Object.assign(this.contentElRef().nativeElement.style, {
                paddingTop: top + "px",
                paddingBottom: bottom + "px",
                paddingRight: right + "px",
                paddingLeft: left + "px",
            });
        });
    }
    static { this.ɵfac = function SdDockContainerControl_Factory(__ngFactoryType__) { return new (__ngFactoryType__ || SdDockContainerControl)(); }; }
    static { this.ɵcmp = /*@__PURE__*/ i0.ɵɵdefineComponent({ type: SdDockContainerControl, selectors: [["sd-dock-container"]], contentQueries: function SdDockContainerControl_ContentQueries(rf, ctx, dirIndex) { if (rf & 1) {
            i0.ɵɵcontentQuerySignal(dirIndex, ctx.dockControls, SdDockControl, 4);
        } if (rf & 2) {
            i0.ɵɵqueryAdvance();
        } }, viewQuery: function SdDockContainerControl_Query(rf, ctx) { if (rf & 1) {
            i0.ɵɵviewQuerySignal(ctx.contentElRef, _c0, 5, ElementRef);
        } if (rf & 2) {
            i0.ɵɵqueryAdvance();
        } }, ngContentSelectors: _c1, decls: 3, vars: 0, consts: [["content", ""], [1, "_content"]], template: function SdDockContainerControl_Template(rf, ctx) { if (rf & 1) {
            i0.ɵɵprojectionDef();
            i0.ɵɵelementStart(0, "div", 1, 0);
            i0.ɵɵprojection(2);
            i0.ɵɵelementEnd();
        } }, styles: ["sd-dock-container{display:block;height:100%}sd-dock-container>._content{position:relative;height:100%}\n"], encapsulation: 2, changeDetection: 0 }); }
}
(() => { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(SdDockContainerControl, [{
        type: Component,
        args: [{ selector: "sd-dock-container", changeDetection: ChangeDetectionStrategy.OnPush, encapsulation: ViewEncapsulation.None, standalone: true, imports: [], template: `
    <div #content class="_content">
      <ng-content />
    </div>
  `, styles: ["sd-dock-container{display:block;height:100%}sd-dock-container>._content{position:relative;height:100%}\n"] }]
    }], () => [], null); })();
(() => { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassDebugInfo(SdDockContainerControl, { className: "SdDockContainerControl", filePath: "packages/sd-angular/src/controls/sd-dock-container.control.ts", lineNumber: 38 }); })();
//# sourceMappingURL=sd-dock-container.control.js.map