import { ChangeDetectionStrategy, Component, HostListener, input, ViewEncapsulation, } from "@angular/core";
import { $effect } from "../utils/bindings/$effect";
import { $signal } from "../utils/bindings/$signal";
import { injectElementRef } from "../utils/injections/inject-element-ref";
import { useSdSystemConfigResource } from "../utils/signals/use-sd-system-config.resource";
import { transformBoolean } from "../utils/type-tramsforms";
import * as i0 from "@angular/core";
const _c0 = ["*"];
function SdDockControl_Conditional_1_Template(rf, ctx) { if (rf & 1) {
    const _r1 = i0.ɵɵgetCurrentView();
    i0.ɵɵelementStart(0, "div", 1);
    i0.ɵɵlistener("mousedown", function SdDockControl_Conditional_1_Template_div_mousedown_0_listener($event) { i0.ɵɵrestoreView(_r1); const ctx_r1 = i0.ɵɵnextContext(); return i0.ɵɵresetView(ctx_r1.onResizeBarMousedown($event)); });
    i0.ɵɵelementEnd();
} }
export class SdDockControl {
    constructor() {
        this._elRef = injectElementRef();
        this.key = input();
        this.position = input("top");
        this.resizable = input(false, { transform: transformBoolean });
        this.size = $signal(0);
        this._config = useSdSystemConfigResource({ key: this.key });
        $effect(() => {
            const conf = this._config.value();
            if (this.resizable() && conf && conf.size != null) {
                if (["right", "left"].includes(this.position())) {
                    this._elRef.nativeElement.style.width = conf.size;
                }
                if (["top", "bottom"].includes(this.position())) {
                    this._elRef.nativeElement.style.height = conf.size;
                }
            }
        });
    }
    assignStyle(style) {
        Object.assign(this._elRef.nativeElement.style, style);
    }
    onResize(event) {
        if (["top", "bottom"].includes(this.position()) && event.heightChanged) {
            this.size.set(this._elRef.nativeElement.offsetHeight);
        }
        if (["right", "left"].includes(this.position()) && event.widthChanged) {
            this.size.set(this._elRef.nativeElement.offsetWidth);
        }
    }
    onResizeBarMousedown(event) {
        const thisEl = this._elRef.nativeElement;
        const startX = event.clientX;
        const startY = event.clientY;
        const startHeight = thisEl.clientHeight;
        const startWidth = thisEl.clientWidth;
        const doDrag = (e) => {
            e.stopPropagation();
            e.preventDefault();
            if (this.position() === "bottom") {
                thisEl.style.height = `${startHeight - e.clientY + startY}px`;
            }
            else if (this.position() === "right") {
                thisEl.style.width = `${startWidth - e.clientX + startX}px`;
            }
            else if (this.position() === "top") {
                thisEl.style.height = `${startHeight + e.clientY - startY}px`;
            }
            else {
                // left
                thisEl.style.width = `${startWidth + e.clientX - startX}px`;
            }
        };
        const stopDrag = (e) => {
            e.stopPropagation();
            e.preventDefault();
            document.removeEventListener("mousemove", doDrag);
            document.removeEventListener("mouseup", stopDrag);
            if (this.key() != null) {
                const newConf = {};
                if (["right", "left"].includes(this.position())) {
                    newConf.size = thisEl.style.width;
                }
                else {
                    newConf.size = thisEl.style.height;
                }
                this._config.set(newConf);
            }
        };
        document.addEventListener("mousemove", doDrag);
        document.addEventListener("mouseup", stopDrag);
    }
    static { this.ɵfac = function SdDockControl_Factory(__ngFactoryType__) { return new (__ngFactoryType__ || SdDockControl)(); }; }
    static { this.ɵcmp = /*@__PURE__*/ i0.ɵɵdefineComponent({ type: SdDockControl, selectors: [["sd-dock"]], hostVars: 2, hostBindings: function SdDockControl_HostBindings(rf, ctx) { if (rf & 1) {
            i0.ɵɵlistener("sdResize", function SdDockControl_sdResize_HostBindingHandler($event) { return ctx.onResize($event); });
        } if (rf & 2) {
            i0.ɵɵattribute("sd-position", ctx.position())("sd-resizable", ctx.resizable());
        } }, inputs: { key: [1, "key"], position: [1, "position"], resizable: [1, "resizable"] }, ngContentSelectors: _c0, decls: 2, vars: 1, consts: [[1, "_resize-bar"], [1, "_resize-bar", 3, "mousedown"]], template: function SdDockControl_Template(rf, ctx) { if (rf & 1) {
            i0.ɵɵprojectionDef();
            i0.ɵɵprojection(0);
            i0.ɵɵtemplate(1, SdDockControl_Conditional_1_Template, 1, 0, "div", 0);
        } if (rf & 2) {
            i0.ɵɵadvance();
            i0.ɵɵconditional(ctx.resizable() ? 1 : -1);
        } }, styles: ["sd-dock{display:block;position:absolute;overflow:auto}sd-dock[sd-resizable=true]>._resize-bar{position:absolute;background:var(--border-color-light)}sd-dock[sd-resizable=true][sd-position=top]>._resize-bar{bottom:0;left:0;width:100%;height:2px;cursor:ns-resize}sd-dock[sd-resizable=true][sd-position=bottom]>._resize-bar{top:0;left:0;width:100%;height:2px;cursor:ns-resize}sd-dock[sd-resizable=true][sd-position=left]>._resize-bar{top:0;right:0;height:100%;width:2px;cursor:ew-resize}sd-dock[sd-resizable=true][sd-position=right]>._resize-bar{top:0;left:0;height:100%;width:2px;cursor:ew-resize}\n"], encapsulation: 2, changeDetection: 0 }); }
}
(() => { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(SdDockControl, [{
        type: Component,
        args: [{ selector: "sd-dock", changeDetection: ChangeDetectionStrategy.OnPush, encapsulation: ViewEncapsulation.None, standalone: true, imports: [], template: `
    <ng-content></ng-content>
    @if (resizable()) {
      <div class="_resize-bar" (mousedown)="onResizeBarMousedown($event)"></div>
    }
  `, host: {
                    "[attr.sd-position]": "position()",
                    "[attr.sd-resizable]": "resizable()",
                }, styles: ["sd-dock{display:block;position:absolute;overflow:auto}sd-dock[sd-resizable=true]>._resize-bar{position:absolute;background:var(--border-color-light)}sd-dock[sd-resizable=true][sd-position=top]>._resize-bar{bottom:0;left:0;width:100%;height:2px;cursor:ns-resize}sd-dock[sd-resizable=true][sd-position=bottom]>._resize-bar{top:0;left:0;width:100%;height:2px;cursor:ns-resize}sd-dock[sd-resizable=true][sd-position=left]>._resize-bar{top:0;right:0;height:100%;width:2px;cursor:ew-resize}sd-dock[sd-resizable=true][sd-position=right]>._resize-bar{top:0;left:0;height:100%;width:2px;cursor:ew-resize}\n"] }]
    }], () => [], { onResize: [{
            type: HostListener,
            args: ["sdResize", ["$event"]]
        }] }); })();
(() => { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassDebugInfo(SdDockControl, { className: "SdDockControl", filePath: "packages/sd-angular/src/controls/sd-dock.control.ts", lineNumber: 89 }); })();
//# sourceMappingURL=sd-dock.control.js.map