import { ChangeDetectionStrategy, Component, forwardRef, inject, ViewEncapsulation } from "@angular/core";
import { SdDropdownControl } from "./sd-dropdown.control";
import { SdEventsDirective } from "../directives/sd-events.directive";
import { injectElementRef } from "../utils/injections/inject-element-ref";
import * as i0 from "@angular/core";
const _c0 = ["*"];
// TODO: 모바일일때는 모달 형식으로 표현
export class SdDropdownPopupControl {
    constructor() {
        this._parentControl = inject(forwardRef(() => SdDropdownControl));
        this._elRef = injectElementRef();
    }
    onKeyDown(event) {
        this._parentControl.onPopupKeydown(event);
    }
    onResize() {
        const el = this._elRef.nativeElement;
        const divEl = this._elRef.nativeElement.firstElementChild;
        if (divEl.clientHeight > 300) {
            el.style.height = "300px";
        }
        else {
            delete el.style.height;
        }
    }
    static { this.ɵfac = function SdDropdownPopupControl_Factory(__ngFactoryType__) { return new (__ngFactoryType__ || SdDropdownPopupControl)(); }; }
    static { this.ɵcmp = /*@__PURE__*/ i0.ɵɵdefineComponent({ type: SdDropdownPopupControl, selectors: [["sd-dropdown-popup"]], ngContentSelectors: _c0, decls: 2, vars: 0, consts: [[3, "sdResize", "keydown"]], template: function SdDropdownPopupControl_Template(rf, ctx) { if (rf & 1) {
            i0.ɵɵprojectionDef();
            i0.ɵɵelementStart(0, "div", 0);
            i0.ɵɵlistener("sdResize", function SdDropdownPopupControl_Template_div_sdResize_0_listener() { return ctx.onResize(); })("keydown", function SdDropdownPopupControl_Template_div_keydown_0_listener($event) { return ctx.onKeyDown($event); });
            i0.ɵɵprojection(1);
            i0.ɵɵelementEnd();
        } }, dependencies: [SdEventsDirective], styles: ["sd-dropdown-popup{position:fixed;z-index:var(--z-index-dropdown);opacity:0;transform:translateY(-10px);transition:.1s linear;transition-property:transform,opacity;pointer-events:none;background:var(--control-color);min-width:120px;box-shadow:0 0 2px #0000000d,0 calc(6 * var(--elevation-size)) calc(6 * 4 * var(--elevation-size)) #0000000d;overflow:hidden;border-radius:var(--border-radius-default);border:1px solid var(--border-color-light)}sd-dropdown-popup>div{width:100%;height:100%;overflow:auto;white-space:nowrap}sd-dropdown-popup:focus{outline:1px solid var(--theme-primary-default)}@media all and (max-width: 520px){sd-dropdown-popup{box-shadow:none;border:1px solid var(--border-color-default)}}\n"], encapsulation: 2, changeDetection: 0 }); }
}
(() => { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(SdDropdownPopupControl, [{
        type: Component,
        args: [{ selector: "sd-dropdown-popup", changeDetection: ChangeDetectionStrategy.OnPush, encapsulation: ViewEncapsulation.None, standalone: true, imports: [SdEventsDirective], template: `
    <div (sdResize)="onResize()" (keydown)="onKeyDown($event)">
      <ng-content></ng-content>
    </div>
  `, styles: ["sd-dropdown-popup{position:fixed;z-index:var(--z-index-dropdown);opacity:0;transform:translateY(-10px);transition:.1s linear;transition-property:transform,opacity;pointer-events:none;background:var(--control-color);min-width:120px;box-shadow:0 0 2px #0000000d,0 calc(6 * var(--elevation-size)) calc(6 * 4 * var(--elevation-size)) #0000000d;overflow:hidden;border-radius:var(--border-radius-default);border:1px solid var(--border-color-light)}sd-dropdown-popup>div{width:100%;height:100%;overflow:auto;white-space:nowrap}sd-dropdown-popup:focus{outline:1px solid var(--theme-primary-default)}@media all and (max-width: 520px){sd-dropdown-popup{box-shadow:none;border:1px solid var(--border-color-default)}}\n"] }]
    }], null, null); })();
(() => { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassDebugInfo(SdDropdownPopupControl, { className: "SdDropdownPopupControl", filePath: "packages/sd-angular/src/controls/sd-dropdown-popup.control.ts", lineNumber: 56 }); })();
//# sourceMappingURL=sd-dropdown-popup.control.js.map