import { ChangeDetectionStrategy, Component, HostListener, input, ViewEncapsulation } from "@angular/core";
import { injectElementRef } from "../utils/injections/inject-element-ref";
import * as echarts from 'echarts';
import { $effect } from "../utils/bindings/$effect";
import * as i0 from "@angular/core";
const _c0 = ["*"];
export class SdEchartsControl {
    constructor() {
        this._elRef = injectElementRef();
        this.option = input.required();
        /*height = input.required<string>();*/
        this.loading = input(false);
        $effect([], () => {
            this._chart = echarts.init(this._elRef.nativeElement, null, { renderer: "svg" });
        });
        $effect(() => {
            this._chart.setOption(this.option());
        });
        $effect(() => {
            if (this.loading()) {
                this._chart.showLoading();
            }
            else {
                this._chart.hideLoading();
            }
        });
    }
    onResize() {
        this._chart.resize();
    }
    static { this.ɵfac = function SdEchartsControl_Factory(__ngFactoryType__) { return new (__ngFactoryType__ || SdEchartsControl)(); }; }
    static { this.ɵcmp = /*@__PURE__*/ i0.ɵɵdefineComponent({ type: SdEchartsControl, selectors: [["sd-echarts"]], hostBindings: function SdEchartsControl_HostBindings(rf, ctx) { if (rf & 1) {
            i0.ɵɵlistener("sdResize", function SdEchartsControl_sdResize_HostBindingHandler() { return ctx.onResize(); });
        } }, inputs: { option: [1, "option"], loading: [1, "loading"] }, ngContentSelectors: _c0, decls: 1, vars: 0, template: function SdEchartsControl_Template(rf, ctx) { if (rf & 1) {
            i0.ɵɵprojectionDef();
            i0.ɵɵprojection(0);
        } }, styles: ["sd-echarts{display:block}\n"], encapsulation: 2, changeDetection: 0 }); }
}
(() => { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(SdEchartsControl, [{
        type: Component,
        args: [{ selector: "sd-echarts", changeDetection: ChangeDetectionStrategy.OnPush, encapsulation: ViewEncapsulation.None, standalone: true, imports: [], template: `
    <ng-content></ng-content>
  `, styles: ["sd-echarts{display:block}\n"] }]
    }], () => [], { onResize: [{
            type: HostListener,
            args: ["sdResize"]
        }] }); })();
(() => { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassDebugInfo(SdEchartsControl, { className: "SdEchartsControl", filePath: "packages/sd-angular/src/controls/sd-echarts.control.ts", lineNumber: 23 }); })();
//# sourceMappingURL=sd-echarts.control.js.map