import { ChangeDetectionStrategy, Component, ElementRef, inject, output, viewChild, ViewEncapsulation, } from "@angular/core";
import { SdToastProvider } from "../providers/sd-toast.provider";
import { SdEventsDirective } from "../directives/sd-events.directive";
import * as i0 from "@angular/core";
const _c0 = ["formEl"];
const _c1 = ["*"];
export class SdFormControl {
    constructor() {
        this._sdToast = inject(SdToastProvider);
        this._formElRef = viewChild.required("formEl", { read: ElementRef });
        this.submit = output();
        this.invalid = output();
    }
    get _formEl() {
        return this._formElRef().nativeElement;
    }
    requestSubmit() {
        this._formEl.requestSubmit();
    }
    _onSubmit(event) {
        event.preventDefault();
        event.stopPropagation();
        if (this._formEl.checkValidity()) {
            this.submit.emit(event);
            return;
        }
        // 자동 메시지 및 포커싱
        this._formEl.reportValidity();
        // const firstInvalidEl = this._formEl.findFirst<HTMLInputElement>("*:invalid")!;
        // this._sdToast.info(firstInvalidEl.validationMessage);
        this.invalid.emit();
    }
    _onInvalidCapture() {
        this.invalid.emit();
    }
    static { this.ɵfac = function SdFormControl_Factory(__ngFactoryType__) { return new (__ngFactoryType__ || SdFormControl)(); }; }
    static { this.ɵcmp = /*@__PURE__*/ i0.ɵɵdefineComponent({ type: SdFormControl, selectors: [["sd-form"]], viewQuery: function SdFormControl_Query(rf, ctx) { if (rf & 1) {
            i0.ɵɵviewQuerySignal(ctx._formElRef, _c0, 5, ElementRef);
        } if (rf & 2) {
            i0.ɵɵqueryAdvance();
        } }, outputs: { submit: "submit", invalid: "invalid" }, ngContentSelectors: _c1, decls: 4, vars: 0, consts: [["formEl", ""], ["novalidate", "", 3, "submit", "invalid.capture"], ["hidden", "", "type", "submit"]], template: function SdFormControl_Template(rf, ctx) { if (rf & 1) {
            const _r1 = i0.ɵɵgetCurrentView();
            i0.ɵɵprojectionDef();
            i0.ɵɵelementStart(0, "form", 1, 0);
            i0.ɵɵlistener("submit", function SdFormControl_Template_form_submit_0_listener($event) { i0.ɵɵrestoreView(_r1); return i0.ɵɵresetView(ctx._onSubmit($event)); })("invalid.capture", function SdFormControl_Template_form_invalid_capture_0_listener() { i0.ɵɵrestoreView(_r1); return i0.ɵɵresetView(ctx._onInvalidCapture()); });
            i0.ɵɵprojection(2);
            i0.ɵɵelement(3, "button", 2);
            i0.ɵɵelementEnd();
        } }, dependencies: [SdEventsDirective], encapsulation: 2, changeDetection: 0 }); }
}
(() => { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(SdFormControl, [{
        type: Component,
        args: [{
                selector: "sd-form",
                changeDetection: ChangeDetectionStrategy.OnPush,
                encapsulation: ViewEncapsulation.None,
                standalone: true,
                imports: [SdEventsDirective],
                template: `
    <form
      #formEl
      novalidate
      (submit)="_onSubmit($event)"
      (invalid.capture)="_onInvalidCapture()"
    >
      <ng-content />
      <button hidden type="submit"></button>
    </form>
  `,
            }]
    }], null, null); })();
(() => { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassDebugInfo(SdFormControl, { className: "SdFormControl", filePath: "packages/sd-angular/src/controls/sd-form.control.ts", lineNumber: 31 }); })();
//# sourceMappingURL=sd-form.control.js.map