import { ChangeDetectionStrategy, Component, input, ViewEncapsulation } from "@angular/core";
import { $effect } from "../utils/bindings/$effect";
import { injectElementRef } from "../utils/injections/inject-element-ref";
import * as i0 from "@angular/core";
export class SdGapControl {
    constructor() {
        this._elRef = injectElementRef();
        this.height = input();
        this.heightPx = input();
        this.width = input();
        this.widthPx = input();
        this.widthEm = input();
        $effect(() => {
            if (this.widthPx() === 0 || this.heightPx() === 0 || this.widthEm() === 0) {
                this._elRef.nativeElement.style.display = "none";
            }
            else if (this.width() !== undefined
                || this.widthPx() !== undefined
                || this.widthEm() !== undefined) {
                this._elRef.nativeElement.style.display = "inline-block";
            }
            else if (this.height() !== undefined || this.heightPx() !== undefined) {
                this._elRef.nativeElement.style.display = "block";
            }
            else {
                this._elRef.nativeElement.style.display = "";
            }
        });
    }
    static { this.ɵfac = function SdGapControl_Factory(__ngFactoryType__) { return new (__ngFactoryType__ || SdGapControl)(); }; }
    static { this.ɵcmp = /*@__PURE__*/ i0.ɵɵdefineComponent({ type: SdGapControl, selectors: [["sd-gap"]], hostVars: 8, hostBindings: function SdGapControl_HostBindings(rf, ctx) { if (rf & 2) {
            i0.ɵɵattribute("sd-height", ctx.height())("sd-width", ctx.width());
            i0.ɵɵstyleProp("height", ctx.heightPx(), "px")("width", ctx.widthPx(), "px")("width", ctx.widthEm(), "em");
        } }, inputs: { height: [1, "height"], heightPx: [1, "heightPx"], width: [1, "width"], widthPx: [1, "widthPx"], widthEm: [1, "widthEm"] }, decls: 0, vars: 0, template: function SdGapControl_Template(rf, ctx) { }, styles: ["sd-gap[sd-height=xxs]{height:var(--gap-xxs)}sd-gap[sd-width=xxs]{width:var(--gap-xxs)}sd-gap[sd-height=xs]{height:var(--gap-xs)}sd-gap[sd-width=xs]{width:var(--gap-xs)}sd-gap[sd-height=sm]{height:var(--gap-sm)}sd-gap[sd-width=sm]{width:var(--gap-sm)}sd-gap[sd-height=default]{height:var(--gap-default)}sd-gap[sd-width=default]{width:var(--gap-default)}sd-gap[sd-height=lg]{height:var(--gap-lg)}sd-gap[sd-width=lg]{width:var(--gap-lg)}sd-gap[sd-height=xl]{height:var(--gap-xl)}sd-gap[sd-width=xl]{width:var(--gap-xl)}sd-gap[sd-height=xxl]{height:var(--gap-xxl)}sd-gap[sd-width=xxl]{width:var(--gap-xxl)}sd-gap[sd-height=\"0\"]{height:var(--gap-0)}sd-gap[sd-width=\"0\"]{width:var(--gap-0)}sd-gap[sd-height=auto]{height:var(--gap-auto)}sd-gap[sd-width=auto]{width:var(--gap-auto)}\n"], encapsulation: 2, changeDetection: 0 }); }
}
(() => { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(SdGapControl, [{
        type: Component,
        args: [{ selector: "sd-gap", changeDetection: ChangeDetectionStrategy.OnPush, encapsulation: ViewEncapsulation.None, standalone: true, imports: [], template: "", host: {
                    "[attr.sd-height]": "height()",
                    "[style.height.px]": "heightPx()",
                    "[attr.sd-width]": "width()",
                    "[style.width.px]": "widthPx()",
                    "[style.width.em]": "widthEm()",
                }, styles: ["sd-gap[sd-height=xxs]{height:var(--gap-xxs)}sd-gap[sd-width=xxs]{width:var(--gap-xxs)}sd-gap[sd-height=xs]{height:var(--gap-xs)}sd-gap[sd-width=xs]{width:var(--gap-xs)}sd-gap[sd-height=sm]{height:var(--gap-sm)}sd-gap[sd-width=sm]{width:var(--gap-sm)}sd-gap[sd-height=default]{height:var(--gap-default)}sd-gap[sd-width=default]{width:var(--gap-default)}sd-gap[sd-height=lg]{height:var(--gap-lg)}sd-gap[sd-width=lg]{width:var(--gap-lg)}sd-gap[sd-height=xl]{height:var(--gap-xl)}sd-gap[sd-width=xl]{width:var(--gap-xl)}sd-gap[sd-height=xxl]{height:var(--gap-xxl)}sd-gap[sd-width=xxl]{width:var(--gap-xxl)}sd-gap[sd-height=\"0\"]{height:var(--gap-0)}sd-gap[sd-width=\"0\"]{width:var(--gap-0)}sd-gap[sd-height=auto]{height:var(--gap-auto)}sd-gap[sd-width=auto]{width:var(--gap-auto)}\n"] }]
    }], () => [], null); })();
(() => { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassDebugInfo(SdGapControl, { className: "SdGapControl", filePath: "packages/sd-angular/src/controls/sd-gap.control.ts", lineNumber: 40 }); })();
//# sourceMappingURL=sd-gap.control.js.map