import { ChangeDetectionStrategy, Component, inject, input, ViewEncapsulation, } from "@angular/core";
import { SdGridControl } from "./sd-grid.control";
import { $computed } from "../utils/bindings/$computed";
import * as i0 from "@angular/core";
const _c0 = ["*"];
export class SdGridItemControl {
    constructor() {
        this._parentControl = inject(SdGridControl);
        this.colSpan = input.required();
        this.colSpanSm = input();
        this.colSpanXs = input();
        this.colSpanXxs = input();
        this.styleGridColumnEnd = $computed(() => {
            const parentWidth = this._parentControl.offsetWidth();
            if (parentWidth < 800) {
                return `span ${this.colSpanXxs() ?? this.colSpanXs() ?? this.colSpanSm() ?? this.colSpan()}`;
            }
            else if (parentWidth < 1024) {
                return `span ${this.colSpanXs() ?? this.colSpanSm() ?? this.colSpan()}`;
            }
            else if (parentWidth < 1280) {
                return `span ${this.colSpanSm() ?? this.colSpan()}`;
            }
            else {
                return `span ${this.colSpan()}`;
            }
        });
    }
    static { this.ɵfac = function SdGridItemControl_Factory(__ngFactoryType__) { return new (__ngFactoryType__ || SdGridItemControl)(); }; }
    static { this.ɵcmp = /*@__PURE__*/ i0.ɵɵdefineComponent({ type: SdGridItemControl, selectors: [["sd-grid-item"]], hostVars: 2, hostBindings: function SdGridItemControl_HostBindings(rf, ctx) { if (rf & 2) {
            i0.ɵɵstyleProp("grid-column-end", ctx.styleGridColumnEnd());
        } }, inputs: { colSpan: [1, "colSpan"], colSpanSm: [1, "colSpanSm"], colSpanXs: [1, "colSpanXs"], colSpanXxs: [1, "colSpanXxs"] }, ngContentSelectors: _c0, decls: 1, vars: 0, template: function SdGridItemControl_Template(rf, ctx) { if (rf & 1) {
            i0.ɵɵprojectionDef();
            i0.ɵɵprojection(0);
        } }, styles: ["sd-grid-item{height:100%}\n"], encapsulation: 2, changeDetection: 0 }); }
}
(() => { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(SdGridItemControl, [{
        type: Component,
        args: [{ selector: "sd-grid-item", changeDetection: ChangeDetectionStrategy.OnPush, encapsulation: ViewEncapsulation.None, standalone: true, imports: [], template: `
    <ng-content /> `, host: {
                    "[style.gridColumnEnd]": "styleGridColumnEnd()",
                }, styles: ["sd-grid-item{height:100%}\n"] }]
    }], null, null); })();
(() => { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassDebugInfo(SdGridItemControl, { className: "SdGridItemControl", filePath: "packages/sd-angular/src/controls/sd-grid-item.control.ts", lineNumber: 30 }); })();
//# sourceMappingURL=sd-grid-item.control.js.map