import { ChangeDetectionStrategy, Component, inject, input, ViewEncapsulation, } from "@angular/core";
import { icon, parse, } from "@fortawesome/fontawesome-svg-core";
import { SdAngularConfigProvider } from "../providers/sd-angular-config.provider";
import { $effect } from "../utils/bindings/$effect";
import { injectElementRef } from "../utils/injections/inject-element-ref";
import { transformBoolean } from "../utils/type-tramsforms";
import * as i0 from "@angular/core";
export class SdIconControl {
    constructor() {
        this._sdNgConf = inject(SdAngularConfigProvider);
        this._elRef = injectElementRef();
        this.icon = input();
        this.animation = input();
        this.size = input();
        this.rotate = input();
        this.fixedWidth = input(false, { transform: transformBoolean });
        this.stackItemSize = input();
        this.transform = input();
        $effect(() => {
            const iconDef = this.icon() ?? this._sdNgConf.icons.fallback;
            const renderedIcon = icon(iconDef, {
                transform: typeof this.transform() === "string"
                    ? parse.transform(this.transform())
                    : this.transform(),
                classes: [
                    this.fixedWidth() ? "fa-fw" : undefined,
                    this.size() != null ? `fa-${this.size()}` : undefined,
                    this.rotate() != null ? `fa-rotate-${this.rotate()}` : undefined,
                    this.stackItemSize() != null ? `fa-stack-${this.stackItemSize()}` : undefined,
                    ...this.animation() != null ? [
                        !this.animation().startsWith("spin") ? `fa-${this.animation()}` : undefined,
                        ["spin", "spin-reverse"].includes(this.animation()) ? "fa-spin" : undefined,
                        ["spin-reverse", "spin-pulse-reverse"].includes(this.animation())
                            ? "fa-spin-reverse"
                            : undefined,
                        ...["spin-pulse", "spin-pulse-reverse"].includes(this.animation()) ? [
                            "fa-pulse",
                            "fa-spin-pulse",
                        ] : [],
                    ] : [],
                ].filterExists(),
            });
            this._elRef.nativeElement.innerHTML = renderedIcon.html.join("\n");
        });
    }
    static { this.ɵfac = function SdIconControl_Factory(__ngFactoryType__) { return new (__ngFactoryType__ || SdIconControl)(); }; }
    static { this.ɵcmp = /*@__PURE__*/ i0.ɵɵdefineComponent({ type: SdIconControl, selectors: [["sd-icon"]], inputs: { icon: [1, "icon"], animation: [1, "animation"], size: [1, "size"], rotate: [1, "rotate"], fixedWidth: [1, "fixedWidth"], stackItemSize: [1, "stackItemSize"], transform: [1, "transform"] }, decls: 0, vars: 0, template: function SdIconControl_Template(rf, ctx) { }, encapsulation: 2, changeDetection: 0 }); }
}
(() => { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(SdIconControl, [{
        type: Component,
        args: [{
                selector: "sd-icon",
                changeDetection: ChangeDetectionStrategy.OnPush,
                encapsulation: ViewEncapsulation.None,
                standalone: true,
                imports: [],
                template: ``,
            }]
    }], () => [], null); })();
(() => { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassDebugInfo(SdIconControl, { className: "SdIconControl", filePath: "packages/sd-angular/src/controls/sd-icon.control.ts", lineNumber: 30 }); })();
//# sourceMappingURL=sd-icon.control.js.map