import { NgTemplateOutlet } from "@angular/common";
import { ChangeDetectionStrategy, Component, contentChild, contentChildren, forwardRef, HostListener, inject, input, model, TemplateRef, ViewEncapsulation, } from "@angular/core";
import { SdAngularConfigProvider } from "../providers/sd-angular-config.provider";
import { $computed } from "../utils/bindings/$computed";
import { $signal } from "../utils/bindings/$signal";
import { transformBoolean } from "../utils/type-tramsforms";
import { SdAnchorControl } from "./sd-anchor.control";
import { SdBusyContainerControl } from "./sd-busy-container.control";
import { SdCheckboxControl } from "./sd-checkbox.control";
import { SdDockContainerControl } from "./sd-dock-container.control";
import { SdDockControl } from "./sd-dock.control";
import { SdIconControl } from "./sd-icon.control";
import { SdKanbanBoardControl } from "./sd-kanban-board.control";
import { SdKanbanControl } from "./sd-kanban.control";
import { SdPaneControl } from "./sd-pane.control";
import * as i0 from "@angular/core";
const _c0 = ["toolsTemplate"];
const _c1 = ["titleTemplate"];
const _c2 = ["*"];
function SdKanbanLaneControl_Conditional_1_Conditional_1_Template(rf, ctx) { if (rf & 1) {
    const _r1 = i0.ɵɵgetCurrentView();
    i0.ɵɵelementStart(0, "sd-anchor", 7);
    i0.ɵɵlistener("click", function SdKanbanLaneControl_Conditional_1_Conditional_1_Template_sd_anchor_click_0_listener() { i0.ɵɵrestoreView(_r1); const ctx_r1 = i0.ɵɵnextContext(2); return i0.ɵɵresetView(ctx_r1.onToggleCollapseButtonClick()); });
    i0.ɵɵelement(1, "sd-icon", 8);
    i0.ɵɵelementEnd();
} if (rf & 2) {
    const ctx_r1 = i0.ɵɵnextContext(2);
    i0.ɵɵadvance();
    i0.ɵɵproperty("icon", ctx_r1.collapse() ? ctx_r1.icons.eyeSlash : ctx_r1.icons.eye);
} }
function SdKanbanLaneControl_Conditional_1_Conditional_2_ng_template_1_Template(rf, ctx) { }
function SdKanbanLaneControl_Conditional_1_Conditional_2_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "div", 6);
    i0.ɵɵtemplate(1, SdKanbanLaneControl_Conditional_1_Conditional_2_ng_template_1_Template, 0, 0, "ng-template", 9);
    i0.ɵɵelementEnd();
} if (rf & 2) {
    let tmp_2_0;
    const ctx_r1 = i0.ɵɵnextContext(2);
    i0.ɵɵadvance();
    i0.ɵɵproperty("ngTemplateOutlet", (tmp_2_0 = ctx_r1.titleTemplateRef()) !== null && tmp_2_0 !== undefined ? tmp_2_0 : null);
} }
function SdKanbanLaneControl_Conditional_1_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "sd-dock", 0);
    i0.ɵɵtemplate(1, SdKanbanLaneControl_Conditional_1_Conditional_1_Template, 2, 1, "sd-anchor", 5)(2, SdKanbanLaneControl_Conditional_1_Conditional_2_Template, 2, 1, "div", 6);
    i0.ɵɵelementEnd();
} if (rf & 2) {
    const ctx_r1 = i0.ɵɵnextContext();
    i0.ɵɵadvance();
    i0.ɵɵconditional(ctx_r1.useCollapse() ? 1 : -1);
    i0.ɵɵadvance();
    i0.ɵɵconditional(ctx_r1.titleTemplateRef() ? 2 : -1);
} }
function SdKanbanLaneControl_Conditional_4_Conditional_1_Template(rf, ctx) { if (rf & 1) {
    const _r3 = i0.ɵɵgetCurrentView();
    i0.ɵɵelementStart(0, "sd-checkbox", 11);
    i0.ɵɵlistener("valueChange", function SdKanbanLaneControl_Conditional_4_Conditional_1_Template_sd_checkbox_valueChange_0_listener($event) { i0.ɵɵrestoreView(_r3); const ctx_r1 = i0.ɵɵnextContext(2); return i0.ɵɵresetView(ctx_r1.onSelectAllButtonClick($event)); });
    i0.ɵɵelementEnd();
} if (rf & 2) {
    const ctx_r1 = i0.ɵɵnextContext(2);
    i0.ɵɵproperty("inline", true)("value", ctx_r1.isAllSelected());
} }
function SdKanbanLaneControl_Conditional_4_ng_template_2_Template(rf, ctx) { }
function SdKanbanLaneControl_Conditional_4_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "div", 3);
    i0.ɵɵtemplate(1, SdKanbanLaneControl_Conditional_4_Conditional_1_Template, 1, 2, "sd-checkbox", 10)(2, SdKanbanLaneControl_Conditional_4_ng_template_2_Template, 0, 0, "ng-template", 9);
    i0.ɵɵelementEnd();
} if (rf & 2) {
    let tmp_2_0;
    const ctx_r1 = i0.ɵɵnextContext();
    i0.ɵɵadvance();
    i0.ɵɵconditional(ctx_r1.kanbanControls().length > 0 ? 1 : -1);
    i0.ɵɵadvance();
    i0.ɵɵproperty("ngTemplateOutlet", (tmp_2_0 = ctx_r1.toolsTemplateRef()) !== null && tmp_2_0 !== undefined ? tmp_2_0 : null);
} }
function SdKanbanLaneControl_Conditional_5_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵprojection(0);
} }
export class SdKanbanLaneControl {
    constructor() {
        this.icons = inject(SdAngularConfigProvider).icons;
        this._boardControl = inject(forwardRef(() => SdKanbanBoardControl));
        this.busy = input(false, { transform: transformBoolean });
        this.useCollapse = input(false, { transform: transformBoolean });
        this.collapse = model(false);
        this.value = input.required();
        this.kanbanControls = contentChildren(SdKanbanControl, { descendants: true });
        this.toolsTemplateRef = contentChild("toolsTemplate", { read: TemplateRef });
        this.titleTemplateRef = contentChild("titleTemplate", { read: TemplateRef });
        this.isAllSelected = $computed(() => this.kanbanControls().every((ctrl) => ctrl.selected()));
        this.dragKanban = $computed(() => this._boardControl.dragKanban());
        this.dragOvered = $signal(false);
    }
    onToggleCollapseButtonClick() {
        this.collapse.update((v) => !v);
    }
    onSelectAllButtonClick(val) {
        if (val) {
            this._boardControl.selectedValues.update((v) => {
                const r = [...v];
                for (const ctrl of this.kanbanControls()) {
                    if (!v.includes(ctrl.value())) {
                        r.push(ctrl.value());
                    }
                }
                return r.length === v.length ? v : r;
            });
        }
        else {
            this._boardControl.selectedValues.update((v) => {
                const r = [...v];
                for (const ctrl of this.kanbanControls()) {
                    if (v.includes(ctrl.value())) {
                        r.remove((item) => item === ctrl.value());
                    }
                }
                return r.length === v.length ? v : r;
            });
        }
    }
    onDragOver(event) {
        if (this._boardControl.dragKanban() == null)
            return;
        event.preventDefault();
        event.stopPropagation();
        this.dragOvered.set(true);
    }
    onDragLeave(event) {
        event.preventDefault();
        event.stopPropagation();
        this.dragOvered.set(false);
    }
    onDragDrop(event) {
        if (this._boardControl.dragKanban() == null)
            return;
        this.dragOvered.set(false);
        event.preventDefault();
        event.stopPropagation();
        this._boardControl.onDropTo(this);
    }
    static { this.ɵfac = function SdKanbanLaneControl_Factory(__ngFactoryType__) { return new (__ngFactoryType__ || SdKanbanLaneControl)(); }; }
    static { this.ɵcmp = /*@__PURE__*/ i0.ɵɵdefineComponent({ type: SdKanbanLaneControl, selectors: [["sd-kanban-lane"]], contentQueries: function SdKanbanLaneControl_ContentQueries(rf, ctx, dirIndex) { if (rf & 1) {
            i0.ɵɵcontentQuerySignal(dirIndex, ctx.kanbanControls, SdKanbanControl, 5);
            i0.ɵɵcontentQuerySignal(dirIndex, ctx.toolsTemplateRef, _c0, 5, TemplateRef);
            i0.ɵɵcontentQuerySignal(dirIndex, ctx.titleTemplateRef, _c1, 5, TemplateRef);
        } if (rf & 2) {
            i0.ɵɵqueryAdvance(3);
        } }, hostVars: 1, hostBindings: function SdKanbanLaneControl_HostBindings(rf, ctx) { if (rf & 1) {
            i0.ɵɵlistener("dragover", function SdKanbanLaneControl_dragover_HostBindingHandler($event) { return ctx.onDragOver($event); })("dragleave", function SdKanbanLaneControl_dragleave_HostBindingHandler($event) { return ctx.onDragLeave($event); })("drop", function SdKanbanLaneControl_drop_HostBindingHandler($event) { return ctx.onDragDrop($event); });
        } if (rf & 2) {
            i0.ɵɵattribute("sd-drag-over", ctx.dragOvered());
        } }, inputs: { busy: [1, "busy"], useCollapse: [1, "useCollapse"], collapse: [1, "collapse"], value: [1, "value"] }, outputs: { collapse: "collapseChange" }, ngContentSelectors: _c2, decls: 7, vars: 8, consts: [[1, "p-default", "pb-0"], [1, "p-default"], ["type", "bar", 2, "min-height", "3em", 3, "busy"], [1, "tx-center", "mb-xl"], [1, "_drop-position"], ["theme", "info"], [1, "pl-default", 2, "display", "inline-block"], ["theme", "info", 3, "click"], ["fixedWidth", "", 3, "icon"], [3, "ngTemplateOutlet"], ["theme", "white", 2, "float", "left", 3, "inline", "value"], ["theme", "white", 2, "float", "left", 3, "valueChange", "inline", "value"]], template: function SdKanbanLaneControl_Template(rf, ctx) { if (rf & 1) {
            i0.ɵɵprojectionDef();
            i0.ɵɵelementStart(0, "sd-dock-container");
            i0.ɵɵtemplate(1, SdKanbanLaneControl_Conditional_1_Template, 3, 2, "sd-dock", 0);
            i0.ɵɵelementStart(2, "sd-pane", 1)(3, "sd-busy-container", 2);
            i0.ɵɵtemplate(4, SdKanbanLaneControl_Conditional_4_Template, 3, 2, "div", 3)(5, SdKanbanLaneControl_Conditional_5_Template, 1, 0);
            i0.ɵɵelement(6, "div", 4);
            i0.ɵɵelementEnd()()();
        } if (rf & 2) {
            let tmp_4_0;
            i0.ɵɵadvance();
            i0.ɵɵconditional(ctx.useCollapse() || ctx.titleTemplateRef() ? 1 : -1);
            i0.ɵɵadvance(2);
            i0.ɵɵproperty("busy", ctx.busy());
            i0.ɵɵadvance();
            i0.ɵɵconditional(ctx.kanbanControls().length > 0 || ctx.toolsTemplateRef() ? 4 : -1);
            i0.ɵɵadvance();
            i0.ɵɵconditional(!ctx.collapse() ? 5 : -1);
            i0.ɵɵadvance();
            i0.ɵɵstyleProp("height", ctx.dragOvered() ? ((tmp_4_0 = (tmp_4_0 = ctx.dragKanban()) == null ? null : tmp_4_0.heightOnDrag()) !== null && tmp_4_0 !== undefined ? tmp_4_0 : 0) + "px" : "0px")("display", ctx.dragKanban() ? "block" : "none");
        } }, dependencies: [SdBusyContainerControl,
            SdCheckboxControl,
            NgTemplateOutlet,
            SdDockContainerControl,
            SdDockControl,
            SdPaneControl,
            SdAnchorControl,
            SdIconControl], styles: ["sd-kanban-lane>sd-dock-container>._content>sd-pane>sd-busy-container{padding:var(--gap-xl) var(--gap-lg);background:var(--theme-grey-lightest);border-radius:var(--border-radius-default);height:100%}sd-kanban-lane>sd-dock-container>._content>sd-pane>sd-busy-container>._drop-position{pointer-events:none;border-radius:var(--border-radius-default);background:var(--trans-light);height:0;margin-bottom:0;visibility:hidden;transition:.1s linear;transition-property:height,margin-bottom,visibility}sd-kanban-lane[sd-drag-over=true]>sd-dock-container>._content>sd-pane>sd-busy-container>._drop-position{margin-bottom:var(--gap-lg);visibility:visible}\n"], encapsulation: 2, changeDetection: 0 }); }
}
(() => { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(SdKanbanLaneControl, [{
        type: Component,
        args: [{ selector: "sd-kanban-lane", changeDetection: ChangeDetectionStrategy.OnPush, encapsulation: ViewEncapsulation.None, standalone: true, imports: [
                    SdBusyContainerControl,
                    SdCheckboxControl,
                    NgTemplateOutlet,
                    SdDockContainerControl,
                    SdDockControl,
                    SdPaneControl,
                    SdAnchorControl,
                    SdIconControl,
                ], template: `
    <sd-dock-container>
      @if (useCollapse() || titleTemplateRef()) {
        <sd-dock class="p-default pb-0">
          @if (useCollapse()) {
            <sd-anchor theme="info" (click)="onToggleCollapseButtonClick()">
              <sd-icon [icon]="collapse() ? icons.eyeSlash : icons.eye" fixedWidth />
            </sd-anchor>
          }

          @if (titleTemplateRef()) {
            <div style="display: inline-block;" class="pl-default">
              <ng-template [ngTemplateOutlet]="titleTemplateRef() ?? null" />
            </div>
          }
        </sd-dock>
      }

      <sd-pane class="p-default">
        <sd-busy-container [busy]="busy()" style="min-height: 3em" type="bar">
          @if (kanbanControls().length > 0 || toolsTemplateRef()) {
            <div class="tx-center mb-xl">
              @if (kanbanControls().length > 0) {
                <sd-checkbox
                  style="float: left"
                  [inline]="true"
                  theme="white"
                  [value]="isAllSelected()"
                  (valueChange)="onSelectAllButtonClick($event)"
                />
              }
              <ng-template [ngTemplateOutlet]="toolsTemplateRef() ?? null" />
            </div>
          }

          @if (!collapse()) {
            <ng-content></ng-content>
          }

          <div
            class="_drop-position"
            [style.height]="dragOvered() ? (dragKanban()?.heightOnDrag() ?? 0) + 'px' : '0px'"
            [style.display]="dragKanban() ? 'block' : 'none'"
          ></div>
        </sd-busy-container>
      </sd-pane>
    </sd-dock-container>
  `, host: {
                    "[attr.sd-drag-over]": "dragOvered()",
                }, styles: ["sd-kanban-lane>sd-dock-container>._content>sd-pane>sd-busy-container{padding:var(--gap-xl) var(--gap-lg);background:var(--theme-grey-lightest);border-radius:var(--border-radius-default);height:100%}sd-kanban-lane>sd-dock-container>._content>sd-pane>sd-busy-container>._drop-position{pointer-events:none;border-radius:var(--border-radius-default);background:var(--trans-light);height:0;margin-bottom:0;visibility:hidden;transition:.1s linear;transition-property:height,margin-bottom,visibility}sd-kanban-lane[sd-drag-over=true]>sd-dock-container>._content>sd-pane>sd-busy-container>._drop-position{margin-bottom:var(--gap-lg);visibility:visible}\n"] }]
    }], null, { onDragOver: [{
            type: HostListener,
            args: ["dragover", ["$event"]]
        }], onDragLeave: [{
            type: HostListener,
            args: ["dragleave", ["$event"]]
        }], onDragDrop: [{
            type: HostListener,
            args: ["drop", ["$event"]]
        }] }); })();
(() => { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassDebugInfo(SdKanbanLaneControl, { className: "SdKanbanLaneControl", filePath: "packages/sd-angular/src/controls/sd-kanban-lane.control.ts", lineNumber: 132 }); })();
//# sourceMappingURL=sd-kanban-lane.control.js.map