import { NgTemplateOutlet } from "@angular/common";
import { ChangeDetectionStrategy, Component, contentChild, forwardRef, inject, input, model, TemplateRef, ViewEncapsulation, } from "@angular/core";
import { SdRippleDirective } from "../directives/sd-ripple.directive";
import { SdAngularConfigProvider } from "../providers/sd-angular-config.provider";
import { $computed } from "../utils/bindings/$computed";
import { transformBoolean } from "../utils/type-tramsforms";
import { SdCollapseIconControl } from "./sd-collapse-icon.control";
import { SdCollapseControl } from "./sd-collapse.control";
import { SdIconControl } from "./sd-icon.control";
import { SdListControl } from "./sd-list.control";
import * as i0 from "@angular/core";
const _c0 = ["toolsTemplate"];
const _c1 = ["*", [["sd-list"]]];
const _c2 = ["*", "sd-list"];
const _c3 = a0 => ["_content", a0];
function SdListItemControl_Conditional_2_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelement(0, "sd-icon", 2);
} if (rf & 2) {
    const ctx_r0 = i0.ɵɵnextContext();
    i0.ɵɵproperty("icon", ctx_r0.selectedIcon());
} }
function SdListItemControl_Conditional_5_ng_template_1_Template(rf, ctx) { }
function SdListItemControl_Conditional_5_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "div");
    i0.ɵɵtemplate(1, SdListItemControl_Conditional_5_ng_template_1_Template, 0, 0, "ng-template", 5);
    i0.ɵɵelementEnd();
} if (rf & 2) {
    const ctx_r0 = i0.ɵɵnextContext();
    i0.ɵɵadvance();
    i0.ɵɵproperty("ngTemplateOutlet", ctx_r0.toolsTemplateRef());
} }
function SdListItemControl_Conditional_6_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "div");
    i0.ɵɵelement(1, "sd-collapse-icon", 6);
    i0.ɵɵelementEnd();
} if (rf & 2) {
    const ctx_r0 = i0.ɵɵnextContext();
    i0.ɵɵadvance();
    i0.ɵɵproperty("open", ctx_r0.open());
} }
function SdListItemControl_Conditional_7_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "sd-collapse", 4);
    i0.ɵɵprojection(1, 1);
    i0.ɵɵelementEnd();
} if (rf & 2) {
    const ctx_r0 = i0.ɵɵnextContext();
    i0.ɵɵproperty("open", ctx_r0.layout() === "flat" || ctx_r0.open());
} }
export class SdListItemControl {
    constructor() {
        this.icons = inject(SdAngularConfigProvider).icons;
        this.open = model(false);
        this.selectedIcon = input();
        this.selected = input(false, { transform: transformBoolean });
        this.layout = input("accordion");
        this.contentStyle = input();
        this.contentClass = input();
        this.readonly = input(false, { transform: transformBoolean });
        this.toolsTemplateRef = contentChild("toolsTemplate", { read: TemplateRef });
        this.childListControl = contentChild(forwardRef(() => SdListControl));
        this.hasChildren = $computed(() => this.childListControl() !== undefined);
    }
    onContentClick() {
        this.open.update((v) => !v);
    }
    static { this.ɵfac = function SdListItemControl_Factory(__ngFactoryType__) { return new (__ngFactoryType__ || SdListItemControl)(); }; }
    static { this.ɵcmp = /*@__PURE__*/ i0.ɵɵdefineComponent({ type: SdListItemControl, selectors: [["sd-list-item"]], contentQueries: function SdListItemControl_ContentQueries(rf, ctx, dirIndex) { if (rf & 1) {
            i0.ɵɵcontentQuerySignal(dirIndex, ctx.toolsTemplateRef, _c0, 5, TemplateRef);
            i0.ɵɵcontentQuerySignal(dirIndex, ctx.childListControl, SdListControl, 5);
        } if (rf & 2) {
            i0.ɵɵqueryAdvance(2);
        } }, hostVars: 6, hostBindings: function SdListItemControl_HostBindings(rf, ctx) { if (rf & 2) {
            i0.ɵɵattribute("sd-layout", ctx.layout())("sd-open", ctx.open())("sd-selected", ctx.selected())("sd-readonly", ctx.readonly())("sd-has-selected-icon", !!ctx.selectedIcon())("sd-has-children", ctx.hasChildren());
        } }, inputs: { open: [1, "open"], selectedIcon: [1, "selectedIcon"], selected: [1, "selected"], layout: [1, "layout"], contentStyle: [1, "contentStyle"], contentClass: [1, "contentClass"], readonly: [1, "readonly"] }, outputs: { open: "openChange" }, ngContentSelectors: _c2, decls: 8, vars: 11, consts: [["tabindex", "0", 3, "click", "sd-ripple"], [1, "flex-row", "flex-gap-xs"], ["fixedWidth", "", 1, "_selected-icon", 3, "icon"], [2, "flex-grow", "1"], [1, "_child", 3, "open"], [3, "ngTemplateOutlet"], [3, "open"]], template: function SdListItemControl_Template(rf, ctx) { if (rf & 1) {
            i0.ɵɵprojectionDef(_c1);
            i0.ɵɵelementStart(0, "div", 0);
            i0.ɵɵlistener("click", function SdListItemControl_Template_div_click_0_listener() { return ctx.onContentClick(); });
            i0.ɵɵelementStart(1, "div", 1);
            i0.ɵɵtemplate(2, SdListItemControl_Conditional_2_Template, 1, 1, "sd-icon", 2);
            i0.ɵɵelementStart(3, "div", 3);
            i0.ɵɵprojection(4);
            i0.ɵɵelementEnd();
            i0.ɵɵtemplate(5, SdListItemControl_Conditional_5_Template, 2, 1, "div")(6, SdListItemControl_Conditional_6_Template, 2, 1, "div");
            i0.ɵɵelementEnd()();
            i0.ɵɵtemplate(7, SdListItemControl_Conditional_7_Template, 2, 1, "sd-collapse", 4);
        } if (rf & 2) {
            i0.ɵɵstyleMap(ctx.contentStyle());
            i0.ɵɵclassMap(i0.ɵɵpureFunction1(9, _c3, ctx.contentClass()).filterExists().join(" "));
            i0.ɵɵproperty("sd-ripple", !ctx.readonly() && !(ctx.layout() === "flat" && ctx.hasChildren()));
            i0.ɵɵadvance(2);
            i0.ɵɵconditional(ctx.selectedIcon() && !ctx.hasChildren() ? 2 : -1);
            i0.ɵɵadvance(3);
            i0.ɵɵconditional(ctx.toolsTemplateRef() ? 5 : -1);
            i0.ɵɵadvance();
            i0.ɵɵconditional(ctx.hasChildren() && ctx.layout() === "accordion" ? 6 : -1);
            i0.ɵɵadvance();
            i0.ɵɵconditional(ctx.hasChildren() ? 7 : -1);
        } }, dependencies: [SdCollapseIconControl,
            SdCollapseControl,
            SdRippleDirective,
            NgTemplateOutlet,
            SdIconControl], styles: ["sd-list-item>._content{padding:var(--gap-sm) var(--gap-default);border-radius:var(--border-radius-default);margin:var(--gap-xxs)}sd-list-item>._content>.flex-row>._selected-icon{color:var(--text-trans-lightest)}sd-list-item:not([sd-readonly=true])>._content{cursor:pointer}sd-list-item>._child{margin:var(--gap-xxs)}sd-list-item[sd-layout=accordion]:not([sd-readonly=true])>._content:hover{background:var(--trans-lighter)}sd-list-item[sd-layout=accordion]>._child>._content>sd-list{padding:var(--gap-sm) 0}sd-list-item[sd-layout=flat]>._content{display:none}sd-list-item[sd-layout=flat][sd-has-children=true]>._content{display:block;background:transparent;cursor:default;font-size:var(--font-size-sm);opacity:.7;margin-top:var(--gap-sm)}sd-list-item[sd-selected=true]>._content{background:var(--trans-lighter);font-weight:700}sd-list-item[sd-has-selected-icon=true][sd-selected=true]>._content{color:var(--text-trans-default)}sd-list-item[sd-has-selected-icon=true][sd-selected=true]>._content>.flex-row>._selected-icon{color:var(--theme-primary-default)}sd-list-item[sd-has-selected-icon=true][sd-selected=true]>._content:hover{background:var(--trans-lighter)}\n"], encapsulation: 2, changeDetection: 0 }); }
}
(() => { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(SdListItemControl, [{
        type: Component,
        args: [{ selector: "sd-list-item", changeDetection: ChangeDetectionStrategy.OnPush, encapsulation: ViewEncapsulation.None, standalone: true, imports: [
                    SdCollapseIconControl,
                    SdCollapseControl,
                    SdRippleDirective,
                    NgTemplateOutlet,
                    SdIconControl,
                ], template: `
    <div
      [class]="['_content', contentClass()].filterExists().join(' ')"
      [style]="contentStyle()"
      (click)="onContentClick()"
      tabindex="0"
      [sd-ripple]="!readonly() && !(layout() === 'flat' && hasChildren())"
    >
      <div class="flex-row flex-gap-xs">
        @if (selectedIcon() && !hasChildren()) {
          <sd-icon class="_selected-icon" [icon]="selectedIcon()!" fixedWidth />
        }
        <div style="flex-grow: 1">
          <ng-content></ng-content>
        </div>

        @if (toolsTemplateRef()) {
          <div>
            <ng-template [ngTemplateOutlet]="toolsTemplateRef()!" />
          </div>
        }

        @if (hasChildren() && layout() === "accordion") {
          <div>
            <sd-collapse-icon [open]="open()" />
          </div>
        }
      </div>
    </div>
    @if (hasChildren()) {
      <sd-collapse class="_child" [open]="layout() === 'flat' || open()">
        <ng-content select="sd-list"></ng-content>
      </sd-collapse>
    }
  `, host: {
                    "[attr.sd-layout]": "layout()",
                    "[attr.sd-open]": "open()",
                    "[attr.sd-selected]": "selected()",
                    "[attr.sd-readonly]": "readonly()",
                    "[attr.sd-has-selected-icon]": "!!selectedIcon()",
                    "[attr.sd-has-children]": "hasChildren()",
                }, styles: ["sd-list-item>._content{padding:var(--gap-sm) var(--gap-default);border-radius:var(--border-radius-default);margin:var(--gap-xxs)}sd-list-item>._content>.flex-row>._selected-icon{color:var(--text-trans-lightest)}sd-list-item:not([sd-readonly=true])>._content{cursor:pointer}sd-list-item>._child{margin:var(--gap-xxs)}sd-list-item[sd-layout=accordion]:not([sd-readonly=true])>._content:hover{background:var(--trans-lighter)}sd-list-item[sd-layout=accordion]>._child>._content>sd-list{padding:var(--gap-sm) 0}sd-list-item[sd-layout=flat]>._content{display:none}sd-list-item[sd-layout=flat][sd-has-children=true]>._content{display:block;background:transparent;cursor:default;font-size:var(--font-size-sm);opacity:.7;margin-top:var(--gap-sm)}sd-list-item[sd-selected=true]>._content{background:var(--trans-lighter);font-weight:700}sd-list-item[sd-has-selected-icon=true][sd-selected=true]>._content{color:var(--text-trans-default)}sd-list-item[sd-has-selected-icon=true][sd-selected=true]>._content>.flex-row>._selected-icon{color:var(--theme-primary-default)}sd-list-item[sd-has-selected-icon=true][sd-selected=true]>._content:hover{background:var(--trans-lighter)}\n"] }]
    }], null, null); })();
(() => { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassDebugInfo(SdListItemControl, { className: "SdListItemControl", filePath: "packages/sd-angular/src/controls/sd-list-item.control.ts", lineNumber: 164 }); })();
//# sourceMappingURL=sd-list-item.control.js.map