import { ElementRef } from "@angular/core";
import { ISdResizeEvent } from "../plugins/events/sd-resize.event-plugin";
import * as i0 from "@angular/core";
export declare class SdModalControl {
    protected readonly icons: import("../providers/sd-angular-config.provider").ISdAngularIcon;
    private _sdSystemConfig;
    private _elRef;
    open: import("@angular/core").ModelSignal<boolean>;
    key: import("@angular/core").InputSignal<string | undefined>;
    title: import("@angular/core").InputSignal<string>;
    hideHeader: import("@angular/core").InputSignalWithTransform<boolean, boolean | "" | undefined>;
    hideCloseButton: import("@angular/core").InputSignalWithTransform<boolean, boolean | "" | undefined>;
    useCloseByBackdrop: import("@angular/core").InputSignalWithTransform<boolean, boolean | "" | undefined>;
    useCloseByEscapeKey: import("@angular/core").InputSignalWithTransform<boolean, boolean | "" | undefined>;
    resizable: import("@angular/core").InputSignalWithTransform<boolean, boolean | "" | undefined>;
    movable: import("@angular/core").InputSignalWithTransform<boolean, boolean | "" | undefined>;
    float: import("@angular/core").InputSignalWithTransform<boolean, boolean | "" | undefined>;
    fill: import("@angular/core").InputSignalWithTransform<boolean, boolean | "" | undefined>;
    heightPx: import("@angular/core").InputSignal<number | undefined>;
    widthPx: import("@angular/core").InputSignal<number | undefined>;
    minHeightPx: import("@angular/core").InputSignal<number | undefined>;
    minWidthPx: import("@angular/core").InputSignal<number | undefined>;
    position: import("@angular/core").InputSignal<"bottom-right" | "top-right" | undefined>;
    headerStyle: import("@angular/core").InputSignal<string | undefined>;
    dialogElRef: import("@angular/core").Signal<ElementRef<HTMLElement>>;
    private _config;
    constructor();
    onDialogFocus(): void;
    onResize(event: ISdResizeEvent): void;
    onDialogResize(event: ISdResizeEvent): void;
    private _calcHeight;
    private _calcWidth;
    onWindowResize(): void;
    onCloseButtonClick(): void;
    onBackdropClick(): void;
    onDialogEscapeKeydown(): void;
    onResizeBarMousedown(event: MouseEvent, direction: "left" | "right" | "top" | "top-left" | "top-right" | "bottom" | "bottom-left" | "bottom-right"): void;
    onHeaderMouseDown(event: MouseEvent): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<SdModalControl, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<SdModalControl, "sd-modal", never, { "open": { "alias": "open"; "required": false; "isSignal": true; }; "key": { "alias": "key"; "required": false; "isSignal": true; }; "title": { "alias": "title"; "required": true; "isSignal": true; }; "hideHeader": { "alias": "hideHeader"; "required": false; "isSignal": true; }; "hideCloseButton": { "alias": "hideCloseButton"; "required": false; "isSignal": true; }; "useCloseByBackdrop": { "alias": "useCloseByBackdrop"; "required": false; "isSignal": true; }; "useCloseByEscapeKey": { "alias": "useCloseByEscapeKey"; "required": false; "isSignal": true; }; "resizable": { "alias": "resizable"; "required": false; "isSignal": true; }; "movable": { "alias": "movable"; "required": false; "isSignal": true; }; "float": { "alias": "float"; "required": false; "isSignal": true; }; "fill": { "alias": "fill"; "required": false; "isSignal": true; }; "heightPx": { "alias": "heightPx"; "required": false; "isSignal": true; }; "widthPx": { "alias": "widthPx"; "required": false; "isSignal": true; }; "minHeightPx": { "alias": "minHeightPx"; "required": false; "isSignal": true; }; "minWidthPx": { "alias": "minWidthPx"; "required": false; "isSignal": true; }; "position": { "alias": "position"; "required": false; "isSignal": true; }; "headerStyle": { "alias": "headerStyle"; "required": false; "isSignal": true; }; }, { "open": "openChange"; }, never, ["*"], true, never>;
}
export interface ISdModalConfigVM {
    position: string;
    left: string;
    top: string;
    right: string;
    bottom: string;
    width: string;
    height: string;
}
