import { ChangeDetectionStrategy, Component, ElementRef, forwardRef, HostListener, inject, input, model, viewChild, ViewEncapsulation, } from "@angular/core";
import { NumberUtils } from "@simplysm/sd-core-common";
import { SdEventsDirective } from "../directives/sd-events.directive";
import { SdAngularConfigProvider } from "../providers/sd-angular-config.provider";
import { SdSystemConfigProvider } from "../providers/sd-system-config.provider";
import { $effect } from "../utils/bindings/$effect";
import { $signal } from "../utils/bindings/$signal";
import { injectElementRef } from "../utils/injections/inject-element-ref";
import { transformBoolean } from "../utils/type-tramsforms";
import { SdAnchorControl } from "./sd-anchor.control";
import { SdDockContainerControl } from "./sd-dock-container.control";
import { SdDockControl } from "./sd-dock.control";
import { SdIconControl } from "./sd-icon.control";
import { SdPaneControl } from "./sd-pane.control";
import * as i0 from "@angular/core";
const _c0 = ["dialogEl"];
const _c1 = ["*"];
function SdModalControl_Conditional_4_Conditional_3_Template(rf, ctx) { if (rf & 1) {
    const _r4 = i0.ɵɵgetCurrentView();
    i0.ɵɵelementStart(0, "sd-anchor", 8);
    i0.ɵɵlistener("click", function SdModalControl_Conditional_4_Conditional_3_Template_sd_anchor_click_0_listener() { i0.ɵɵrestoreView(_r4); const ctx_r2 = i0.ɵɵnextContext(2); return i0.ɵɵresetView(ctx_r2.onCloseButtonClick()); });
    i0.ɵɵelement(1, "sd-icon", 9);
    i0.ɵɵelementEnd();
} if (rf & 2) {
    const ctx_r2 = i0.ɵɵnextContext(2);
    i0.ɵɵadvance();
    i0.ɵɵproperty("icon", ctx_r2.icons.xmark);
} }
function SdModalControl_Conditional_4_Template(rf, ctx) { if (rf & 1) {
    const _r2 = i0.ɵɵgetCurrentView();
    i0.ɵɵelementStart(0, "sd-dock", 5);
    i0.ɵɵlistener("mousedown", function SdModalControl_Conditional_4_Template_sd_dock_mousedown_0_listener($event) { i0.ɵɵrestoreView(_r2); const ctx_r2 = i0.ɵɵnextContext(); return i0.ɵɵresetView(ctx_r2.onHeaderMouseDown($event)); });
    i0.ɵɵelementStart(1, "h5", 6);
    i0.ɵɵtext(2);
    i0.ɵɵelementEnd();
    i0.ɵɵtemplate(3, SdModalControl_Conditional_4_Conditional_3_Template, 2, 1, "sd-anchor", 7);
    i0.ɵɵelementEnd();
} if (rf & 2) {
    const ctx_r2 = i0.ɵɵnextContext();
    i0.ɵɵstyleMap(ctx_r2.headerStyle());
    i0.ɵɵadvance(2);
    i0.ɵɵtextInterpolate(ctx_r2.title());
    i0.ɵɵadvance();
    i0.ɵɵconditional(!ctx_r2.hideCloseButton() ? 3 : -1);
} }
function SdModalControl_Conditional_7_Template(rf, ctx) { if (rf & 1) {
    const _r5 = i0.ɵɵgetCurrentView();
    i0.ɵɵelementStart(0, "div", 10);
    i0.ɵɵlistener("mousedown", function SdModalControl_Conditional_7_Template_div_mousedown_0_listener($event) { i0.ɵɵrestoreView(_r5); const ctx_r2 = i0.ɵɵnextContext(); return i0.ɵɵresetView(ctx_r2.onResizeBarMousedown($event, "left")); });
    i0.ɵɵelementEnd();
    i0.ɵɵelementStart(1, "div", 11);
    i0.ɵɵlistener("mousedown", function SdModalControl_Conditional_7_Template_div_mousedown_1_listener($event) { i0.ɵɵrestoreView(_r5); const ctx_r2 = i0.ɵɵnextContext(); return i0.ɵɵresetView(ctx_r2.onResizeBarMousedown($event, "right")); });
    i0.ɵɵelementEnd();
    i0.ɵɵelementStart(2, "div", 12);
    i0.ɵɵlistener("mousedown", function SdModalControl_Conditional_7_Template_div_mousedown_2_listener($event) { i0.ɵɵrestoreView(_r5); const ctx_r2 = i0.ɵɵnextContext(); return i0.ɵɵresetView(ctx_r2.onResizeBarMousedown($event, "top")); });
    i0.ɵɵelementEnd();
    i0.ɵɵelementStart(3, "div", 13);
    i0.ɵɵlistener("mousedown", function SdModalControl_Conditional_7_Template_div_mousedown_3_listener($event) { i0.ɵɵrestoreView(_r5); const ctx_r2 = i0.ɵɵnextContext(); return i0.ɵɵresetView(ctx_r2.onResizeBarMousedown($event, "top-right")); });
    i0.ɵɵelementEnd();
    i0.ɵɵelementStart(4, "div", 14);
    i0.ɵɵlistener("mousedown", function SdModalControl_Conditional_7_Template_div_mousedown_4_listener($event) { i0.ɵɵrestoreView(_r5); const ctx_r2 = i0.ɵɵnextContext(); return i0.ɵɵresetView(ctx_r2.onResizeBarMousedown($event, "top-left")); });
    i0.ɵɵelementEnd();
    i0.ɵɵelementStart(5, "div", 15);
    i0.ɵɵlistener("mousedown", function SdModalControl_Conditional_7_Template_div_mousedown_5_listener($event) { i0.ɵɵrestoreView(_r5); const ctx_r2 = i0.ɵɵnextContext(); return i0.ɵɵresetView(ctx_r2.onResizeBarMousedown($event, "bottom")); });
    i0.ɵɵelementEnd();
    i0.ɵɵelementStart(6, "div", 16);
    i0.ɵɵlistener("mousedown", function SdModalControl_Conditional_7_Template_div_mousedown_6_listener($event) { i0.ɵɵrestoreView(_r5); const ctx_r2 = i0.ɵɵnextContext(); return i0.ɵɵresetView(ctx_r2.onResizeBarMousedown($event, "bottom-right")); });
    i0.ɵɵelementEnd();
    i0.ɵɵelementStart(7, "div", 17);
    i0.ɵɵlistener("mousedown", function SdModalControl_Conditional_7_Template_div_mousedown_7_listener($event) { i0.ɵɵrestoreView(_r5); const ctx_r2 = i0.ɵɵnextContext(); return i0.ɵɵresetView(ctx_r2.onResizeBarMousedown($event, "bottom-left")); });
    i0.ɵɵelementEnd();
} }
export class SdModalControl {
    constructor() {
        this.icons = inject(SdAngularConfigProvider).icons;
        this._sdSystemConfig = inject(SdSystemConfigProvider);
        this._elRef = injectElementRef();
        this.open = model(false);
        this.key = input();
        this.title = input.required();
        this.hideHeader = input(false, { transform: transformBoolean });
        this.hideCloseButton = input(false, { transform: transformBoolean });
        this.useCloseByBackdrop = input(false, { transform: transformBoolean });
        this.useCloseByEscapeKey = input(false, { transform: transformBoolean });
        this.resizable = input(false, { transform: transformBoolean });
        this.movable = input(true, { transform: transformBoolean });
        this.float = input(false, { transform: transformBoolean });
        this.fill = input(false, { transform: transformBoolean });
        this.heightPx = input();
        this.widthPx = input();
        this.minHeightPx = input();
        this.minWidthPx = input();
        this.position = input();
        this.headerStyle = input();
        this.dialogElRef = viewChild.required("dialogEl", { read: ElementRef });
        this._config = $signal();
        $effect([this.key], async () => {
            this._config.set(await this._sdSystemConfig.getAsync(`sd-modal.${this.key()}`));
        });
        $effect(() => {
            const conf = this._config();
            if (conf) {
                this.dialogElRef().nativeElement.style.position = conf.position;
                this.dialogElRef().nativeElement.style.left = conf.left;
                this.dialogElRef().nativeElement.style.top = conf.top;
                this.dialogElRef().nativeElement.style.right = conf.right;
                this.dialogElRef().nativeElement.style.bottom = conf.bottom;
                if (conf.width) {
                    this.dialogElRef().nativeElement.style.width = conf.width;
                }
                if (conf.height) {
                    this.dialogElRef().nativeElement.style.height = conf.height;
                }
            }
            this._elRef.nativeElement.setAttribute("sd-init", "true");
        });
        $effect(() => {
            if (this.open()) {
                this.dialogElRef().nativeElement.focus();
            }
        });
    }
    onDialogFocus() {
        const maxZIndex = document.body.findAll("sd-modal")
            .max((el) => Number(getComputedStyle(el).zIndex));
        if (maxZIndex !== undefined) {
            this._elRef.nativeElement.style.zIndex = (maxZIndex + 1).toString();
        }
    }
    onResize(event) {
        if (event.heightChanged) {
            this._calcHeight();
        }
        if (event.widthChanged) {
            this._calcWidth();
        }
    }
    onDialogResize(event) {
        if (event.heightChanged) {
            this._calcHeight();
        }
        if (event.widthChanged) {
            this._calcWidth();
        }
    }
    _calcHeight() {
        const style = getComputedStyle(this._elRef.nativeElement);
        let paddingTop = style.paddingTop === "" ? 0 : (NumberUtils.parseInt(style.paddingTop) ?? 0);
        if (this.dialogElRef().nativeElement.offsetHeight
            > this._elRef.nativeElement.offsetHeight
                - paddingTop) {
            this.dialogElRef().nativeElement.style.maxHeight = `100%`; // `calc(100% - ${paddingTop}px)`;
            this.dialogElRef().nativeElement.style.height = `100%`; // `calc(100% - ${paddingTop}px)`;
        }
    }
    _calcWidth() {
        if (this.dialogElRef().nativeElement.offsetWidth > this._elRef.nativeElement.offsetWidth) {
            this.dialogElRef().nativeElement.style.maxWidth = `100%`;
            this.dialogElRef().nativeElement.style.width = `100%`;
        }
    }
    onWindowResize() {
        if (this.dialogElRef().nativeElement.offsetLeft > this._elRef.nativeElement.offsetWidth - 100) {
            this.dialogElRef().nativeElement.style.left = this._elRef.nativeElement.offsetWidth
                - 100
                + "px";
        }
        if (this.dialogElRef().nativeElement.offsetTop > this._elRef.nativeElement.offsetHeight - 100) {
            this.dialogElRef().nativeElement.style.right = this._elRef.nativeElement.offsetHeight
                - 100
                + "px";
        }
    }
    onCloseButtonClick() {
        if (this.hideCloseButton()) {
            return;
        }
        this.open.set(false);
    }
    onBackdropClick() {
        if (this.hideCloseButton() || !this.useCloseByBackdrop()) {
            return;
        }
        this.open.set(false);
    }
    onDialogEscapeKeydown() {
        if (this.hideCloseButton() || !this.useCloseByEscapeKey()) {
            return;
        }
        this.open.set(false);
    }
    onResizeBarMousedown(event, direction) {
        if (!this.resizable())
            return;
        const dialogEl = this.dialogElRef().nativeElement;
        const startX = event.clientX;
        const startY = event.clientY;
        const startHeight = dialogEl.clientHeight;
        const startWidth = dialogEl.clientWidth;
        const startTop = dialogEl.offsetTop;
        const startLeft = dialogEl.offsetLeft;
        let isDoDrag = false;
        const doDrag = (e) => {
            e.stopPropagation();
            e.preventDefault();
            if (direction === "top" || direction === "top-right" || direction === "top-left") {
                if (dialogEl.style.position === "absolute") {
                    dialogEl.style.top = startTop + (e.clientY - startY) + "px";
                    dialogEl.style.bottom = "auto";
                }
                dialogEl.style.height = `${Math.max(startHeight - (e.clientY - startY), this.minHeightPx() ?? 0)}px`;
            }
            if (direction === "bottom" || direction === "bottom-right" || direction === "bottom-left") {
                dialogEl.style.height = `${Math.max(startHeight + e.clientY - startY, this.minHeightPx() ?? 0)}px`;
            }
            if (direction === "right" || direction === "bottom-right" || direction === "top-right") {
                dialogEl.style.width = `${Math.max(startWidth
                    + (e.clientX - startX)
                        * (dialogEl.style.position === "absolute"
                            ? 1
                            : 2), this.minWidthPx() ?? 0)}px`;
            }
            if (direction === "left" || direction === "bottom-left" || direction === "top-left") {
                if (dialogEl.style.position === "absolute") {
                    dialogEl.style.left = startLeft + (e.clientX - startX) + "px";
                }
                dialogEl.style.width = `${Math.max(startWidth
                    - (e.clientX - startX)
                        * (dialogEl.style.position === "absolute"
                            ? 1
                            : 2), this.minWidthPx() ?? 0)}px`;
            }
            isDoDrag = true;
        };
        const stopDrag = async (e) => {
            e.stopPropagation();
            e.preventDefault();
            document.documentElement.removeEventListener("mousemove", doDrag, false);
            document.documentElement.removeEventListener("mouseup", stopDrag, false);
            if (this.key() != null && isDoDrag) {
                const newConf = {
                    position: dialogEl.style.position,
                    left: dialogEl.style.left,
                    top: dialogEl.style.top,
                    right: dialogEl.style.right,
                    bottom: dialogEl.style.bottom,
                    width: dialogEl.style.width,
                    height: dialogEl.style.height,
                };
                this._config.set(newConf);
                await this._sdSystemConfig.setAsync(`sd-modal.${this.key()}`, newConf);
            }
        };
        document.documentElement.addEventListener("mousemove", doDrag, false);
        document.documentElement.addEventListener("mouseup", stopDrag, false);
    }
    onHeaderMouseDown(event) {
        if (!this.movable())
            return;
        const dialogEl = this.dialogElRef().nativeElement;
        const startX = event.clientX;
        const startY = event.clientY;
        const startTop = dialogEl.offsetTop;
        const startLeft = dialogEl.offsetLeft;
        let isDoDrag = false;
        const doDrag = (e) => {
            e.stopPropagation();
            e.preventDefault();
            dialogEl.style.position = "absolute";
            dialogEl.style.left = `${startLeft + e.clientX - startX}px`;
            dialogEl.style.top = `${startTop + e.clientY - startY}px`;
            dialogEl.style.right = "auto";
            dialogEl.style.bottom = "auto";
            const el = this._elRef.nativeElement;
            if (dialogEl.offsetLeft > el.offsetWidth - 100) {
                dialogEl.style.left = el.offsetWidth - 100 + "px";
            }
            if (dialogEl.offsetTop > el.offsetHeight - 100) {
                dialogEl.style.top = el.offsetHeight - 100 + "px";
            }
            if (dialogEl.offsetTop < 0) {
                dialogEl.style.top = "0";
            }
            if (dialogEl.offsetLeft < -dialogEl.offsetWidth + 100) {
                dialogEl.style.left = -dialogEl.offsetWidth + 100 + "px";
            }
            isDoDrag = true;
        };
        const stopDrag = async (e) => {
            e.stopPropagation();
            e.preventDefault();
            document.documentElement.removeEventListener("mousemove", doDrag, false);
            document.documentElement.removeEventListener("mouseup", stopDrag, false);
            if (this.key() != null && isDoDrag) {
                const newConf = {
                    position: dialogEl.style.position,
                    left: dialogEl.style.left,
                    top: dialogEl.style.top,
                    right: dialogEl.style.right,
                    bottom: dialogEl.style.bottom,
                    width: dialogEl.style.width,
                    height: dialogEl.style.height,
                };
                this._config.set(newConf);
                await this._sdSystemConfig.setAsync(`sd-modal.${this.key()}`, newConf);
            }
        };
        document.documentElement.addEventListener("mousemove", doDrag, false);
        document.documentElement.addEventListener("mouseup", stopDrag, false);
    }
    static { this.ɵfac = function SdModalControl_Factory(__ngFactoryType__) { return new (__ngFactoryType__ || SdModalControl)(); }; }
    static { this.ɵcmp = /*@__PURE__*/ i0.ɵɵdefineComponent({ type: SdModalControl, selectors: [["sd-modal"]], viewQuery: function SdModalControl_Query(rf, ctx) { if (rf & 1) {
            i0.ɵɵviewQuerySignal(ctx.dialogElRef, _c0, 5, ElementRef);
        } if (rf & 2) {
            i0.ɵɵqueryAdvance();
        } }, hostVars: 4, hostBindings: function SdModalControl_HostBindings(rf, ctx) { if (rf & 1) {
            i0.ɵɵlistener("sdResize", function SdModalControl_sdResize_HostBindingHandler($event) { return ctx.onResize($event); })("resize", function SdModalControl_resize_HostBindingHandler() { return ctx.onWindowResize(); }, false, i0.ɵɵresolveWindow);
        } if (rf & 2) {
            i0.ɵɵattribute("sd-open", ctx.open())("sd-float", ctx.float())("sd-position", ctx.position())("sd-fill", ctx.fill());
        } }, inputs: { open: [1, "open"], key: [1, "key"], title: [1, "title"], hideHeader: [1, "hideHeader"], hideCloseButton: [1, "hideCloseButton"], useCloseByBackdrop: [1, "useCloseByBackdrop"], useCloseByEscapeKey: [1, "useCloseByEscapeKey"], resizable: [1, "resizable"], movable: [1, "movable"], float: [1, "float"], fill: [1, "fill"], heightPx: [1, "heightPx"], widthPx: [1, "widthPx"], minHeightPx: [1, "minHeightPx"], minWidthPx: [1, "minWidthPx"], position: [1, "position"], headerStyle: [1, "headerStyle"] }, outputs: { open: "openChange" }, ngContentSelectors: _c1, decls: 8, vars: 10, consts: [["dialogEl", ""], [1, "_backdrop", 3, "click"], ["tabindex", "0", 1, "_dialog", 3, "keydown.escape", "focus", "sdResize"], [1, "_header", 3, "style"], [1, "_content"], [1, "_header", 3, "mousedown"], [1, "_title"], ["theme", "grey", 1, "_close-button"], ["theme", "grey", 1, "_close-button", 3, "click"], ["fixedWidth", "", 3, "icon"], [1, "_left-resize-bar", 3, "mousedown"], [1, "_right-resize-bar", 3, "mousedown"], [1, "_top-resize-bar", 3, "mousedown"], [1, "_top-right-resize-bar", 3, "mousedown"], [1, "_top-left-resize-bar", 3, "mousedown"], [1, "_bottom-resize-bar", 3, "mousedown"], [1, "_bottom-right-resize-bar", 3, "mousedown"], [1, "_bottom-left-resize-bar", 3, "mousedown"]], template: function SdModalControl_Template(rf, ctx) { if (rf & 1) {
            const _r1 = i0.ɵɵgetCurrentView();
            i0.ɵɵprojectionDef();
            i0.ɵɵelementStart(0, "div", 1);
            i0.ɵɵlistener("click", function SdModalControl_Template_div_click_0_listener() { i0.ɵɵrestoreView(_r1); return i0.ɵɵresetView(ctx.onBackdropClick()); });
            i0.ɵɵelementEnd();
            i0.ɵɵelementStart(1, "div", 2, 0);
            i0.ɵɵlistener("keydown.escape", function SdModalControl_Template_div_keydown_escape_1_listener() { i0.ɵɵrestoreView(_r1); return i0.ɵɵresetView(ctx.onDialogEscapeKeydown()); })("focus", function SdModalControl_Template_div_focus_1_listener() { i0.ɵɵrestoreView(_r1); return i0.ɵɵresetView(ctx.onDialogFocus()); })("sdResize", function SdModalControl_Template_div_sdResize_1_listener($event) { i0.ɵɵrestoreView(_r1); return i0.ɵɵresetView(ctx.onDialogResize($event)); });
            i0.ɵɵelementStart(3, "sd-dock-container");
            i0.ɵɵtemplate(4, SdModalControl_Conditional_4_Template, 4, 4, "sd-dock", 3);
            i0.ɵɵelementStart(5, "sd-pane", 4);
            i0.ɵɵprojection(6);
            i0.ɵɵelementEnd()();
            i0.ɵɵtemplate(7, SdModalControl_Conditional_7_Template, 8, 0);
            i0.ɵɵelementEnd();
        } if (rf & 2) {
            i0.ɵɵadvance();
            i0.ɵɵstyleProp("min-width", ctx.minWidthPx(), "px")("min-height", ctx.minHeightPx(), "px")("width", ctx.minWidthPx() && ctx.widthPx() && ctx.minWidthPx() > ctx.widthPx() ? ctx.minWidthPx() : ctx.widthPx(), "px")("height", ctx.minHeightPx() && ctx.heightPx() && ctx.minHeightPx() > ctx.heightPx() ? ctx.minHeightPx() : ctx.heightPx(), "px");
            i0.ɵɵadvance(3);
            i0.ɵɵconditional(!ctx.hideHeader() ? 4 : -1);
            i0.ɵɵadvance(3);
            i0.ɵɵconditional(ctx.resizable() ? 7 : -1);
        } }, dependencies: () => [SdAnchorControl,
            SdPaneControl,
            SdDockContainerControl,
            SdDockControl,
            SdEventsDirective, SdIconControl], styles: ["sd-modal{display:block;position:fixed;z-index:var(--z-index-modal);top:0;left:0;width:100%;height:100%;padding-top:calc(var(--topbar-height) + var(--gap-sm));opacity:0;transition:opacity var(--animation-duration) ease-in-out;pointer-events:none}sd-modal>._backdrop{position:fixed;top:0;left:0;width:100%;height:100%;background:#0009}sd-modal>._dialog{position:relative;display:block;margin:0 auto;width:fit-content;min-width:240px;background:var(--control-color);overflow:hidden;box-shadow:0 0 2px #0000000d,0 calc(16 * var(--elevation-size)) calc(16 * 4 * var(--elevation-size)) #0000000d;border-radius:var(--border-radius-default)}sd-modal>._dialog:focus{outline:none}sd-modal>._dialog>sd-dock-container>._content>._header{display:flex;flex-direction:row;user-select:none;border-bottom:1px solid var(--trans-light)}sd-modal>._dialog>sd-dock-container>._content>._header>._title{flex-grow:1;padding:var(--gap-sm) var(--gap-default)}sd-modal>._dialog>sd-dock-container>._content>._header>._close-button{padding:var(--gap-sm) var(--gap-default)}sd-modal>._dialog>._left-resize-bar{position:absolute;top:0;left:0;width:var(--gap-sm);height:100%;cursor:ew-resize}sd-modal>._dialog>._right-resize-bar{position:absolute;top:0;right:0;width:var(--gap-sm);height:100%;cursor:ew-resize}sd-modal>._dialog>._top-resize-bar{position:absolute;top:0;left:0;width:100%;height:var(--gap-sm);cursor:ns-resize}sd-modal>._dialog>._top-right-resize-bar{position:absolute;right:0;top:0;width:var(--gap-sm);height:var(--gap-sm);z-index:1;cursor:nesw-resize}sd-modal>._dialog>._top-left-resize-bar{position:absolute;left:0;top:0;width:var(--gap-sm);height:var(--gap-sm);cursor:nwse-resize;z-index:1}sd-modal>._dialog>._bottom-resize-bar{position:absolute;bottom:0;left:0;width:100%;height:var(--gap-sm);cursor:ns-resize}sd-modal>._dialog>._bottom-right-resize-bar{position:absolute;right:0;bottom:0;width:var(--gap-sm);height:var(--gap-sm);z-index:1;cursor:nwse-resize}sd-modal>._dialog>._bottom-left-resize-bar{position:absolute;left:0;bottom:0;width:var(--gap-sm);height:var(--gap-sm);cursor:nesw-resize;z-index:1}sd-modal>._dialog{transform:translateY(-25px);transition:transform var(--animation-duration) ease-in-out}sd-modal[sd-open=true][sd-init=true]{opacity:1;pointer-events:auto}sd-modal[sd-open=true][sd-init=true]>._dialog{transform:none}sd-modal[sd-float=true]{pointer-events:none}sd-modal[sd-float=true]>._backdrop{display:none}sd-modal[sd-float=true]>._dialog{pointer-events:auto;opacity:0;box-shadow:0 0 2px #0000000d,0 calc(4 * var(--elevation-size)) calc(4 * 4 * var(--elevation-size)) #0000000d;border:1px solid var(--theme-grey-lighter)}sd-modal[sd-float=true]>._dialog:focus{box-shadow:0 0 2px #0000000d,0 calc(16 * var(--elevation-size)) calc(16 * 4 * var(--elevation-size)) #0000000d}sd-modal[sd-float=true][sd-open=true][sd-init=true]{pointer-events:none}sd-modal[sd-float=true][sd-open=true][sd-init=true]>._dialog{pointer-events:auto;opacity:1}sd-modal[sd-position=bottom-right]>._dialog{position:absolute;right:calc(var(--gap-xxl) * 2);bottom:var(--gap-xxl)}sd-modal[sd-position=top-right]>._dialog{position:absolute;right:var(--gap-xxl);top:var(--gap-xxl)}sd-modal[sd-fill=true]{padding-top:0}sd-modal[sd-fill=true]>._dialog{width:100%;height:100%;border:none;border-radius:0}sd-modal[sd-fill=true]>._dialog>sd-dock-container>._content>._header{background:transparent;color:var(--text-trans-lighter)}\n"], encapsulation: 2, changeDetection: 0 }); }
}
(() => { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(SdModalControl, [{
        type: Component,
        args: [{ selector: "sd-modal", changeDetection: ChangeDetectionStrategy.OnPush, encapsulation: ViewEncapsulation.None, standalone: true, imports: [
                    SdAnchorControl,
                    SdPaneControl,
                    SdDockContainerControl,
                    SdDockControl,
                    SdEventsDirective,
                    forwardRef(() => SdIconControl),
                ], template: `
    <div class="_backdrop" (click)="onBackdropClick()"></div>

    <div
      #dialogEl
      class="_dialog"
      tabindex="0"
      (keydown.escape)="onDialogEscapeKeydown()"
      [style.min-width.px]="minWidthPx()"
      [style.min-height.px]="minHeightPx()"
      [style.width.px]="minWidthPx() && widthPx() && minWidthPx()! > widthPx()! ? minWidthPx() : widthPx()"
      [style.height.px]="minHeightPx() && heightPx() && minHeightPx()! > heightPx()! ? minHeightPx() : heightPx()"
      (focus)="onDialogFocus()"
      (sdResize)="onDialogResize($event)"
    >
      <sd-dock-container>
        @if (!hideHeader()) {
          <sd-dock class="_header" (mousedown)="onHeaderMouseDown($event)" [style]="headerStyle()">
            <h5 class="_title">{{ title() }}</h5>
            @if (!hideCloseButton()) {
              <sd-anchor class="_close-button" theme="grey" (click)="onCloseButtonClick()">
                <sd-icon [icon]="icons.xmark" fixedWidth />
              </sd-anchor>
            }
          </sd-dock>
        }

        <sd-pane class="_content">
          <ng-content></ng-content>
        </sd-pane>
      </sd-dock-container>

      @if (resizable()) {
        <div class="_left-resize-bar" (mousedown)="onResizeBarMousedown($event, 'left')"></div>
        <div class="_right-resize-bar" (mousedown)="onResizeBarMousedown($event, 'right')"></div>
        <div class="_top-resize-bar" (mousedown)="onResizeBarMousedown($event, 'top')"></div>
        <div
          class="_top-right-resize-bar"
          (mousedown)="onResizeBarMousedown($event, 'top-right')"
        ></div>
        <div
          class="_top-left-resize-bar"
          (mousedown)="onResizeBarMousedown($event, 'top-left')"
        ></div>
        <div class="_bottom-resize-bar" (mousedown)="onResizeBarMousedown($event, 'bottom')"></div>
        <div
          class="_bottom-right-resize-bar"
          (mousedown)="onResizeBarMousedown($event, 'bottom-right')"
        ></div>
        <div
          class="_bottom-left-resize-bar"
          (mousedown)="onResizeBarMousedown($event, 'bottom-left')"
        ></div>
      }
    </div>
  `, host: {
                    "[attr.sd-open]": "open()",
                    "[attr.sd-float]": "float()",
                    "[attr.sd-position]": "position()",
                    "[attr.sd-fill]": "fill()",
                }, styles: ["sd-modal{display:block;position:fixed;z-index:var(--z-index-modal);top:0;left:0;width:100%;height:100%;padding-top:calc(var(--topbar-height) + var(--gap-sm));opacity:0;transition:opacity var(--animation-duration) ease-in-out;pointer-events:none}sd-modal>._backdrop{position:fixed;top:0;left:0;width:100%;height:100%;background:#0009}sd-modal>._dialog{position:relative;display:block;margin:0 auto;width:fit-content;min-width:240px;background:var(--control-color);overflow:hidden;box-shadow:0 0 2px #0000000d,0 calc(16 * var(--elevation-size)) calc(16 * 4 * var(--elevation-size)) #0000000d;border-radius:var(--border-radius-default)}sd-modal>._dialog:focus{outline:none}sd-modal>._dialog>sd-dock-container>._content>._header{display:flex;flex-direction:row;user-select:none;border-bottom:1px solid var(--trans-light)}sd-modal>._dialog>sd-dock-container>._content>._header>._title{flex-grow:1;padding:var(--gap-sm) var(--gap-default)}sd-modal>._dialog>sd-dock-container>._content>._header>._close-button{padding:var(--gap-sm) var(--gap-default)}sd-modal>._dialog>._left-resize-bar{position:absolute;top:0;left:0;width:var(--gap-sm);height:100%;cursor:ew-resize}sd-modal>._dialog>._right-resize-bar{position:absolute;top:0;right:0;width:var(--gap-sm);height:100%;cursor:ew-resize}sd-modal>._dialog>._top-resize-bar{position:absolute;top:0;left:0;width:100%;height:var(--gap-sm);cursor:ns-resize}sd-modal>._dialog>._top-right-resize-bar{position:absolute;right:0;top:0;width:var(--gap-sm);height:var(--gap-sm);z-index:1;cursor:nesw-resize}sd-modal>._dialog>._top-left-resize-bar{position:absolute;left:0;top:0;width:var(--gap-sm);height:var(--gap-sm);cursor:nwse-resize;z-index:1}sd-modal>._dialog>._bottom-resize-bar{position:absolute;bottom:0;left:0;width:100%;height:var(--gap-sm);cursor:ns-resize}sd-modal>._dialog>._bottom-right-resize-bar{position:absolute;right:0;bottom:0;width:var(--gap-sm);height:var(--gap-sm);z-index:1;cursor:nwse-resize}sd-modal>._dialog>._bottom-left-resize-bar{position:absolute;left:0;bottom:0;width:var(--gap-sm);height:var(--gap-sm);cursor:nesw-resize;z-index:1}sd-modal>._dialog{transform:translateY(-25px);transition:transform var(--animation-duration) ease-in-out}sd-modal[sd-open=true][sd-init=true]{opacity:1;pointer-events:auto}sd-modal[sd-open=true][sd-init=true]>._dialog{transform:none}sd-modal[sd-float=true]{pointer-events:none}sd-modal[sd-float=true]>._backdrop{display:none}sd-modal[sd-float=true]>._dialog{pointer-events:auto;opacity:0;box-shadow:0 0 2px #0000000d,0 calc(4 * var(--elevation-size)) calc(4 * 4 * var(--elevation-size)) #0000000d;border:1px solid var(--theme-grey-lighter)}sd-modal[sd-float=true]>._dialog:focus{box-shadow:0 0 2px #0000000d,0 calc(16 * var(--elevation-size)) calc(16 * 4 * var(--elevation-size)) #0000000d}sd-modal[sd-float=true][sd-open=true][sd-init=true]{pointer-events:none}sd-modal[sd-float=true][sd-open=true][sd-init=true]>._dialog{pointer-events:auto;opacity:1}sd-modal[sd-position=bottom-right]>._dialog{position:absolute;right:calc(var(--gap-xxl) * 2);bottom:var(--gap-xxl)}sd-modal[sd-position=top-right]>._dialog{position:absolute;right:var(--gap-xxl);top:var(--gap-xxl)}sd-modal[sd-fill=true]{padding-top:0}sd-modal[sd-fill=true]>._dialog{width:100%;height:100%;border:none;border-radius:0}sd-modal[sd-fill=true]>._dialog>sd-dock-container>._content>._header{background:transparent;color:var(--text-trans-lighter)}\n"] }]
    }], () => [], { onResize: [{
            type: HostListener,
            args: ["sdResize", ["$event"]]
        }], onWindowResize: [{
            type: HostListener,
            args: ["window:resize"]
        }] }); })();
(() => { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassDebugInfo(SdModalControl, { className: "SdModalControl", filePath: "packages/sd-angular/src/controls/sd-modal.control.ts", lineNumber: 346 }); })();
//# sourceMappingURL=sd-modal.control.js.map