import { ChangeDetectionStrategy, Component, inject, input, model, output, ViewEncapsulation, } from "@angular/core";
import { NumberUtils, StringUtils } from "@simplysm/sd-core-common";
import { SdAngularConfigProvider } from "../providers/sd-angular-config.provider";
import { $effect } from "../utils/bindings/$effect";
import { $signal } from "../utils/bindings/$signal";
import { transformBoolean } from "../utils/type-tramsforms";
import { SdButtonControl } from "./sd-button.control";
import { SdIconControl } from "./sd-icon.control";
import { SdTextfieldControl } from "./sd-textfield.control";
import * as i0 from "@angular/core";
const _c0 = () => [2, 1, 0];
const _c1 = () => [0, 1, 2];
function SdNumpadControl_Conditional_5_Template(rf, ctx) { if (rf & 1) {
    const _r1 = i0.ɵɵgetCurrentView();
    i0.ɵɵelementStart(0, "td")(1, "sd-button", 6);
    i0.ɵɵlistener("click", function SdNumpadControl_Conditional_5_Template_sd_button_click_1_listener() { i0.ɵɵrestoreView(_r1); const ctx_r1 = i0.ɵɵnextContext(); return i0.ɵɵresetView(ctx_r1.onButtonClick("ENT")); });
    i0.ɵɵtext(2, " ENT ");
    i0.ɵɵelementEnd()();
} if (rf & 2) {
    const ctx_r1 = i0.ɵɵnextContext();
    i0.ɵɵadvance();
    i0.ɵɵproperty("disabled", ctx_r1.required() && ctx_r1.value() == null);
} }
function SdNumpadControl_Conditional_8_Template(rf, ctx) { if (rf & 1) {
    const _r3 = i0.ɵɵgetCurrentView();
    i0.ɵɵelementStart(0, "td")(1, "sd-button", 5);
    i0.ɵɵlistener("click", function SdNumpadControl_Conditional_8_Template_sd_button_click_1_listener() { i0.ɵɵrestoreView(_r3); const ctx_r1 = i0.ɵɵnextContext(); return i0.ɵɵresetView(ctx_r1.onButtonClick("Minus")); });
    i0.ɵɵtext(2, "-");
    i0.ɵɵelementEnd()();
} }
function SdNumpadControl_For_16_For_2_Template(rf, ctx) { if (rf & 1) {
    const _r4 = i0.ɵɵgetCurrentView();
    i0.ɵɵelementStart(0, "td")(1, "sd-button", 5);
    i0.ɵɵlistener("click", function SdNumpadControl_For_16_For_2_Template_sd_button_click_1_listener() { const c_r5 = i0.ɵɵrestoreView(_r4).$implicit; const r_r6 = i0.ɵɵnextContext().$implicit; const ctx_r1 = i0.ɵɵnextContext(); return i0.ɵɵresetView(ctx_r1.onButtonClick((r_r6 * 3 + c_r5 + 1).toString())); });
    i0.ɵɵtext(2);
    i0.ɵɵelementEnd()();
} if (rf & 2) {
    const c_r5 = ctx.$implicit;
    const r_r6 = i0.ɵɵnextContext().$implicit;
    i0.ɵɵadvance(2);
    i0.ɵɵtextInterpolate1(" ", r_r6 * 3 + c_r5 + 1, " ");
} }
function SdNumpadControl_For_16_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "tr");
    i0.ɵɵrepeaterCreate(1, SdNumpadControl_For_16_For_2_Template, 3, 1, "td", null, i0.ɵɵrepeaterTrackByIndex);
    i0.ɵɵelementEnd();
} if (rf & 2) {
    i0.ɵɵadvance();
    i0.ɵɵrepeater(i0.ɵɵpureFunction0(0, _c1));
} }
export class SdNumpadControl {
    constructor() {
        this.icons = inject(SdAngularConfigProvider).icons;
        this.text = $signal();
        this.placeholder = input();
        this.value = model();
        this.required = input(false, { transform: transformBoolean });
        this.inputDisabled = input(false, { transform: transformBoolean });
        this.useEnterButton = input(false, { transform: transformBoolean });
        this.useMinusButton = input(false, { transform: transformBoolean });
        this.enterButtonClick = output();
        $effect([this.text], () => {
            const newValue = NumberUtils.parseFloat(this.text());
            if (newValue !== this.value()) {
                this.value.set(newValue);
            }
        });
        $effect([this.value], () => {
            const prevValue = NumberUtils.parseFloat(this.text());
            if (prevValue !== this.value()) {
                this.text.set(this.value()?.toString());
            }
        });
    }
    onButtonClick(key) {
        if (key === "C") {
            this.text.set(undefined);
        }
        else if (key === "BS") {
            this.text.update((v) => {
                const str = v?.slice(0, -1);
                return StringUtils.isNullOrEmpty(str) ? undefined : str;
            });
        }
        else if (key === "ENT") {
            this.enterButtonClick.emit();
        }
        else if (key === "Minus") {
            this.text.update((v) => {
                if (v != null && v[0] === "-") {
                    return v.slice(1);
                }
                else {
                    return "-" + (v ?? "");
                }
            });
        }
        else {
            this.text.update((v) => (v ?? "") + key);
        }
    }
    static { this.ɵfac = function SdNumpadControl_Factory(__ngFactoryType__) { return new (__ngFactoryType__ || SdNumpadControl)(); }; }
    static { this.ɵcmp = /*@__PURE__*/ i0.ɵɵdefineComponent({ type: SdNumpadControl, selectors: [["sd-numpad"]], inputs: { placeholder: [1, "placeholder"], value: [1, "value"], required: [1, "required"], inputDisabled: [1, "inputDisabled"], useEnterButton: [1, "useEnterButton"], useMinusButton: [1, "useMinusButton"] }, outputs: { value: "valueChange", enterButtonClick: "enterButtonClick" }, decls: 24, vars: 11, consts: [["type", "text", "inputClass", "tx-right ft-size-h3", 3, "valueChange", "placeholder", "required", "disabled", "value"], ["size", "lg", "buttonClass", "tx-theme-danger-default", 3, "click"], [3, "icon"], ["size", "lg", "buttonClass", "tx-theme-warning-default", 3, "click"], ["colspan", "2"], ["size", "lg", 3, "click"], ["size", "lg", "theme", "primary", 3, "click", "disabled"]], template: function SdNumpadControl_Template(rf, ctx) { if (rf & 1) {
            i0.ɵɵelementStart(0, "table")(1, "thead")(2, "tr")(3, "td")(4, "sd-textfield", 0);
            i0.ɵɵtwoWayListener("valueChange", function SdNumpadControl_Template_sd_textfield_valueChange_4_listener($event) { i0.ɵɵtwoWayBindingSet(ctx.text, $event) || (ctx.text = $event); return $event; });
            i0.ɵɵelementEnd()();
            i0.ɵɵtemplate(5, SdNumpadControl_Conditional_5_Template, 3, 1, "td");
            i0.ɵɵelementEnd()();
            i0.ɵɵelementStart(6, "tbody")(7, "tr");
            i0.ɵɵtemplate(8, SdNumpadControl_Conditional_8_Template, 3, 0, "td");
            i0.ɵɵelementStart(9, "td")(10, "sd-button", 1);
            i0.ɵɵlistener("click", function SdNumpadControl_Template_sd_button_click_10_listener() { return ctx.onButtonClick("C"); });
            i0.ɵɵelement(11, "sd-icon", 2);
            i0.ɵɵelementEnd()();
            i0.ɵɵelementStart(12, "td")(13, "sd-button", 3);
            i0.ɵɵlistener("click", function SdNumpadControl_Template_sd_button_click_13_listener() { return ctx.onButtonClick("BS"); });
            i0.ɵɵelement(14, "sd-icon", 2);
            i0.ɵɵelementEnd()()();
            i0.ɵɵrepeaterCreate(15, SdNumpadControl_For_16_Template, 3, 1, "tr", null, i0.ɵɵrepeaterTrackByIdentity);
            i0.ɵɵelementStart(17, "tr")(18, "td", 4)(19, "sd-button", 5);
            i0.ɵɵlistener("click", function SdNumpadControl_Template_sd_button_click_19_listener() { return ctx.onButtonClick("0"); });
            i0.ɵɵtext(20, "0");
            i0.ɵɵelementEnd()();
            i0.ɵɵelementStart(21, "td")(22, "sd-button", 5);
            i0.ɵɵlistener("click", function SdNumpadControl_Template_sd_button_click_22_listener() { return ctx.onButtonClick("."); });
            i0.ɵɵtext(23, ".");
            i0.ɵɵelementEnd()()()()();
        } if (rf & 2) {
            i0.ɵɵadvance(3);
            i0.ɵɵattribute("colspan", ctx.useEnterButton() ? 2 : 3);
            i0.ɵɵadvance();
            i0.ɵɵproperty("placeholder", ctx.placeholder())("required", ctx.required())("disabled", ctx.inputDisabled());
            i0.ɵɵtwoWayProperty("value", ctx.text);
            i0.ɵɵadvance();
            i0.ɵɵconditional(ctx.useEnterButton() ? 5 : -1);
            i0.ɵɵadvance(3);
            i0.ɵɵconditional(ctx.useMinusButton() ? 8 : -1);
            i0.ɵɵadvance();
            i0.ɵɵattribute("colspan", ctx.useMinusButton() ? 1 : 2);
            i0.ɵɵadvance(2);
            i0.ɵɵproperty("icon", ctx.icons.eraser);
            i0.ɵɵadvance(3);
            i0.ɵɵproperty("icon", ctx.icons.arrowLeftLong);
            i0.ɵɵadvance();
            i0.ɵɵrepeater(i0.ɵɵpureFunction0(10, _c0));
        } }, dependencies: [SdTextfieldControl, SdButtonControl, SdIconControl], styles: ["sd-numpad table{width:100%;border-collapse:collapse}sd-numpad table>*>tr>*{border:none;padding:var(--gap-xxs)}sd-numpad table>*>tr>*>sd-button>button{border:none}\n"], encapsulation: 2, changeDetection: 0 }); }
}
(() => { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(SdNumpadControl, [{
        type: Component,
        args: [{ selector: "sd-numpad", changeDetection: ChangeDetectionStrategy.OnPush, encapsulation: ViewEncapsulation.None, standalone: true, imports: [SdTextfieldControl, SdButtonControl, SdIconControl], template: `
    <table>
      <thead>
        <tr>
          <td [attr.colspan]="useEnterButton() ? 2 : 3">
            <sd-textfield
              type="text"
              inputClass="tx-right ft-size-h3"
              [placeholder]="placeholder()"
              [required]="required()"
              [disabled]="inputDisabled()"
              [(value)]="text"
            />
          </td>
          @if (useEnterButton()) {
            <td>
              <sd-button
                size="lg"
                theme="primary"
                [disabled]="required() && value() == null"
                (click)="onButtonClick('ENT')"
              >
                ENT
              </sd-button>
            </td>
          }
        </tr>
      </thead>
      <tbody>
        <tr>
          @if (useMinusButton()) {
            <td>
              <sd-button size="lg" (click)="onButtonClick('Minus')">-</sd-button>
            </td>
          }
          <td [attr.colspan]="useMinusButton() ? 1 : 2">
            <sd-button size="lg" buttonClass="tx-theme-danger-default" (click)="onButtonClick('C')">
              <sd-icon [icon]="icons.eraser" />
            </sd-button>
          </td>
          <td>
            <sd-button
              size="lg"
              buttonClass="tx-theme-warning-default"
              (click)="onButtonClick('BS')"
            >
              <sd-icon [icon]="icons.arrowLeftLong" />
            </sd-button>
          </td>
        </tr>
        @for (r of [2, 1, 0]; track r) {
          <tr>
            @for (c of [0, 1, 2]; track $index) {
              <td>
                <sd-button size="lg" (click)="onButtonClick((r * 3 + c + 1).toString())">
                  {{ r * 3 + c + 1 }}
                </sd-button>
              </td>
            }
          </tr>
        }
        <tr>
          <td colspan="2">
            <sd-button size="lg" (click)="onButtonClick('0')">0</sd-button>
          </td>
          <td>
            <sd-button size="lg" (click)="onButtonClick('.')">.</sd-button>
          </td>
        </tr>
      </tbody>
    </table>
  `, styles: ["sd-numpad table{width:100%;border-collapse:collapse}sd-numpad table>*>tr>*{border:none;padding:var(--gap-xxs)}sd-numpad table>*>tr>*>sd-button>button{border:none}\n"] }]
    }], () => [], null); })();
(() => { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassDebugInfo(SdNumpadControl, { className: "SdNumpadControl", filePath: "packages/sd-angular/src/controls/sd-numpad.control.ts", lineNumber: 117 }); })();
//# sourceMappingURL=sd-numpad.control.js.map