import { ChangeDetectionStrategy, Component, inject, input, model, ViewEncapsulation, } from "@angular/core";
import { SdAngularConfigProvider } from "../providers/sd-angular-config.provider";
import { $computed } from "../utils/bindings/$computed";
import { SdAnchorControl } from "./sd-anchor.control";
import { SdIconControl } from "./sd-icon.control";
import * as i0 from "@angular/core";
function SdPaginationControl_For_5_Template(rf, ctx) { if (rf & 1) {
    const _r1 = i0.ɵɵgetCurrentView();
    i0.ɵɵelementStart(0, "sd-anchor", 2);
    i0.ɵɵlistener("click", function SdPaginationControl_For_5_Template_sd_anchor_click_0_listener() { const displayPage_r2 = i0.ɵɵrestoreView(_r1).$implicit; const ctx_r2 = i0.ɵɵnextContext(); return i0.ɵɵresetView(ctx_r2.onPageClick(displayPage_r2)); });
    i0.ɵɵtext(1);
    i0.ɵɵelementEnd();
} if (rf & 2) {
    const displayPage_r2 = ctx.$implicit;
    const ctx_r2 = i0.ɵɵnextContext();
    i0.ɵɵattribute("sd-selected", displayPage_r2 === ctx_r2.currentPage());
    i0.ɵɵadvance();
    i0.ɵɵtextInterpolate1(" ", displayPage_r2 + 1, " ");
} }
export class SdPaginationControl {
    constructor() {
        this.icons = inject(SdAngularConfigProvider).icons;
        this.currentPage = model(0);
        this.totalPageCount = input(0);
        this.visiblePageCount = input(10);
        this.displayPages = $computed(() => {
            const pages = [];
            for (let i = 0; i < this.totalPageCount(); i++) {
                pages.push(i);
            }
            const from = Math.floor(this.currentPage() / this.visiblePageCount()) * this.visiblePageCount();
            const to = Math.min(from + this.visiblePageCount(), this.totalPageCount());
            return pages.filter((item) => item >= from && item < to);
        });
        this.hasNext = $computed(() => {
            return (this.displayPages().last() ?? 0) < this.totalPageCount() - 1;
        });
        this.hasPrev = $computed(() => {
            return (this.displayPages().first() ?? 0) > 0;
        });
    }
    onPageClick(page) {
        this.currentPage.set(page);
    }
    onNextClick() {
        const page = (this.displayPages().last() ?? 0) + 1;
        this.currentPage.set(page);
    }
    onPrevClick() {
        const page = (this.displayPages().first() ?? 0) - 1;
        this.currentPage.set(page);
    }
    onGoFirstClick() {
        const page = 0;
        this.currentPage.set(page);
    }
    onGoLastClick() {
        const page = this.totalPageCount() - 1;
        this.currentPage.set(page);
    }
    static { this.ɵfac = function SdPaginationControl_Factory(__ngFactoryType__) { return new (__ngFactoryType__ || SdPaginationControl)(); }; }
    static { this.ɵcmp = /*@__PURE__*/ i0.ɵɵdefineComponent({ type: SdPaginationControl, selectors: [["sd-pagination"]], inputs: { currentPage: [1, "currentPage"], totalPageCount: [1, "totalPageCount"], visiblePageCount: [1, "visiblePageCount"] }, outputs: { currentPage: "currentPageChange" }, decls: 10, vars: 8, consts: [[3, "click", "disabled"], ["fixedWidth", "", 3, "icon"], [3, "click"]], template: function SdPaginationControl_Template(rf, ctx) { if (rf & 1) {
            i0.ɵɵelementStart(0, "sd-anchor", 0);
            i0.ɵɵlistener("click", function SdPaginationControl_Template_sd_anchor_click_0_listener() { return ctx.onGoFirstClick(); });
            i0.ɵɵelement(1, "sd-icon", 1);
            i0.ɵɵelementEnd();
            i0.ɵɵelementStart(2, "sd-anchor", 0);
            i0.ɵɵlistener("click", function SdPaginationControl_Template_sd_anchor_click_2_listener() { return ctx.onPrevClick(); });
            i0.ɵɵelement(3, "sd-icon", 1);
            i0.ɵɵelementEnd();
            i0.ɵɵrepeaterCreate(4, SdPaginationControl_For_5_Template, 2, 2, "sd-anchor", null, i0.ɵɵrepeaterTrackByIdentity);
            i0.ɵɵelementStart(6, "sd-anchor", 0);
            i0.ɵɵlistener("click", function SdPaginationControl_Template_sd_anchor_click_6_listener() { return ctx.onNextClick(); });
            i0.ɵɵelement(7, "sd-icon", 1);
            i0.ɵɵelementEnd();
            i0.ɵɵelementStart(8, "sd-anchor", 0);
            i0.ɵɵlistener("click", function SdPaginationControl_Template_sd_anchor_click_8_listener() { return ctx.onGoLastClick(); });
            i0.ɵɵelement(9, "sd-icon", 1);
            i0.ɵɵelementEnd();
        } if (rf & 2) {
            i0.ɵɵproperty("disabled", !ctx.hasPrev());
            i0.ɵɵadvance();
            i0.ɵɵproperty("icon", ctx.icons.angleDoubleLeft);
            i0.ɵɵadvance();
            i0.ɵɵproperty("disabled", !ctx.hasPrev());
            i0.ɵɵadvance();
            i0.ɵɵproperty("icon", ctx.icons.angleLeft);
            i0.ɵɵadvance();
            i0.ɵɵrepeater(ctx.displayPages());
            i0.ɵɵadvance(2);
            i0.ɵɵproperty("disabled", !ctx.hasNext());
            i0.ɵɵadvance();
            i0.ɵɵproperty("icon", ctx.icons.angleRight);
            i0.ɵɵadvance();
            i0.ɵɵproperty("disabled", !ctx.hasNext());
            i0.ɵɵadvance();
            i0.ɵɵproperty("icon", ctx.icons.angleDoubleRight);
        } }, dependencies: [SdAnchorControl, SdIconControl], styles: ["sd-pagination{display:flex;flex-direction:row}sd-pagination>sd-anchor{display:inline-block;padding:var(--gap-sm)}sd-pagination>sd-anchor[sd-selected=true]{text-decoration:underline}\n"], encapsulation: 2, changeDetection: 0 }); }
}
(() => { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(SdPaginationControl, [{
        type: Component,
        args: [{ selector: "sd-pagination", changeDetection: ChangeDetectionStrategy.OnPush, encapsulation: ViewEncapsulation.None, standalone: true, imports: [SdAnchorControl, SdIconControl], template: `
    <sd-anchor [disabled]="!hasPrev()" (click)="onGoFirstClick()">
      <sd-icon [icon]="icons.angleDoubleLeft" fixedWidth />
    </sd-anchor>
    <sd-anchor [disabled]="!hasPrev()" (click)="onPrevClick()">
      <sd-icon [icon]="icons.angleLeft" fixedWidth />
    </sd-anchor>
    @for (displayPage of displayPages(); track displayPage) {
      <sd-anchor
        (click)="onPageClick(displayPage)"
        [attr.sd-selected]="displayPage === currentPage()"
      >
        {{ displayPage + 1 }}
      </sd-anchor>
    }
    <sd-anchor [disabled]="!hasNext()" (click)="onNextClick()">
      <sd-icon [icon]="icons.angleRight" fixedWidth />
    </sd-anchor>
    <sd-anchor [disabled]="!hasNext()" (click)="onGoLastClick()">
      <sd-icon [icon]="icons.angleDoubleRight" fixedWidth />
    </sd-anchor>
  `, styles: ["sd-pagination{display:flex;flex-direction:row}sd-pagination>sd-anchor{display:inline-block;padding:var(--gap-sm)}sd-pagination>sd-anchor[sd-selected=true]{text-decoration:underline}\n"] }]
    }], null, null); })();
(() => { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassDebugInfo(SdPaginationControl, { className: "SdPaginationControl", filePath: "packages/sd-angular/src/controls/sd-pagination.control.ts", lineNumber: 62 }); })();
//# sourceMappingURL=sd-pagination.control.js.map