import { ChangeDetectionStrategy, Component, input, model, ViewEncapsulation } from "@angular/core";
import Quill from "quill";
import QuillResizeImage from "quill-resize-image";
import { $effect } from "../utils/bindings/$effect";
import { injectElementRef } from "../utils/injections/inject-element-ref";
import { transformBoolean } from "../utils/type-tramsforms";
import * as i0 from "@angular/core";
Quill.register("modules/resize", QuillResizeImage);
export class SdQuillEditorControl {
    constructor() {
        this._elRef = injectElementRef();
        this.value = model();
        this.disabled = input(false, { transform: transformBoolean });
        $effect([], () => {
            this._quill = new Quill(this._elRef.nativeElement.firstElementChild, {
                theme: "snow",
                modules: {
                    toolbar: [
                        [{ header: 1 }, { header: 2 }, "bold", "italic", "underline", "strike"],
                        [{ color: [] }, { background: [] }],
                        [{ list: "ordered" }, { list: "bullet" }],
                        [{ indent: "-1" }, { indent: "+1" }],
                        ["blockquote", "code-block"],
                        [{ align: "" }, { align: "center" }, { align: "right" }, { align: "justify" }],
                        ["clean"],
                    ],
                    resize: {},
                },
            });
            this._quill.root.addEventListener("input", () => {
                const newValue = this._quill.root.innerHTML;
                this.value.set(newValue === "" ? undefined : newValue);
            });
            this._quill.on("text-change", () => {
                const newValue = this._quill.root.innerHTML;
                this.value.set(newValue === "" ? undefined : newValue);
            });
        });
        $effect(() => {
            if (this._quill.root.innerHTML !== (this.value() ?? "")) {
                this._quill.root.innerHTML = this.value() ?? "";
            }
        });
        $effect(() => {
            this._quill.enable(!this.disabled());
        });
    }
    static { this.ɵfac = function SdQuillEditorControl_Factory(__ngFactoryType__) { return new (__ngFactoryType__ || SdQuillEditorControl)(); }; }
    static { this.ɵcmp = /*@__PURE__*/ i0.ɵɵdefineComponent({ type: SdQuillEditorControl, selectors: [["sd-quill-editor"]], hostVars: 1, hostBindings: function SdQuillEditorControl_HostBindings(rf, ctx) { if (rf & 2) {
            i0.ɵɵattribute("sd-disabled", ctx.disabled());
        } }, inputs: { value: [1, "value"], disabled: [1, "disabled"] }, outputs: { value: "valueChange" }, decls: 1, vars: 0, template: function SdQuillEditorControl_Template(rf, ctx) { if (rf & 1) {
            i0.ɵɵelement(0, "div");
        } }, styles: ["sd-quill-editor{display:block;border:1px solid var(--theme-grey-lighter);border-radius:var(--border-radius-default)}sd-quill-editor>.ql-toolbar{border:none!important;border-bottom:1px solid var(--theme-grey-lighter)!important;padding:var(--gap-sm) var(--gap-default)!important}sd-quill-editor>.ql-toolbar button{font-size:var(--font-size-default);height:1.75em!important;width:2em!important;padding:var(--gap-xs) var(--gap-sm)!important}sd-quill-editor>.ql-toolbar button:hover{color:var(--theme-primary-default)!important}sd-quill-editor>.ql-toolbar button.ql-active{color:var(--theme-primary-default)!important}sd-quill-editor>.ql-container{border:none!important;background:var(--theme-secondary-lightest)!important;border-bottom-left-radius:var(--border-radius-default);border-bottom-right-radius:var(--border-radius-default)}sd-quill-editor>.ql-container>.ql-editor{padding:var(--gap-lg)!important;min-height:4em}sd-quill-editor[sd-disabled1=true]{border:none}sd-quill-editor[sd-disabled1=true]>.ql-toolbar{display:none!important}sd-quill-editor[sd-disabled1=true]>.ql-container{border-top-left-radius:var(--border-radius-default);border-top-right-radius:var(--border-radius-default)}\n"], encapsulation: 2, changeDetection: 0 }); }
}
(() => { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(SdQuillEditorControl, [{
        type: Component,
        args: [{ selector: "sd-quill-editor", changeDetection: ChangeDetectionStrategy.OnPush, encapsulation: ViewEncapsulation.None, standalone: true, imports: [], template: `
    <div></div>
  `, host: {
                    "[attr.sd-disabled]": "disabled()",
                }, styles: ["sd-quill-editor{display:block;border:1px solid var(--theme-grey-lighter);border-radius:var(--border-radius-default)}sd-quill-editor>.ql-toolbar{border:none!important;border-bottom:1px solid var(--theme-grey-lighter)!important;padding:var(--gap-sm) var(--gap-default)!important}sd-quill-editor>.ql-toolbar button{font-size:var(--font-size-default);height:1.75em!important;width:2em!important;padding:var(--gap-xs) var(--gap-sm)!important}sd-quill-editor>.ql-toolbar button:hover{color:var(--theme-primary-default)!important}sd-quill-editor>.ql-toolbar button.ql-active{color:var(--theme-primary-default)!important}sd-quill-editor>.ql-container{border:none!important;background:var(--theme-secondary-lightest)!important;border-bottom-left-radius:var(--border-radius-default);border-bottom-right-radius:var(--border-radius-default)}sd-quill-editor>.ql-container>.ql-editor{padding:var(--gap-lg)!important;min-height:4em}sd-quill-editor[sd-disabled1=true]{border:none}sd-quill-editor[sd-disabled1=true]>.ql-toolbar{display:none!important}sd-quill-editor[sd-disabled1=true]>.ql-container{border-top-left-radius:var(--border-radius-default);border-top-right-radius:var(--border-radius-default)}\n"] }]
    }], () => [], null); })();
(() => { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassDebugInfo(SdQuillEditorControl, { className: "SdQuillEditorControl", filePath: "packages/sd-angular/src/controls/sd-quill-editor.control.ts", lineNumber: 78 }); })();
//# sourceMappingURL=sd-quill-editor.control.js.map