import { ElementRef, TemplateRef } from "@angular/core";
import { SdItemOfTemplateContext } from "../directives/sd-item-of.template-directive";
import { SdDropdownControl } from "./sd-dropdown.control";
import { SdSelectItemControl } from "./sd-select-item.control";
import * as i0 from "@angular/core";
export declare class SdSelectControl<M extends "single" | "multi", T> {
    protected readonly icons: import("../providers/sd-angular-config.provider").ISdAngularIcon;
    value: import("@angular/core").ModelSignal<TSelectValue<any>[M] | undefined>;
    open: import("@angular/core").ModelSignal<boolean>;
    required: import("@angular/core").InputSignalWithTransform<boolean, boolean | "" | undefined>;
    disabled: import("@angular/core").InputSignalWithTransform<boolean, boolean | "" | undefined>;
    items: import("@angular/core").InputSignal<T[] | undefined>;
    trackByFn: import("@angular/core").InputSignal<(item: T, index: number) => any>;
    getChildrenFn: import("@angular/core").InputSignal<((item: T, index: number, depth: number) => T[]) | undefined>;
    inline: import("@angular/core").InputSignalWithTransform<boolean, boolean | "" | undefined>;
    inset: import("@angular/core").InputSignalWithTransform<boolean, boolean | "" | undefined>;
    size: import("@angular/core").InputSignal<"sm" | "lg" | undefined>;
    selectMode: import("@angular/core").InputSignal<M>;
    contentClass: import("@angular/core").InputSignal<string | undefined>;
    contentStyle: import("@angular/core").InputSignal<string | undefined>;
    multiSelectionDisplayDirection: import("@angular/core").InputSignal<"vertical" | "horizontal" | undefined>;
    hideSelectAll: import("@angular/core").InputSignalWithTransform<boolean, boolean | "" | undefined>;
    placeholder: import("@angular/core").InputSignal<string | undefined>;
    contentElRef: import("@angular/core").Signal<ElementRef<HTMLElement>>;
    dropdownControl: import("@angular/core").Signal<SdDropdownControl>;
    dropdownPopupElRef: import("@angular/core").Signal<ElementRef<HTMLElement>>;
    headerTemplateRef: import("@angular/core").Signal<TemplateRef<void> | undefined>;
    beforeTemplateRef: import("@angular/core").Signal<TemplateRef<void> | undefined>;
    itemTemplateRef: import("@angular/core").Signal<TemplateRef<SdItemOfTemplateContext<T>> | undefined>;
    itemControls: import("../utils/bindings/$signal").SdWritableSignal<SdSelectItemControl[]>;
    constructor();
    onPopupKeydown(event: KeyboardEvent): void;
    getIsSelectedItemControl(itemControl: SdSelectItemControl): boolean;
    onItemControlClick(itemControl: SdSelectItemControl, close: boolean): void;
    onSelectAllButtonClick(check: boolean): void;
    protected readonly rowOfListType: {
        items: T[];
        depth: number;
    };
    static ɵfac: i0.ɵɵFactoryDeclaration<SdSelectControl<any, any>, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<SdSelectControl<any, any>, "sd-select", never, { "value": { "alias": "value"; "required": false; "isSignal": true; }; "open": { "alias": "open"; "required": false; "isSignal": true; }; "required": { "alias": "required"; "required": false; "isSignal": true; }; "disabled": { "alias": "disabled"; "required": false; "isSignal": true; }; "items": { "alias": "items"; "required": false; "isSignal": true; }; "trackByFn": { "alias": "trackByFn"; "required": false; "isSignal": true; }; "getChildrenFn": { "alias": "getChildrenFn"; "required": false; "isSignal": true; }; "inline": { "alias": "inline"; "required": false; "isSignal": true; }; "inset": { "alias": "inset"; "required": false; "isSignal": true; }; "size": { "alias": "size"; "required": false; "isSignal": true; }; "selectMode": { "alias": "selectMode"; "required": false; "isSignal": true; }; "contentClass": { "alias": "contentClass"; "required": false; "isSignal": true; }; "contentStyle": { "alias": "contentStyle"; "required": false; "isSignal": true; }; "multiSelectionDisplayDirection": { "alias": "multiSelectionDisplayDirection"; "required": false; "isSignal": true; }; "hideSelectAll": { "alias": "hideSelectAll"; "required": false; "isSignal": true; }; "placeholder": { "alias": "placeholder"; "required": false; "isSignal": true; }; }, { "value": "valueChange"; "open": "openChange"; }, ["headerTemplateRef", "beforeTemplateRef", "itemTemplateRef"], ["sd-select-button", "*"], true, never>;
}
export type TSelectValue<T> = {
    multi: T[];
    single: T;
};
