import { afterRender, ChangeDetectionStrategy, Component, forwardRef, HostListener, inject, input, ViewEncapsulation, } from "@angular/core";
import { SdSelectControl } from "./sd-select-control";
import { SdCheckboxControl } from "./sd-checkbox.control";
import { SdGapControl } from "./sd-gap.control";
import { injectElementRef } from "../utils/injections/inject-element-ref";
import { setupRipple } from "../utils/setups/setup-ripple";
import { transformBoolean } from "../utils/type-tramsforms";
import { $computed } from "../utils/bindings/$computed";
import { $signal } from "../utils/bindings/$signal";
import { $effect } from "../utils/bindings/$effect";
import * as i0 from "@angular/core";
const _c0 = ["*"];
function SdSelectItemControl_Conditional_0_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelement(0, "sd-checkbox", 1)(1, "sd-gap", 2);
} if (rf & 2) {
    const ctx_r0 = i0.ɵɵnextContext();
    i0.ɵɵproperty("value", ctx_r0.isSelected())("inline", true);
} }
export class SdSelectItemControl {
    constructor() {
        this._selectControl = inject(forwardRef(() => SdSelectControl));
        this.elRef = injectElementRef();
        this.value = input();
        this.disabled = input(false, { transform: transformBoolean });
        this.hidden = input(false, { transform: transformBoolean });
        this.selectMode = $computed(() => this._selectControl.selectMode());
        this.isSelected = $computed(() => this._selectControl.getIsSelectedItemControl(this));
        this.contentHTML = $signal("");
        setupRipple(() => !this.disabled());
        $effect((onCleanup) => {
            this._selectControl.itemControls.update((v) => [...v, this]);
            onCleanup(() => {
                this._selectControl.itemControls.update((v) => v.filter((item) => item !== this));
            });
        });
        afterRender(() => {
            const html = this.elRef.nativeElement.findFirst("> ._content").innerHTML;
            if (this.contentHTML() !== html.trim()) {
                this.contentHTML.set(html.trim());
            }
        });
    }
    onClick(event) {
        event.preventDefault();
        event.stopPropagation();
        if (this.disabled())
            return;
        this._selectControl.onItemControlClick(this, this.selectMode() === "single");
    }
    onKeydown(event) {
        if (this.disabled())
            return;
        if (!event.ctrlKey && !event.altKey && event.key === " ") {
            event.preventDefault();
            event.stopPropagation();
            this._selectControl.onItemControlClick(this, false);
        }
        if (!event.ctrlKey && !event.altKey && event.key === "Enter") {
            event.preventDefault();
            event.stopPropagation();
            this._selectControl.onItemControlClick(this, this.selectMode() === "single");
        }
    }
    static { this.ɵfac = function SdSelectItemControl_Factory(__ngFactoryType__) { return new (__ngFactoryType__ || SdSelectItemControl)(); }; }
    static { this.ɵcmp = /*@__PURE__*/ i0.ɵɵdefineComponent({ type: SdSelectItemControl, selectors: [["sd-select-item"]], hostVars: 5, hostBindings: function SdSelectItemControl_HostBindings(rf, ctx) { if (rf & 1) {
            i0.ɵɵlistener("click", function SdSelectItemControl_click_HostBindingHandler($event) { return ctx.onClick($event); })("keydown", function SdSelectItemControl_keydown_HostBindingHandler($event) { return ctx.onKeydown($event); });
        } if (rf & 2) {
            i0.ɵɵattribute("tabindex", "0")("sd-disabled", ctx.disabled())("sd-select-mode", ctx.selectMode())("sd-selected", ctx.isSelected())("sd-hidden", ctx.hidden());
        } }, inputs: { value: [1, "value"], disabled: [1, "disabled"], hidden: [1, "hidden"] }, ngContentSelectors: _c0, decls: 3, vars: 1, consts: [[1, "_content", 2, "display", "inline-block"], [3, "value", "inline"], ["width", "sm"]], template: function SdSelectItemControl_Template(rf, ctx) { if (rf & 1) {
            i0.ɵɵprojectionDef();
            i0.ɵɵtemplate(0, SdSelectItemControl_Conditional_0_Template, 2, 2);
            i0.ɵɵelementStart(1, "div", 0);
            i0.ɵɵprojection(2);
            i0.ɵɵelementEnd();
        } if (rf & 2) {
            i0.ɵɵconditional(ctx.selectMode() === "multi" ? 0 : -1);
        } }, dependencies: [SdCheckboxControl, SdGapControl], styles: ["sd-select-item{display:block;padding:var(--gap-sm) var(--gap-default);cursor:pointer;transition:background .1s ease-in;background:var(--control-color)}sd-select-item:hover{transition:background .1s ease-out;background:#00000012}sd-select-item:focus{outline:none;transition:background .1s ease-out;background:#00000012}sd-select-item[sd-selected=true]{color:var(--theme-primary-default);font-weight:700;background:#00000012}sd-select-item[sd-disabled=true]{background:var(--theme-grey-default);opacity:.3}sd-select-item[sd-hidden=true]{display:none}\n"], encapsulation: 2, changeDetection: 0 }); }
}
(() => { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(SdSelectItemControl, [{
        type: Component,
        args: [{ selector: "sd-select-item", changeDetection: ChangeDetectionStrategy.OnPush, encapsulation: ViewEncapsulation.None, standalone: true, imports: [SdCheckboxControl, SdGapControl], template: `
    @if (selectMode() === "multi") {
      <sd-checkbox [value]="isSelected()" [inline]="true"></sd-checkbox>
      <sd-gap width="sm" />
    }

    <div class="_content" style="display: inline-block;">
      <ng-content />
    </div>
  `, host: {
                    "[attr.tabindex]": "'0'",
                    "[attr.sd-disabled]": "disabled()",
                    "[attr.sd-select-mode]": "selectMode()",
                    "[attr.sd-selected]": "isSelected()",
                    "[attr.sd-hidden]": "hidden()",
                }, styles: ["sd-select-item{display:block;padding:var(--gap-sm) var(--gap-default);cursor:pointer;transition:background .1s ease-in;background:var(--control-color)}sd-select-item:hover{transition:background .1s ease-out;background:#00000012}sd-select-item:focus{outline:none;transition:background .1s ease-out;background:#00000012}sd-select-item[sd-selected=true]{color:var(--theme-primary-default);font-weight:700;background:#00000012}sd-select-item[sd-disabled=true]{background:var(--theme-grey-default);opacity:.3}sd-select-item[sd-hidden=true]{display:none}\n"] }]
    }], () => [], { onClick: [{
            type: HostListener,
            args: ["click", ["$event"]]
        }], onKeydown: [{
            type: HostListener,
            args: ["keydown", ["$event"]]
        }] }); })();
(() => { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassDebugInfo(SdSelectItemControl, { className: "SdSelectItemControl", filePath: "packages/sd-angular/src/controls/sd-select-item.control.ts", lineNumber: 85 }); })();
//# sourceMappingURL=sd-select-item.control.js.map