import { $computed } from "../../../utils/bindings/$computed";
import { $signal } from "../../../utils/bindings/$signal";
export class SdSheetColumnFixingManager {
    constructor(_options) {
        this._options = _options;
        this._widths = $signal({});
        this.fixedLeftMap = $computed(() => {
            const fixedLength = this._options.fixedLength();
            const widths = this._widths();
            const result = new Map();
            let nextLeft = 0;
            for (const keyC of Object.keys(widths).orderBy()) {
                const c = Number.parseInt(keyC);
                if (c < fixedLength) {
                    result.set(c, nextLeft);
                    nextLeft += widths[c];
                }
            }
            return result;
        });
    }
    registerWidth(col, width) {
        if (this._widths()[col] !== width) {
            this._widths.update(v => ({
                ...v,
                [col]: width,
            }));
        }
    }
}
//# sourceMappingURL=sd-sheet-column-fixing-manager.js.map