import { injectElementRef } from "../../../utils/injections/inject-element-ref";
export class SdSheetDomAccessor {
    constructor() {
        this._elRef = injectElementRef();
    }
    getRoot() {
        return this._elRef.nativeElement;
    }
    getContainer() {
        return this._elRef.nativeElement.findFirst("._sheet-container");
    }
    getTable() {
        return this.getContainer().findFirst("> table");
    }
    getTHead() {
        return this.getTable().findFirst("> thead");
    }
    getLastDepthFixedHeaders() {
        return this.getTHead().findAll("> tr > th._last-depth._fixed");
    }
    getFocusRowIndicator() {
        return this.getContainer().findFirst("> ._focus-row-indicator");
    }
    getFocusCellIndicator() {
        return this.getFocusRowIndicator().firstElementChild;
    }
    getSelectRowIndicatorContainer() {
        return this.getContainer().findFirst("> ._select-row-indicator-container");
    }
    getSelectRowIndicators() {
        return this.getSelectRowIndicatorContainer().findAll("> ._select-row-indicator");
    }
    getColumnResizeIndicator() {
        return this.getContainer().findFirst("> ._resize-indicator");
    }
    getRow(r) {
        return this.getTable().findFirst(`> tbody > tr[r='${r}']`);
    }
    getCell(r, c) {
        return this.getRow(r)?.findFirst(` > td[c='${c}']`);
    }
}
//# sourceMappingURL=sd-sheet-dom-accessor.js.map