import { ISdResizeEvent } from "../../plugins/events/sd-resize.event-plugin";
import { SdExpandingManager } from "../../utils/managers/sd-expanding-manager";
import { SdSelectionManager } from "../../utils/managers/sd-selection-manager";
import { ISdSortingDef, SdSortingManager } from "../../utils/managers/sd-sorting-manager";
import { SdSheetColumnDirective } from "./directives/sd-sheet-column.directive";
import { SdSheetCellAgent } from "./features/sd-sheet-cell-agent";
import { SdSheetColumnFixingManager } from "./features/sd-sheet-column-fixing-manager";
import { SdSheetDomAccessor } from "./features/sd-sheet-dom-accessor";
import { SdSheetFocusIndicatorRenderer } from "./features/sd-sheet-focus-indicator-renderer";
import { SdSheetLayoutEngine } from "./features/sd-sheet-layout-engine";
import { SdSheetSelectRowIndicatorRenderer } from "./features/sd-sheet-select-row-indicator-renderer";
import { ISdSheetConfig, ISdSheetHeaderDef, ISdSheetItemKeydownEventParam } from "./sd-sheet.types";
import * as i0 from "@angular/core";
export declare class SdSheetControl<T> {
    protected readonly icons: import("../../providers/sd-angular-config.provider").ISdAngularIcon;
    private _sdModal;
    busy: import("@angular/core").InputSignalWithTransform<boolean, boolean | "" | undefined>;
    hideConfigBar: import("@angular/core").InputSignalWithTransform<boolean, boolean | "" | undefined>;
    inset: import("@angular/core").InputSignalWithTransform<boolean, boolean | "" | undefined>;
    contentStyle: import("@angular/core").InputSignal<string | undefined>;
    getItemCellClassFn: import("@angular/core").InputSignal<((item: T, colKey: string) => string | undefined) | undefined>;
    getItemCellStyleFn: import("@angular/core").InputSignal<((item: T, colKey: string) => string | undefined) | undefined>;
    itemKeydown: import("@angular/core").OutputEmitterRef<ISdSheetItemKeydownEventParam<T>>;
    cellKeydown: import("@angular/core").OutputEmitterRef<ISdSheetItemKeydownEventParam<T>>;
    columnControls: import("@angular/core").Signal<readonly SdSheetColumnDirective<T>[]>;
    items: import("@angular/core").InputSignal<T[]>;
    trackByFn: import("@angular/core").InputSignal<(item: T, index: number) => any>;
    domAccessor: SdSheetDomAccessor;
    key: import("@angular/core").InputSignal<string>;
    config: import("@angular/core").ResourceRef<ISdSheetConfig | undefined>;
    onConfigButtonClick(): Promise<void>;
    private _saveColumnConfig;
    layoutEngine: SdSheetLayoutEngine<T>;
    columnFixingManager: SdSheetColumnFixingManager;
    onHeaderLastRowCellResize(event: ISdResizeEvent, c: number): void;
    private _isOnResizing;
    onResizerMousedown(event: MouseEvent, colKey: string): void;
    onResizerDoubleClick(event: MouseEvent, colKey: string): void;
    sorts: import("@angular/core").ModelSignal<ISdSortingDef[]>;
    sortingManager: SdSortingManager;
    useAutoSort: import("@angular/core").InputSignalWithTransform<boolean, boolean | "" | undefined>;
    onHeaderCellClick(event: MouseEvent, headerCell: ISdSheetHeaderDef): void;
    private _sortedItems;
    visiblePageCount: import("@angular/core").InputSignal<number>;
    totalPageCount: import("@angular/core").InputSignal<number>;
    itemsPerPage: import("@angular/core").InputSignal<number | undefined>;
    currentPage: import("@angular/core").ModelSignal<number>;
    effectivePageCount: import("@angular/core").Signal<number>;
    private _sortedPagedItems;
    expandedItems: import("@angular/core").ModelSignal<T[]>;
    getChildrenFn: import("@angular/core").InputSignal<((item: T, index: number) => T[] | undefined) | undefined>;
    expandingManager: SdExpandingManager<T>;
    displayItems: import("@angular/core").Signal<T[]>;
    selectMode: import("@angular/core").InputSignal<"single" | "multi" | undefined>;
    selectedItems: import("@angular/core").ModelSignal<T[]>;
    autoSelect: import("@angular/core").InputSignal<"click" | "focus" | undefined>;
    getItemSelectableFn: import("@angular/core").InputSignal<((item: T) => boolean | string) | undefined>;
    selectionManager: SdSelectionManager<T>;
    onItemCellClick(item: T): void;
    onFocusCaptureForSelection(event: FocusEvent): void;
    cellAgent: SdSheetCellAgent;
    onKeydownCapture(event: KeyboardEvent): Promise<void>;
    onItemCellDoubleClick(event: MouseEvent): void;
    onBlurCaptureForCellAgent(event: FocusEvent): void;
    onFocusCaptureForAutoScroll(event: FocusEvent): void;
    focusMode: import("@angular/core").InputSignal<"row" | "cell">;
    selectRowIndicatorRenderer: SdSheetSelectRowIndicatorRenderer<T>;
    focusIndicatorRenderer: SdSheetFocusIndicatorRenderer;
    onFocusCaptureForIndicator(): void;
    onBlurCaptureForFocusIndicator(): void;
    onSheetResize(event: ISdResizeEvent): void;
    onContainerScroll(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<SdSheetControl<any>, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<SdSheetControl<any>, "sd-sheet", never, { "busy": { "alias": "busy"; "required": false; "isSignal": true; }; "hideConfigBar": { "alias": "hideConfigBar"; "required": false; "isSignal": true; }; "inset": { "alias": "inset"; "required": false; "isSignal": true; }; "contentStyle": { "alias": "contentStyle"; "required": false; "isSignal": true; }; "getItemCellClassFn": { "alias": "getItemCellClassFn"; "required": false; "isSignal": true; }; "getItemCellStyleFn": { "alias": "getItemCellStyleFn"; "required": false; "isSignal": true; }; "items": { "alias": "items"; "required": false; "isSignal": true; }; "trackByFn": { "alias": "trackByFn"; "required": false; "isSignal": true; }; "key": { "alias": "key"; "required": true; "isSignal": true; }; "sorts": { "alias": "sorts"; "required": false; "isSignal": true; }; "useAutoSort": { "alias": "useAutoSort"; "required": false; "isSignal": true; }; "visiblePageCount": { "alias": "visiblePageCount"; "required": false; "isSignal": true; }; "totalPageCount": { "alias": "totalPageCount"; "required": false; "isSignal": true; }; "itemsPerPage": { "alias": "itemsPerPage"; "required": false; "isSignal": true; }; "currentPage": { "alias": "currentPage"; "required": false; "isSignal": true; }; "expandedItems": { "alias": "expandedItems"; "required": false; "isSignal": true; }; "getChildrenFn": { "alias": "getChildrenFn"; "required": false; "isSignal": true; }; "selectMode": { "alias": "selectMode"; "required": false; "isSignal": true; }; "selectedItems": { "alias": "selectedItems"; "required": false; "isSignal": true; }; "autoSelect": { "alias": "autoSelect"; "required": false; "isSignal": true; }; "getItemSelectableFn": { "alias": "getItemSelectableFn"; "required": false; "isSignal": true; }; "focusMode": { "alias": "focusMode"; "required": false; "isSignal": true; }; }, { "itemKeydown": "itemKeydown"; "cellKeydown": "cellKeydown"; "sorts": "sortsChange"; "currentPage": "currentPageChange"; "expandedItems": "expandedItemsChange"; "selectedItems": "selectedItemsChange"; }, ["columnControls"], never, true, never>;
}
