import { NgTemplateOutlet } from "@angular/common";
import { ChangeDetectionStrategy, Component, contentChildren, HostListener, inject, input, model, output, ViewEncapsulation, } from "@angular/core";
import { SdEventsDirective } from "../../directives/sd-events.directive";
import { SdSheetConfigModal } from "../../modals/sd-sheet-config.modal";
import { SdAngularConfigProvider } from "../../providers/sd-angular-config.provider";
import { SdModalProvider } from "../../providers/sd-modal.provider";
import { $computed } from "../../utils/bindings/$computed";
import { SdExpandingManager } from "../../utils/managers/sd-expanding-manager";
import { SdSelectionManager } from "../../utils/managers/sd-selection-manager";
import { SdSortingManager } from "../../utils/managers/sd-sorting-manager";
import { useSdSystemConfigResource } from "../../utils/signals/use-sd-system-config.resource";
import { transformBoolean } from "../../utils/type-tramsforms";
import { SdAnchorControl } from "../sd-anchor.control";
import { SdBusyContainerControl } from "../sd-busy-container.control";
import { SdCheckboxControl } from "../sd-checkbox.control";
import { SdDockContainerControl } from "../sd-dock-container.control";
import { SdDockControl } from "../sd-dock.control";
import { SdIconLayersControl } from "../sd-icon-layers.control";
import { SdIconControl } from "../sd-icon.control";
import { SdPaginationControl } from "../sd-pagination.control";
import { SdPaneControl } from "../sd-pane.control";
import { SdSheetColumnDirective } from "./directives/sd-sheet-column.directive";
import { SdSheetCellAgent } from "./features/sd-sheet-cell-agent";
import { SdSheetColumnFixingManager } from "./features/sd-sheet-column-fixing-manager";
import { SdSheetDomAccessor } from "./features/sd-sheet-dom-accessor";
import { SdSheetFocusIndicatorRenderer } from "./features/sd-sheet-focus-indicator-renderer";
import { SdSheetLayoutEngine } from "./features/sd-sheet-layout-engine";
import { SdSheetSelectRowIndicatorRenderer } from "./features/sd-sheet-select-row-indicator-renderer";
import * as i0 from "@angular/core";
const _c0 = (a0, a1) => ({ r: a0, c: a1 });
const _c1 = (a0, a1, a2, a3, a4) => ({ $implicit: a0, item: a1, index: a2, depth: a3, edit: a4 });
function _forTrack0($index, $item) { return this.trackByFn()($item, $index); }
const _forTrack1 = ($index, $item) => $item.control.key();
function SdSheetControl_Conditional_2_Conditional_2_Template(rf, ctx) { if (rf & 1) {
    const _r1 = i0.ɵɵgetCurrentView();
    i0.ɵɵelementStart(0, "sd-anchor", 11);
    i0.ɵɵlistener("click", function SdSheetControl_Conditional_2_Conditional_2_Template_sd_anchor_click_0_listener() { i0.ɵɵrestoreView(_r1); const ctx_r1 = i0.ɵɵnextContext(2); return i0.ɵɵresetView(ctx_r1.onConfigButtonClick()); });
    i0.ɵɵelement(1, "sd-icon", 12);
    i0.ɵɵelementEnd();
} if (rf & 2) {
    const ctx_r1 = i0.ɵɵnextContext(2);
    i0.ɵɵadvance();
    i0.ɵɵproperty("icon", ctx_r1.icons.cog);
} }
function SdSheetControl_Conditional_2_Conditional_3_Template(rf, ctx) { if (rf & 1) {
    const _r3 = i0.ɵɵgetCurrentView();
    i0.ɵɵelementStart(0, "sd-pagination", 13);
    i0.ɵɵtwoWayListener("currentPageChange", function SdSheetControl_Conditional_2_Conditional_3_Template_sd_pagination_currentPageChange_0_listener($event) { i0.ɵɵrestoreView(_r3); const ctx_r1 = i0.ɵɵnextContext(2); i0.ɵɵtwoWayBindingSet(ctx_r1.currentPage, $event) || (ctx_r1.currentPage = $event); return i0.ɵɵresetView($event); });
    i0.ɵɵelementEnd();
} if (rf & 2) {
    const ctx_r1 = i0.ɵɵnextContext(2);
    i0.ɵɵtwoWayProperty("currentPage", ctx_r1.currentPage);
    i0.ɵɵproperty("totalPageCount", ctx_r1.effectivePageCount())("visiblePageCount", ctx_r1.visiblePageCount());
} }
function SdSheetControl_Conditional_2_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "sd-dock")(1, "div", 9);
    i0.ɵɵtemplate(2, SdSheetControl_Conditional_2_Conditional_2_Template, 2, 1, "sd-anchor")(3, SdSheetControl_Conditional_2_Conditional_3_Template, 1, 3, "sd-pagination", 10);
    i0.ɵɵelementEnd()();
} if (rf & 2) {
    const ctx_r1 = i0.ɵɵnextContext();
    i0.ɵɵadvance(2);
    i0.ɵɵconditional(ctx_r1.key() ? 2 : -1);
    i0.ɵɵadvance();
    i0.ɵɵconditional(ctx_r1.effectivePageCount() > 1 ? 3 : -1);
} }
function SdSheetControl_For_7_Conditional_1_Conditional_2_Template(rf, ctx) { if (rf & 1) {
    const _r6 = i0.ɵɵgetCurrentView();
    i0.ɵɵelementStart(0, "sd-checkbox", 17);
    i0.ɵɵlistener("valueChange", function SdSheetControl_For_7_Conditional_1_Conditional_2_Template_sd_checkbox_valueChange_0_listener() { i0.ɵɵrestoreView(_r6); const ctx_r1 = i0.ɵɵnextContext(3); return i0.ɵɵresetView(ctx_r1.selectionManager.toggleAll()); });
    i0.ɵɵelementEnd();
} if (rf & 2) {
    const ctx_r1 = i0.ɵɵnextContext(3);
    i0.ɵɵproperty("value", ctx_r1.selectionManager.isAllSelected())("inline", true);
} }
function SdSheetControl_For_7_Conditional_1_Conditional_3_Template(rf, ctx) { if (rf & 1) {
    const _r7 = i0.ɵɵgetCurrentView();
    i0.ɵɵelementStart(0, "th", 14);
    i0.ɵɵlistener("sdResize", function SdSheetControl_For_7_Conditional_1_Conditional_3_Template_th_sdResize_0_listener($event) { i0.ɵɵrestoreView(_r7); const ctx_r1 = i0.ɵɵnextContext(3); return i0.ɵɵresetView(ctx_r1.onHeaderLastRowCellResize($event, -1)); });
    i0.ɵɵelementStart(1, "sd-icon", 18);
    i0.ɵɵlistener("click", function SdSheetControl_For_7_Conditional_1_Conditional_3_Template_sd_icon_click_1_listener() { i0.ɵɵrestoreView(_r7); const ctx_r1 = i0.ɵɵnextContext(3); return i0.ɵɵresetView(ctx_r1.expandingManager.toggleAll()); });
    i0.ɵɵelementEnd()();
} if (rf & 2) {
    const ctx_r1 = i0.ɵɵnextContext(3);
    i0.ɵɵstyleProp("left", ctx_r1.columnFixingManager.fixedLeftMap().get(-1), "px");
    i0.ɵɵattribute("rowspan", ctx_r1.layoutEngine.headerFeatureRowSpan())("c", -1);
    i0.ɵɵadvance();
    i0.ɵɵclassProp("tx-theme-primary-default", ctx_r1.expandingManager.isAllExpanded());
    i0.ɵɵproperty("icon", ctx_r1.icons.caretRight)("rotate", ctx_r1.expandingManager.isAllExpanded() ? 90 : undefined);
} }
function SdSheetControl_For_7_Conditional_1_Template(rf, ctx) { if (rf & 1) {
    const _r4 = i0.ɵɵgetCurrentView();
    i0.ɵɵdeclareLet(0);
    i0.ɵɵelementStart(1, "th", 14);
    i0.ɵɵlistener("sdResize", function SdSheetControl_For_7_Conditional_1_Template_th_sdResize_1_listener($event) { i0.ɵɵrestoreView(_r4); const _c_r5 = i0.ɵɵreadContextLet(0); const ctx_r1 = i0.ɵɵnextContext(2); return i0.ɵɵresetView(ctx_r1.onHeaderLastRowCellResize($event, _c_r5)); });
    i0.ɵɵtemplate(2, SdSheetControl_For_7_Conditional_1_Conditional_2_Template, 1, 2, "sd-checkbox", 15);
    i0.ɵɵelementEnd();
    i0.ɵɵtemplate(3, SdSheetControl_For_7_Conditional_1_Conditional_3_Template, 2, 8, "th", 16);
} if (rf & 2) {
    const ctx_r1 = i0.ɵɵnextContext(2);
    const _c_r8 = i0.ɵɵstoreLet(ctx_r1.expandingManager.hasExpandable() ? -2 : -1);
    i0.ɵɵadvance();
    i0.ɵɵstyleProp("left", ctx_r1.columnFixingManager.fixedLeftMap().get(_c_r8), "px");
    i0.ɵɵattribute("rowspan", ctx_r1.layoutEngine.headerFeatureRowSpan())("c", _c_r8);
    i0.ɵɵadvance();
    i0.ɵɵconditional(ctx_r1.selectionManager.hasSelectable() && ctx_r1.selectMode() === "multi" ? 2 : -1);
    i0.ɵɵadvance();
    i0.ɵɵconditional(ctx_r1.expandingManager.hasExpandable() ? 3 : -1);
} }
function SdSheetControl_For_7_For_3_Conditional_0_Conditional_0_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "th")(1, "div", 21)(2, "div", 22)(3, "pre");
    i0.ɵɵtext(4);
    i0.ɵɵelementEnd()()()();
} if (rf & 2) {
    const ctx_r8 = i0.ɵɵnextContext(2);
    const headerCell_r10 = ctx_r8.$implicit;
    const ɵ$index_39_r11 = ctx_r8.$index;
    const ctx_r1 = i0.ɵɵnextContext(2);
    i0.ɵɵstyleProp("left", ctx_r1.columnFixingManager.fixedLeftMap().get(ɵ$index_39_r11), "px");
    i0.ɵɵclassProp("_fixed", headerCell_r10.fixed);
    i0.ɵɵattribute("colspan", headerCell_r10.colspan)("rowspan", headerCell_r10.rowspan)("c", ɵ$index_39_r11)("title", headerCell_r10.text);
    i0.ɵɵadvance(4);
    i0.ɵɵtextInterpolate(headerCell_r10.text);
} }
function SdSheetControl_For_7_For_3_Conditional_0_Conditional_1_Conditional_4_ng_template_0_Template(rf, ctx) { }
function SdSheetControl_For_7_For_3_Conditional_0_Conditional_1_Conditional_4_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵtemplate(0, SdSheetControl_For_7_For_3_Conditional_0_Conditional_1_Conditional_4_ng_template_0_Template, 0, 0, "ng-template", 25);
} if (rf & 2) {
    i0.ɵɵnextContext();
    const _tempRef_r13 = i0.ɵɵreadContextLet(2);
    i0.ɵɵproperty("ngTemplateOutlet", _tempRef_r13);
} }
function SdSheetControl_For_7_For_3_Conditional_0_Conditional_1_Conditional_5_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "pre");
    i0.ɵɵtext(1);
    i0.ɵɵelementEnd();
} if (rf & 2) {
    const headerCell_r10 = i0.ɵɵnextContext(3).$implicit;
    i0.ɵɵadvance();
    i0.ɵɵtextInterpolate(headerCell_r10.text);
} }
function SdSheetControl_For_7_For_3_Conditional_0_Conditional_1_Conditional_6_Conditional_4_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelement(0, "sd-icon", 29);
} if (rf & 2) {
    const ctx_r1 = i0.ɵɵnextContext(6);
    i0.ɵɵproperty("icon", ctx_r1.icons.sortDown);
} }
function SdSheetControl_For_7_For_3_Conditional_0_Conditional_1_Conditional_6_Conditional_5_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelement(0, "sd-icon", 29);
} if (rf & 2) {
    const ctx_r1 = i0.ɵɵnextContext(6);
    i0.ɵɵproperty("icon", ctx_r1.icons.sortUp);
} }
function SdSheetControl_For_7_For_3_Conditional_0_Conditional_1_Conditional_6_Conditional_7_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "sub");
    i0.ɵɵtext(1);
    i0.ɵɵelementEnd();
} if (rf & 2) {
    i0.ɵɵnextContext();
    const _idxText_r14 = i0.ɵɵreadContextLet(6);
    i0.ɵɵadvance();
    i0.ɵɵtextInterpolate(_idxText_r14);
} }
function SdSheetControl_For_7_For_3_Conditional_0_Conditional_1_Conditional_6_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "div", 26)(1, "sd-icon-layers");
    i0.ɵɵelement(2, "sd-icon", 28);
    i0.ɵɵdeclareLet(3);
    i0.ɵɵtemplate(4, SdSheetControl_For_7_For_3_Conditional_0_Conditional_1_Conditional_6_Conditional_4_Template, 1, 1, "sd-icon", 29)(5, SdSheetControl_For_7_For_3_Conditional_0_Conditional_1_Conditional_6_Conditional_5_Template, 1, 1, "sd-icon", 29);
    i0.ɵɵelementEnd();
    i0.ɵɵdeclareLet(6);
    i0.ɵɵtemplate(7, SdSheetControl_For_7_For_3_Conditional_0_Conditional_1_Conditional_6_Conditional_7_Template, 2, 1, "sub");
    i0.ɵɵelementEnd();
} if (rf & 2) {
    const headerCell_r10 = i0.ɵɵnextContext(3).$implicit;
    const ctx_r1 = i0.ɵɵnextContext(2);
    i0.ɵɵadvance(2);
    i0.ɵɵproperty("icon", ctx_r1.icons.sort);
    const _def_r15 = ctx_r1.sortingManager.defMap().get(headerCell_r10.control.key());
    i0.ɵɵadvance(2);
    i0.ɵɵconditional((_def_r15 == null ? null : _def_r15.desc) === false ? 4 : (_def_r15 == null ? null : _def_r15.desc) === true ? 5 : -1);
    i0.ɵɵadvance(2);
    const _idxText_r16 = i0.ɵɵstoreLet(_def_r15 == null ? null : _def_r15.indexText);
    i0.ɵɵadvance();
    i0.ɵɵconditional(_idxText_r16 ? 7 : -1);
} }
function SdSheetControl_For_7_For_3_Conditional_0_Conditional_1_Conditional_7_Template(rf, ctx) { if (rf & 1) {
    const _r17 = i0.ɵɵgetCurrentView();
    i0.ɵɵelementStart(0, "div", 30);
    i0.ɵɵlistener("mousedown", function SdSheetControl_For_7_For_3_Conditional_0_Conditional_1_Conditional_7_Template_div_mousedown_0_listener($event) { i0.ɵɵrestoreView(_r17); const headerCell_r10 = i0.ɵɵnextContext(3).$implicit; const ctx_r1 = i0.ɵɵnextContext(2); return i0.ɵɵresetView(ctx_r1.onResizerMousedown($event, headerCell_r10.control.key())); })("dblclick", function SdSheetControl_For_7_For_3_Conditional_0_Conditional_1_Conditional_7_Template_div_dblclick_0_listener($event) { i0.ɵɵrestoreView(_r17); const headerCell_r10 = i0.ɵɵnextContext(3).$implicit; const ctx_r1 = i0.ɵɵnextContext(2); return i0.ɵɵresetView(ctx_r1.onResizerDoubleClick($event, headerCell_r10.control.key())); });
    i0.ɵɵelementEnd();
} }
function SdSheetControl_For_7_For_3_Conditional_0_Conditional_1_Template(rf, ctx) { if (rf & 1) {
    const _r12 = i0.ɵɵgetCurrentView();
    i0.ɵɵelementStart(0, "th", 23);
    i0.ɵɵlistener("sdResize", function SdSheetControl_For_7_For_3_Conditional_0_Conditional_1_Template_th_sdResize_0_listener($event) { i0.ɵɵrestoreView(_r12); const ɵ$index_39_r11 = i0.ɵɵnextContext(2).$index; const ctx_r1 = i0.ɵɵnextContext(2); return i0.ɵɵresetView(ctx_r1.onHeaderLastRowCellResize($event, ɵ$index_39_r11)); })("click", function SdSheetControl_For_7_For_3_Conditional_0_Conditional_1_Template_th_click_0_listener($event) { i0.ɵɵrestoreView(_r12); const headerCell_r10 = i0.ɵɵnextContext(2).$implicit; const ctx_r1 = i0.ɵɵnextContext(2); return i0.ɵɵresetView(ctx_r1.onHeaderCellClick($event, headerCell_r10)); });
    i0.ɵɵelementStart(1, "div", 21);
    i0.ɵɵdeclareLet(2);
    i0.ɵɵelementStart(3, "div", 24);
    i0.ɵɵtemplate(4, SdSheetControl_For_7_For_3_Conditional_0_Conditional_1_Conditional_4_Template, 1, 1, null, 25)(5, SdSheetControl_For_7_For_3_Conditional_0_Conditional_1_Conditional_5_Template, 2, 1, "pre");
    i0.ɵɵelementEnd();
    i0.ɵɵtemplate(6, SdSheetControl_For_7_For_3_Conditional_0_Conditional_1_Conditional_6_Template, 8, 4, "div", 26);
    i0.ɵɵelementEnd();
    i0.ɵɵtemplate(7, SdSheetControl_For_7_For_3_Conditional_0_Conditional_1_Conditional_7_Template, 1, 0, "div", 27);
    i0.ɵɵelementEnd();
} if (rf & 2) {
    let tmp_34_0;
    const ctx_r8 = i0.ɵɵnextContext(2);
    const headerCell_r10 = ctx_r8.$implicit;
    const ɵ$index_39_r11 = ctx_r8.$index;
    const ctx_r1 = i0.ɵɵnextContext(2);
    i0.ɵɵstyleProp("width", headerCell_r10.width)("min-width", headerCell_r10.width)("max-width", headerCell_r10.width)("left", ctx_r1.columnFixingManager.fixedLeftMap().get(ɵ$index_39_r11), "px");
    i0.ɵɵclassProp("_fixed", headerCell_r10.fixed)("_sort", !headerCell_r10.control.disableSorting())("help", headerCell_r10.control.tooltip());
    i0.ɵɵattribute("colspan", headerCell_r10.colspan)("rowspan", headerCell_r10.rowspan)("c", ɵ$index_39_r11)("title", (tmp_34_0 = headerCell_r10.control.tooltip()) !== null && tmp_34_0 !== undefined ? tmp_34_0 : headerCell_r10.text);
    i0.ɵɵadvance(2);
    const _tempRef_r18 = i0.ɵɵstoreLet(headerCell_r10.control.headerTemplateRef());
    i0.ɵɵadvance();
    i0.ɵɵclassProp("_padding", !_tempRef_r18);
    i0.ɵɵattribute("style", headerCell_r10.style, i0.ɵɵsanitizeStyle);
    i0.ɵɵadvance();
    i0.ɵɵconditional(_tempRef_r18 ? 4 : 5);
    i0.ɵɵadvance(2);
    i0.ɵɵconditional(!headerCell_r10.control.disableSorting() ? 6 : -1);
    i0.ɵɵadvance();
    i0.ɵɵconditional(!headerCell_r10.control.disableResizing() ? 7 : -1);
} }
function SdSheetControl_For_7_For_3_Conditional_0_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵtemplate(0, SdSheetControl_For_7_For_3_Conditional_0_Conditional_0_Template, 5, 9, "th", 19)(1, SdSheetControl_For_7_For_3_Conditional_0_Conditional_1_Template, 8, 25, "th", 20);
} if (rf & 2) {
    const headerCell_r10 = i0.ɵɵnextContext().$implicit;
    i0.ɵɵconditional(!headerCell_r10.isLastRow ? 0 : 1);
} }
function SdSheetControl_For_7_For_3_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵtemplate(0, SdSheetControl_For_7_For_3_Conditional_0_Template, 2, 1);
} if (rf & 2) {
    const headerCell_r10 = ctx.$implicit;
    i0.ɵɵconditional(headerCell_r10 ? 0 : -1);
} }
function SdSheetControl_For_7_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "tr");
    i0.ɵɵtemplate(1, SdSheetControl_For_7_Conditional_1_Template, 4, 7);
    i0.ɵɵrepeaterCreate(2, SdSheetControl_For_7_For_3_Template, 1, 1, null, null, i0.ɵɵrepeaterTrackByIndex);
    i0.ɵɵelementEnd();
} if (rf & 2) {
    const headerRow_r19 = ctx.$implicit;
    const ɵ$index_24_r20 = ctx.$index;
    i0.ɵɵadvance();
    i0.ɵɵconditional(ɵ$index_24_r20 === 0 ? 1 : -1);
    i0.ɵɵadvance();
    i0.ɵɵrepeater(headerRow_r19);
} }
function SdSheetControl_Conditional_8_For_2_Conditional_2_ng_template_0_Template(rf, ctx) { }
function SdSheetControl_Conditional_8_For_2_Conditional_2_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵtemplate(0, SdSheetControl_Conditional_8_For_2_Conditional_2_ng_template_0_Template, 0, 0, "ng-template", 25);
} if (rf & 2) {
    i0.ɵɵnextContext();
    const _tempRef_r21 = i0.ɵɵreadContextLet(1);
    i0.ɵɵproperty("ngTemplateOutlet", _tempRef_r21);
} }
function SdSheetControl_Conditional_8_For_2_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "th");
    i0.ɵɵdeclareLet(1);
    i0.ɵɵtemplate(2, SdSheetControl_Conditional_8_For_2_Conditional_2_Template, 1, 1, null, 25);
    i0.ɵɵelementEnd();
} if (rf & 2) {
    const colDef_r22 = ctx.$implicit;
    const ɵ$index_91_r23 = ctx.$index;
    const ctx_r1 = i0.ɵɵnextContext(2);
    i0.ɵɵstyleProp("left", ctx_r1.columnFixingManager.fixedLeftMap().get(ɵ$index_91_r23), "px");
    i0.ɵɵclassProp("_fixed", colDef_r22.fixed);
    i0.ɵɵadvance();
    const _tempRef_r24 = i0.ɵɵstoreLet(colDef_r22.control.summaryTemplateRef());
    i0.ɵɵadvance();
    i0.ɵɵconditional(_tempRef_r24 ? 2 : -1);
} }
function SdSheetControl_Conditional_8_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "tr", 4);
    i0.ɵɵrepeaterCreate(1, SdSheetControl_Conditional_8_For_2_Template, 3, 6, "th", 19, i0.ɵɵrepeaterTrackByIndex);
    i0.ɵɵelementEnd();
} if (rf & 2) {
    const ctx_r1 = i0.ɵɵnextContext();
    i0.ɵɵadvance();
    i0.ɵɵrepeater(ctx_r1.layoutEngine.columnDefs());
} }
function SdSheetControl_For_11_Conditional_3_Template(rf, ctx) { if (rf & 1) {
    const _r27 = i0.ɵɵgetCurrentView();
    i0.ɵɵdeclareLet(0);
    i0.ɵɵelementStart(1, "sd-checkbox", 36);
    i0.ɵɵlistener("valueChange", function SdSheetControl_For_11_Conditional_3_Template_sd_checkbox_valueChange_1_listener() { i0.ɵɵrestoreView(_r27); const item_r26 = i0.ɵɵnextContext().$implicit; const ctx_r1 = i0.ɵɵnextContext(); return i0.ɵɵresetView(ctx_r1.selectionManager.toggle(item_r26)); });
    i0.ɵɵelementEnd();
} if (rf & 2) {
    const item_r26 = i0.ɵɵnextContext().$implicit;
    const ctx_r1 = i0.ɵɵnextContext();
    const _selectable_r28 = ctx_r1.selectionManager.getSelectable(item_r26);
    i0.ɵɵadvance();
    i0.ɵɵproperty("value", ctx_r1.selectedItems().includes(item_r26))("beforeChangeFn", ctx_r1.selectionManager.getBeforeChangeFn(item_r26))("inline", true)("disabled", _selectable_r28 !== true);
    i0.ɵɵattribute("title", _selectable_r28);
} }
function SdSheetControl_For_11_Conditional_4_Template(rf, ctx) { if (rf & 1) {
    const _r29 = i0.ɵɵgetCurrentView();
    i0.ɵɵdeclareLet(0);
    i0.ɵɵelementStart(1, "sd-checkbox", 36);
    i0.ɵɵlistener("valueChange", function SdSheetControl_For_11_Conditional_4_Template_sd_checkbox_valueChange_1_listener() { i0.ɵɵrestoreView(_r29); const item_r26 = i0.ɵɵnextContext().$implicit; const ctx_r1 = i0.ɵɵnextContext(); return i0.ɵɵresetView(ctx_r1.selectionManager.toggle(item_r26)); });
    i0.ɵɵelementEnd();
} if (rf & 2) {
    const item_r26 = i0.ɵɵnextContext().$implicit;
    const ctx_r1 = i0.ɵɵnextContext();
    const _selectable_r30 = ctx_r1.selectionManager.getSelectable(item_r26);
    i0.ɵɵadvance();
    i0.ɵɵproperty("value", ctx_r1.selectedItems().includes(item_r26))("beforeChangeFn", ctx_r1.selectionManager.getBeforeChangeFn(item_r26))("inline", true)("disabled", _selectable_r30 !== true);
    i0.ɵɵattribute("title", _selectable_r30);
} }
function SdSheetControl_For_11_Conditional_5_Conditional_2_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelement(0, "div", 39);
} if (rf & 2) {
    i0.ɵɵnextContext();
    const itemExpDef_r31 = i0.ɵɵreadContextLet(1);
    i0.ɵɵstyleProp("margin-left", itemExpDef_r31.depth - 0.5, "em");
} }
function SdSheetControl_For_11_Conditional_5_Conditional_3_Template(rf, ctx) { if (rf & 1) {
    const _r32 = i0.ɵɵgetCurrentView();
    i0.ɵɵelementStart(0, "sd-icon", 18);
    i0.ɵɵlistener("click", function SdSheetControl_For_11_Conditional_5_Conditional_3_Template_sd_icon_click_0_listener() { i0.ɵɵrestoreView(_r32); const item_r26 = i0.ɵɵnextContext(2).$implicit; const ctx_r1 = i0.ɵɵnextContext(); return i0.ɵɵresetView(ctx_r1.expandingManager.toggle(item_r26)); });
    i0.ɵɵelementEnd();
} if (rf & 2) {
    const item_r26 = i0.ɵɵnextContext(2).$implicit;
    const ctx_r1 = i0.ɵɵnextContext();
    i0.ɵɵclassProp("tx-theme-primary-default", ctx_r1.expandedItems().includes(item_r26));
    i0.ɵɵproperty("icon", ctx_r1.icons.caretRight)("rotate", ctx_r1.expandedItems().includes(item_r26) ? 90 : undefined);
} }
function SdSheetControl_For_11_Conditional_5_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "td", 32);
    i0.ɵɵdeclareLet(1);
    i0.ɵɵtemplate(2, SdSheetControl_For_11_Conditional_5_Conditional_2_Template, 1, 2, "div", 37)(3, SdSheetControl_For_11_Conditional_5_Conditional_3_Template, 1, 4, "sd-icon", 38);
    i0.ɵɵelementEnd();
} if (rf & 2) {
    const ctx_r32 = i0.ɵɵnextContext();
    const item_r26 = ctx_r32.$implicit;
    const ɵ$index_100_r34 = ctx_r32.$index;
    const ctx_r1 = i0.ɵɵnextContext();
    i0.ɵɵstyleProp("left", ctx_r1.columnFixingManager.fixedLeftMap().get(-1), "px");
    i0.ɵɵattribute("r", ɵ$index_100_r34)("c", -1);
    i0.ɵɵadvance();
    const itemExpDef_r35 = i0.ɵɵstoreLet(ctx_r1.expandingManager.getDef(item_r26));
    i0.ɵɵadvance();
    i0.ɵɵconditional(itemExpDef_r35.depth > 0 ? 2 : -1);
    i0.ɵɵadvance();
    i0.ɵɵconditional(itemExpDef_r35.hasChildren ? 3 : -1);
} }
function SdSheetControl_For_11_For_7_ng_template_1_Template(rf, ctx) { }
function SdSheetControl_For_11_For_7_Template(rf, ctx) { if (rf & 1) {
    const _r36 = i0.ɵɵgetCurrentView();
    i0.ɵɵelementStart(0, "td", 40);
    i0.ɵɵlistener("click", function SdSheetControl_For_11_For_7_Template_td_click_0_listener() { i0.ɵɵrestoreView(_r36); const item_r26 = i0.ɵɵnextContext().$implicit; const ctx_r1 = i0.ɵɵnextContext(); return i0.ɵɵresetView(ctx_r1.onItemCellClick(item_r26)); })("dblclick", function SdSheetControl_For_11_For_7_Template_td_dblclick_0_listener($event) { i0.ɵɵrestoreView(_r36); const ctx_r1 = i0.ɵɵnextContext(2); return i0.ɵɵresetView(ctx_r1.onItemCellDoubleClick($event)); })("keydown", function SdSheetControl_For_11_For_7_Template_td_keydown_0_listener($event) { const columnDef_r37 = i0.ɵɵrestoreView(_r36).$implicit; const item_r26 = i0.ɵɵnextContext().$implicit; const ctx_r1 = i0.ɵɵnextContext(); return i0.ɵɵresetView(ctx_r1.cellKeydown.emit({ item: item_r26, key: columnDef_r37.control.key(), event: $event })); });
    i0.ɵɵtemplate(1, SdSheetControl_For_11_For_7_ng_template_1_Template, 0, 0, "ng-template", 41);
    i0.ɵɵelementEnd();
} if (rf & 2) {
    let tmp_23_0;
    let tmp_24_0;
    const columnDef_r37 = ctx.$implicit;
    const ɵ$index_124_r38 = ctx.$index;
    const ctx_r32 = i0.ɵɵnextContext();
    const item_r26 = ctx_r32.$implicit;
    const ɵ$index_100_r34 = ctx_r32.$index;
    const ctx_r1 = i0.ɵɵnextContext();
    i0.ɵɵstyleMap((tmp_23_0 = ctx_r1.getItemCellStyleFn()) == null ? null : tmp_23_0(item_r26, columnDef_r37.control.key()));
    i0.ɵɵclassMap((tmp_24_0 = ctx_r1.getItemCellClassFn()) == null ? null : tmp_24_0(item_r26, columnDef_r37.control.key()));
    i0.ɵɵstyleProp("width", columnDef_r37.width)("min-width", columnDef_r37.width)("max-width", columnDef_r37.width)("left", ctx_r1.columnFixingManager.fixedLeftMap().get(ɵ$index_124_r38), "px");
    i0.ɵɵclassProp("_fixed", columnDef_r37.fixed);
    i0.ɵɵattribute("r", ɵ$index_100_r34)("c", ɵ$index_124_r38);
    i0.ɵɵadvance();
    i0.ɵɵproperty("ngTemplateOutlet", columnDef_r37.control.cellTemplateRef())("ngTemplateOutletContext", i0.ɵɵpureFunction5(21, _c1, item_r26, item_r26, ɵ$index_100_r34, ctx_r1.expandingManager.getDef(item_r26).depth, ctx_r1.cellAgent.getIsCellEditMode(i0.ɵɵpureFunction2(18, _c0, ɵ$index_100_r34, ɵ$index_124_r38))));
} }
function SdSheetControl_For_11_Template(rf, ctx) { if (rf & 1) {
    const _r25 = i0.ɵɵgetCurrentView();
    i0.ɵɵelementStart(0, "tr", 31);
    i0.ɵɵlistener("keydown", function SdSheetControl_For_11_Template_tr_keydown_0_listener($event) { const item_r26 = i0.ɵɵrestoreView(_r25).$implicit; const ctx_r1 = i0.ɵɵnextContext(); return i0.ɵɵresetView(ctx_r1.itemKeydown.emit({ item: item_r26, event: $event })); });
    i0.ɵɵdeclareLet(1);
    i0.ɵɵelementStart(2, "td", 32);
    i0.ɵɵtemplate(3, SdSheetControl_For_11_Conditional_3_Template, 2, 5, "sd-checkbox", 33)(4, SdSheetControl_For_11_Conditional_4_Template, 2, 5, "sd-checkbox", 33);
    i0.ɵɵelementEnd();
    i0.ɵɵtemplate(5, SdSheetControl_For_11_Conditional_5_Template, 4, 7, "td", 34);
    i0.ɵɵrepeaterCreate(6, SdSheetControl_For_11_For_7_Template, 2, 27, "td", 35, _forTrack1);
    i0.ɵɵelementEnd();
} if (rf & 2) {
    const item_r26 = ctx.$implicit;
    const ɵ$index_100_r34 = ctx.$index;
    const ctx_r1 = i0.ɵɵnextContext();
    i0.ɵɵproperty("hidden", !ctx_r1.expandingManager.getIsVisible(item_r26));
    i0.ɵɵattribute("r", ɵ$index_100_r34);
    const _c_r39 = ctx_r1.getChildrenFn() ? -2 : -1;
    i0.ɵɵadvance(2);
    i0.ɵɵstyleProp("left", ctx_r1.columnFixingManager.fixedLeftMap().get(_c_r39), "px");
    i0.ɵɵattribute("r", ɵ$index_100_r34)("c", _c_r39);
    i0.ɵɵadvance();
    i0.ɵɵconditional(ctx_r1.selectMode() === "multi" ? 3 : ctx_r1.selectMode() === "single" ? 4 : -1);
    i0.ɵɵadvance(2);
    i0.ɵɵconditional(ctx_r1.expandingManager.hasExpandable() ? 5 : -1);
    i0.ɵɵadvance();
    i0.ɵɵrepeater(ctx_r1.layoutEngine.columnDefs());
} }
export class SdSheetControl {
    constructor() {
        this.icons = inject(SdAngularConfigProvider).icons;
        this._sdModal = inject(SdModalProvider);
        this.busy = input(false, { transform: transformBoolean });
        this.hideConfigBar = input(false, { transform: transformBoolean });
        this.inset = input(false, { transform: transformBoolean });
        this.contentStyle = input();
        this.getItemCellClassFn = input();
        this.getItemCellStyleFn = input();
        this.itemKeydown = output();
        this.cellKeydown = output();
        this.columnControls = contentChildren(SdSheetColumnDirective);
        this.items = input([]);
        this.trackByFn = input((item) => item);
        this.domAccessor = new SdSheetDomAccessor();
        //region config
        this.key = input.required();
        this.config = useSdSystemConfigResource({
            key: this.key,
        });
        //endregion
        this.layoutEngine = new SdSheetLayoutEngine({
            columnControls: this.columnControls,
            config: this.config,
        });
        //region Column fixing
        this.columnFixingManager = new SdSheetColumnFixingManager({
            fixedLength: $computed(() => this.layoutEngine.columnDefs().filter((item) => item.fixed).length),
        });
        //endregion
        //region Resizing
        this._isOnResizing = false;
        //endregion
        //region Sorting
        this.sorts = model([]);
        this.sortingManager = new SdSortingManager({ sorts: this.sorts });
        this.useAutoSort = input(false, { transform: transformBoolean });
        this._sortedItems = $computed(() => {
            if (!this.useAutoSort())
                return this.items();
            return this.sortingManager.sort(this.items());
        });
        //endregion
        //region Paging
        this.visiblePageCount = input(10);
        this.totalPageCount = input(0);
        this.itemsPerPage = input();
        this.currentPage = model(0);
        this.effectivePageCount = $computed(() => {
            const itemsPerPage = this.itemsPerPage();
            if (itemsPerPage != null && itemsPerPage !== 0 && this.items().length > 0) {
                return Math.ceil(this.items().length / itemsPerPage);
            }
            else {
                return this.totalPageCount();
            }
        });
        this._sortedPagedItems = $computed(() => {
            const itemsPerPage = this.itemsPerPage();
            if (itemsPerPage == null || itemsPerPage === 0)
                return this._sortedItems();
            if (this.items().length <= 0)
                return this._sortedItems();
            const currentPage = this.currentPage();
            return this._sortedItems().slice(currentPage * itemsPerPage, (currentPage + 1) * itemsPerPage);
        });
        //endregion
        //region Expanding
        this.expandedItems = model([]);
        this.getChildrenFn = input();
        this.expandingManager = new SdExpandingManager({
            items: this._sortedPagedItems,
            expandedItems: this.expandedItems,
            getChildrenFn: this.getChildrenFn,
            sort: (items) => {
                return this.useAutoSort() ? this.sortingManager.sort(items) : items;
            },
        });
        this.displayItems = this.expandingManager.flattedItems;
        //endregion
        //region Selecting
        this.selectMode = input();
        this.selectedItems = model([]);
        this.autoSelect = input();
        this.getItemSelectableFn = input();
        this.selectionManager = new SdSelectionManager({
            displayItems: this.displayItems,
            selectedItems: this.selectedItems,
            selectMode: this.selectMode,
            getItemSelectableFn: this.getItemSelectableFn,
        });
        //endregion
        //region Cell agent
        this.cellAgent = new SdSheetCellAgent({
            domAccessor: this.domAccessor,
        });
        //endregion
        //region focus/select indicator
        this.focusMode = input("cell");
        this.selectRowIndicatorRenderer = new SdSheetSelectRowIndicatorRenderer({
            domAccessor: this.domAccessor,
            selectedItems: this.selectedItems,
            displayItems: this.displayItems,
        });
        this.focusIndicatorRenderer = new SdSheetFocusIndicatorRenderer({
            domAccessor: this.domAccessor,
        });
    }
    async onConfigButtonClick() {
        const result = await this._sdModal.showAsync({
            type: SdSheetConfigModal,
            title: "시트 설정창",
            inputs: {
                sheetKey: this.key(),
                controls: this.columnControls(),
                config: this.config.value(),
            },
        }, {
            useCloseByBackdrop: true,
        });
        if (!result)
            return;
        this.config.set(result);
    }
    _saveColumnConfig(columnKey, config) {
        this.config.update((v) => ({
            ...v,
            columnRecord: {
                ...v?.columnRecord,
                [columnKey]: {
                    ...v?.columnRecord?.[columnKey],
                    ...config,
                },
            },
        }));
    }
    onHeaderLastRowCellResize(event, c) {
        this.columnFixingManager.registerWidth(c, event.contentRect.width);
    }
    onResizerMousedown(event, colKey) {
        this._isOnResizing = true;
        const thEl = event.target.findParent("th");
        const indicatorEl = this.domAccessor.getColumnResizeIndicator();
        const startX = event.clientX;
        const startWidthPx = thEl.clientWidth;
        const startLeft = thEl.offsetLeft;
        const doDrag = (e) => {
            e.stopPropagation();
            e.preventDefault();
            Object.assign(indicatorEl.style, {
                display: "block",
                left: startLeft + startWidthPx + e.clientX - startX + "px",
            });
        };
        const stopDrag = (e) => {
            e.stopPropagation();
            e.preventDefault();
            document.documentElement.removeEventListener("mousemove", doDrag, false);
            document.documentElement.removeEventListener("mouseup", stopDrag, false);
            indicatorEl.style.display = "none";
            const newWidthPx = Math.max(startWidthPx + e.clientX - startX, 5);
            this._saveColumnConfig(colKey, { width: newWidthPx + "px" });
            setTimeout(() => {
                this._isOnResizing = false;
            }, 300);
        };
        document.documentElement.addEventListener("mousemove", doDrag, false);
        document.documentElement.addEventListener("mouseup", stopDrag, false);
    }
    onResizerDoubleClick(event, colKey) {
        this._saveColumnConfig(colKey, { width: undefined });
    }
    onHeaderCellClick(event, headerCell) {
        if (headerCell.control.disableSorting())
            return;
        if (this._isOnResizing)
            return;
        if (event.target instanceof HTMLElement && event.target.classList.contains("_resizer"))
            return;
        if (event.shiftKey || event.ctrlKey) {
            this.sortingManager.toggle(headerCell.control.key(), true);
        }
        else {
            this.sortingManager.toggle(headerCell.control.key(), false);
        }
    }
    onItemCellClick(item) {
        if (this.autoSelect() !== "click")
            return;
        this.selectionManager.select(item);
    }
    onFocusCaptureForSelection(event) {
        if (!(event.target instanceof HTMLElement))
            return;
        const tdEl = event.target.tagName.toLowerCase() === "td" ? event.target : event.target.findParent("td");
        if (!(tdEl instanceof HTMLTableCellElement))
            return;
        const addr = this.cellAgent.getCellAddr(tdEl);
        const item = this.displayItems()[addr.r];
        if (this.autoSelect() === "focus") {
            this.selectionManager.select(item);
        }
    }
    async onKeydownCapture(event) {
        await this.cellAgent.handleKeydownCaptureAsync(event);
    }
    onItemCellDoubleClick(event) {
        this.cellAgent.handleCellDoubleClick(event);
    }
    onBlurCaptureForCellAgent(event) {
        this.cellAgent.handleBlurCapture(event);
    }
    //endregion
    //region Auto scroll
    onFocusCaptureForAutoScroll(event) {
        if (!(event.target instanceof HTMLElement))
            return;
        const containerEl = this.domAccessor.getContainer();
        const theadEl = this.domAccessor.getTHead();
        const fixedHeaderLastDepthEls = this.domAccessor.getLastDepthFixedHeaders();
        const tdEl = event.target.tagName.toLowerCase() === "td" ? event.target : event.target.findParent("td");
        if (!(tdEl instanceof HTMLTableCellElement))
            return;
        if (tdEl.classList.contains("_fixed"))
            return;
        const target = {
            top: tdEl.offsetTop,
            left: tdEl.offsetLeft - (tdEl.classList.contains("_fixed") ? containerEl.scrollLeft : 0),
        };
        const offset = {
            top: theadEl.offsetHeight,
            left: fixedHeaderLastDepthEls.sum((item) => item.offsetWidth),
        };
        containerEl.scrollIntoViewIfNeeded(target, offset);
    }
    onFocusCaptureForIndicator() {
        this.focusIndicatorRenderer.redraw();
    }
    onBlurCaptureForFocusIndicator() {
        this.focusIndicatorRenderer.redraw();
    }
    onSheetResize(event) {
        if (!event.widthChanged)
            return;
        this.focusIndicatorRenderer.redraw();
        this.selectRowIndicatorRenderer.redraw();
    }
    onContainerScroll() {
        this.focusIndicatorRenderer.redraw();
    }
    static { this.ɵfac = function SdSheetControl_Factory(__ngFactoryType__) { return new (__ngFactoryType__ || SdSheetControl)(); }; }
    static { this.ɵcmp = /*@__PURE__*/ i0.ɵɵdefineComponent({ type: SdSheetControl, selectors: [["sd-sheet"]], contentQueries: function SdSheetControl_ContentQueries(rf, ctx, dirIndex) { if (rf & 1) {
            i0.ɵɵcontentQuerySignal(dirIndex, ctx.columnControls, SdSheetColumnDirective, 4);
        } if (rf & 2) {
            i0.ɵɵqueryAdvance();
        } }, hostVars: 2, hostBindings: function SdSheetControl_HostBindings(rf, ctx) { if (rf & 1) {
            i0.ɵɵlistener("focus.capture", function SdSheetControl_focus_capture_HostBindingHandler($event) { return ctx.onFocusCaptureForIndicator($event); })("keydown.capture", function SdSheetControl_keydown_capture_HostBindingHandler($event) { return ctx.onKeydownCapture($event); })("blur.capture", function SdSheetControl_blur_capture_HostBindingHandler($event) { return ctx.onBlurCaptureForFocusIndicator($event); });
        } if (rf & 2) {
            i0.ɵɵattribute("sd-inset", ctx.inset())("sd-focus-mode", ctx.focusMode());
        } }, inputs: { busy: [1, "busy"], hideConfigBar: [1, "hideConfigBar"], inset: [1, "inset"], contentStyle: [1, "contentStyle"], getItemCellClassFn: [1, "getItemCellClassFn"], getItemCellStyleFn: [1, "getItemCellStyleFn"], items: [1, "items"], trackByFn: [1, "trackByFn"], key: [1, "key"], sorts: [1, "sorts"], useAutoSort: [1, "useAutoSort"], visiblePageCount: [1, "visiblePageCount"], totalPageCount: [1, "totalPageCount"], itemsPerPage: [1, "itemsPerPage"], currentPage: [1, "currentPage"], expandedItems: [1, "expandedItems"], getChildrenFn: [1, "getChildrenFn"], selectMode: [1, "selectMode"], selectedItems: [1, "selectedItems"], autoSelect: [1, "autoSelect"], getItemSelectableFn: [1, "getItemSelectableFn"], focusMode: [1, "focusMode"] }, outputs: { itemKeydown: "itemKeydown", cellKeydown: "cellKeydown", sorts: "sortsChange", currentPage: "currentPageChange", expandedItems: "expandedItemsChange", selectedItems: "selectedItemsChange" }, decls: 16, vars: 6, consts: [["type", "cube", 3, "busy"], [3, "hidden"], [1, "_sheet-container", 3, "scroll"], [3, "sdResize"], [1, "_summary-row"], [1, "_focus-row-indicator"], [1, "_focus-cell-indicator"], [1, "_resize-indicator"], [1, "_select-row-indicator-container"], [1, "flex-row-inline", "flex-gap-sm"], [3, "currentPage", "totalPageCount", "visiblePageCount"], [3, "click"], ["fixedWidth", "", 3, "icon"], [3, "currentPageChange", "currentPage", "totalPageCount", "visiblePageCount"], [1, "_fixed", "_feature-cell", "_last-depth", 3, "sdResize"], ["theme", "white", 3, "value", "inline"], [1, "_fixed", "_feature-cell", "_last-depth", 3, "left"], ["theme", "white", 3, "valueChange", "value", "inline"], ["fixedWidth", "", 3, "click", "icon", "rotate"], [3, "_fixed", "left"], [1, "_last-depth", 3, "_fixed", "_sort", "width", "min-width", "max-width", "left", "help"], [1, "flex-row", "align-items-end"], [1, "_contents", "flex-grow", "_padding"], [1, "_last-depth", 3, "sdResize", "click"], [1, "_contents", "flex-grow"], [3, "ngTemplateOutlet"], [1, "_sort-icon"], [1, "_resizer"], [1, "tx-trans-lightest", 3, "icon"], [3, "icon"], [1, "_resizer", 3, "mousedown", "dblclick"], [3, "keydown", "hidden"], [1, "_fixed", "_feature-cell"], ["theme", "white", 3, "value", "beforeChangeFn", "inline", "disabled"], [1, "_fixed", "_feature-cell", 3, "left"], ["tabindex", "0", 3, "_fixed", "width", "min-width", "max-width", "left", "class", "style"], ["theme", "white", 3, "valueChange", "value", "beforeChangeFn", "inline", "disabled"], [1, "_depth-indicator", 3, "margin-left"], ["fixedWidth", "", 3, "icon", "rotate", "tx-theme-primary-default"], [1, "_depth-indicator"], ["tabindex", "0", 3, "click", "dblclick", "keydown"], [3, "ngTemplateOutlet", "ngTemplateOutletContext"]], template: function SdSheetControl_Template(rf, ctx) { if (rf & 1) {
            i0.ɵɵelementStart(0, "sd-busy-container", 0)(1, "sd-dock-container", 1);
            i0.ɵɵtemplate(2, SdSheetControl_Conditional_2_Template, 4, 2, "sd-dock");
            i0.ɵɵelementStart(3, "sd-pane", 2);
            i0.ɵɵlistener("scroll", function SdSheetControl_Template_sd_pane_scroll_3_listener() { return ctx.onContainerScroll(); });
            i0.ɵɵelementStart(4, "table", 3);
            i0.ɵɵlistener("sdResize", function SdSheetControl_Template_table_sdResize_4_listener($event) { return ctx.onSheetResize($event); });
            i0.ɵɵelementStart(5, "thead");
            i0.ɵɵrepeaterCreate(6, SdSheetControl_For_7_Template, 4, 1, "tr", null, i0.ɵɵrepeaterTrackByIndex);
            i0.ɵɵtemplate(8, SdSheetControl_Conditional_8_Template, 3, 0, "tr", 4);
            i0.ɵɵelementEnd();
            i0.ɵɵelementStart(9, "tbody");
            i0.ɵɵrepeaterCreate(10, SdSheetControl_For_11_Template, 8, 8, "tr", 1, _forTrack0, true);
            i0.ɵɵelementEnd()();
            i0.ɵɵelementStart(12, "div", 5);
            i0.ɵɵelement(13, "div", 6);
            i0.ɵɵelementEnd();
            i0.ɵɵelement(14, "div", 7)(15, "div", 8);
            i0.ɵɵelementEnd()()();
        } if (rf & 2) {
            i0.ɵɵproperty("busy", ctx.busy());
            i0.ɵɵadvance();
            i0.ɵɵproperty("hidden", ctx.busy());
            i0.ɵɵadvance();
            i0.ɵɵconditional((ctx.key() || ctx.effectivePageCount() > 0) && !ctx.hideConfigBar() ? 2 : -1);
            i0.ɵɵadvance();
            i0.ɵɵstyleMap(ctx.contentStyle());
            i0.ɵɵadvance(3);
            i0.ɵɵrepeater(ctx.layoutEngine.headerDefTable());
            i0.ɵɵadvance(2);
            i0.ɵɵconditional(ctx.layoutEngine.hasSummary() ? 8 : -1);
            i0.ɵɵadvance(2);
            i0.ɵɵrepeater(ctx.displayItems());
        } }, dependencies: [SdBusyContainerControl,
            SdDockContainerControl,
            SdDockControl,
            SdAnchorControl,
            SdPaginationControl,
            SdPaneControl,
            NgTemplateOutlet,
            SdCheckboxControl,
            SdIconControl,
            SdIconLayersControl,
            SdEventsDirective], styles: ["sd-sheet>sd-busy-container{border-radius:var(--border-radius-default)}sd-sheet>sd-busy-container>._screen{border-radius:var(--border-radius-default)}sd-sheet>sd-busy-container>sd-dock-container>._content{border:1px solid var(--theme-grey-lighter);border-radius:var(--border-radius-default)}sd-sheet>sd-busy-container>sd-dock-container>._content>sd-dock{background:var(--control-color);border-top-left-radius:var(--border-radius-default);border-top-right-radius:var(--border-radius-default);border-bottom:1px solid var(--theme-grey-lighter)}sd-sheet>sd-busy-container>sd-dock-container>._content>sd-dock>div>sd-anchor{padding:var(--gap-sm)}sd-sheet>sd-busy-container>sd-dock-container>._content>sd-pane._sheet-container{background:var(--sheet-bg);border-bottom-left-radius:var(--border-radius-default);border-bottom-right-radius:var(--border-radius-default)}sd-sheet>sd-busy-container>sd-dock-container>._content>sd-pane._sheet-container>table{border-spacing:0;table-layout:fixed;margin-right:2px;margin-bottom:2px}sd-sheet>sd-busy-container>sd-dock-container>._content>sd-pane._sheet-container>table>*>tr>*:last-child{border-right:1px solid var(--theme-grey-lighter)}sd-sheet>sd-busy-container>sd-dock-container>._content>sd-pane._sheet-container>table>*>tr:last-child>*{border-bottom:1px solid var(--theme-grey-lighter)}sd-sheet>sd-busy-container>sd-dock-container>._content>sd-pane._sheet-container>table>*>tr>*{border-right:1px solid var(--theme-grey-lighter);border-bottom:1px solid var(--theme-grey-lighter);white-space:nowrap;overflow:hidden;padding:0;position:relative}sd-sheet>sd-busy-container>sd-dock-container>._content>sd-pane._sheet-container>table>*>tr>*._feature-cell{background:var(--theme-grey-lightest);min-width:calc(var(--font-size-default) + 2px + var(--sheet-ph) * 2);padding:var(--sheet-pv) var(--sheet-ph);text-align:left}sd-sheet>sd-busy-container>sd-dock-container>._content>sd-pane._sheet-container>table>*>tr>*._feature-cell>sd-icon{cursor:pointer;color:var(--text-trans-lightest)}sd-sheet>sd-busy-container>sd-dock-container>._content>sd-pane._sheet-container>table>*>tr>*._fixed{position:sticky;left:0}.js-has-pseudo [csstools-has-37-2s-19-37-2w-2t-2t-38-w-1q-w-37-2s-19-2q-39-37-3d-19-2r-33-32-38-2p-2x-32-2t-36-w-1q-w-37-2s-19-2s-33-2r-2z-19-2r-33-32-38-2p-2x-32-2t-36-w-1q-w-1a-2n-2r-33-32-38-2t-32-38-w-1q-w-37-2s-19-34-2p-32-2t-1a-2n-37-2w-2t-2t-38-19-2r-33-32-38-2p-2x-32-2t-36-w-1q-w-38-2p-2q-30-2t-w-1q-w-16-w-1q-w-38-36-w-1q-w-16-1a-2n-2u-2x-3c-2t-2s-1m-2w-2p-37-14-17-w-1m-32-33-38-14-1a-2n-2u-2x-3c-2t-2s-15-15]:not(.does-not-exist):not(.does-not-exist):not(.does-not-exist):not(does-not-exist):not(does-not-exist):not(does-not-exist):not(does-not-exist):not(does-not-exist):not(does-not-exist){border-right:1px solid var(--theme-grey-lighter)}sd-sheet>sd-busy-container>sd-dock-container>._content>sd-pane._sheet-container>table>*>tr>*._fixed:has(+:not(._fixed)){border-right:1px solid var(--theme-grey-lighter)}sd-sheet>sd-busy-container>sd-dock-container>._content>sd-pane._sheet-container>table>thead{position:sticky;top:0;z-index:3}sd-sheet>sd-busy-container>sd-dock-container>._content>sd-pane._sheet-container>table>thead>tr>th{position:relative;background:var(--theme-grey-lightest);vertical-align:middle}sd-sheet>sd-busy-container>sd-dock-container>._content>sd-pane._sheet-container>table>thead>tr>th._fixed{z-index:4}sd-sheet>sd-busy-container>sd-dock-container>._content>sd-pane._sheet-container>table>thead>tr>th._last-depth{border-bottom:1px solid var(--theme-grey-lighter)}sd-sheet>sd-busy-container>sd-dock-container>._content>sd-pane._sheet-container>table>thead>tr>th._feature-cell{border-bottom:1px solid var(--theme-grey-lighter)}sd-sheet>sd-busy-container>sd-dock-container>._content>sd-pane._sheet-container>table>thead>tr>th._sort{cursor:pointer}sd-sheet>sd-busy-container>sd-dock-container>._content>sd-pane._sheet-container>table>thead>tr>th._sort:hover{text-decoration:underline}sd-sheet>sd-busy-container>sd-dock-container>._content>sd-pane._sheet-container>table>thead>tr>th>div:first-child>._contents._padding{padding:var(--sheet-pv) var(--sheet-ph)}sd-sheet>sd-busy-container>sd-dock-container>._content>sd-pane._sheet-container>table>thead>tr>th>div:first-child>._sort-icon{display:inline-block;padding:var(--gap-xs) var(--gap-xs) var(--gap-xs) 0;background-color:var(--theme-grey-lightest)}sd-sheet>sd-busy-container>sd-dock-container>._content>sd-pane._sheet-container>table>thead>tr>th>._resizer{position:absolute;top:0;right:0;bottom:0;width:2px;cursor:ew-resize}.js-has-pseudo [csstools-has-37-2s-19-37-2w-2t-2t-38-w-1q-w-37-2s-19-2q-39-37-3d-19-2r-33-32-38-2p-2x-32-2t-36-w-1q-w-37-2s-19-2s-33-2r-2z-19-2r-33-32-38-2p-2x-32-2t-36-w-1q-w-1a-2n-2r-33-32-38-2t-32-38-w-1q-w-37-2s-19-34-2p-32-2t-1a-2n-37-2w-2t-2t-38-19-2r-33-32-38-2p-2x-32-2t-36-w-1q-w-38-2p-2q-30-2t-w-1q-w-38-2w-2t-2p-2s-1m-2w-2p-37-14-1q-w-38-36-1a-2n-37-39-31-31-2p-36-3d-19-36-33-3b-15-w-1q-w-38-36-w-1q-w-38-2w-1a-2n-30-2p-37-38-19-2s-2t-34-38-2w]:not(.does-not-exist):not(.does-not-exist):not(.does-not-exist):not(does-not-exist):not(does-not-exist):not(does-not-exist):not(does-not-exist):not(does-not-exist):not(does-not-exist):not(does-not-exist):not(does-not-exist):not(does-not-exist){border-bottom:1px solid var(--theme-grey-lighter)}sd-sheet>sd-busy-container>sd-dock-container>._content>sd-pane._sheet-container>table>thead:has(>tr._summary-row)>tr>th._last-depth{border-bottom:1px solid var(--theme-grey-lighter)}.js-has-pseudo [csstools-has-37-2s-19-37-2w-2t-2t-38-w-1q-w-37-2s-19-2q-39-37-3d-19-2r-33-32-38-2p-2x-32-2t-36-w-1q-w-37-2s-19-2s-33-2r-2z-19-2r-33-32-38-2p-2x-32-2t-36-w-1q-w-1a-2n-2r-33-32-38-2t-32-38-w-1q-w-37-2s-19-34-2p-32-2t-1a-2n-37-2w-2t-2t-38-19-2r-33-32-38-2p-2x-32-2t-36-w-1q-w-38-2p-2q-30-2t-w-1q-w-38-2w-2t-2p-2s-1m-2w-2p-37-14-1q-w-38-36-1a-2n-37-39-31-31-2p-36-3d-19-36-33-3b-15-w-1q-w-38-36-1a-2n-37-39-31-31-2p-36-3d-19-36-33-3b-w-1q-w-38-2w]:not(.does-not-exist):not(.does-not-exist):not(.does-not-exist):not(does-not-exist):not(does-not-exist):not(does-not-exist):not(does-not-exist):not(does-not-exist):not(does-not-exist):not(does-not-exist):not(does-not-exist):not(does-not-exist){background:var(--theme-warning-lightest);text-align:left;border-bottom:1px solid var(--theme-grey-lighter)}sd-sheet>sd-busy-container>sd-dock-container>._content>sd-pane._sheet-container>table>thead:has(>tr._summary-row)>tr._summary-row>th{background:var(--theme-warning-lightest);text-align:left;border-bottom:1px solid var(--theme-grey-lighter)}sd-sheet>sd-busy-container>sd-dock-container>._content>sd-pane._sheet-container>table>tbody>tr>td{background:var(--control-color);vertical-align:top}sd-sheet>sd-busy-container>sd-dock-container>._content>sd-pane._sheet-container>table>tbody>tr>td._fixed{z-index:2}sd-sheet>sd-busy-container>sd-dock-container>._content>sd-pane._sheet-container>table>tbody>tr>td>._depth-indicator{display:inline-block;margin-top:.4em;width:.5em;height:.5em;border-left:1px solid var(--text-trans-default);border-bottom:1px solid var(--text-trans-default);vertical-align:top}sd-sheet>sd-busy-container>sd-dock-container>._content>sd-pane._sheet-container>._focus-row-indicator{display:none;position:absolute;pointer-events:none;background:#9e9e9e1a;z-index:6}sd-sheet>sd-busy-container>sd-dock-container>._content>sd-pane._sheet-container>._focus-row-indicator>._focus-cell-indicator{position:absolute;border:2px solid var(--theme-primary-default)}sd-sheet>sd-busy-container>sd-dock-container>._content>sd-pane._sheet-container>._resize-indicator{display:none;position:absolute;pointer-events:none;top:0;height:100%;border:1px dotted var(--theme-grey-light);z-index:7}sd-sheet>sd-busy-container>sd-dock-container>._content>sd-pane._sheet-container>._select-row-indicator-container{display:none;position:absolute;pointer-events:none;top:0;left:0;width:100%;height:100%;z-index:5}sd-sheet>sd-busy-container>sd-dock-container>._content>sd-pane._sheet-container>._select-row-indicator-container>._select-row-indicator{display:block;left:0;position:absolute;pointer-events:none;background:var(--theme-primary-default);opacity:.1}sd-sheet[sd-focus-mode=row]>sd-busy-container>sd-dock-container>._content>sd-pane._sheet-container>._focus-row-indicator>._focus-cell-indicator{display:none!important}sd-sheet[sd-inset=true]>sd-busy-container{border-radius:var(--border-radius-default)}sd-sheet[sd-inset=true]>sd-busy-container>._screen{border-radius:var(--border-radius-default)}sd-sheet[sd-inset=true]>sd-busy-container>sd-dock-container>._content{border:none;border-radius:0}\n"], encapsulation: 2, changeDetection: 0 }); }
}
(() => { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(SdSheetControl, [{
        type: Component,
        args: [{ selector: "sd-sheet", changeDetection: ChangeDetectionStrategy.OnPush, encapsulation: ViewEncapsulation.None, standalone: true, imports: [
                    SdBusyContainerControl,
                    SdDockContainerControl,
                    SdDockControl,
                    SdAnchorControl,
                    SdPaginationControl,
                    SdPaneControl,
                    NgTemplateOutlet,
                    SdCheckboxControl,
                    SdIconControl,
                    SdIconLayersControl,
                    SdEventsDirective,
                ], template: `
    <sd-busy-container [busy]="busy()" type="cube">
      <sd-dock-container [hidden]="busy()">
        @if ((key() || effectivePageCount() > 0) && !hideConfigBar()) {
          <sd-dock>
            <div class="flex-row-inline flex-gap-sm">
              @if (key()) {
                <sd-anchor (click)="onConfigButtonClick()">
                  <sd-icon [icon]="icons.cog" fixedWidth />
                </sd-anchor>
              }
              @if (effectivePageCount() > 1) {
                <sd-pagination
                  [(currentPage)]="currentPage"
                  [totalPageCount]="effectivePageCount()"
                  [visiblePageCount]="visiblePageCount()"
                />
              }
            </div>
          </sd-dock>
        }

        <sd-pane class="_sheet-container" (scroll)="onContainerScroll()" [style]="contentStyle()">
          <table (sdResize)="onSheetResize($event)">
            <thead>
              @for (headerRow of layoutEngine.headerDefTable(); let r = $index; track r) {
                <tr>
                  <!-- 첫번째 ROW에만 기능컬럼 작성 -->
                  @if (r === 0) {
                    @let _c = expandingManager.hasExpandable() ? -2 : -1;
                    <th
                      class="_fixed _feature-cell _last-depth"
                      [attr.rowspan]="layoutEngine.headerFeatureRowSpan()"
                      [attr.c]="_c"
                      [style.left.px]="columnFixingManager.fixedLeftMap().get(_c)"
                      (sdResize)="onHeaderLastRowCellResize($event, _c)"
                    >
                      @if (selectionManager.hasSelectable() && selectMode() === "multi") {
                        <sd-checkbox
                          [value]="selectionManager.isAllSelected()"
                          (valueChange)="selectionManager.toggleAll()"
                          [inline]="true"
                          theme="white"
                        />
                      }
                    </th>

                    <!-- Expand 가능일때, expand 컬럼 추가 -->
                    @if (expandingManager.hasExpandable()) {
                      <th
                        class="_fixed _feature-cell _last-depth"
                        [attr.rowspan]="layoutEngine.headerFeatureRowSpan()"
                        [attr.c]="-1"
                        [style.left.px]="columnFixingManager.fixedLeftMap().get(-1)"
                        (sdResize)="onHeaderLastRowCellResize($event, -1)"
                      >
                        <sd-icon
                          [icon]="icons.caretRight"
                          fixedWidth
                          [class.tx-theme-primary-default]="expandingManager.isAllExpanded()"
                          [rotate]="expandingManager.isAllExpanded() ? 90 : undefined"
                          (click)="expandingManager.toggleAll()"
                        />
                      </th>
                    }
                  }
                  @for (headerCell of headerRow; let c = $index; track c) {
                    @if (headerCell) {
                      @if (!headerCell.isLastRow) {
                        <!-- 마지막 ROW가 아닐때 -->
                        <th
                          [class._fixed]="headerCell.fixed"
                          [attr.colspan]="headerCell.colspan"
                          [attr.rowspan]="headerCell.rowspan"
                          [attr.c]="c"
                          [attr.title]="headerCell.text"
                          [style.left.px]="columnFixingManager.fixedLeftMap().get(c)"
                        >
                          <div class="flex-row align-items-end">
                            <div class="_contents flex-grow _padding">
                              <pre>{{ headerCell.text }}</pre>
                            </div>
                          </div>
                        </th>
                      } @else {
                        <!-- 마지막 ROW일때 -->
                        <th
                          [class._fixed]="headerCell.fixed"
                          [attr.colspan]="headerCell.colspan"
                          [attr.rowspan]="headerCell.rowspan"
                          [attr.c]="c"
                          class="_last-depth"
                          [class._sort]="!headerCell.control.disableSorting()"
                          [attr.title]="headerCell.control.tooltip() ?? headerCell.text"
                          [style.width]="headerCell.width"
                          [style.min-width]="headerCell.width"
                          [style.max-width]="headerCell.width"
                          [style.left.px]="columnFixingManager.fixedLeftMap().get(c)"
                          [class.help]="headerCell.control.tooltip()"
                          (sdResize)="onHeaderLastRowCellResize($event, c)"
                          (click)="onHeaderCellClick($event, headerCell)"
                        >
                          <div class="flex-row align-items-end">
                            @let _tempRef = headerCell.control.headerTemplateRef();
                            <div
                              class="_contents flex-grow"
                              [class._padding]="!_tempRef"
                              [attr.style]="headerCell.style"
                            >
                              @if (_tempRef) {
                                <ng-template [ngTemplateOutlet]="_tempRef" />
                              } @else {
                                <pre>{{ headerCell.text }}</pre>
                              }
                            </div>

                            <!-- 정렬 아이콘 -->
                            @if (!headerCell.control.disableSorting()) {
                              <div class="_sort-icon">
                                <sd-icon-layers>
                                  <sd-icon [icon]="icons.sort" class="tx-trans-lightest" />
                                  @let _def = sortingManager.defMap().get(headerCell.control.key());
                                  @if (_def?.desc === false) {
                                    <sd-icon [icon]="icons.sortDown" />
                                  } @else if (_def?.desc === true) {
                                    <sd-icon [icon]="icons.sortUp" />
                                  }
                                </sd-icon-layers>
                                @let _idxText = _def?.indexText;
                                @if (_idxText) {
                                  <sub>{{ _idxText }}</sub>
                                }
                              </div>
                            }
                          </div>

                          <!-- 정렬 리사이징 -->
                          @if (!headerCell.control.disableResizing()) {
                            <div
                              class="_resizer"
                              (mousedown)="onResizerMousedown($event, headerCell.control.key())"
                              (dblclick)="onResizerDoubleClick($event, headerCell.control.key())"
                            ></div>
                          }
                        </th>
                      }
                    }
                  }
                </tr>
              }

            <!-- 합계 행 -->
              @if (layoutEngine.hasSummary()) {
                <tr class="_summary-row">
                  @for (colDef of layoutEngine.columnDefs(); let c = $index; track c) {
                    <th
                      [class._fixed]="colDef.fixed"
                      [style.left.px]="columnFixingManager.fixedLeftMap().get(c)"
                    >
                      @let _tempRef = colDef.control.summaryTemplateRef();
                      @if (_tempRef) {
                        <ng-template [ngTemplateOutlet]="_tempRef" />
                      }
                    </th>
                  }
                </tr>
              }
            </thead>
            <tbody>
              @for (item of displayItems(); let r = $index; track trackByFn()(item, r)) {
                <tr
                  [attr.r]="r"
                  (keydown)="itemKeydown.emit({ item: item, event: $event })"
                  [hidden]="!expandingManager.getIsVisible(item)"
                >
                  @let _c = getChildrenFn() ? -2 : -1;
                  <td
                    class="_fixed _feature-cell"
                    [attr.r]="r"
                    [attr.c]="_c"
                    [style.left.px]="columnFixingManager.fixedLeftMap().get(_c)"
                  >
                    @if (selectMode() === "multi") {
                      @let _selectable = selectionManager.getSelectable(item);
                      <sd-checkbox
                        [value]="selectedItems().includes(item)"
                        (valueChange)="selectionManager.toggle(item)"
                        [beforeChangeFn]="selectionManager.getBeforeChangeFn(item)"
                        [inline]="true"
                        theme="white"
                        [disabled]="_selectable !== true"
                        [attr.title]="_selectable"
                      />
                    } @else if (selectMode() === "single") {
                      @let _selectable = selectionManager.getSelectable(item);
                      <sd-checkbox
                        [value]="selectedItems().includes(item)"
                        (valueChange)="selectionManager.toggle(item)"
                        [beforeChangeFn]="selectionManager.getBeforeChangeFn(item)"
                        [inline]="true"
                        theme="white"
                        [disabled]="_selectable !== true"
                        [attr.title]="_selectable"
                      />
                    }
                  </td>
                  @if (expandingManager.hasExpandable()) {
                    <td
                      class="_fixed _feature-cell"
                      [attr.r]="r"
                      [attr.c]="-1"
                      [style.left.px]="columnFixingManager.fixedLeftMap().get(-1)"
                    >
                      @let itemExpDef = expandingManager.getDef(item);
                      @if (itemExpDef.depth > 0) {
                        <div
                          class="_depth-indicator"
                          [style.margin-left.em]="itemExpDef.depth - 0.5"
                        ></div>
                      }
                      @if (itemExpDef.hasChildren) {
                        <sd-icon
                          [icon]="icons.caretRight"
                          fixedWidth
                          [rotate]="expandedItems().includes(item) ? 90 : undefined"
                          [class.tx-theme-primary-default]="expandedItems().includes(item)"
                          (click)="expandingManager.toggle(item)"
                        />
                      }
                    </td>
                  }
                  @for (columnDef of layoutEngine.columnDefs();
                    let c = $index;
                    track columnDef.control.key()) {
                    <td
                      tabindex="0"
                      [class._fixed]="columnDef.fixed"
                      [attr.r]="r"
                      [attr.c]="c"
                      [style.width]="columnDef.width"
                      [style.min-width]="columnDef.width"
                      [style.max-width]="columnDef.width"
                      [style.left.px]="columnFixingManager.fixedLeftMap().get(c)"
                      [class]="getItemCellClassFn()?.(item, columnDef.control.key())"
                      [style]="getItemCellStyleFn()?.(item, columnDef.control.key())"
                      (click)="onItemCellClick(item)"
                      (dblclick)="onItemCellDoubleClick($event)"
                      (keydown)="
                        cellKeydown.emit({
                          item: item,
                          key: columnDef.control.key(),
                          event: $event,
                        })
                      "
                    >
                      <ng-template
                        [ngTemplateOutlet]="columnDef.control.cellTemplateRef()"
                        [ngTemplateOutletContext]="{
                          $implicit: item,
                          item: item,
                          index: r,
                          depth: expandingManager.getDef(item).depth,
                          edit: cellAgent.getIsCellEditMode({ r, c }),
                        }"
                      />
                    </td>
                  }
                </tr>
              }
            </tbody>
          </table>

          <div class="_focus-row-indicator">
            <div class="_focus-cell-indicator"></div>
          </div>
          <div class="_resize-indicator"></div>
          <div class="_select-row-indicator-container"></div>
        </sd-pane>
      </sd-dock-container>
    </sd-busy-container>
  `, host: {
                    "[attr.sd-inset]": "inset()",
                    "[attr.sd-focus-mode]": "focusMode()",
                }, styles: ["sd-sheet>sd-busy-container{border-radius:var(--border-radius-default)}sd-sheet>sd-busy-container>._screen{border-radius:var(--border-radius-default)}sd-sheet>sd-busy-container>sd-dock-container>._content{border:1px solid var(--theme-grey-lighter);border-radius:var(--border-radius-default)}sd-sheet>sd-busy-container>sd-dock-container>._content>sd-dock{background:var(--control-color);border-top-left-radius:var(--border-radius-default);border-top-right-radius:var(--border-radius-default);border-bottom:1px solid var(--theme-grey-lighter)}sd-sheet>sd-busy-container>sd-dock-container>._content>sd-dock>div>sd-anchor{padding:var(--gap-sm)}sd-sheet>sd-busy-container>sd-dock-container>._content>sd-pane._sheet-container{background:var(--sheet-bg);border-bottom-left-radius:var(--border-radius-default);border-bottom-right-radius:var(--border-radius-default)}sd-sheet>sd-busy-container>sd-dock-container>._content>sd-pane._sheet-container>table{border-spacing:0;table-layout:fixed;margin-right:2px;margin-bottom:2px}sd-sheet>sd-busy-container>sd-dock-container>._content>sd-pane._sheet-container>table>*>tr>*:last-child{border-right:1px solid var(--theme-grey-lighter)}sd-sheet>sd-busy-container>sd-dock-container>._content>sd-pane._sheet-container>table>*>tr:last-child>*{border-bottom:1px solid var(--theme-grey-lighter)}sd-sheet>sd-busy-container>sd-dock-container>._content>sd-pane._sheet-container>table>*>tr>*{border-right:1px solid var(--theme-grey-lighter);border-bottom:1px solid var(--theme-grey-lighter);white-space:nowrap;overflow:hidden;padding:0;position:relative}sd-sheet>sd-busy-container>sd-dock-container>._content>sd-pane._sheet-container>table>*>tr>*._feature-cell{background:var(--theme-grey-lightest);min-width:calc(var(--font-size-default) + 2px + var(--sheet-ph) * 2);padding:var(--sheet-pv) var(--sheet-ph);text-align:left}sd-sheet>sd-busy-container>sd-dock-container>._content>sd-pane._sheet-container>table>*>tr>*._feature-cell>sd-icon{cursor:pointer;color:var(--text-trans-lightest)}sd-sheet>sd-busy-container>sd-dock-container>._content>sd-pane._sheet-container>table>*>tr>*._fixed{position:sticky;left:0}.js-has-pseudo [csstools-has-37-2s-19-37-2w-2t-2t-38-w-1q-w-37-2s-19-2q-39-37-3d-19-2r-33-32-38-2p-2x-32-2t-36-w-1q-w-37-2s-19-2s-33-2r-2z-19-2r-33-32-38-2p-2x-32-2t-36-w-1q-w-1a-2n-2r-33-32-38-2t-32-38-w-1q-w-37-2s-19-34-2p-32-2t-1a-2n-37-2w-2t-2t-38-19-2r-33-32-38-2p-2x-32-2t-36-w-1q-w-38-2p-2q-30-2t-w-1q-w-16-w-1q-w-38-36-w-1q-w-16-1a-2n-2u-2x-3c-2t-2s-1m-2w-2p-37-14-17-w-1m-32-33-38-14-1a-2n-2u-2x-3c-2t-2s-15-15]:not(.does-not-exist):not(.does-not-exist):not(.does-not-exist):not(does-not-exist):not(does-not-exist):not(does-not-exist):not(does-not-exist):not(does-not-exist):not(does-not-exist){border-right:1px solid var(--theme-grey-lighter)}sd-sheet>sd-busy-container>sd-dock-container>._content>sd-pane._sheet-container>table>*>tr>*._fixed:has(+:not(._fixed)){border-right:1px solid var(--theme-grey-lighter)}sd-sheet>sd-busy-container>sd-dock-container>._content>sd-pane._sheet-container>table>thead{position:sticky;top:0;z-index:3}sd-sheet>sd-busy-container>sd-dock-container>._content>sd-pane._sheet-container>table>thead>tr>th{position:relative;background:var(--theme-grey-lightest);vertical-align:middle}sd-sheet>sd-busy-container>sd-dock-container>._content>sd-pane._sheet-container>table>thead>tr>th._fixed{z-index:4}sd-sheet>sd-busy-container>sd-dock-container>._content>sd-pane._sheet-container>table>thead>tr>th._last-depth{border-bottom:1px solid var(--theme-grey-lighter)}sd-sheet>sd-busy-container>sd-dock-container>._content>sd-pane._sheet-container>table>thead>tr>th._feature-cell{border-bottom:1px solid var(--theme-grey-lighter)}sd-sheet>sd-busy-container>sd-dock-container>._content>sd-pane._sheet-container>table>thead>tr>th._sort{cursor:pointer}sd-sheet>sd-busy-container>sd-dock-container>._content>sd-pane._sheet-container>table>thead>tr>th._sort:hover{text-decoration:underline}sd-sheet>sd-busy-container>sd-dock-container>._content>sd-pane._sheet-container>table>thead>tr>th>div:first-child>._contents._padding{padding:var(--sheet-pv) var(--sheet-ph)}sd-sheet>sd-busy-container>sd-dock-container>._content>sd-pane._sheet-container>table>thead>tr>th>div:first-child>._sort-icon{display:inline-block;padding:var(--gap-xs) var(--gap-xs) var(--gap-xs) 0;background-color:var(--theme-grey-lightest)}sd-sheet>sd-busy-container>sd-dock-container>._content>sd-pane._sheet-container>table>thead>tr>th>._resizer{position:absolute;top:0;right:0;bottom:0;width:2px;cursor:ew-resize}.js-has-pseudo [csstools-has-37-2s-19-37-2w-2t-2t-38-w-1q-w-37-2s-19-2q-39-37-3d-19-2r-33-32-38-2p-2x-32-2t-36-w-1q-w-37-2s-19-2s-33-2r-2z-19-2r-33-32-38-2p-2x-32-2t-36-w-1q-w-1a-2n-2r-33-32-38-2t-32-38-w-1q-w-37-2s-19-34-2p-32-2t-1a-2n-37-2w-2t-2t-38-19-2r-33-32-38-2p-2x-32-2t-36-w-1q-w-38-2p-2q-30-2t-w-1q-w-38-2w-2t-2p-2s-1m-2w-2p-37-14-1q-w-38-36-1a-2n-37-39-31-31-2p-36-3d-19-36-33-3b-15-w-1q-w-38-36-w-1q-w-38-2w-1a-2n-30-2p-37-38-19-2s-2t-34-38-2w]:not(.does-not-exist):not(.does-not-exist):not(.does-not-exist):not(does-not-exist):not(does-not-exist):not(does-not-exist):not(does-not-exist):not(does-not-exist):not(does-not-exist):not(does-not-exist):not(does-not-exist):not(does-not-exist){border-bottom:1px solid var(--theme-grey-lighter)}sd-sheet>sd-busy-container>sd-dock-container>._content>sd-pane._sheet-container>table>thead:has(>tr._summary-row)>tr>th._last-depth{border-bottom:1px solid var(--theme-grey-lighter)}.js-has-pseudo [csstools-has-37-2s-19-37-2w-2t-2t-38-w-1q-w-37-2s-19-2q-39-37-3d-19-2r-33-32-38-2p-2x-32-2t-36-w-1q-w-37-2s-19-2s-33-2r-2z-19-2r-33-32-38-2p-2x-32-2t-36-w-1q-w-1a-2n-2r-33-32-38-2t-32-38-w-1q-w-37-2s-19-34-2p-32-2t-1a-2n-37-2w-2t-2t-38-19-2r-33-32-38-2p-2x-32-2t-36-w-1q-w-38-2p-2q-30-2t-w-1q-w-38-2w-2t-2p-2s-1m-2w-2p-37-14-1q-w-38-36-1a-2n-37-39-31-31-2p-36-3d-19-36-33-3b-15-w-1q-w-38-36-1a-2n-37-39-31-31-2p-36-3d-19-36-33-3b-w-1q-w-38-2w]:not(.does-not-exist):not(.does-not-exist):not(.does-not-exist):not(does-not-exist):not(does-not-exist):not(does-not-exist):not(does-not-exist):not(does-not-exist):not(does-not-exist):not(does-not-exist):not(does-not-exist):not(does-not-exist){background:var(--theme-warning-lightest);text-align:left;border-bottom:1px solid var(--theme-grey-lighter)}sd-sheet>sd-busy-container>sd-dock-container>._content>sd-pane._sheet-container>table>thead:has(>tr._summary-row)>tr._summary-row>th{background:var(--theme-warning-lightest);text-align:left;border-bottom:1px solid var(--theme-grey-lighter)}sd-sheet>sd-busy-container>sd-dock-container>._content>sd-pane._sheet-container>table>tbody>tr>td{background:var(--control-color);vertical-align:top}sd-sheet>sd-busy-container>sd-dock-container>._content>sd-pane._sheet-container>table>tbody>tr>td._fixed{z-index:2}sd-sheet>sd-busy-container>sd-dock-container>._content>sd-pane._sheet-container>table>tbody>tr>td>._depth-indicator{display:inline-block;margin-top:.4em;width:.5em;height:.5em;border-left:1px solid var(--text-trans-default);border-bottom:1px solid var(--text-trans-default);vertical-align:top}sd-sheet>sd-busy-container>sd-dock-container>._content>sd-pane._sheet-container>._focus-row-indicator{display:none;position:absolute;pointer-events:none;background:#9e9e9e1a;z-index:6}sd-sheet>sd-busy-container>sd-dock-container>._content>sd-pane._sheet-container>._focus-row-indicator>._focus-cell-indicator{position:absolute;border:2px solid var(--theme-primary-default)}sd-sheet>sd-busy-container>sd-dock-container>._content>sd-pane._sheet-container>._resize-indicator{display:none;position:absolute;pointer-events:none;top:0;height:100%;border:1px dotted var(--theme-grey-light);z-index:7}sd-sheet>sd-busy-container>sd-dock-container>._content>sd-pane._sheet-container>._select-row-indicator-container{display:none;position:absolute;pointer-events:none;top:0;left:0;width:100%;height:100%;z-index:5}sd-sheet>sd-busy-container>sd-dock-container>._content>sd-pane._sheet-container>._select-row-indicator-container>._select-row-indicator{display:block;left:0;position:absolute;pointer-events:none;background:var(--theme-primary-default);opacity:.1}sd-sheet[sd-focus-mode=row]>sd-busy-container>sd-dock-container>._content>sd-pane._sheet-container>._focus-row-indicator>._focus-cell-indicator{display:none!important}sd-sheet[sd-inset=true]>sd-busy-container{border-radius:var(--border-radius-default)}sd-sheet[sd-inset=true]>sd-busy-container>._screen{border-radius:var(--border-radius-default)}sd-sheet[sd-inset=true]>sd-busy-container>sd-dock-container>._content{border:none;border-radius:0}\n"] }]
    }], null, { onFocusCaptureForSelection: [{
            type: HostListener,
            args: ["focus.capture", ["$event"]]
        }], onKeydownCapture: [{
            type: HostListener,
            args: ["keydown.capture", ["$event"]]
        }], onBlurCaptureForCellAgent: [{
            type: HostListener,
            args: ["blur.capture", ["$event"]]
        }], onFocusCaptureForAutoScroll: [{
            type: HostListener,
            args: ["focus.capture", ["$event"]]
        }], onFocusCaptureForIndicator: [{
            type: HostListener,
            args: ["focus.capture", ["$event"]]
        }], onBlurCaptureForFocusIndicator: [{
            type: HostListener,
            args: ["blur.capture", ["$event"]]
        }] }); })();
(() => { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassDebugInfo(SdSheetControl, { className: "SdSheetControl", filePath: "packages/sd-angular/src/controls/sd-sheet/sd-sheet.control.ts", lineNumber: 599 }); })();
//# sourceMappingURL=sd-sheet.control.js.map