import { ChangeDetectionStrategy, Component, input, ViewEncapsulation } from "@angular/core";
import { useFullPageCodeSignal } from "../utils/signals/use-full-page-code.signal";
import { SdListControl } from "./sd-list.control";
import { NgTemplateOutlet } from "@angular/common";
import { SdTypedTemplateDirective } from "../directives/sd-typed.template-directive";
import { SdListItemControl } from "./sd-list-item.control";
import { SdRouterLinkDirective } from "../directives/sd-router-link.directive";
import { SdIconControl } from "./sd-icon.control";
import * as querystring from "querystring";
import { $computed } from "../utils/bindings/$computed";
import * as i0 from "@angular/core";
const _c0 = a0 => ({ menus: a0, depth: 0 });
const _c1 = (a0, a1) => ({ menus: a0, depth: a1 });
const _forTrack0 = ($index, $item) => $item.codeChain.join(".");
function SdSidebarMenuControl_Conditional_0_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "h5", 1);
    i0.ɵɵtext(1, "MENU");
    i0.ɵɵelementEnd();
} }
function SdSidebarMenuControl_ng_template_2_Template(rf, ctx) { }
function SdSidebarMenuControl_ng_template_3_For_1_Conditional_1_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelement(0, "sd-icon", 8);
    i0.ɵɵtext(1, " \u00A0 ");
} if (rf & 2) {
    const menu_r2 = i0.ɵɵnextContext().$implicit;
    i0.ɵɵproperty("icon", menu_r2.icon);
} }
function SdSidebarMenuControl_ng_template_3_For_1_Conditional_3_ng_template_1_Template(rf, ctx) { }
function SdSidebarMenuControl_ng_template_3_For_1_Conditional_3_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "sd-list", 2);
    i0.ɵɵtemplate(1, SdSidebarMenuControl_ng_template_3_For_1_Conditional_3_ng_template_1_Template, 0, 0, "ng-template", 3);
    i0.ɵɵelementEnd();
} if (rf & 2) {
    const menu_r2 = i0.ɵɵnextContext().$implicit;
    const depth_r4 = i0.ɵɵnextContext().depth;
    const ctx_r2 = i0.ɵɵnextContext();
    const itemTemplate_r5 = i0.ɵɵreference(4);
    i0.ɵɵstyleProp("padding-left", (depth_r4 + 1 - (ctx_r2.rootLayout() === "accordion" ? 0 : 1)) * 6 + "px");
    i0.ɵɵproperty("inset", true);
    i0.ɵɵadvance();
    i0.ɵɵproperty("ngTemplateOutlet", itemTemplate_r5)("ngTemplateOutletContext", i0.ɵɵpureFunction2(5, _c1, menu_r2.children, depth_r4 + 1));
} }
function SdSidebarMenuControl_ng_template_3_For_1_Template(rf, ctx) { if (rf & 1) {
    const _r1 = i0.ɵɵgetCurrentView();
    i0.ɵɵelementStart(0, "sd-list-item", 6);
    i0.ɵɵlistener("click", function SdSidebarMenuControl_ng_template_3_For_1_Template_sd_list_item_click_0_listener() { const menu_r2 = i0.ɵɵrestoreView(_r1).$implicit; const ctx_r2 = i0.ɵɵnextContext(2); return i0.ɵɵresetView(ctx_r2.onMenuClick(menu_r2)); });
    i0.ɵɵtemplate(1, SdSidebarMenuControl_ng_template_3_For_1_Conditional_1_Template, 2, 1);
    i0.ɵɵtext(2);
    i0.ɵɵtemplate(3, SdSidebarMenuControl_ng_template_3_For_1_Conditional_3_Template, 2, 8, "sd-list", 7);
    i0.ɵɵelementEnd();
} if (rf & 2) {
    const menu_r2 = ctx.$implicit;
    const depth_r4 = i0.ɵɵnextContext().depth;
    const ctx_r2 = i0.ɵɵnextContext();
    i0.ɵɵproperty("contentClass", depth_r4 === 0 ? "pv-default" : "")("sd-router-link", ctx_r2.getMenuRouterLinkOption(menu_r2))("selected", ctx_r2.getIsMenuSelected(menu_r2))("layout", depth_r4 === 0 ? ctx_r2.rootLayout() : "accordion");
    i0.ɵɵadvance();
    i0.ɵɵconditional(menu_r2.icon ? 1 : -1);
    i0.ɵɵadvance();
    i0.ɵɵtextInterpolate1(" ", menu_r2.title, " ");
    i0.ɵɵadvance();
    i0.ɵɵconditional(menu_r2.children ? 3 : -1);
} }
function SdSidebarMenuControl_ng_template_3_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵrepeaterCreate(0, SdSidebarMenuControl_ng_template_3_For_1_Template, 4, 7, "sd-list-item", 5, _forTrack0);
} if (rf & 2) {
    const currMenus_r6 = ctx.menus;
    i0.ɵɵrepeater(currMenus_r6);
} }
export class SdSidebarMenuControl {
    constructor() {
        this.menus = input([]);
        this.layout = input();
        this.getMenuIsSelectedFn = input();
        this.fullPageCode = useFullPageCodeSignal();
        this.rootLayout = $computed(() => this.layout() ?? (this.menus().length <= 3 ? "flat" : "accordion"));
    }
    getMenuRouterLinkOption(menu) {
        if (menu.children || menu.url != null) {
            return undefined;
        }
        const relNav = menu.codeChain.join("/");
        const n = relNav.split("?")[0];
        const q = relNav.split("?")[1];
        const qp = q == null ? undefined : querystring.parse(q);
        return {
            link: "/home/" + n,
            queryParams: qp,
        };
    }
    getIsMenuSelected(menu) {
        return this.getMenuIsSelectedFn()
            ? this.getMenuIsSelectedFn()(menu)
            : this.fullPageCode() === menu.codeChain.join(".");
    }
    onMenuClick(menu) {
        if (menu.url != null) {
            window.open(menu.url, "_blank");
        }
    }
    static { this.ɵfac = function SdSidebarMenuControl_Factory(__ngFactoryType__) { return new (__ngFactoryType__ || SdSidebarMenuControl)(); }; }
    static { this.ɵcmp = /*@__PURE__*/ i0.ɵɵdefineComponent({ type: SdSidebarMenuControl, selectors: [["sd-sidebar-menu"]], hostVars: 1, hostBindings: function SdSidebarMenuControl_HostBindings(rf, ctx) { if (rf & 2) {
            i0.ɵɵattribute("sd-root-layout", ctx.rootLayout());
        } }, inputs: { menus: [1, "menus"], layout: [1, "layout"], getMenuIsSelectedFn: [1, "getMenuIsSelectedFn"] }, decls: 5, vars: 7, consts: [["itemTemplate", ""], [1, "_title"], [3, "inset"], [3, "ngTemplateOutlet", "ngTemplateOutletContext"], [3, "typed"], [3, "contentClass", "sd-router-link", "selected", "layout"], [3, "click", "contentClass", "sd-router-link", "selected", "layout"], [3, "inset", "padding-left"], ["fixedWidth", "", 3, "icon"]], template: function SdSidebarMenuControl_Template(rf, ctx) { if (rf & 1) {
            i0.ɵɵtemplate(0, SdSidebarMenuControl_Conditional_0_Template, 2, 0, "h5", 1);
            i0.ɵɵelementStart(1, "sd-list", 2);
            i0.ɵɵtemplate(2, SdSidebarMenuControl_ng_template_2_Template, 0, 0, "ng-template", 3);
            i0.ɵɵelementEnd();
            i0.ɵɵtemplate(3, SdSidebarMenuControl_ng_template_3_Template, 2, 0, "ng-template", 4, 0, i0.ɵɵtemplateRefExtractor);
        } if (rf & 2) {
            const itemTemplate_r5 = i0.ɵɵreference(4);
            i0.ɵɵconditional(ctx.rootLayout() === "accordion" ? 0 : -1);
            i0.ɵɵadvance();
            i0.ɵɵproperty("inset", true);
            i0.ɵɵadvance();
            i0.ɵɵproperty("ngTemplateOutlet", itemTemplate_r5)("ngTemplateOutletContext", i0.ɵɵpureFunction1(5, _c0, ctx.menus()));
            i0.ɵɵadvance();
            i0.ɵɵproperty("typed", ctx.itemTemplateType);
        } }, dependencies: [SdListControl,
            NgTemplateOutlet,
            SdTypedTemplateDirective,
            SdListItemControl,
            SdRouterLinkDirective,
            SdIconControl], styles: ["sd-sidebar-menu>._title{padding:var(--gap-xs) var(--gap-sm);margin:0 var(--gap-sm);color:var(--text-trans-lighter);font-size:var(--font-size-sm)}sd-sidebar-menu>sd-list[sd-inset=true]{padding-left:var(--gap-default)}sd-sidebar-menu>sd-list[sd-inset=true] sd-list-item>._content{margin-right:0;border-top-right-radius:0;border-bottom-right-radius:0}sd-sidebar-menu>sd-list[sd-inset=true] sd-list-item>._child{margin-right:0}sd-sidebar-menu>sd-list[sd-inset=true] sd-list{background:#00000008;border-top-left-radius:var(--border-radius-default);border-bottom-left-radius:var(--border-radius-default)}sd-sidebar-menu:not([sd-root-layout=accordion])>sd-list[sd-inset=true]>sd-list-item>sd-collapse>._content>sd-list{background:transparent}\n"], encapsulation: 2, changeDetection: 0 }); }
}
(() => { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(SdSidebarMenuControl, [{
        type: Component,
        args: [{ selector: "sd-sidebar-menu", changeDetection: ChangeDetectionStrategy.OnPush, encapsulation: ViewEncapsulation.None, standalone: true, imports: [
                    SdListControl,
                    NgTemplateOutlet,
                    SdTypedTemplateDirective,
                    SdListItemControl,
                    SdRouterLinkDirective,
                    SdIconControl,
                ], template: `
    @if (rootLayout() === "accordion") {
      <h5 class="_title">MENU</h5>
    }
    <sd-list [inset]="true">
      <ng-template
        [ngTemplateOutlet]="itemTemplate"
        [ngTemplateOutletContext]="{ menus: menus(), depth: 0 }"
      ></ng-template>
    </sd-list>
    <ng-template #itemTemplate [typed]="itemTemplateType" let-currMenus="menus" let-depth="depth">
      @for (menu of currMenus; track menu.codeChain.join(".")) {
        <!--[contentStyle]="'padding-left: ' + ((depth + 1) * 6) + 'px'"-->
        <sd-list-item
          [contentClass]="depth === 0 ? 'pv-default' : ''"
          [sd-router-link]="getMenuRouterLinkOption(menu)"
          (click)="onMenuClick(menu)"
          [selected]="getIsMenuSelected(menu)"
          [layout]="depth === 0 ? rootLayout() : 'accordion'"
        >
          @if (menu.icon) {
            <sd-icon [icon]="menu.icon" fixedWidth />
            &nbsp;
          }
          {{ menu.title }}
          @if (menu.children) {
            <sd-list
              [inset]="true"
              [style.padding-left]="(depth + 1 - (rootLayout() === 'accordion' ? 0 : 1)) * 6 + 'px'"
            >
              <ng-template
                [ngTemplateOutlet]="itemTemplate"
                [ngTemplateOutletContext]="{
                  menus: menu.children,
                  depth: depth + 1,
                }"
              ></ng-template>
            </sd-list>
          }
        </sd-list-item>
      }
    </ng-template>
  `, host: {
                    "[attr.sd-root-layout]": "rootLayout()",
                }, styles: ["sd-sidebar-menu>._title{padding:var(--gap-xs) var(--gap-sm);margin:0 var(--gap-sm);color:var(--text-trans-lighter);font-size:var(--font-size-sm)}sd-sidebar-menu>sd-list[sd-inset=true]{padding-left:var(--gap-default)}sd-sidebar-menu>sd-list[sd-inset=true] sd-list-item>._content{margin-right:0;border-top-right-radius:0;border-bottom-right-radius:0}sd-sidebar-menu>sd-list[sd-inset=true] sd-list-item>._child{margin-right:0}sd-sidebar-menu>sd-list[sd-inset=true] sd-list{background:#00000008;border-top-left-radius:var(--border-radius-default);border-bottom-left-radius:var(--border-radius-default)}sd-sidebar-menu:not([sd-root-layout=accordion])>sd-list[sd-inset=true]>sd-list-item>sd-collapse>._content>sd-list{background:transparent}\n"] }]
    }], null, null); })();
(() => { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassDebugInfo(SdSidebarMenuControl, { className: "SdSidebarMenuControl", filePath: "packages/sd-angular/src/controls/sd-sidebar-menu.control.ts", lineNumber: 116 }); })();
//# sourceMappingURL=sd-sidebar-menu.control.js.map