import { ChangeDetectionStrategy, Component, inject, input, model, ViewEncapsulation, } from "@angular/core";
import { ObjectUtils } from "@simplysm/sd-core-common";
import { SdAngularConfigProvider } from "../providers/sd-angular-config.provider";
import { SdSystemConfigProvider } from "../providers/sd-system-config.provider";
import { SdToastProvider } from "../providers/sd-toast.provider";
import { $effect } from "../utils/bindings/$effect";
import { $signal } from "../utils/bindings/$signal";
import { SdAnchorControl } from "./sd-anchor.control";
import { SdGapControl } from "./sd-gap.control";
import { SdIconControl } from "./sd-icon.control";
import * as i0 from "@angular/core";
const _forTrack0 = ($index, $item) => $item.name;
function SdStatePresetControl_For_4_Template(rf, ctx) { if (rf & 1) {
    const _r1 = i0.ɵɵgetCurrentView();
    i0.ɵɵelementStart(0, "div")(1, "sd-anchor", 3);
    i0.ɵɵlistener("click", function SdStatePresetControl_For_4_Template_sd_anchor_click_1_listener() { const preset_r2 = i0.ɵɵrestoreView(_r1).$implicit; const ctx_r2 = i0.ɵɵnextContext(); return i0.ɵɵresetView(ctx_r2.onItemClick(preset_r2)); });
    i0.ɵɵtext(2);
    i0.ɵɵelementEnd();
    i0.ɵɵelementStart(3, "sd-anchor", 0);
    i0.ɵɵlistener("click", function SdStatePresetControl_For_4_Template_sd_anchor_click_3_listener() { const preset_r2 = i0.ɵɵrestoreView(_r1).$implicit; const ctx_r2 = i0.ɵɵnextContext(); return i0.ɵɵresetView(ctx_r2.onSaveButtonClick(preset_r2)); });
    i0.ɵɵelement(4, "sd-icon", 4);
    i0.ɵɵelementEnd();
    i0.ɵɵelementStart(5, "sd-anchor", 0);
    i0.ɵɵlistener("click", function SdStatePresetControl_For_4_Template_sd_anchor_click_5_listener() { const preset_r2 = i0.ɵɵrestoreView(_r1).$implicit; const ctx_r2 = i0.ɵɵnextContext(); return i0.ɵɵresetView(ctx_r2.onRemoveButtonClick(preset_r2)); });
    i0.ɵɵelement(6, "sd-icon", 4);
    i0.ɵɵelementEnd()();
    i0.ɵɵelement(7, "sd-gap", 2);
} if (rf & 2) {
    const preset_r2 = ctx.$implicit;
    const ctx_r2 = i0.ɵɵnextContext();
    i0.ɵɵadvance(2);
    i0.ɵɵtextInterpolate1(" ", preset_r2.name, " ");
    i0.ɵɵadvance(2);
    i0.ɵɵproperty("icon", ctx_r2.icons.save);
    i0.ɵɵadvance(2);
    i0.ɵɵproperty("icon", ctx_r2.icons.xmark);
} }
export class SdStatePresetControl {
    constructor() {
        this.icons = inject(SdAngularConfigProvider).icons;
        this._sdSystemConfig = inject(SdSystemConfigProvider);
        this._sdToast = inject(SdToastProvider);
        this.state = model();
        this.key = input.required();
        this.size = input();
        this.presets = $signal([]);
        $effect([this.key], async () => {
            this.presets.set((await this._sdSystemConfig.getAsync(`sd-state-preset.${this.key()}`)) ?? []);
        });
    }
    async onAddButtonClick() {
        const newName = prompt("현재 상태를 저장합니다.");
        if (newName == null)
            return;
        this.presets.update((v) => [
            ...v,
            {
                name: newName,
                state: ObjectUtils.clone(this.state),
            },
        ]);
        await this._sdSystemConfig.setAsync(`sd-state-preset.${this.key()}`, this.presets());
        this._sdToast.info(`현재 상태가 ${newName}에 저장되었습니다.`);
    }
    onItemClick(preset) {
        if (!ObjectUtils.equal(this.state(), preset.state)) {
            this.state.set(ObjectUtils.clone(preset.state));
        }
    }
    async onRemoveButtonClick(preset) {
        if (!confirm("저장된 '" + preset.name + "'상태가 삭제됩니다."))
            return;
        this.presets.update((v) => v.filter((item) => item !== preset));
        await this._sdSystemConfig.setAsync(`sd-state-preset.${this.key()}`, this.presets());
    }
    async onSaveButtonClick(preset) {
        preset.state = ObjectUtils.clone(this.state());
        await this._sdSystemConfig.setAsync(`sd-state-preset.${this.key()}`, this.presets());
        this._sdToast.info(`현재 상태가 ${preset.name}에 저장되었습니다.`);
    }
    static { this.ɵfac = function SdStatePresetControl_Factory(__ngFactoryType__) { return new (__ngFactoryType__ || SdStatePresetControl)(); }; }
    static { this.ɵcmp = /*@__PURE__*/ i0.ɵɵdefineComponent({ type: SdStatePresetControl, selectors: [["sd-state-preset"]], hostVars: 1, hostBindings: function SdStatePresetControl_HostBindings(rf, ctx) { if (rf & 2) {
            i0.ɵɵattribute("sd-size", ctx.size());
        } }, inputs: { state: [1, "state"], key: [1, "key"], size: [1, "size"] }, outputs: { state: "stateChange" }, decls: 5, vars: 1, consts: [[3, "click"], ["fixedWidth", "", 1, "tx-theme-warning-default", 3, "icon"], ["width", "sm"], [1, "tx-trans-default", 3, "click"], ["size", "sm", 3, "icon"]], template: function SdStatePresetControl_Template(rf, ctx) { if (rf & 1) {
            i0.ɵɵelementStart(0, "sd-anchor", 0);
            i0.ɵɵlistener("click", function SdStatePresetControl_Template_sd_anchor_click_0_listener() { return ctx.onAddButtonClick(); });
            i0.ɵɵelement(1, "sd-icon", 1);
            i0.ɵɵelementEnd();
            i0.ɵɵelement(2, "sd-gap", 2);
            i0.ɵɵrepeaterCreate(3, SdStatePresetControl_For_4_Template, 8, 3, null, null, _forTrack0);
        } if (rf & 2) {
            i0.ɵɵadvance();
            i0.ɵɵproperty("icon", ctx.icons.star);
            i0.ɵɵadvance(2);
            i0.ɵɵrepeater(ctx.presets());
        } }, dependencies: [SdAnchorControl, SdGapControl, SdIconControl], styles: ["sd-state-preset{display:inline-block;vertical-align:top}sd-state-preset>sd-anchor{display:inline-block;vertical-align:top;line-height:var(--line-height);border:1px solid transparent;padding:var(--gap-sm) var(--gap-default)}sd-state-preset>div{display:inline-block;vertical-align:top;line-height:var(--line-height);border:1px solid transparent;padding:var(--gap-sm) var(--gap-default);background:var(--theme-grey-lightest);border-radius:var(--border-radius-lg)}sd-state-preset>div:hover{background:var(--theme-grey-lighter)}sd-state-preset>div>sd-anchor{padding:0 var(--gap-sm)}sd-state-preset[sd-size=sm]>sd-anchor,sd-state-preset[sd-size=sm]>div{padding:var(--gap-xs) var(--gap-default)}sd-state-preset[sd-size=lg]>sd-anchor,sd-state-preset[sd-size=lg]>div{padding:var(--gap-default) var(--gap-lg)}\n"], encapsulation: 2, changeDetection: 0 }); }
}
(() => { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(SdStatePresetControl, [{
        type: Component,
        args: [{ selector: "sd-state-preset", changeDetection: ChangeDetectionStrategy.OnPush, encapsulation: ViewEncapsulation.None, standalone: true, imports: [SdAnchorControl, SdGapControl, SdIconControl], template: `
    <sd-anchor (click)="onAddButtonClick()">
      <sd-icon [icon]="icons.star" class="tx-theme-warning-default" fixedWidth />
    </sd-anchor>
    <sd-gap width="sm"></sd-gap>
    @for (preset of presets(); track preset.name) {
      <div>
        <sd-anchor (click)="onItemClick(preset)" class="tx-trans-default">
          {{ preset.name }}
        </sd-anchor>
        <sd-anchor (click)="onSaveButtonClick(preset)">
          <sd-icon [icon]="icons.save" size="sm" />
        </sd-anchor>
        <sd-anchor (click)="onRemoveButtonClick(preset)">
          <sd-icon [icon]="icons.xmark" size="sm" />
        </sd-anchor>
      </div>
      <sd-gap width="sm"></sd-gap>
    }
  `, host: {
                    "[attr.sd-size]": "size()",
                }, styles: ["sd-state-preset{display:inline-block;vertical-align:top}sd-state-preset>sd-anchor{display:inline-block;vertical-align:top;line-height:var(--line-height);border:1px solid transparent;padding:var(--gap-sm) var(--gap-default)}sd-state-preset>div{display:inline-block;vertical-align:top;line-height:var(--line-height);border:1px solid transparent;padding:var(--gap-sm) var(--gap-default);background:var(--theme-grey-lightest);border-radius:var(--border-radius-lg)}sd-state-preset>div:hover{background:var(--theme-grey-lighter)}sd-state-preset>div>sd-anchor{padding:0 var(--gap-sm)}sd-state-preset[sd-size=sm]>sd-anchor,sd-state-preset[sd-size=sm]>div{padding:var(--gap-xs) var(--gap-default)}sd-state-preset[sd-size=lg]>sd-anchor,sd-state-preset[sd-size=lg]>div{padding:var(--gap-default) var(--gap-lg)}\n"] }]
    }], () => [], null); })();
(() => { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassDebugInfo(SdStatePresetControl, { className: "SdStatePresetControl", filePath: "packages/sd-angular/src/controls/sd-state-preset.control.ts", lineNumber: 98 }); })();
//# sourceMappingURL=sd-state-preset.control.js.map