import { ChangeDetectionStrategy, Component, HostListener, input, model, ViewEncapsulation, } from "@angular/core";
import { transformBoolean } from "../utils/type-tramsforms";
import * as i0 from "@angular/core";
export class SdSwitchControl {
    constructor() {
        this.value = model(false);
        this.disabled = input(false, { transform: transformBoolean });
        this.inline = input(false, { transform: transformBoolean });
        this.inset = input(false, { transform: transformBoolean });
        this.size = input();
        this.theme = input();
    }
    onClick(event) {
        if (this.disabled())
            return;
        event.preventDefault();
        event.stopPropagation();
        this.value.update((v) => !v);
    }
    onKeydown(event) {
        if (this.disabled())
            return;
        if (event.key === " ") {
            this.value.update((v) => !v);
        }
    }
    static { this.ɵfac = function SdSwitchControl_Factory(__ngFactoryType__) { return new (__ngFactoryType__ || SdSwitchControl)(); }; }
    static { this.ɵcmp = /*@__PURE__*/ i0.ɵɵdefineComponent({ type: SdSwitchControl, selectors: [["sd-switch"]], hostVars: 7, hostBindings: function SdSwitchControl_HostBindings(rf, ctx) { if (rf & 1) {
            i0.ɵɵlistener("click", function SdSwitchControl_click_HostBindingHandler($event) { return ctx.onClick($event); })("keydown", function SdSwitchControl_keydown_HostBindingHandler($event) { return ctx.onKeydown($event); });
        } if (rf & 2) {
            i0.ɵɵattribute("sd-on", ctx.value())("sd-disabled", ctx.disabled())("sd-inline", ctx.inline())("sd-inset", ctx.inset())("sd-size", ctx.size())("sd-theme", ctx.theme())("tabindex", "0");
        } }, inputs: { value: [1, "value"], disabled: [1, "disabled"], inline: [1, "inline"], inset: [1, "inset"], size: [1, "size"], theme: [1, "theme"] }, outputs: { value: "valueChange" }, decls: 2, vars: 0, template: function SdSwitchControl_Template(rf, ctx) { if (rf & 1) {
            i0.ɵɵelementStart(0, "div");
            i0.ɵɵelement(1, "div");
            i0.ɵɵelementEnd();
        } }, styles: ["sd-switch{display:block;padding:var(--gap-sm) 0;border:1px solid transparent;vertical-align:top;cursor:pointer}sd-switch>div{height:var(--line-height);width:calc(var(--line-height) * 2 - var(--gap-xs));padding:calc(var(--gap-xs) / 2);border-radius:calc(var(--line-height) / 2);text-align:left;background:var(--theme-grey-lighter)}sd-switch>div>div{display:inline-block;width:calc(var(--line-height) - var(--gap-xs));height:calc(var(--line-height) - var(--gap-xs));border-radius:100%;background:var(--control-color);transition:transform var(--animation-duration)}sd-switch[sd-on=true]>div{background:var(--theme-success-default)}sd-switch[sd-on=true]>div>div{transform:translate(100%)}sd-switch[sd-inline=true]{display:inline-block;padding:0;border:none}sd-switch[sd-inset=true]{border:none}sd-switch[sd-size=sm]{padding:var(--gap-sm) 0}sd-switch[sd-size=lg]{font-size:var(--font-size-lg);padding:var(--gap-default) 0}sd-switch[sd-theme=grey][sd-on=true]>div{background:var(--theme-grey-default)}sd-switch[sd-theme=blue-grey][sd-on=true]>div{background:var(--theme-blue-grey-default)}sd-switch[sd-theme=primary][sd-on=true]>div{background:var(--theme-primary-default)}sd-switch[sd-theme=secondary][sd-on=true]>div{background:var(--theme-secondary-default)}sd-switch[sd-theme=info][sd-on=true]>div{background:var(--theme-info-default)}sd-switch[sd-theme=success][sd-on=true]>div{background:var(--theme-success-default)}sd-switch[sd-theme=warning][sd-on=true]>div{background:var(--theme-warning-default)}sd-switch[sd-theme=danger][sd-on=true]>div{background:var(--theme-danger-default)}sd-switch[sd-disabled=true]>div{opacity:.5}sd-switch[sd-disabled=true]>div>div{background:var(--theme-grey-default)}\n"], encapsulation: 2, changeDetection: 0 }); }
}
(() => { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(SdSwitchControl, [{
        type: Component,
        args: [{ selector: "sd-switch", changeDetection: ChangeDetectionStrategy.OnPush, encapsulation: ViewEncapsulation.None, standalone: true, imports: [], template: `
    <div>
      <div></div>
    </div>
  `, host: {
                    "[attr.sd-on]": "value()",
                    "[attr.sd-disabled]": "disabled()",
                    "[attr.sd-inline]": "inline()",
                    "[attr.sd-inset]": "inset()",
                    "[attr.sd-size]": "size()",
                    "[attr.sd-theme]": "theme()",
                    "[attr.tabindex]": "'0'",
                }, styles: ["sd-switch{display:block;padding:var(--gap-sm) 0;border:1px solid transparent;vertical-align:top;cursor:pointer}sd-switch>div{height:var(--line-height);width:calc(var(--line-height) * 2 - var(--gap-xs));padding:calc(var(--gap-xs) / 2);border-radius:calc(var(--line-height) / 2);text-align:left;background:var(--theme-grey-lighter)}sd-switch>div>div{display:inline-block;width:calc(var(--line-height) - var(--gap-xs));height:calc(var(--line-height) - var(--gap-xs));border-radius:100%;background:var(--control-color);transition:transform var(--animation-duration)}sd-switch[sd-on=true]>div{background:var(--theme-success-default)}sd-switch[sd-on=true]>div>div{transform:translate(100%)}sd-switch[sd-inline=true]{display:inline-block;padding:0;border:none}sd-switch[sd-inset=true]{border:none}sd-switch[sd-size=sm]{padding:var(--gap-sm) 0}sd-switch[sd-size=lg]{font-size:var(--font-size-lg);padding:var(--gap-default) 0}sd-switch[sd-theme=grey][sd-on=true]>div{background:var(--theme-grey-default)}sd-switch[sd-theme=blue-grey][sd-on=true]>div{background:var(--theme-blue-grey-default)}sd-switch[sd-theme=primary][sd-on=true]>div{background:var(--theme-primary-default)}sd-switch[sd-theme=secondary][sd-on=true]>div{background:var(--theme-secondary-default)}sd-switch[sd-theme=info][sd-on=true]>div{background:var(--theme-info-default)}sd-switch[sd-theme=success][sd-on=true]>div{background:var(--theme-success-default)}sd-switch[sd-theme=warning][sd-on=true]>div{background:var(--theme-warning-default)}sd-switch[sd-theme=danger][sd-on=true]>div{background:var(--theme-danger-default)}sd-switch[sd-disabled=true]>div{opacity:.5}sd-switch[sd-disabled=true]>div>div{background:var(--theme-grey-default)}\n"] }]
    }], null, { onClick: [{
            type: HostListener,
            args: ["click", ["$event"]]
        }], onKeydown: [{
            type: HostListener,
            args: ["keydown", ["$event"]]
        }] }); })();
(() => { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassDebugInfo(SdSwitchControl, { className: "SdSwitchControl", filePath: "packages/sd-angular/src/controls/sd-switch.control.ts", lineNumber: 117 }); })();
//# sourceMappingURL=sd-switch.control.js.map