import { DateOnly, DateTime, Time } from "@simplysm/sd-core-common";
import * as i0 from "@angular/core";
export declare class SdTextfieldControl<K extends keyof TSdTextfieldTypes> {
    value: import("@angular/core").ModelSignal<TSdTextfieldTypes[K] | undefined>;
    type: import("@angular/core").InputSignal<K>;
    placeholder: import("@angular/core").InputSignal<string | undefined>;
    title: import("@angular/core").InputSignal<string | undefined>;
    inputStyle: import("@angular/core").InputSignal<string | undefined>;
    inputClass: import("@angular/core").InputSignal<string | undefined>;
    disabled: import("@angular/core").InputSignalWithTransform<boolean, boolean | "" | undefined>;
    readonly: import("@angular/core").InputSignalWithTransform<boolean, boolean | "" | undefined>;
    required: import("@angular/core").InputSignalWithTransform<boolean, boolean | "" | undefined>;
    min: import("@angular/core").InputSignal<TSdTextfieldTypes[K] | undefined>;
    max: import("@angular/core").InputSignal<TSdTextfieldTypes[K] | undefined>;
    minlength: import("@angular/core").InputSignal<number | undefined>;
    maxlength: import("@angular/core").InputSignal<number | undefined>;
    pattern: import("@angular/core").InputSignal<string | undefined>;
    validatorFn: import("@angular/core").InputSignal<((value: TSdTextfieldTypes[K] | undefined) => string | undefined) | undefined>;
    format: import("@angular/core").InputSignal<string | undefined>;
    /** 10, 1, 0.1, 0.01, 0.01 방식으로 입력 */
    step: import("@angular/core").InputSignal<number | undefined>;
    autocomplete: import("@angular/core").InputSignal<string | undefined>;
    useNumberComma: import("@angular/core").InputSignalWithTransform<boolean, boolean | "" | undefined>;
    inline: import("@angular/core").InputSignalWithTransform<boolean, boolean | "" | undefined>;
    inset: import("@angular/core").InputSignalWithTransform<boolean, boolean | "" | undefined>;
    size: import("@angular/core").InputSignal<"sm" | "lg" | undefined>;
    theme: import("@angular/core").InputSignal<"info" | "success" | "warning" | "danger" | "primary" | "secondary" | "grey" | "blue-grey" | undefined>;
    controlType: import("@angular/core").Signal<"text" | K | "time" | "datetime-local">;
    controlValue: import("@angular/core").Signal<string>;
    controlValueText: import("@angular/core").Signal<string>;
    controlStep: import("@angular/core").Signal<number | "any" | undefined>;
    constructor();
    onInput(event: Event): void;
    private _setValue;
    private _convertToControlValue;
    static ɵfac: i0.ɵɵFactoryDeclaration<SdTextfieldControl<any>, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<SdTextfieldControl<any>, "sd-textfield", never, { "value": { "alias": "value"; "required": false; "isSignal": true; }; "type": { "alias": "type"; "required": true; "isSignal": true; }; "placeholder": { "alias": "placeholder"; "required": false; "isSignal": true; }; "title": { "alias": "title"; "required": false; "isSignal": true; }; "inputStyle": { "alias": "inputStyle"; "required": false; "isSignal": true; }; "inputClass": { "alias": "inputClass"; "required": false; "isSignal": true; }; "disabled": { "alias": "disabled"; "required": false; "isSignal": true; }; "readonly": { "alias": "readonly"; "required": false; "isSignal": true; }; "required": { "alias": "required"; "required": false; "isSignal": true; }; "min": { "alias": "min"; "required": false; "isSignal": true; }; "max": { "alias": "max"; "required": false; "isSignal": true; }; "minlength": { "alias": "minlength"; "required": false; "isSignal": true; }; "maxlength": { "alias": "maxlength"; "required": false; "isSignal": true; }; "pattern": { "alias": "pattern"; "required": false; "isSignal": true; }; "validatorFn": { "alias": "validatorFn"; "required": false; "isSignal": true; }; "format": { "alias": "format"; "required": false; "isSignal": true; }; "step": { "alias": "step"; "required": false; "isSignal": true; }; "autocomplete": { "alias": "autocomplete"; "required": false; "isSignal": true; }; "useNumberComma": { "alias": "useNumberComma"; "required": false; "isSignal": true; }; "inline": { "alias": "inline"; "required": false; "isSignal": true; }; "inset": { "alias": "inset"; "required": false; "isSignal": true; }; "size": { "alias": "size"; "required": false; "isSignal": true; }; "theme": { "alias": "theme"; "required": false; "isSignal": true; }; }, { "value": "valueChange"; }, never, never, true, never>;
}
export type TSdTextfieldTypes = {
    "number": number;
    "text": string;
    "password": string;
    "color": string;
    "email": string;
    "format": string;
    "date": DateOnly;
    "month": DateOnly;
    "year": DateOnly;
    "datetime": DateTime;
    "datetime-sec": DateTime;
    "time": Time;
    "time-sec": Time;
};
export declare const sdTextfieldTypes: (keyof TSdTextfieldTypes)[];
