import { ChangeDetectionStrategy, Component, input, model, ViewEncapsulation } from "@angular/core";
import { DateOnly, DateTime, NumberUtils, SdError, StringUtils, Time, } from "@simplysm/sd-core-common";
import { $computed } from "../utils/bindings/$computed";
import { setupInvalid } from "../utils/setups/setup-invalid";
import { transformBoolean } from "../utils/type-tramsforms";
import * as i0 from "@angular/core";
const _c0 = a0 => ["_contents", a0];
function SdTextfieldControl_Conditional_1_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "span", 0);
    i0.ɵɵtext(1, "****");
    i0.ɵɵelementEnd();
} }
function SdTextfieldControl_Conditional_2_Conditional_0_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "span");
    i0.ɵɵtext(1);
    i0.ɵɵelementEnd();
} if (rf & 2) {
    const ctx_r0 = i0.ɵɵnextContext(2);
    i0.ɵɵadvance();
    i0.ɵɵtextInterpolate(ctx_r0.controlValueText());
} }
function SdTextfieldControl_Conditional_2_Conditional_1_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "span", 2);
    i0.ɵɵtext(1);
    i0.ɵɵelementEnd();
} if (rf & 2) {
    const ctx_r0 = i0.ɵɵnextContext(2);
    i0.ɵɵadvance();
    i0.ɵɵtextInterpolate(ctx_r0.placeholder());
} }
function SdTextfieldControl_Conditional_2_Conditional_2_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelementStart(0, "span");
    i0.ɵɵtext(1, "\u00A0");
    i0.ɵɵelementEnd();
} }
function SdTextfieldControl_Conditional_2_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵtemplate(0, SdTextfieldControl_Conditional_2_Conditional_0_Template, 2, 1, "span")(1, SdTextfieldControl_Conditional_2_Conditional_1_Template, 2, 1, "span", 2)(2, SdTextfieldControl_Conditional_2_Conditional_2_Template, 2, 0, "span");
} if (rf & 2) {
    const ctx_r0 = i0.ɵɵnextContext();
    i0.ɵɵconditional(ctx_r0.controlValue() ? 0 : ctx_r0.placeholder() ? 1 : 2);
} }
function SdTextfieldControl_Conditional_3_Template(rf, ctx) { if (rf & 1) {
    const _r2 = i0.ɵɵgetCurrentView();
    i0.ɵɵelementStart(0, "input", 3);
    i0.ɵɵlistener("input", function SdTextfieldControl_Conditional_3_Template_input_input_0_listener($event) { i0.ɵɵrestoreView(_r2); const ctx_r0 = i0.ɵɵnextContext(); return i0.ɵɵresetView(ctx_r0.onInput($event)); });
    i0.ɵɵelementEnd();
} if (rf & 2) {
    let tmp_5_0;
    const ctx_r0 = i0.ɵɵnextContext();
    i0.ɵɵstyleMap(ctx_r0.inputStyle());
    i0.ɵɵclassMap(ctx_r0.inputClass());
    i0.ɵɵproperty("type", ctx_r0.controlType())("value", ctx_r0.controlValue());
    i0.ɵɵattribute("title", (tmp_5_0 = ctx_r0.title()) !== null && tmp_5_0 !== undefined ? tmp_5_0 : ctx_r0.placeholder())("placeholder", ctx_r0.placeholder())("inputmode", ctx_r0.type() === "number" ? "numeric" : undefined)("autocomplete", ctx_r0.autocomplete())("step", ctx_r0.controlStep());
} }
export class SdTextfieldControl {
    constructor() {
        this.value = model();
        this.type = input.required();
        this.placeholder = input();
        this.title = input();
        this.inputStyle = input();
        this.inputClass = input();
        this.disabled = input(false, { transform: transformBoolean });
        this.readonly = input(false, { transform: transformBoolean });
        this.required = input(false, { transform: transformBoolean });
        this.min = input();
        this.max = input();
        this.minlength = input();
        this.maxlength = input();
        this.pattern = input();
        this.validatorFn = input();
        this.format = input();
        /** 10, 1, 0.1, 0.01, 0.01 방식으로 입력 */
        this.step = input();
        this.autocomplete = input();
        this.useNumberComma = input(true, { transform: transformBoolean });
        this.inline = input(false, { transform: transformBoolean });
        this.inset = input(false, { transform: transformBoolean });
        this.size = input();
        this.theme = input();
        this.controlType = $computed(() => {
            return this.type() === "number"
                ? "text"
                : this.type() === "format"
                    ? "text"
                    : this.type() === "datetime"
                        ? "datetime-local"
                        : this.type() === "datetime-sec"
                            ? "datetime-local"
                            : this.type() === "time-sec"
                                ? "time"
                                : this.type();
        });
        this.controlValue = $computed(() => {
            return this._convertToControlValue(this.value());
        });
        this.controlValueText = $computed(() => {
            const type = this.type();
            const value = this.value();
            if (type === "datetime" && value instanceof DateTime) {
                return value.toFormatString("yyyy-MM-dd tt hh:mm");
            }
            else if (type === "datetime-sec" && value instanceof DateTime) {
                return value.toFormatString("yyyy-MM-dd tt hh:mm:ss");
            }
            else if (type === "time" && (value instanceof DateTime || value instanceof Time)) {
                return value.toFormatString("tt hh:mm");
            }
            else if (type === "time-sec" && (value instanceof DateTime || value instanceof Time)) {
                return value.toFormatString("tt hh:mm:ss");
            }
            else {
                return this.controlValue();
            }
        });
        this.controlStep = $computed(() => {
            if (this.step() !== undefined) {
                return this.step();
            }
            else if (this.type() === "datetime-sec" || this.type() === "time-sec") {
                return 1;
            }
            else {
                return "any";
            }
        });
        setupInvalid(() => {
            const value = this.value();
            const errorMessages = [];
            if (value == null) {
                if (this.required()) {
                    errorMessages.push("값을 입력하세요.");
                }
            }
            else if (this.type() === "number") {
                if (typeof value !== "number") {
                    errorMessages.push("숫자를 입력하세요");
                }
                else {
                    const min = this.min();
                    const max = this.max();
                    if (typeof min === "number" && min > value) {
                        errorMessages.push(`${min}보다 크거나 같아야 합니다.`);
                    }
                    if (typeof max === "number" && max < value) {
                        errorMessages.push(`${max}보다 작거나 같아야 합니다.`);
                    }
                }
            }
            else if (this.type() === "format" && !StringUtils.isNullOrEmpty(this.format())) {
                const formatItems = this.format().split("|");
                if (!formatItems.some((formatItem) => formatItem.match(/X/g)?.length === value.length)) {
                    errorMessages.push(`문자의 길이가 요구되는 길이와 다릅니다.`);
                }
            }
            else if (["year", "month", "date"].includes(this.type())) {
                if (!(value instanceof DateOnly)) {
                    errorMessages.push("날짜를 입력하세요");
                }
                else {
                    const min = this.min();
                    const max = this.max();
                    if (min instanceof DateOnly && min.tick > value.tick) {
                        errorMessages.push(`${min}보다 크거나 같아야 합니다.`);
                    }
                    if (max instanceof DateOnly && max.tick < value.tick) {
                        errorMessages.push(`${max}보다 작거나 같아야 합니다.`);
                    }
                }
            }
            else if (["datetime", "datetime-sec"].includes(this.type())) {
                if (!(value instanceof DateTime)) {
                    errorMessages.push("날짜 및 시간을 입력하세요");
                }
            }
            else if (["time", "time-sec"].includes(this.type())) {
                if (!(value instanceof Time)) {
                    errorMessages.push("시간을 입력하세요");
                }
            }
            else if (this.type() === "text") {
                const minlength = this.minlength();
                const maxlength = this.maxlength();
                if (minlength !== undefined && minlength > value.length) {
                    errorMessages.push(`문자의 길이가 ${minlength}보다 길거나 같아야 합니다.`);
                }
                if (maxlength !== undefined && maxlength > value.length) {
                    errorMessages.push(`문자의 길이가 ${maxlength}보다 짧거나 같아야 합니다.`);
                }
                // 👇 pattern 속성 검사 수동 적용
                const pattern = this.pattern();
                if (!StringUtils.isNullOrEmpty(pattern)) {
                    try {
                        const regex = new RegExp(`^(?:${pattern})$`);
                        if (!regex.test(value)) {
                            errorMessages.push(`입력 값이 형식에 맞지 않습니다.`);
                        }
                    }
                    catch (err) {
                        throw new SdError(`잘못된 pattern: ${pattern}`, err);
                    }
                }
            }
            if (this.validatorFn()) {
                const message = this.validatorFn()(value);
                if (message !== undefined) {
                    errorMessages.push(message);
                }
            }
            return errorMessages.join("\r\n");
        });
    }
    onInput(event) {
        const inputEl = event.target;
        if (inputEl.value === "") {
            this._setValue(undefined);
        }
        else if (this.type() === "number") {
            const inputValue = inputEl.value.replace(/[^0-9-.]/g, "");
            if (Number.isNaN(Number(inputValue)) ||
                inputValue.endsWith(".") ||
                (inputValue.includes(".") && Number(inputValue) === 0)) {
            }
            else {
                this._setValue(NumberUtils.parseFloat(inputValue));
            }
        }
        else if (this.type() === "format") {
            const nonFormatChars = this.format()?.match(/[^X]/g)?.distinct();
            if (nonFormatChars) {
                this._setValue(inputEl.value.replace(new RegExp(`[${nonFormatChars.map((item) => "\\" + item).join("")}]`, "g"), ""));
            }
            else {
                this._setValue(inputEl.value);
            }
        }
        else if (["year", "month", "date"].includes(this.type())) {
            try {
                this._setValue(DateOnly.parse(inputEl.value));
            }
            catch { }
        }
        else if (["datetime", "datetime-sec"].includes(this.type())) {
            try {
                this._setValue(DateTime.parse(inputEl.value));
            }
            catch { }
        }
        else if (["time", "time-sec"].includes(this.type())) {
            try {
                this._setValue(Time.parse(inputEl.value));
            }
            catch { }
        }
        else {
            this._setValue(inputEl.value);
        }
    }
    _setValue(newValue) {
        this.value.set(newValue);
    }
    _convertToControlValue(value) {
        if (value == null) {
            return "";
        }
        if (this.type() === "number" && typeof value === "number") {
            return this.useNumberComma()
                ? value.toLocaleString(undefined, { maximumFractionDigits: 10 })
                : value.toString(10);
        }
        if (this.type() === "format" &&
            !StringUtils.isNullOrEmpty(this.format()) &&
            typeof value === "string") {
            const formatItems = this.format().split("|");
            for (const formatItem of formatItems) {
                const fullLength = formatItem.match(/X/g)?.length;
                if (fullLength === value.length) {
                    let result = "";
                    let valCur = 0;
                    for (const formatItemChar of formatItem) {
                        if (formatItemChar === "X") {
                            result += value[valCur];
                            valCur++;
                        }
                        else {
                            result += formatItemChar;
                        }
                    }
                    return result;
                }
            }
            return value;
        }
        if (this.type() === "datetime" && value instanceof DateTime) {
            return value.toFormatString("yyyy-MM-ddTHH:mm");
        }
        if (this.type() === "datetime-sec" && value instanceof DateTime) {
            return value.toFormatString("yyyy-MM-ddTHH:mm:ss");
        }
        if (this.type() === "year" && value instanceof DateOnly) {
            return value.toFormatString("yyyy");
        }
        if (this.type() === "month" && value instanceof DateOnly) {
            return value.toFormatString("yyyy-MM");
        }
        if (this.type() === "date" && value instanceof DateOnly) {
            return value.toFormatString("yyyy-MM-dd");
        }
        if (this.type() === "time" && (value instanceof DateTime || value instanceof Time)) {
            return value.toFormatString("HH:mm");
        }
        if (this.type() === "time-sec" && (value instanceof DateTime || value instanceof Time)) {
            return value.toFormatString("HH:mm:ss");
        }
        if (typeof value === "string") {
            return value;
        }
        throw new Error(`'sd-textfield'에 대한 'value'가 잘못되었습니다. (입력값: ${value.toString()})`);
    }
    static { this.ɵfac = function SdTextfieldControl_Factory(__ngFactoryType__) { return new (__ngFactoryType__ || SdTextfieldControl)(); }; }
    static { this.ɵcmp = /*@__PURE__*/ i0.ɵɵdefineComponent({ type: SdTextfieldControl, selectors: [["sd-textfield"]], hostVars: 7, hostBindings: function SdTextfieldControl_HostBindings(rf, ctx) { if (rf & 2) {
            i0.ɵɵattribute("sd-type", ctx.type())("sd-disabled", ctx.disabled())("sd-readonly", ctx.readonly())("sd-inline", ctx.inline())("sd-inset", ctx.inset())("sd-size", ctx.size())("sd-theme", ctx.theme());
        } }, inputs: { value: [1, "value"], type: [1, "type"], placeholder: [1, "placeholder"], title: [1, "title"], inputStyle: [1, "inputStyle"], inputClass: [1, "inputClass"], disabled: [1, "disabled"], readonly: [1, "readonly"], required: [1, "required"], min: [1, "min"], max: [1, "max"], minlength: [1, "minlength"], maxlength: [1, "maxlength"], pattern: [1, "pattern"], validatorFn: [1, "validatorFn"], format: [1, "format"], step: [1, "step"], autocomplete: [1, "autocomplete"], useNumberComma: [1, "useNumberComma"], inline: [1, "inline"], inset: [1, "inset"], size: [1, "size"], theme: [1, "theme"] }, outputs: { value: "valueChange" }, decls: 4, vars: 11, consts: [[1, "tx-trans-light"], [3, "style", "class", "type", "value"], [1, "tx-trans-lighter"], [3, "input", "type", "value"]], template: function SdTextfieldControl_Template(rf, ctx) { if (rf & 1) {
            i0.ɵɵelementStart(0, "div");
            i0.ɵɵtemplate(1, SdTextfieldControl_Conditional_1_Template, 2, 0, "span", 0)(2, SdTextfieldControl_Conditional_2_Template, 3, 1);
            i0.ɵɵelementEnd();
            i0.ɵɵtemplate(3, SdTextfieldControl_Conditional_3_Template, 1, 11, "input", 1);
        } if (rf & 2) {
            let tmp_3_0;
            i0.ɵɵstyleMap(ctx.inputStyle());
            i0.ɵɵclassMap(i0.ɵɵpureFunction1(9, _c0, ctx.inputClass()).filterExists().join(" "));
            i0.ɵɵstyleProp("visibility", !ctx.readonly() && !ctx.disabled() ? "hidden" : undefined);
            i0.ɵɵattribute("title", (tmp_3_0 = ctx.title()) !== null && tmp_3_0 !== undefined ? tmp_3_0 : ctx.placeholder());
            i0.ɵɵadvance();
            i0.ɵɵconditional(ctx.controlType() === "password" ? 1 : 2);
            i0.ɵɵadvance(2);
            i0.ɵɵconditional(!ctx.readonly() && !ctx.disabled() ? 3 : -1);
        } }, styles: ["sd-textfield{display:block;position:relative}sd-textfield>input,sd-textfield>._contents{display:block;padding:var(--gap-sm) var(--gap-default);border:1px solid transparent;font-size:var(--font-size-default);font-family:var(--font-family);font-variant-numeric:tabular-nums;line-height:var(--line-height);color:var(--text-trans-default);overflow:auto;width:100%}body.sd-theme-compact sd-textfield>input,body.sd-theme-compact sd-textfield>._contents{border:1px solid var(--trans-lighter);border-radius:var(--border-radius-default);background:var(--theme-secondary-lightest)}body.sd-theme-compact sd-textfield>input:focus,body.sd-theme-compact sd-textfield>._contents:focus{outline:none;border-color:var(--theme-secondary-default)}body.sd-theme-mobile sd-textfield>input,body.sd-theme-kiosk sd-textfield>input,body.sd-theme-mobile sd-textfield>._contents,body.sd-theme-kiosk sd-textfield>._contents{border-left:none;border-right:none;border-top:none;border-bottom:2px solid var(--border-color-default);background:transparent;padding:calc(var(--gap-sm) + 1px) 0 calc(var(--gap-sm) - 1px)}body.sd-theme-mobile sd-textfield>input:focus,body.sd-theme-kiosk sd-textfield>input:focus,body.sd-theme-mobile sd-textfield>._contents:focus,body.sd-theme-kiosk sd-textfield>._contents:focus{outline:none;border-bottom-color:var(--theme-secondary-default)}sd-textfield>input::-webkit-scrollbar,sd-textfield>._contents::-webkit-scrollbar{display:none}sd-textfield>input::-webkit-input-placeholder,sd-textfield>._contents::-webkit-input-placeholder{color:var(--text-trans-lighter)}sd-textfield>input::-webkit-outer-spin-button,sd-textfield>input::-webkit-inner-spin-button,sd-textfield>._contents::-webkit-outer-spin-button,sd-textfield>._contents::-webkit-inner-spin-button{-webkit-appearance:none;margin:0}sd-textfield>input::-webkit-calendar-picker-indicator,sd-textfield>._contents::-webkit-calendar-picker-indicator{cursor:pointer;margin:auto}sd-textfield>._contents{display:none}sd-textfield[sd-type=number]>input,sd-textfield[sd-type=number]>._contents{text-align:right}body.sd-theme-compact sd-textfield[sd-theme=grey]>input,body.sd-theme-compact sd-textfield[sd-theme=grey]>._contents{background:var(--theme-grey-lightest)}body.sd-theme-mobile sd-textfield[sd-theme=grey],body.sd-theme-kiosk sd-textfield[sd-theme=grey]{border-bottom-color:var(--theme-grey-lighter)}body.sd-theme-mobile sd-textfield[sd-theme=grey]:focus,body.sd-theme-kiosk sd-textfield[sd-theme=grey]:focus{border-bottom-color:var(--theme-grey-default)}body.sd-theme-compact sd-textfield[sd-theme=blue-grey]>input,body.sd-theme-compact sd-textfield[sd-theme=blue-grey]>._contents{background:var(--theme-blue-grey-lightest)}body.sd-theme-mobile sd-textfield[sd-theme=blue-grey],body.sd-theme-kiosk sd-textfield[sd-theme=blue-grey]{border-bottom-color:var(--theme-blue-grey-lighter)}body.sd-theme-mobile sd-textfield[sd-theme=blue-grey]:focus,body.sd-theme-kiosk sd-textfield[sd-theme=blue-grey]:focus{border-bottom-color:var(--theme-blue-grey-default)}body.sd-theme-compact sd-textfield[sd-theme=primary]>input,body.sd-theme-compact sd-textfield[sd-theme=primary]>._contents{background:var(--theme-primary-lightest)}body.sd-theme-mobile sd-textfield[sd-theme=primary],body.sd-theme-kiosk sd-textfield[sd-theme=primary]{border-bottom-color:var(--theme-primary-lighter)}body.sd-theme-mobile sd-textfield[sd-theme=primary]:focus,body.sd-theme-kiosk sd-textfield[sd-theme=primary]:focus{border-bottom-color:var(--theme-primary-default)}body.sd-theme-compact sd-textfield[sd-theme=secondary]>input,body.sd-theme-compact sd-textfield[sd-theme=secondary]>._contents{background:var(--theme-secondary-lightest)}body.sd-theme-mobile sd-textfield[sd-theme=secondary],body.sd-theme-kiosk sd-textfield[sd-theme=secondary]{border-bottom-color:var(--theme-secondary-lighter)}body.sd-theme-mobile sd-textfield[sd-theme=secondary]:focus,body.sd-theme-kiosk sd-textfield[sd-theme=secondary]:focus{border-bottom-color:var(--theme-secondary-default)}body.sd-theme-compact sd-textfield[sd-theme=info]>input,body.sd-theme-compact sd-textfield[sd-theme=info]>._contents{background:var(--theme-info-lightest)}body.sd-theme-mobile sd-textfield[sd-theme=info],body.sd-theme-kiosk sd-textfield[sd-theme=info]{border-bottom-color:var(--theme-info-lighter)}body.sd-theme-mobile sd-textfield[sd-theme=info]:focus,body.sd-theme-kiosk sd-textfield[sd-theme=info]:focus{border-bottom-color:var(--theme-info-default)}body.sd-theme-compact sd-textfield[sd-theme=success]>input,body.sd-theme-compact sd-textfield[sd-theme=success]>._contents{background:var(--theme-success-lightest)}body.sd-theme-mobile sd-textfield[sd-theme=success],body.sd-theme-kiosk sd-textfield[sd-theme=success]{border-bottom-color:var(--theme-success-lighter)}body.sd-theme-mobile sd-textfield[sd-theme=success]:focus,body.sd-theme-kiosk sd-textfield[sd-theme=success]:focus{border-bottom-color:var(--theme-success-default)}body.sd-theme-compact sd-textfield[sd-theme=warning]>input,body.sd-theme-compact sd-textfield[sd-theme=warning]>._contents{background:var(--theme-warning-lightest)}body.sd-theme-mobile sd-textfield[sd-theme=warning],body.sd-theme-kiosk sd-textfield[sd-theme=warning]{border-bottom-color:var(--theme-warning-lighter)}body.sd-theme-mobile sd-textfield[sd-theme=warning]:focus,body.sd-theme-kiosk sd-textfield[sd-theme=warning]:focus{border-bottom-color:var(--theme-warning-default)}body.sd-theme-compact sd-textfield[sd-theme=danger]>input,body.sd-theme-compact sd-textfield[sd-theme=danger]>._contents{background:var(--theme-danger-lightest)}body.sd-theme-mobile sd-textfield[sd-theme=danger],body.sd-theme-kiosk sd-textfield[sd-theme=danger]{border-bottom-color:var(--theme-danger-lighter)}body.sd-theme-mobile sd-textfield[sd-theme=danger]:focus,body.sd-theme-kiosk sd-textfield[sd-theme=danger]:focus{border-bottom-color:var(--theme-danger-default)}sd-textfield[sd-size=sm]>input,sd-textfield[sd-size=sm]>._contents{padding:var(--gap-xs) var(--gap-sm)}sd-textfield[sd-size=sm]>input[type=date],sd-textfield[sd-size=sm]>._contents[type=date]{padding-top:calc(var(--gap-xs) - 1px);padding-bottom:calc(var(--gap-xs) - 1px)}sd-textfield[sd-size=lg]>input,sd-textfield[sd-size=lg]>._contents{padding:var(--gap-default) var(--gap-lg)}sd-textfield[sd-inline=true]{display:inline-block;vertical-align:top}sd-textfield[sd-inline=true]>input,sd-textfield[sd-inline=true]>._contents{width:auto;vertical-align:top}body.sd-theme-compact sd-textfield[sd-inset=true]>._contents,body.sd-theme-mobile sd-textfield[sd-inset=true]>._contents,body.sd-theme-kiosk sd-textfield[sd-inset=true]>._contents{display:block}body.sd-theme-compact sd-textfield[sd-inset=true]>input,body.sd-theme-mobile sd-textfield[sd-inset=true]>input,body.sd-theme-kiosk sd-textfield[sd-inset=true]>input{position:absolute;top:0;left:0}body.sd-theme-compact sd-textfield[sd-inset=true]>input,body.sd-theme-compact sd-textfield[sd-inset=true]>._contents,body.sd-theme-mobile sd-textfield[sd-inset=true]>input,body.sd-theme-mobile sd-textfield[sd-inset=true]>._contents,body.sd-theme-kiosk sd-textfield[sd-inset=true]>input,body.sd-theme-kiosk sd-textfield[sd-inset=true]>._contents{width:100%;border:none;border-radius:0}body.sd-theme-compact sd-textfield[sd-inset=true][sd-type=month]>input,body.sd-theme-compact sd-textfield[sd-inset=true][sd-type=month]>._contents,body.sd-theme-mobile sd-textfield[sd-inset=true][sd-type=month]>input,body.sd-theme-mobile sd-textfield[sd-inset=true][sd-type=month]>._contents,body.sd-theme-kiosk sd-textfield[sd-inset=true][sd-type=month]>input,body.sd-theme-kiosk sd-textfield[sd-inset=true][sd-type=month]>._contents{width:9em}body.sd-theme-compact sd-textfield[sd-inset=true][sd-type=date]>input,body.sd-theme-compact sd-textfield[sd-inset=true][sd-type=date]>._contents,body.sd-theme-mobile sd-textfield[sd-inset=true][sd-type=date]>input,body.sd-theme-mobile sd-textfield[sd-inset=true][sd-type=date]>._contents,body.sd-theme-kiosk sd-textfield[sd-inset=true][sd-type=date]>input,body.sd-theme-kiosk sd-textfield[sd-inset=true][sd-type=date]>._contents{width:8.25em}body.sd-theme-compact sd-textfield[sd-inset=true][sd-type=datetime]>input,body.sd-theme-compact sd-textfield[sd-inset=true][sd-type=datetime]>._contents,body.sd-theme-mobile sd-textfield[sd-inset=true][sd-type=datetime]>input,body.sd-theme-mobile sd-textfield[sd-inset=true][sd-type=datetime]>._contents,body.sd-theme-kiosk sd-textfield[sd-inset=true][sd-type=datetime]>input,body.sd-theme-kiosk sd-textfield[sd-inset=true][sd-type=datetime]>._contents{width:14em}body.sd-theme-compact sd-textfield[sd-inset=true]>input:focus{outline:1px solid var(--theme-primary-default);outline-offset:-1px}body.sd-theme-mobile sd-textfield[sd-inset=true][sd-size=sm]>input,body.sd-theme-mobile sd-textfield[sd-inset=true][sd-size=sm]>._contents,body.sd-theme-kiosk sd-textfield[sd-inset=true][sd-size=sm]>input,body.sd-theme-kiosk sd-textfield[sd-inset=true][sd-size=sm]>._contents{padding:calc(var(--gap-xs) + 1px) 0 calc(var(--gap-xs) - 1px)}body.sd-theme-mobile sd-textfield[sd-inset=true][sd-size=lg]>input,body.sd-theme-mobile sd-textfield[sd-inset=true][sd-size=lg]>._contents,body.sd-theme-kiosk sd-textfield[sd-inset=true][sd-size=lg]>input,body.sd-theme-kiosk sd-textfield[sd-inset=true][sd-size=lg]>._contents{padding:calc(var(--gap-default) + 1px) 0 calc(var(--gap-default) - 1px)}body.sd-theme-mobile sd-textfield[sd-inset=true]>input:focus,body.sd-theme-kiosk sd-textfield[sd-inset=true]>input:focus{outline:none;border-bottom-color:var(--theme-primary-default)}body.sd-theme-compact sd-textfield[sd-disabled=true]>._contents{display:block;background:var(--theme-grey-lightest);color:var(--text-trans-light)}body.sd-theme-compact sd-textfield[sd-disabled=true][sd-inset=true]>._contents{background:var(--control-color);color:var(--text-trans-default)}body.sd-theme-compact sd-textfield[sd-readonly=true]>._contents{display:block}body.sd-theme-mobile sd-textfield[sd-disabled=true]>._contents,body.sd-theme-kiosk sd-textfield[sd-disabled=true]>._contents{display:block;color:var(--text-trans-light)}body.sd-theme-mobile sd-textfield[sd-disabled=true][sd-inset=true]>._contents,body.sd-theme-kiosk sd-textfield[sd-disabled=true][sd-inset=true]>._contents{color:var(--text-trans-default);border-color:transparent}body.sd-theme-mobile sd-textfield[sd-readonly=true]>._contents,body.sd-theme-kiosk sd-textfield[sd-readonly=true]>._contents{display:block;border-color:transparent!important}\n"], encapsulation: 2, changeDetection: 0 }); }
}
(() => { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(SdTextfieldControl, [{
        type: Component,
        args: [{ selector: "sd-textfield", changeDetection: ChangeDetectionStrategy.OnPush, encapsulation: ViewEncapsulation.None, standalone: true, imports: [], template: `
    <div
      [style]="inputStyle()"
      [class]="['_contents', inputClass()].filterExists().join(' ')"
      [attr.title]="title() ?? placeholder()"
      [style.visibility]="!readonly() && !disabled() ? 'hidden' : undefined"
    >
      @if (controlType() === "password") {
        <span class="tx-trans-light">****</span>
      } @else {
        @if (controlValue()) {
          <span>{{ controlValueText() }}</span>
        } @else if (placeholder()) {
          <span class="tx-trans-lighter">{{ placeholder() }}</span>
        } @else {
          <span>&nbsp;</span>
        }
      }
    </div>
    @if (!readonly() && !disabled()) {
      <input
        [style]="inputStyle()"
        [class]="inputClass()"
        [attr.title]="title() ?? placeholder()"
        [attr.placeholder]="placeholder()"
        [type]="controlType()"
        [attr.inputmode]="type() === 'number' ? 'numeric' : undefined"
        [value]="controlValue()"
        [attr.autocomplete]="autocomplete()"
        [attr.step]="controlStep()"
        (input)="onInput($event)"
      />
    }
  `, host: {
                    "[attr.sd-type]": "type()",
                    "[attr.sd-disabled]": "disabled()",
                    "[attr.sd-readonly]": "readonly()",
                    "[attr.sd-inline]": "inline()",
                    "[attr.sd-inset]": "inset()",
                    "[attr.sd-size]": "size()",
                    "[attr.sd-theme]": "theme()",
                }, styles: ["sd-textfield{display:block;position:relative}sd-textfield>input,sd-textfield>._contents{display:block;padding:var(--gap-sm) var(--gap-default);border:1px solid transparent;font-size:var(--font-size-default);font-family:var(--font-family);font-variant-numeric:tabular-nums;line-height:var(--line-height);color:var(--text-trans-default);overflow:auto;width:100%}body.sd-theme-compact sd-textfield>input,body.sd-theme-compact sd-textfield>._contents{border:1px solid var(--trans-lighter);border-radius:var(--border-radius-default);background:var(--theme-secondary-lightest)}body.sd-theme-compact sd-textfield>input:focus,body.sd-theme-compact sd-textfield>._contents:focus{outline:none;border-color:var(--theme-secondary-default)}body.sd-theme-mobile sd-textfield>input,body.sd-theme-kiosk sd-textfield>input,body.sd-theme-mobile sd-textfield>._contents,body.sd-theme-kiosk sd-textfield>._contents{border-left:none;border-right:none;border-top:none;border-bottom:2px solid var(--border-color-default);background:transparent;padding:calc(var(--gap-sm) + 1px) 0 calc(var(--gap-sm) - 1px)}body.sd-theme-mobile sd-textfield>input:focus,body.sd-theme-kiosk sd-textfield>input:focus,body.sd-theme-mobile sd-textfield>._contents:focus,body.sd-theme-kiosk sd-textfield>._contents:focus{outline:none;border-bottom-color:var(--theme-secondary-default)}sd-textfield>input::-webkit-scrollbar,sd-textfield>._contents::-webkit-scrollbar{display:none}sd-textfield>input::-webkit-input-placeholder,sd-textfield>._contents::-webkit-input-placeholder{color:var(--text-trans-lighter)}sd-textfield>input::-webkit-outer-spin-button,sd-textfield>input::-webkit-inner-spin-button,sd-textfield>._contents::-webkit-outer-spin-button,sd-textfield>._contents::-webkit-inner-spin-button{-webkit-appearance:none;margin:0}sd-textfield>input::-webkit-calendar-picker-indicator,sd-textfield>._contents::-webkit-calendar-picker-indicator{cursor:pointer;margin:auto}sd-textfield>._contents{display:none}sd-textfield[sd-type=number]>input,sd-textfield[sd-type=number]>._contents{text-align:right}body.sd-theme-compact sd-textfield[sd-theme=grey]>input,body.sd-theme-compact sd-textfield[sd-theme=grey]>._contents{background:var(--theme-grey-lightest)}body.sd-theme-mobile sd-textfield[sd-theme=grey],body.sd-theme-kiosk sd-textfield[sd-theme=grey]{border-bottom-color:var(--theme-grey-lighter)}body.sd-theme-mobile sd-textfield[sd-theme=grey]:focus,body.sd-theme-kiosk sd-textfield[sd-theme=grey]:focus{border-bottom-color:var(--theme-grey-default)}body.sd-theme-compact sd-textfield[sd-theme=blue-grey]>input,body.sd-theme-compact sd-textfield[sd-theme=blue-grey]>._contents{background:var(--theme-blue-grey-lightest)}body.sd-theme-mobile sd-textfield[sd-theme=blue-grey],body.sd-theme-kiosk sd-textfield[sd-theme=blue-grey]{border-bottom-color:var(--theme-blue-grey-lighter)}body.sd-theme-mobile sd-textfield[sd-theme=blue-grey]:focus,body.sd-theme-kiosk sd-textfield[sd-theme=blue-grey]:focus{border-bottom-color:var(--theme-blue-grey-default)}body.sd-theme-compact sd-textfield[sd-theme=primary]>input,body.sd-theme-compact sd-textfield[sd-theme=primary]>._contents{background:var(--theme-primary-lightest)}body.sd-theme-mobile sd-textfield[sd-theme=primary],body.sd-theme-kiosk sd-textfield[sd-theme=primary]{border-bottom-color:var(--theme-primary-lighter)}body.sd-theme-mobile sd-textfield[sd-theme=primary]:focus,body.sd-theme-kiosk sd-textfield[sd-theme=primary]:focus{border-bottom-color:var(--theme-primary-default)}body.sd-theme-compact sd-textfield[sd-theme=secondary]>input,body.sd-theme-compact sd-textfield[sd-theme=secondary]>._contents{background:var(--theme-secondary-lightest)}body.sd-theme-mobile sd-textfield[sd-theme=secondary],body.sd-theme-kiosk sd-textfield[sd-theme=secondary]{border-bottom-color:var(--theme-secondary-lighter)}body.sd-theme-mobile sd-textfield[sd-theme=secondary]:focus,body.sd-theme-kiosk sd-textfield[sd-theme=secondary]:focus{border-bottom-color:var(--theme-secondary-default)}body.sd-theme-compact sd-textfield[sd-theme=info]>input,body.sd-theme-compact sd-textfield[sd-theme=info]>._contents{background:var(--theme-info-lightest)}body.sd-theme-mobile sd-textfield[sd-theme=info],body.sd-theme-kiosk sd-textfield[sd-theme=info]{border-bottom-color:var(--theme-info-lighter)}body.sd-theme-mobile sd-textfield[sd-theme=info]:focus,body.sd-theme-kiosk sd-textfield[sd-theme=info]:focus{border-bottom-color:var(--theme-info-default)}body.sd-theme-compact sd-textfield[sd-theme=success]>input,body.sd-theme-compact sd-textfield[sd-theme=success]>._contents{background:var(--theme-success-lightest)}body.sd-theme-mobile sd-textfield[sd-theme=success],body.sd-theme-kiosk sd-textfield[sd-theme=success]{border-bottom-color:var(--theme-success-lighter)}body.sd-theme-mobile sd-textfield[sd-theme=success]:focus,body.sd-theme-kiosk sd-textfield[sd-theme=success]:focus{border-bottom-color:var(--theme-success-default)}body.sd-theme-compact sd-textfield[sd-theme=warning]>input,body.sd-theme-compact sd-textfield[sd-theme=warning]>._contents{background:var(--theme-warning-lightest)}body.sd-theme-mobile sd-textfield[sd-theme=warning],body.sd-theme-kiosk sd-textfield[sd-theme=warning]{border-bottom-color:var(--theme-warning-lighter)}body.sd-theme-mobile sd-textfield[sd-theme=warning]:focus,body.sd-theme-kiosk sd-textfield[sd-theme=warning]:focus{border-bottom-color:var(--theme-warning-default)}body.sd-theme-compact sd-textfield[sd-theme=danger]>input,body.sd-theme-compact sd-textfield[sd-theme=danger]>._contents{background:var(--theme-danger-lightest)}body.sd-theme-mobile sd-textfield[sd-theme=danger],body.sd-theme-kiosk sd-textfield[sd-theme=danger]{border-bottom-color:var(--theme-danger-lighter)}body.sd-theme-mobile sd-textfield[sd-theme=danger]:focus,body.sd-theme-kiosk sd-textfield[sd-theme=danger]:focus{border-bottom-color:var(--theme-danger-default)}sd-textfield[sd-size=sm]>input,sd-textfield[sd-size=sm]>._contents{padding:var(--gap-xs) var(--gap-sm)}sd-textfield[sd-size=sm]>input[type=date],sd-textfield[sd-size=sm]>._contents[type=date]{padding-top:calc(var(--gap-xs) - 1px);padding-bottom:calc(var(--gap-xs) - 1px)}sd-textfield[sd-size=lg]>input,sd-textfield[sd-size=lg]>._contents{padding:var(--gap-default) var(--gap-lg)}sd-textfield[sd-inline=true]{display:inline-block;vertical-align:top}sd-textfield[sd-inline=true]>input,sd-textfield[sd-inline=true]>._contents{width:auto;vertical-align:top}body.sd-theme-compact sd-textfield[sd-inset=true]>._contents,body.sd-theme-mobile sd-textfield[sd-inset=true]>._contents,body.sd-theme-kiosk sd-textfield[sd-inset=true]>._contents{display:block}body.sd-theme-compact sd-textfield[sd-inset=true]>input,body.sd-theme-mobile sd-textfield[sd-inset=true]>input,body.sd-theme-kiosk sd-textfield[sd-inset=true]>input{position:absolute;top:0;left:0}body.sd-theme-compact sd-textfield[sd-inset=true]>input,body.sd-theme-compact sd-textfield[sd-inset=true]>._contents,body.sd-theme-mobile sd-textfield[sd-inset=true]>input,body.sd-theme-mobile sd-textfield[sd-inset=true]>._contents,body.sd-theme-kiosk sd-textfield[sd-inset=true]>input,body.sd-theme-kiosk sd-textfield[sd-inset=true]>._contents{width:100%;border:none;border-radius:0}body.sd-theme-compact sd-textfield[sd-inset=true][sd-type=month]>input,body.sd-theme-compact sd-textfield[sd-inset=true][sd-type=month]>._contents,body.sd-theme-mobile sd-textfield[sd-inset=true][sd-type=month]>input,body.sd-theme-mobile sd-textfield[sd-inset=true][sd-type=month]>._contents,body.sd-theme-kiosk sd-textfield[sd-inset=true][sd-type=month]>input,body.sd-theme-kiosk sd-textfield[sd-inset=true][sd-type=month]>._contents{width:9em}body.sd-theme-compact sd-textfield[sd-inset=true][sd-type=date]>input,body.sd-theme-compact sd-textfield[sd-inset=true][sd-type=date]>._contents,body.sd-theme-mobile sd-textfield[sd-inset=true][sd-type=date]>input,body.sd-theme-mobile sd-textfield[sd-inset=true][sd-type=date]>._contents,body.sd-theme-kiosk sd-textfield[sd-inset=true][sd-type=date]>input,body.sd-theme-kiosk sd-textfield[sd-inset=true][sd-type=date]>._contents{width:8.25em}body.sd-theme-compact sd-textfield[sd-inset=true][sd-type=datetime]>input,body.sd-theme-compact sd-textfield[sd-inset=true][sd-type=datetime]>._contents,body.sd-theme-mobile sd-textfield[sd-inset=true][sd-type=datetime]>input,body.sd-theme-mobile sd-textfield[sd-inset=true][sd-type=datetime]>._contents,body.sd-theme-kiosk sd-textfield[sd-inset=true][sd-type=datetime]>input,body.sd-theme-kiosk sd-textfield[sd-inset=true][sd-type=datetime]>._contents{width:14em}body.sd-theme-compact sd-textfield[sd-inset=true]>input:focus{outline:1px solid var(--theme-primary-default);outline-offset:-1px}body.sd-theme-mobile sd-textfield[sd-inset=true][sd-size=sm]>input,body.sd-theme-mobile sd-textfield[sd-inset=true][sd-size=sm]>._contents,body.sd-theme-kiosk sd-textfield[sd-inset=true][sd-size=sm]>input,body.sd-theme-kiosk sd-textfield[sd-inset=true][sd-size=sm]>._contents{padding:calc(var(--gap-xs) + 1px) 0 calc(var(--gap-xs) - 1px)}body.sd-theme-mobile sd-textfield[sd-inset=true][sd-size=lg]>input,body.sd-theme-mobile sd-textfield[sd-inset=true][sd-size=lg]>._contents,body.sd-theme-kiosk sd-textfield[sd-inset=true][sd-size=lg]>input,body.sd-theme-kiosk sd-textfield[sd-inset=true][sd-size=lg]>._contents{padding:calc(var(--gap-default) + 1px) 0 calc(var(--gap-default) - 1px)}body.sd-theme-mobile sd-textfield[sd-inset=true]>input:focus,body.sd-theme-kiosk sd-textfield[sd-inset=true]>input:focus{outline:none;border-bottom-color:var(--theme-primary-default)}body.sd-theme-compact sd-textfield[sd-disabled=true]>._contents{display:block;background:var(--theme-grey-lightest);color:var(--text-trans-light)}body.sd-theme-compact sd-textfield[sd-disabled=true][sd-inset=true]>._contents{background:var(--control-color);color:var(--text-trans-default)}body.sd-theme-compact sd-textfield[sd-readonly=true]>._contents{display:block}body.sd-theme-mobile sd-textfield[sd-disabled=true]>._contents,body.sd-theme-kiosk sd-textfield[sd-disabled=true]>._contents{display:block;color:var(--text-trans-light)}body.sd-theme-mobile sd-textfield[sd-disabled=true][sd-inset=true]>._contents,body.sd-theme-kiosk sd-textfield[sd-disabled=true][sd-inset=true]>._contents{color:var(--text-trans-default);border-color:transparent}body.sd-theme-mobile sd-textfield[sd-readonly=true]>._contents,body.sd-theme-kiosk sd-textfield[sd-readonly=true]>._contents{display:block;border-color:transparent!important}\n"] }]
    }], () => [], null); })();
(() => { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassDebugInfo(SdTextfieldControl, { className: "SdTextfieldControl", filePath: "packages/sd-angular/src/controls/sd-textfield.control.ts", lineNumber: 348 }); })();
export const sdTextfieldTypes = [
    "number",
    "text",
    "password",
    "color",
    "email",
    "format",
    "date",
    "month",
    "year",
    "datetime",
    "datetime-sec",
    "time",
    "time-sec",
];
//# sourceMappingURL=sd-textfield.control.js.map