import { ChangeDetectionStrategy, Component, inject, viewChild, ViewEncapsulation, } from "@angular/core";
import { SdDropdownControl } from "./sd-dropdown.control";
import { SdAnchorControl } from "./sd-anchor.control";
import { SdListControl } from "./sd-list.control";
import { SdListItemControl } from "./sd-list-item.control";
import { SdThemeProvider } from "../providers/sd-theme.provider";
import { SdDropdownPopupControl } from "./sd-dropdown-popup.control";
import { SdAngularConfigProvider } from "../providers/sd-angular-config.provider";
import { SdIconControl } from "./sd-icon.control";
import { $effect } from "../utils/bindings/$effect";
import * as i0 from "@angular/core";
function SdThemeSelectorControl_Conditional_8_Template(rf, ctx) { if (rf & 1) {
    const _r1 = i0.ɵɵgetCurrentView();
    i0.ɵɵelementStart(0, "sd-list-item", 2);
    i0.ɵɵlistener("click", function SdThemeSelectorControl_Conditional_8_Template_sd_list_item_click_0_listener() { i0.ɵɵrestoreView(_r1); const ctx_r1 = i0.ɵɵnextContext(); ctx_r1.theme.set("compact"); return i0.ɵɵresetView(ctx_r1.dark.set(true)); });
    i0.ɵɵtext(1, " compact-dark ");
    i0.ɵɵelementEnd();
} if (rf & 2) {
    const ctx_r1 = i0.ɵɵnextContext();
    i0.ɵɵproperty("selected", ctx_r1.theme() === "compact" && ctx_r1.dark())("selectedIcon", ctx_r1.icons.check);
} }
export class SdThemeSelectorControl {
    constructor() {
        this.icons = inject(SdAngularConfigProvider).icons;
        this._sdTheme = inject(SdThemeProvider);
        this.dropdownControl = viewChild.required(SdDropdownControl);
        this.theme = this._sdTheme.theme;
        this.dark = this._sdTheme.dark;
        this.isDev = process.env["NODE_ENV"] === "development";
        $effect([this.theme], () => {
            this.dropdownControl().open.set(false);
        });
    }
    static { this.ɵfac = function SdThemeSelectorControl_Factory(__ngFactoryType__) { return new (__ngFactoryType__ || SdThemeSelectorControl)(); }; }
    static { this.ɵcmp = /*@__PURE__*/ i0.ɵɵdefineComponent({ type: SdThemeSelectorControl, selectors: [["sd-theme-selector"]], viewQuery: function SdThemeSelectorControl_Query(rf, ctx) { if (rf & 1) {
            i0.ɵɵviewQuerySignal(ctx.dropdownControl, SdDropdownControl, 5);
        } if (rf & 2) {
            i0.ɵɵqueryAdvance();
        } }, decls: 9, vars: 5, consts: [[2, "color", "var(--theme-grey-default)"], [3, "icon"], [3, "click", "selected", "selectedIcon"], [3, "selected", "selectedIcon"]], template: function SdThemeSelectorControl_Template(rf, ctx) { if (rf & 1) {
            i0.ɵɵelementStart(0, "sd-dropdown")(1, "sd-anchor", 0);
            i0.ɵɵelement(2, "sd-icon", 1);
            i0.ɵɵtext(3);
            i0.ɵɵelementEnd();
            i0.ɵɵelementStart(4, "sd-dropdown-popup")(5, "sd-list")(6, "sd-list-item", 2);
            i0.ɵɵlistener("click", function SdThemeSelectorControl_Template_sd_list_item_click_6_listener() { ctx.theme.set("compact"); return ctx.dark.set(false); });
            i0.ɵɵtext(7, " compact ");
            i0.ɵɵelementEnd();
            i0.ɵɵtemplate(8, SdThemeSelectorControl_Conditional_8_Template, 2, 2, "sd-list-item", 3);
            i0.ɵɵelementEnd()()();
        } if (rf & 2) {
            i0.ɵɵadvance(2);
            i0.ɵɵproperty("icon", ctx.icons.mountainSun);
            i0.ɵɵadvance();
            i0.ɵɵtextInterpolate1(" ", ctx.theme(), " ");
            i0.ɵɵadvance(3);
            i0.ɵɵproperty("selected", ctx.theme() === "compact" && !ctx.dark())("selectedIcon", ctx.icons.check);
            i0.ɵɵadvance(2);
            i0.ɵɵconditional(ctx.isDev ? 8 : -1);
        } }, dependencies: [SdDropdownControl,
            SdDropdownPopupControl,
            SdAnchorControl,
            SdListControl,
            SdListItemControl,
            SdIconControl], encapsulation: 2, changeDetection: 0 }); }
}
(() => { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(SdThemeSelectorControl, [{
        type: Component,
        args: [{
                selector: "sd-theme-selector",
                changeDetection: ChangeDetectionStrategy.OnPush,
                encapsulation: ViewEncapsulation.None,
                standalone: true,
                imports: [
                    SdDropdownControl,
                    SdDropdownPopupControl,
                    SdAnchorControl,
                    SdListControl,
                    SdListItemControl,
                    SdIconControl,
                ],
                template: `
    <sd-dropdown>
      <sd-anchor style="color: var(--theme-grey-default)">
        <sd-icon [icon]="icons.mountainSun" />
        {{ theme() }}
      </sd-anchor>

      <sd-dropdown-popup>
        <sd-list>
          <sd-list-item
            [selected]="theme() === 'compact' && !dark()"
            [selectedIcon]="icons.check"
            (click)="theme.set('compact'); dark.set(false)"
          >
            compact
          </sd-list-item>
          @if (isDev) {
            <sd-list-item
              [selected]="theme() === 'compact' && dark()"
              [selectedIcon]="icons.check"
              (click)="theme.set('compact'); dark.set(true)"
            >
              compact-dark
            </sd-list-item>
          }
        </sd-list>
      </sd-dropdown-popup>
    </sd-dropdown>
  `,
            }]
    }], () => [], null); })();
(() => { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassDebugInfo(SdThemeSelectorControl, { className: "SdThemeSelectorControl", filePath: "packages/sd-angular/src/controls/sd-theme-selector.control.ts", lineNumber: 61 }); })();
//# sourceMappingURL=sd-theme-selector.control.js.map