import { ChangeDetectionStrategy, Component, inject, output, ViewEncapsulation, } from "@angular/core";
import { SdAnchorControl } from "./sd-anchor.control";
import { SdAngularConfigProvider } from "../providers/sd-angular-config.provider";
import { SdIconControl } from "./sd-icon.control";
import * as i0 from "@angular/core";
const _c0 = ["*"];
export class SdTopbarTabControl {
    constructor() {
        this.icons = inject(SdAngularConfigProvider).icons;
        this.clickClose = output();
    }
    onCloseButtonClick(event) {
        event.preventDefault();
        event.stopPropagation();
        this.clickClose.emit(event);
    }
    static { this.ɵfac = function SdTopbarTabControl_Factory(__ngFactoryType__) { return new (__ngFactoryType__ || SdTopbarTabControl)(); }; }
    static { this.ɵcmp = /*@__PURE__*/ i0.ɵɵdefineComponent({ type: SdTopbarTabControl, selectors: [["sd-topbar-tab"]], outputs: { clickClose: "clickClose" }, ngContentSelectors: _c0, decls: 3, vars: 1, consts: [[3, "click"], ["fixedWidth", "", 3, "icon"]], template: function SdTopbarTabControl_Template(rf, ctx) { if (rf & 1) {
            i0.ɵɵprojectionDef();
            i0.ɵɵprojection(0);
            i0.ɵɵelementStart(1, "sd-anchor", 0);
            i0.ɵɵlistener("click", function SdTopbarTabControl_Template_sd_anchor_click_1_listener($event) { return ctx.onCloseButtonClick($event); });
            i0.ɵɵelement(2, "sd-icon", 1);
            i0.ɵɵelementEnd();
        } if (rf & 2) {
            i0.ɵɵadvance(2);
            i0.ɵɵproperty("icon", ctx.icons.xmark);
        } }, dependencies: [SdAnchorControl, SdIconControl], styles: ["sd-topbar-tab{display:inline-block;padding:0 var(--gap-lg);cursor:pointer;line-height:calc(var(--topbar-height-sm) - var(--gap-sm) - 2px);border-top:2px solid var(--theme-primary-darkest);border-left:1px solid var(--theme-primary-darkest);border-right:1px solid var(--theme-primary-darkest);margin-right:var(--gap-xs);background:var(--theme-primary-light);color:var(--text-trans-default)}sd-topbar-tab>sd-anchor{color:var(--theme-primary-default)}sd-topbar-tab>sd-anchor:hover{color:var(--theme-primary-darker)}sd-topbar-tab._selected{background:var(--control-color);font-weight:700}\n"], encapsulation: 2, changeDetection: 0 }); }
}
(() => { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(SdTopbarTabControl, [{
        type: Component,
        args: [{ selector: "sd-topbar-tab", changeDetection: ChangeDetectionStrategy.OnPush, encapsulation: ViewEncapsulation.None, standalone: true, imports: [SdAnchorControl, SdIconControl], template: `
    <ng-content></ng-content>
    <sd-anchor (click)="onCloseButtonClick($event)">
      <sd-icon [icon]="icons.xmark" fixedWidth />
    </sd-anchor>`, styles: ["sd-topbar-tab{display:inline-block;padding:0 var(--gap-lg);cursor:pointer;line-height:calc(var(--topbar-height-sm) - var(--gap-sm) - 2px);border-top:2px solid var(--theme-primary-darkest);border-left:1px solid var(--theme-primary-darkest);border-right:1px solid var(--theme-primary-darkest);margin-right:var(--gap-xs);background:var(--theme-primary-light);color:var(--text-trans-default)}sd-topbar-tab>sd-anchor{color:var(--theme-primary-default)}sd-topbar-tab>sd-anchor:hover{color:var(--theme-primary-darker)}sd-topbar-tab._selected{background:var(--control-color);font-weight:700}\n"] }]
    }], null, null); })();
(() => { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassDebugInfo(SdTopbarTabControl, { className: "SdTopbarTabControl", filePath: "packages/sd-angular/src/controls/sd-topbar-tab.control.ts", lineNumber: 53 }); })();
//# sourceMappingURL=sd-topbar-tab.control.js.map