import { ChangeDetectionStrategy, Component, forwardRef, HostListener, inject, input, ViewEncapsulation, } from "@angular/core";
import { SdTopbarContainerControl } from "./sd-topbar-container.control";
import { SdSidebarContainerControl } from "./sd-sidebar-container.control";
import { SdAnchorControl } from "./sd-anchor.control";
import { SdGapControl } from "./sd-gap.control";
import { SdAngularConfigProvider } from "../providers/sd-angular-config.provider";
import { injectElementRef } from "../utils/injections/inject-element-ref";
import { SdIconControl } from "./sd-icon.control";
import { $computed } from "../utils/bindings/$computed";
import * as i0 from "@angular/core";
const _c0 = ["*", [["sd-topbar-menu"]]];
const _c1 = ["*", "sd-topbar-menu"];
function SdTopbarControl_Conditional_0_Template(rf, ctx) { if (rf & 1) {
    const _r1 = i0.ɵɵgetCurrentView();
    i0.ɵɵelementStart(0, "sd-anchor", 2);
    i0.ɵɵlistener("click", function SdTopbarControl_Conditional_0_Template_sd_anchor_click_0_listener() { i0.ɵɵrestoreView(_r1); const ctx_r1 = i0.ɵɵnextContext(); return i0.ɵɵresetView(ctx_r1.onSidebarToggleButtonClick()); });
    i0.ɵɵelement(1, "sd-icon", 3);
    i0.ɵɵelementEnd();
} if (rf & 2) {
    const ctx_r1 = i0.ɵɵnextContext();
    i0.ɵɵadvance();
    i0.ɵɵproperty("icon", ctx_r1.icons.bars);
} }
function SdTopbarControl_Conditional_1_Template(rf, ctx) { if (rf & 1) {
    i0.ɵɵelement(0, "sd-gap", 1);
} }
export class SdTopbarControl {
    constructor() {
        this.icons = inject(SdAngularConfigProvider).icons;
        this._elRef = injectElementRef();
        this._parentSidebarContainerControl = inject(SdSidebarContainerControl, { optional: true });
        this._topbarContainerControl = inject(forwardRef(() => SdTopbarContainerControl));
        this.sidebarContainer = input();
        this.hasSidebar = $computed(() => !!this.sidebarContainer() || !!this._parentSidebarContainerControl);
    }
    onSidebarToggleButtonClick() {
        const sidebarContainerControl = this.sidebarContainer() ?? this._parentSidebarContainerControl;
        sidebarContainerControl.toggle.update((v) => !v);
    }
    onResize(event) {
        if (!event.heightChanged)
            return;
        this._topbarContainerControl.paddingTop.set(this._elRef.nativeElement.offsetHeight + "px");
    }
    static { this.ɵfac = function SdTopbarControl_Factory(__ngFactoryType__) { return new (__ngFactoryType__ || SdTopbarControl)(); }; }
    static { this.ɵcmp = /*@__PURE__*/ i0.ɵɵdefineComponent({ type: SdTopbarControl, selectors: [["sd-topbar"]], hostBindings: function SdTopbarControl_HostBindings(rf, ctx) { if (rf & 1) {
            i0.ɵɵlistener("sdResize", function SdTopbarControl_sdResize_HostBindingHandler($event) { return ctx.onResize($event); });
        } }, inputs: { sidebarContainer: [1, "sidebarContainer"] }, ngContentSelectors: _c1, decls: 4, vars: 1, consts: [["sdUseRipple", "", 1, "_sidebar-toggle-button"], ["width", "sm"], ["sdUseRipple", "", 1, "_sidebar-toggle-button", 3, "click"], ["fixedWidth", "", 3, "icon"]], template: function SdTopbarControl_Template(rf, ctx) { if (rf & 1) {
            i0.ɵɵprojectionDef(_c0);
            i0.ɵɵtemplate(0, SdTopbarControl_Conditional_0_Template, 2, 1, "sd-anchor", 0)(1, SdTopbarControl_Conditional_1_Template, 1, 0, "sd-gap", 1);
            i0.ɵɵprojection(2);
            i0.ɵɵprojection(3, 1);
        } if (rf & 2) {
            i0.ɵɵconditional(ctx.hasSidebar() ? 0 : 1);
        } }, dependencies: [SdAnchorControl, SdGapControl, SdIconControl], styles: ["sd-topbar{display:flex;flex-direction:row;flex-wrap:nowrap;gap:var(--gap-default);align-items:center;justify-content:start;position:absolute;z-index:var(--z-index-topbar);top:0;left:0;width:100%;height:var(--topbar-height);overflow-x:auto;overflow-y:hidden;user-select:none;background:var(--control-color);color:var(--text-trans-default)}sd-topbar>h1{padding-right:var(--gap-xl)}sd-topbar>h2{padding-right:var(--gap-xl)}sd-topbar>h3{padding-right:var(--gap-xl)}sd-topbar>h4{padding-right:var(--gap-xl)}sd-topbar>h5{padding-right:var(--gap-xl)}sd-topbar>h6{padding-right:var(--gap-xl)}sd-topbar::-webkit-scrollbar-track{background-color:#0000001a}sd-topbar::-webkit-scrollbar-corner{background-color:#0000001a}sd-topbar::-webkit-scrollbar{width:var(--gap-sm);height:var(--gap-sm);background-color:#0000}sd-topbar::-webkit-scrollbar-thumb{background-color:#0003}sd-topbar>._sidebar-toggle-button{text-align:center;cursor:pointer;line-height:var(--topbar-height);min-width:var(--topbar-height);font-size:var(--font-size-h4);color:var(--theme-primary-default)}sd-topbar>._sidebar-toggle-button:hover{background:transparent;color:var(--theme-primary-darker)}body.sd-theme-mobile sd-topbar{background:var(--background-color)}\n"], encapsulation: 2, changeDetection: 0 }); }
}
(() => { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(SdTopbarControl, [{
        type: Component,
        args: [{ selector: "sd-topbar", changeDetection: ChangeDetectionStrategy.OnPush, encapsulation: ViewEncapsulation.None, standalone: true, imports: [SdAnchorControl, SdGapControl, SdIconControl], template: `
    @if (hasSidebar()) {
      <sd-anchor class="_sidebar-toggle-button" (click)="onSidebarToggleButtonClick()" sdUseRipple>
        <sd-icon [icon]="icons.bars" fixedWidth />
      </sd-anchor>
    } @else {
      <sd-gap width="sm" />
    }

    <ng-content />

    <ng-content select="sd-topbar-menu"></ng-content>
  `, styles: ["sd-topbar{display:flex;flex-direction:row;flex-wrap:nowrap;gap:var(--gap-default);align-items:center;justify-content:start;position:absolute;z-index:var(--z-index-topbar);top:0;left:0;width:100%;height:var(--topbar-height);overflow-x:auto;overflow-y:hidden;user-select:none;background:var(--control-color);color:var(--text-trans-default)}sd-topbar>h1{padding-right:var(--gap-xl)}sd-topbar>h2{padding-right:var(--gap-xl)}sd-topbar>h3{padding-right:var(--gap-xl)}sd-topbar>h4{padding-right:var(--gap-xl)}sd-topbar>h5{padding-right:var(--gap-xl)}sd-topbar>h6{padding-right:var(--gap-xl)}sd-topbar::-webkit-scrollbar-track{background-color:#0000001a}sd-topbar::-webkit-scrollbar-corner{background-color:#0000001a}sd-topbar::-webkit-scrollbar{width:var(--gap-sm);height:var(--gap-sm);background-color:#0000}sd-topbar::-webkit-scrollbar-thumb{background-color:#0003}sd-topbar>._sidebar-toggle-button{text-align:center;cursor:pointer;line-height:var(--topbar-height);min-width:var(--topbar-height);font-size:var(--font-size-h4);color:var(--theme-primary-default)}sd-topbar>._sidebar-toggle-button:hover{background:transparent;color:var(--theme-primary-darker)}body.sd-theme-mobile sd-topbar{background:var(--background-color)}\n"] }]
    }], null, { onResize: [{
            type: HostListener,
            args: ["sdResize", ["$event"]]
        }] }); })();
(() => { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassDebugInfo(SdTopbarControl, { className: "SdTopbarControl", filePath: "packages/sd-angular/src/controls/sd-topbar.control.ts", lineNumber: 134 }); })();
//# sourceMappingURL=sd-topbar.control.js.map