import { Directive, HostListener, inject, input } from "@angular/core";
import { Router } from "@angular/router";
import { SdNavigateWindowProvider } from "../providers/sd-navigate-window.provider";
import * as querystring from "querystring";
import * as i0 from "@angular/core";
export class SdRouterLinkDirective {
    constructor() {
        this._router = inject(Router);
        this._navWindow = inject(SdNavigateWindowProvider);
        this.option = input(undefined, { alias: "sd-router-link" });
    }
    async onClick(event) {
        const option = this.option();
        if (!option)
            return;
        event.preventDefault();
        event.stopPropagation();
        // const obj = link[1];
        if (this._navWindow.isWindow) {
            const width = option.window?.width ?? 800;
            const height = option.window?.height ?? 800;
            const qp = option.queryParams ? "?" + querystring.stringify(option.queryParams) : "";
            this._navWindow.open(option.link + qp, option.params, `width=${width},height=${height}`);
        }
        else if (event.ctrlKey || event.altKey) {
            // 알트키: 새탭
            // 컨트롤키: 새탭 (새탭이 포커싱되지 않음)
            const qp = option.queryParams ? "?" + querystring.stringify(option.queryParams) : "";
            this._navWindow.open(option.link + qp, option.params, "_blank");
        }
        else if (event.shiftKey) {
            // 쉬프트키: 새창
            const width = option.window?.width ?? 800;
            const height = option.window?.height ?? 800;
            const qp = option.queryParams ? "?" + querystring.stringify(option.queryParams) : "";
            this._navWindow.open(option.link + qp, option.params, `width=${width},height=${height}`);
        }
        else if (option.outletName === undefined) {
            await this._router.navigate([option.link, ...(option.params ? [option.params] : [])], option.queryParams ? { queryParams: option.queryParams } : undefined);
        }
        else {
            await this._router.navigate([
                { outlets: { [option.outletName]: option.link } },
                ...(option.params ? [option.params] : []),
            ], option.queryParams ? { queryParams: option.queryParams } : undefined);
        }
    }
    static { this.ɵfac = function SdRouterLinkDirective_Factory(__ngFactoryType__) { return new (__ngFactoryType__ || SdRouterLinkDirective)(); }; }
    static { this.ɵdir = /*@__PURE__*/ i0.ɵɵdefineDirective({ type: SdRouterLinkDirective, selectors: [["", "sd-router-link", ""]], hostVars: 2, hostBindings: function SdRouterLinkDirective_HostBindings(rf, ctx) { if (rf & 1) {
            i0.ɵɵlistener("click", function SdRouterLinkDirective_click_HostBindingHandler($event) { return ctx.onClick($event); });
        } if (rf & 2) {
            i0.ɵɵstyleProp("cursor", "pointer");
        } }, inputs: { option: [1, "sd-router-link", "option"] } }); }
}
(() => { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(SdRouterLinkDirective, [{
        type: Directive,
        args: [{
                selector: "[sd-router-link]",
                standalone: true,
                host: {
                    "[style.cursor]": "'pointer'",
                },
            }]
    }], null, { onClick: [{
            type: HostListener,
            args: ["click", ["$event"]]
        }] }); })();
//# sourceMappingURL=sd-router-link.directive.js.map