import { Pipe } from "@angular/core";
import { DateOnly, DateTime } from "@simplysm/sd-core-common";
import * as i0 from "@angular/core";
export class FormatPipe {
    transform(value, format) {
        if (value == null) {
            return "";
        }
        else if (value instanceof DateTime || value instanceof DateOnly) {
            return value.toFormatString(format);
        }
        else {
            const formatItems = format.split("|");
            for (const formatItem of formatItems) {
                const fullLength = formatItem.match(/X/g)?.length;
                if (fullLength === value.length) {
                    let result = "";
                    let valCur = 0;
                    for (const formatItemChar of formatItem) {
                        if (formatItemChar === "X") {
                            result += value[valCur];
                            valCur++;
                        }
                        else {
                            result += formatItemChar;
                        }
                    }
                    return result;
                }
            }
            return value;
        }
    }
    static { this.ɵfac = function FormatPipe_Factory(__ngFactoryType__) { return new (__ngFactoryType__ || FormatPipe)(); }; }
    static { this.ɵpipe = /*@__PURE__*/ i0.ɵɵdefinePipe({ name: "format", type: FormatPipe, pure: true }); }
}
(() => { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(FormatPipe, [{
        type: Pipe,
        args: [{
                standalone: true,
                name: "format",
            }]
    }], null, null); })();
//# sourceMappingURL=format.pipe.js.map