import { inject, Injectable } from "@angular/core";
import { EventManagerPlugin } from "@angular/platform-browser";
import { DOCUMENT } from "@angular/common";
import { SdModalProvider } from "../../providers/sd-modal.provider";
import * as i0 from "@angular/core";
export class SdInsertCommandEventPlugin extends EventManagerPlugin {
    constructor() {
        super(inject(DOCUMENT));
        this._sdModal = inject(SdModalProvider);
    }
    supports(eventName) {
        return eventName === "sdInsertCommand";
    }
    addEventListener(element, eventName, handler) {
        const listener = (event) => {
            if (event.key === "Insert" && event.ctrlKey && !event.altKey && !event.shiftKey) {
                if (this._sdModal.modalCount() > 0) {
                    if (event.target.findParent("sd-modal") === element.findParent("sd-modal")) {
                        event.preventDefault();
                        event.stopPropagation();
                        handler(event);
                    }
                }
                else {
                    event.preventDefault();
                    event.stopPropagation();
                    handler(event);
                }
            }
        };
        document.addEventListener("keydown", listener);
        return () => {
            document.removeEventListener("keydown", listener);
        };
    }
    static { this.ɵfac = function SdInsertCommandEventPlugin_Factory(__ngFactoryType__) { return new (__ngFactoryType__ || SdInsertCommandEventPlugin)(); }; }
    static { this.ɵprov = /*@__PURE__*/ i0.ɵɵdefineInjectable({ token: SdInsertCommandEventPlugin, factory: SdInsertCommandEventPlugin.ɵfac, providedIn: null }); }
}
(() => { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(SdInsertCommandEventPlugin, [{
        type: Injectable,
        args: [{ providedIn: null }]
    }], () => [], null); })();
//# sourceMappingURL=sd-insert-command.event-plugin.js.map