import { inject, Injectable } from "@angular/core";
import { EventManagerPlugin } from "@angular/platform-browser";
import { DOCUMENT } from "@angular/common";
import { SdModalProvider } from "../../providers/sd-modal.provider";
import * as i0 from "@angular/core";
export class SdSaveCommandEventPlugin extends EventManagerPlugin {
    constructor() {
        super(inject(DOCUMENT));
        this._sdModal = inject(SdModalProvider);
    }
    supports(eventName) {
        return eventName === "sdSaveCommand";
    }
    addEventListener(element, eventName, handler) {
        // 모달이 안 열려 있을 때, event.target의 parent에 element가 있으면,
        // 모달이 열려있고, 포커싱된 모달이 나의 Parent일때,
        const listener = (event) => {
            if ((event.key === "s" || event.key === "S")
                && event.ctrlKey
                && !event.altKey
                && !event.shiftKey) {
                if (this._sdModal.modalCount() > 0) {
                    if (event.target.findParent("sd-modal") === element.findParent("sd-modal")) {
                        event.preventDefault();
                        event.stopPropagation();
                        handler(event);
                    }
                }
                else {
                    event.preventDefault();
                    event.stopPropagation();
                    handler(event);
                }
            }
        };
        document.addEventListener("keydown", listener);
        return () => {
            document.removeEventListener("keydown", listener);
        };
    }
    static { this.ɵfac = function SdSaveCommandEventPlugin_Factory(__ngFactoryType__) { return new (__ngFactoryType__ || SdSaveCommandEventPlugin)(); }; }
    static { this.ɵprov = /*@__PURE__*/ i0.ɵɵdefineInjectable({ token: SdSaveCommandEventPlugin, factory: SdSaveCommandEventPlugin.ɵfac, providedIn: null }); }
}
(() => { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(SdSaveCommandEventPlugin, [{
        type: Injectable,
        args: [{ providedIn: null }]
    }], () => [], null); })();
//# sourceMappingURL=sd-save-command.event-plugin.js.map