import { inject, Injectable } from "@angular/core";
import { EventManagerPlugin } from "@angular/platform-browser";
import { DOCUMENT } from "@angular/common";
import * as i0 from "@angular/core";
export class SdBackbuttonEventPlugin extends EventManagerPlugin {
    constructor() {
        super(inject(DOCUMENT));
    }
    supports(eventName) {
        return eventName === "sdBackbutton";
    }
    addEventListener(element, eventName, handler) {
        const listener = (event) => {
            event.preventDefault();
            event.stopPropagation();
            handler(event);
        };
        const listener2 = (event) => {
            if (event.key === "ArrowLeft" && !event.ctrlKey && event.altKey && !event.shiftKey) {
                event.preventDefault();
                event.stopPropagation();
                handler(event);
            }
        };
        document.addEventListener("backbutton", listener);
        document.addEventListener("keydown", listener2);
        return () => {
            document.removeEventListener("backbutton", listener);
            document.removeEventListener("keydown", listener2);
        };
    }
    static { this.ɵfac = function SdBackbuttonEventPlugin_Factory(__ngFactoryType__) { return new (__ngFactoryType__ || SdBackbuttonEventPlugin)(); }; }
    static { this.ɵprov = /*@__PURE__*/ i0.ɵɵdefineInjectable({ token: SdBackbuttonEventPlugin, factory: SdBackbuttonEventPlugin.ɵfac, providedIn: null }); }
}
(() => { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(SdBackbuttonEventPlugin, [{
        type: Injectable,
        args: [{ providedIn: null }]
    }], () => [], null); })();
//# sourceMappingURL=sd-backbutton.event-plugin.js.map