import { inject, Injectable } from "@angular/core";
import { EventManagerPlugin } from "@angular/platform-browser";
import { DOCUMENT } from "@angular/common";
import * as i0 from "@angular/core";
export class SdIntersectionEventPlugin extends EventManagerPlugin {
    constructor() {
        super(inject(DOCUMENT));
    }
    supports(eventName) {
        return eventName === "sdIntersection";
    }
    addEventListener(element, eventName, handler) {
        const observer = new IntersectionObserver((entries) => {
            const entry = entries.single();
            if (!entry)
                return;
            handler({ entry });
        });
        observer.observe(element);
        return () => {
            observer.disconnect();
        };
    }
    static { this.ɵfac = function SdIntersectionEventPlugin_Factory(__ngFactoryType__) { return new (__ngFactoryType__ || SdIntersectionEventPlugin)(); }; }
    static { this.ɵprov = /*@__PURE__*/ i0.ɵɵdefineInjectable({ token: SdIntersectionEventPlugin, factory: SdIntersectionEventPlugin.ɵfac, providedIn: null }); }
}
(() => { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(SdIntersectionEventPlugin, [{
        type: Injectable,
        args: [{ providedIn: null }]
    }], () => [], null); })();
//# sourceMappingURL=sd-intersection.event-plugin.js.map