import { inject, Injectable } from "@angular/core";
import { EventManagerPlugin } from "@angular/platform-browser";
import { DOCUMENT } from "@angular/common";
import * as i0 from "@angular/core";
export class SdOptionEventPlugin extends EventManagerPlugin {
    constructor() {
        super(inject(DOCUMENT));
    }
    supports(eventName) {
        return !eventName.startsWith("sd") && eventName.includes(".capture");
    }
    addEventListener(element, eventName, handler) {
        const capture = eventName.includes(".capture");
        const realEventName = eventName.replace(/\.capture/, "");
        const listener = (event) => {
            handler(event);
        };
        element.addEventListener(realEventName, listener, capture);
        return () => {
            element.removeEventListener(realEventName, listener, capture);
        };
    }
    static { this.ɵfac = function SdOptionEventPlugin_Factory(__ngFactoryType__) { return new (__ngFactoryType__ || SdOptionEventPlugin)(); }; }
    static { this.ɵprov = /*@__PURE__*/ i0.ɵɵdefineInjectable({ token: SdOptionEventPlugin, factory: SdOptionEventPlugin.ɵfac, providedIn: null }); }
}
(() => { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(SdOptionEventPlugin, [{
        type: Injectable,
        args: [{ providedIn: null }]
    }], () => [], null); })();
//# sourceMappingURL=sd-option.event-plugin.js.map