import { ISdAppStructureItem, ISdFlatPage, ISdMenu, ISdPermission } from "../utils/sd-app-structure.utils";
import * as i0 from "@angular/core";
export declare class SdAppStructureProvider<T extends string> {
    private _items;
    private _usableModules;
    private _permRecord;
    initialize(usableModules?: T[], permRecord?: Record<string, boolean | undefined>): void;
    getTitleByCode(pageCode: string): string;
    getViewPerms<K extends string>(viewCodes: string[], keys: K[]): K[];
    getFlatPages(): ISdFlatPage<T>[];
    getMenus(): ISdMenu<T>[];
    getPerms(): ISdPermission<T>[];
    getExtPermRoot(params: {
        appStructure: ISdAppStructureItem<T>[];
        title: string;
        codes: string[];
    }): ISdPermission;
    private _getPermsByModule;
    private _getDisplayMenus;
    private _isUsableModulePage;
    private _isModulesEnabled;
    static ɵfac: i0.ɵɵFactoryDeclaration<SdAppStructureProvider<any>, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<SdAppStructureProvider<any>>;
}
