import { ApplicationRef, createComponent, inject, Injectable } from "@angular/core";
import { SdBusyContainerControl } from "../controls/sd-busy-container.control";
import { $effect } from "../utils/bindings/$effect";
import { $signal } from "../utils/bindings/$signal";
import * as i0 from "@angular/core";
export class SdBusyProvider {
    get containerRef() {
        if (this._containerRef === undefined) {
            const compRef = createComponent(SdBusyContainerControl, {
                environmentInjector: this._appRef.injector,
            });
            compRef.setInput("type", this.type());
            compRef.location.nativeElement.style.position = "absolute";
            this._appRef.attachView(compRef.hostView);
            this._containerRef = compRef;
        }
        if (this._appRef.components.length > 0
            && this._containerRef.location.nativeElement.parentElement == null) {
            const rootComp = this._appRef.components[0];
            const rootCompEl = rootComp.location.nativeElement;
            rootCompEl.appendChild(this._containerRef.location.nativeElement);
        }
        return this._containerRef;
    }
    constructor() {
        this._appRef = inject(ApplicationRef);
        this.type = $signal("bar");
        this.globalBusyCount = $signal(0);
        $effect(() => {
            this.containerRef.setInput("busy", this.globalBusyCount() > 0);
            this.containerRef.location.nativeElement.style.pointerEvents =
                this.globalBusyCount() > 0 ? "auto" : "none";
        });
    }
    static { this.ɵfac = function SdBusyProvider_Factory(__ngFactoryType__) { return new (__ngFactoryType__ || SdBusyProvider)(); }; }
    static { this.ɵprov = /*@__PURE__*/ i0.ɵɵdefineInjectable({ token: SdBusyProvider, factory: SdBusyProvider.ɵfac, providedIn: "root" }); }
}
(() => { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(SdBusyProvider, [{
        type: Injectable,
        args: [{ providedIn: "root" }]
    }], () => [], null); })();
//# sourceMappingURL=sd-busy.provider.js.map