import { Wait } from "@simplysm/sd-core-common";
import { Injectable } from "@angular/core";
import * as i0 from "@angular/core";
export class SdFileDialogProvider {
    async showAsync(multiple, accept) {
        return await new Promise((resolve) => {
            let inputEl = document.createElement("input");
            inputEl.type = "file";
            inputEl.multiple = multiple ?? false;
            if (accept !== undefined) {
                inputEl.accept = accept;
            }
            inputEl.onchange = (event) => {
                if (inputEl) {
                    document.body.removeChild(inputEl);
                    inputEl = undefined;
                }
                const files = event.target["files"];
                resolve(multiple ? files : files[0]);
            };
            inputEl.style.opacity = "0";
            inputEl.style.position = "fixed";
            inputEl.style.top = "0";
            inputEl.style.left = "0";
            inputEl.style.pointerEvents = "none";
            document.body.appendChild(inputEl);
            inputEl.focus();
            inputEl.click();
            setTimeout(() => {
                inputEl.onfocus = async () => {
                    await Wait.time(1000);
                    if (inputEl) {
                        document.body.removeChild(inputEl);
                        inputEl = undefined;
                    }
                    resolve(undefined);
                };
            });
        });
    }
    static { this.ɵfac = function SdFileDialogProvider_Factory(__ngFactoryType__) { return new (__ngFactoryType__ || SdFileDialogProvider)(); }; }
    static { this.ɵprov = /*@__PURE__*/ i0.ɵɵdefineInjectable({ token: SdFileDialogProvider, factory: SdFileDialogProvider.ɵfac, providedIn: "root" }); }
}
(() => { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(SdFileDialogProvider, [{
        type: Injectable,
        args: [{ providedIn: "root" }]
    }], null, null); })();
//# sourceMappingURL=sd-file-dialog.provider.js.map