import { JsonConvert } from "@simplysm/sd-core-common";
import { inject, Injectable } from "@angular/core";
import { SdAngularConfigProvider } from "./sd-angular-config.provider";
import * as i0 from "@angular/core";
export function injectSdLocalStorage() {
    return inject(SdLocalStorageProvider);
}
export class SdLocalStorageProvider {
    constructor() {
        this._sdNgConf = inject(SdAngularConfigProvider);
    }
    set(key, value) {
        localStorage.setItem(`${this._sdNgConf.clientName}.${key}`, JsonConvert.stringify(value));
    }
    get(key) {
        const json = localStorage.getItem(`${this._sdNgConf.clientName}.${key}`);
        if (json == null)
            return undefined;
        return JsonConvert.parse(json);
    }
    remove(key) {
        localStorage.removeItem(`${this._sdNgConf.clientName}.${key}`);
    }
    static { this.ɵfac = function SdLocalStorageProvider_Factory(__ngFactoryType__) { return new (__ngFactoryType__ || SdLocalStorageProvider)(); }; }
    static { this.ɵprov = /*@__PURE__*/ i0.ɵɵdefineInjectable({ token: SdLocalStorageProvider, factory: SdLocalStorageProvider.ɵfac, providedIn: "root" }); }
}
(() => { (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(SdLocalStorageProvider, [{
        type: Injectable,
        args: [{ providedIn: "root" }]
    }], null, null); })();
//# sourceMappingURL=sd-local-storage.provider.js.map