import { OutputEmitterRef, Type } from "@angular/core";
import { SdModalControl } from "../controls/sd-modal.control";
import { TDirectiveInputSignals } from "../utils/types";
import * as i0 from "@angular/core";
export declare class SdModalProvider {
    private _appRef;
    private _sdBusy;
    modalCount: import("../utils/bindings/$signal").SdWritableSignal<number>;
    showAsync<T extends ISdModal<any>>(modal: ISdModalInput<T>, options?: {
        key?: string;
        hideHeader?: boolean;
        hideCloseButton?: boolean;
        useCloseByBackdrop?: boolean;
        useCloseByEscapeKey?: boolean;
        float?: boolean;
        minHeightPx?: number;
        minWidthPx?: number;
        resizable?: boolean;
        movable?: boolean;
        headerStyle?: string;
        fill?: boolean;
        noFirstControlFocusing?: boolean;
    }): Promise<Parameters<T["close"]["emit"]>[0] | undefined>;
    static ɵfac: i0.ɵɵFactoryDeclaration<SdModalProvider, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<SdModalProvider>;
}
export interface ISdModal<O> {
    close: OutputEmitterRef<O | undefined>;
}
export declare class SdActivatedModalProvider<T> {
    modalComponent: import("../utils/bindings/$signal").SdWritableSignal<SdModalControl | undefined>;
    contentComponent: import("../utils/bindings/$signal").SdWritableSignal<T | undefined>;
    canDeactivefn: () => boolean;
    static ɵfac: i0.ɵɵFactoryDeclaration<SdActivatedModalProvider<any>, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<SdActivatedModalProvider<any>>;
}
export interface ISdModalInput<T extends ISdModal<any>, X extends keyof any = ""> {
    title: string;
    type: Type<T>;
    inputs: Omit<TDirectiveInputSignals<T>, X>;
}
