import { ComponentRef, Type } from "@angular/core";
import { SdToastContainerControl } from "../controls/sd-toast-container.control";
import * as i0 from "@angular/core";
export declare class SdToastProvider {
    private _appRef;
    private _systemLog;
    alertThemes: ("info" | "success" | "warning" | "danger")[];
    overlap: boolean;
    private _containerRef?;
    beforeShowFn?: (theme: "info" | "success" | "warning" | "danger") => void;
    get containerRef(): ComponentRef<SdToastContainerControl>;
    try<R>(fn: () => Promise<R>, messageFn?: (err: Error) => string): Promise<R>;
    try<R>(fn: () => R, messageFn?: (err: Error) => string): R;
    notify<T extends SdToastBase<any, any>>(toastType: Type<T>, params: T["__tInput__"], onclose: (result: T["__tOutput__"] | undefined) => void | Promise<void>): void;
    info<T extends boolean>(message: string, progress?: T): T extends true ? ISdProgressToast : void;
    success<T extends boolean>(message: string, progress?: T): T extends true ? ISdProgressToast : void;
    warning<T extends boolean>(message: string, progress?: T): T extends true ? ISdProgressToast : void;
    danger<T extends boolean>(message: string, progress?: T): T extends true ? ISdProgressToast : void;
    private _show;
    private _closeAfterTime;
    static ɵfac: i0.ɵɵFactoryDeclaration<SdToastProvider, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<SdToastProvider>;
}
export interface ISdProgressToast {
    progress(percent: number): void;
    message(msg: string): void;
}
export declare abstract class SdToastBase<I, O> {
    __tInput__: I;
    __tOutput__: O;
    params: import("@angular/core").InputSignal<I>;
    close(value?: O): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<SdToastBase<any, any>, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<SdToastBase<any, any>, never, never, { "params": { "alias": "params"; "required": true; "isSignal": true; }; }, {}, never, never, true, never>;
}
