import { computed, effect, signal, untracked } from "@angular/core";
export function $computed(...args) {
    const signals = args[0] instanceof Array ? args[0] : undefined;
    const fn = args[0] instanceof Array ? args[1] : args[0];
    const opt = args[0] instanceof Array ? args[2] : args[1];
    if (signals) {
        const resultSig = signal(opt?.initialValue);
        effect(() => {
            for (const sig of signals) {
                sig();
            }
            void untracked(async () => {
                resultSig.set(await fn());
            });
        });
        return resultSig;
    }
    else {
        return computed(() => fn());
    }
}
//# sourceMappingURL=$computed.js.map