import { ObjectUtils } from "@simplysm/sd-core-common";
const ORIGIN_SNAPSHOT = Symbol();
export function $obj(sig) {
    return {
        snapshot() {
            sig[ORIGIN_SNAPSHOT] = ObjectUtils.clone(sig());
        },
        changed() {
            const orgData = sig[ORIGIN_SNAPSHOT];
            return !ObjectUtils.equal(orgData, sig());
        },
        get origin() {
            return sig[ORIGIN_SNAPSHOT] ?? ObjectUtils.clone(sig());
        },
        updateField(key, val) {
            if (!("update" in sig))
                throw new Error("Readonly signal does not support remove.");
            if (sig()[key] === val)
                return;
            sig.update(v => ({
                ...v,
                [key]: val,
            }));
        },
        deleteField(key) {
            if (!("update" in sig))
                throw new Error("Readonly signal does not support remove.");
            if (!(key in sig()))
                return;
            sig.update(v => {
                const r = { ...v };
                delete v[key];
                return r;
            });
        },
    };
}
//# sourceMappingURL=$obj.js.map