import { inject, Injector, ViewContainerRef } from "@angular/core";
export function injectParent(type, options) {
    let currentInjector = inject(ViewContainerRef).injector;
    while (true) {
        if (!currentInjector) {
            if (options?.optional) {
                return undefined;
            }
            else {
                throw new Error("부모 컴포넌트를 찾을 수 없습니다.");
            }
        }
        const comp = currentInjector["_lView"][8];
        if (!type) {
            return comp;
        }
        if (comp instanceof type) {
            return comp;
        }
        currentInjector = currentInjector.get(Injector, undefined, { skipSelf: true, optional: true });
    }
}
//# sourceMappingURL=inject-parent.js.map