import { Signal, WritableSignal } from "@angular/core";
export declare class SdSelectionManager<T> {
    private _options;
    constructor(_options: {
        displayItems: Signal<T[]>;
        selectedItems: WritableSignal<T[]>;
        selectMode: Signal<"single" | "multi" | undefined>;
        getItemSelectableFn: Signal<((item: T) => boolean | string) | undefined>;
    });
    private _selectableItems;
    hasSelectable: Signal<boolean>;
    isAllSelected: Signal<boolean>;
    getBeforeChangeFn(item: T): () => boolean;
    getSelectable(item: T): true | string | undefined;
    toggleAll(): void;
    select(item: T): void;
    toggle(item: T): void;
}
