import { IconDefinition } from "@fortawesome/fontawesome-svg-core";
export declare class SdAppStructureUtils {
    static getFlatPermissions<T extends string>(menus: ISdAppStructureItem<T>[], codes?: string[], modules?: T[]): ISdFlatPermission<T>[];
    static getMenus<T extends string>(menus: ISdAppStructureItem<T>[], codeChain?: string[]): ISdMenu<T>[];
    static getFlatPages<T extends string>(menus: ISdAppStructureItem<T>[], titleChain?: string[], codeChain?: string[], modulesChain?: T[][]): ISdFlatPage<T>[];
    static getTitleByCode(menus: ISdAppStructureItem[], code: string, withoutParent?: boolean): string;
    static getPermissions<T extends string>(menus: ISdAppStructureItem<T>[], codes?: string[]): ISdPermission<T>[];
    static getPermissionDisplayNameRecord(menus: ISdAppStructureItem[], codes?: string[], titles?: string[]): Record<string, string>;
}
export interface ISdAppStructureItem<T extends string = string> {
    title: string;
    code: string;
    modules?: T[];
    perms?: ("use" | "edit")[];
    subPerms?: ISdAppStructureItemPermission<T>[];
    icon?: IconDefinition;
    isNotMenu?: boolean;
    isNotPage?: boolean;
    children?: ISdAppStructureItem<T>[];
}
export interface ISdAppStructureItemPermission<T extends string = string> {
    title: string;
    code: string;
    modules?: T[];
    perms: ("use" | "edit")[];
}
export interface ISdFlatPermission<T extends string = string> {
    code: string;
    modules: T[];
}
export interface ISdMenu<T extends string = string> {
    title: string;
    codeChain: string[];
    hasPerms: boolean;
    icon?: IconDefinition;
    modules?: T[];
    children?: ISdMenu<T>[];
}
export interface ISdFlatPage<T extends string = string> {
    titleChain: string[];
    codeChain: string[];
    modulesChain: T[][];
    hasPerms: boolean;
}
export interface ISdPermission<T extends string = string> {
    title: string;
    codes: string[];
    modules?: T[];
    perms?: ("use" | "edit")[];
    children?: ISdPermission<T>[];
}
